module: QD3DMath

define module QD3DMath
	use Dylan;
	use Extern;							// imports "load-object-file", etc.
	use Extensions;						// for <boolean>.
	use QD3DTypes;
	
	export
		Q3Point2D-Set,
		Q3Param2D-Set,
		Q3Point3D-Set,
		Q3RationalPoint3D-Set,
		Q3RationalPoint4D-Set,
		Q3Vector2D-Set,
		Q3Vector3D-Set,
		Q3PolarPoint-Set,
		Q3SphericalPoint-Set,
		Q3Point2D-To3D,
		Q3RationalPoint3D-To2D,
		Q3Point3D-To4D,
		Q3RationalPoint4D-To3D,
		Q3Vector2D-To3D,
		Q3Vector3D-To2D,
		Q3Point2D-Subtract,
		Q3Param2D-Subtract,
		Q3Point3D-Subtract,
		Q3Point2D-Distance,
		Q3Point2D-DistanceSquared,
		Q3Param2D-Distance,
		Q3Param2D-DistanceSquared,
		Q3RationalPoint3D-Distance,
		Q3RationalPoint3D-DistanceSquared,
		Q3Point3D-Distance,
		Q3Point3D-DistanceSquared,
		Q3RationalPoint4D-Distance,
		Q3RationalPoint4D-DistanceSquared,
		Q3Point2D-RRatio,
		Q3Param2D-RRatio,
		Q3Point3D-RRatio,
		Q3RationalPoint4D-RRatio,
		Q3Point2D-Vector2D-Add,
		Q3Param2D-Vector2D-Add,
		Q3Point3D-Vector3D-Add,
		Q3Point2D-Vector2D-Subtract,
		Q3Param2D-Vector2D-Subtract,
		Q3Point3D-Vector3D-Subtract,
		Q3Vector2D-Scale,
		Q3Vector3D-Scale,
		Q3Vector2D-Length,
		Q3Vector3D-Length,
		Q3Vector2D-Normalize,
		Q3Vector3D-Normalize,
		Q3Vector2D-Add,
		Q3Vector3D-Add,
		Q3Vector2D-Subtract,
		Q3Vector3D-Subtract,
		Q3Vector2D-Cross,
		Q3Vector3D-Cross,
		Q3Point3D-CrossProductTri,
		Q3Vector2D-Dot,
		Q3Vector3D-Dot,
		Q3Vector2D-Transform,
		Q3Vector3D-Transform,
		Q3Point2D-Transform,
		Q3Param2D-Transform,
		Q3Point3D-Transform,
		Q3RationalPoint4D-Transform,
		Q3Point3D-To3DTransformArray,
		Q3Point3D-To4DTransformArray,
		Q3RationalPoint4D-To4DTransformArray,
		Q3Vector2D-Negate,
		Q3Vector3D-Negate,
		Q3Point2D-ToPolar,
		Q3PolarPoint-ToPoint2D,
		Q3Point3D-ToSpherical,
		Q3SphericalPoint-ToPoint3D,
		Q3Point2D-AffineComb,
		Q3Param2D-AffineComb,
		Q3RationalPoint3D-AffineComb,
		Q3Point3D-AffineComb,
		Q3RationalPoint4D-AffineComb,
		Q3Matrix3x3-Copy,
		Q3Matrix4x4-Copy,
		Q3Matrix3x3-SetIdentity,
		Q3Matrix4x4-SetIdentity,
		Q3Matrix3x3-Transpose,
		Q3Matrix4x4-Transpose,
		Q3Matrix3x3-Invert,
		Q3Matrix4x4-Invert,
		Q3Matrix3x3-Adjoint,
		Q3Matrix3x3-Multiply,
		Q3Matrix4x4-Multiply,
		Q3Matrix3x3-SetTranslate,
		Q3Matrix3x3-SetScale,
		Q3Matrix3x3-SetRotateAboutPoint,
		Q3Matrix4x4-SetTranslate,
		Q3Matrix4x4-SetScale,
		Q3Matrix4x4-SetRotateAboutPoint,
		Q3Matrix4x4-SetRotateAboutAxis,
		Q3Matrix4x4-SetRotate-X,
		Q3Matrix4x4-SetRotate-Y,
		Q3Matrix4x4-SetRotate-Z,
		Q3Matrix4x4-SetRotate-XYZ,
		Q3Matrix4x4-SetRotateVectorToVector,
		Q3Matrix3x3-Determinant,
		Q3Matrix4x4-Determinant,
		Q3Quaternion-Set,
		Q3Quaternion-SetIdentity,
		Q3Quaternion-Copy,
		Q3Quaternion-IsIdentity,
		Q3Quaternion-Invert,
		Q3Quaternion-Normalize,
		Q3Quaternion-Dot,
		Q3Quaternion-Multiply,
		Q3Quaternion-SetRotateAboutAxis,
		Q3Quaternion-SetRotateXYZ,
		Q3Quaternion-SetRotateX,
		Q3Quaternion-SetRotateY,
		Q3Quaternion-SetRotateZ,
		Q3Quaternion-SetMatrix,
		Q3Quaternion-SetRotateVectorToVector,
		Q3Matrix4x4-SetQuaternion,
		Q3Quaternion-MatchReflection,
		Q3Quaternion-InterpolateFast,
		Q3Quaternion-InterpolateLinear,
		Q3Vector3D-TransformQuaternion,
		Q3Point3D-TransformQuaternion,
		Q3BoundingBox-Copy,
		Q3BoundingBox-Union,
		Q3BoundingBox-Set,
		Q3BoundingBox-UnionPoint3D,
		Q3BoundingBox-UnionRationalPoint4D,
		Q3BoundingBox-SetFromPoints3D,
		Q3BoundingBox-SetFromRationalPoints4D,
		Q3BoundingSphere-Copy,
		Q3BoundingSphere-Union,
		Q3BoundingSphere-Set,
		Q3BoundingSphere-UnionPoint3D,
		Q3BoundingSphere-UnionRationalPoint4D,
		Q3BoundingSphere-SetFromPoints3D,
		Q3BoundingSphere-SetFromRationalPoints4D
end module QD3DMath;

define constant anonymous-168
  = load-object-file(#("QuickDraw 3D"), include: #("Q3Point2D_Set", "Q3Param2D_Set", "Q3Point3D_Set", "Q3RationalPoint3D_Set", "Q3RationalPoint4D_Set", "Q3Vector2D_Set", "Q3Vector3D_Set", "Q3PolarPoint_Set", "Q3SphericalPoint_Set", "Q3Point2D_To3D", "Q3RationalPoint3D_To2D", "Q3Point3D_To4D", "Q3RationalPoint4D_To3D", "Q3Vector2D_To3D", "Q3Vector3D_To2D", "Q3Point2D_Subtract", "Q3Param2D_Subtract", "Q3Point3D_Subtract", "Q3Point2D_Distance", "Q3Point2D_DistanceSquared", "Q3Param2D_Distance", "Q3Param2D_DistanceSquared", "Q3RationalPoint3D_Distance", "Q3RationalPoint3D_DistanceSquared", "Q3Point3D_Distance", "Q3Point3D_DistanceSquared", "Q3RationalPoint4D_Distance", "Q3RationalPoint4D_DistanceSquared", "Q3Point2D_RRatio", "Q3Param2D_RRatio", "Q3Point3D_RRatio", "Q3RationalPoint4D_RRatio", "Q3Point2D_Vector2D_Add", "Q3Param2D_Vector2D_Add", "Q3Point3D_Vector3D_Add", "Q3Point2D_Vector2D_Subtract", "Q3Param2D_Vector2D_Subtract", "Q3Point3D_Vector3D_Subtract", "Q3Vector2D_Scale", "Q3Vector3D_Scale", "Q3Vector2D_Length", "Q3Vector3D_Length", "Q3Vector2D_Normalize", "Q3Vector3D_Normalize", "Q3Vector2D_Add", "Q3Vector3D_Add", "Q3Vector2D_Subtract", "Q3Vector3D_Subtract", "Q3Vector2D_Cross", "Q3Vector3D_Cross", "Q3Point3D_CrossProductTri", "Q3Vector2D_Dot", "Q3Vector3D_Dot", "Q3Vector2D_Transform", "Q3Vector3D_Transform", "Q3Point2D_Transform", "Q3Param2D_Transform", "Q3Point3D_Transform", "Q3RationalPoint4D_Transform", "Q3Point3D_To3DTransformArray", "Q3Point3D_To4DTransformArray", "Q3RationalPoint4D_To4DTransformArray", "Q3Vector2D_Negate", "Q3Vector3D_Negate", "Q3Point2D_ToPolar", "Q3PolarPoint_ToPoint2D", "Q3Point3D_ToSpherical", "Q3SphericalPoint_ToPoint3D", "Q3Point2D_AffineComb", "Q3Param2D_AffineComb", "Q3RationalPoint3D_AffineComb", "Q3Point3D_AffineComb", "Q3RationalPoint4D_AffineComb", "Q3Matrix3x3_Copy", "Q3Matrix4x4_Copy", "Q3Matrix3x3_SetIdentity", "Q3Matrix4x4_SetIdentity", "Q3Matrix3x3_Transpose", "Q3Matrix4x4_Transpose", "Q3Matrix3x3_Invert", "Q3Matrix4x4_Invert", "Q3Matrix3x3_Adjoint", "Q3Matrix3x3_Multiply", "Q3Matrix4x4_Multiply", "Q3Matrix3x3_SetTranslate", "Q3Matrix3x3_SetScale", "Q3Matrix3x3_SetRotateAboutPoint", "Q3Matrix4x4_SetTranslate", "Q3Matrix4x4_SetScale", "Q3Matrix4x4_SetRotateAboutPoint", "Q3Matrix4x4_SetRotateAboutAxis", "Q3Matrix4x4_SetRotate_X", "Q3Matrix4x4_SetRotate_Y", "Q3Matrix4x4_SetRotate_Z", "Q3Matrix4x4_SetRotate_XYZ", "Q3Matrix4x4_SetRotateVectorToVector", "Q3Matrix4x4_SetQuaternion", "Q3Matrix3x3_Determinant", "Q3Matrix4x4_Determinant", "Q3Quaternion_Set", "Q3Quaternion_SetIdentity", "Q3Quaternion_Copy", "Q3Quaternion_IsIdentity", "Q3Quaternion_Invert", "Q3Quaternion_Normalize", "Q3Quaternion_Dot", "Q3Quaternion_Multiply", "Q3Quaternion_SetRotateAboutAxis", "Q3Quaternion_SetRotateXYZ", "Q3Quaternion_SetRotateX", "Q3Quaternion_SetRotateY", "Q3Quaternion_SetRotateZ", "Q3Quaternion_SetMatrix", "Q3Quaternion_SetRotateVectorToVector", "Q3Quaternion_MatchReflection", "Q3Quaternion_InterpolateFast", "Q3Quaternion_InterpolateLinear", "Q3Vector3D_TransformQuaternion", "Q3Point3D_TransformQuaternion", "Q3BoundingBox_Copy", "Q3BoundingBox_Union", "Q3BoundingBox_Set", "Q3BoundingBox_UnionPoint3D", "Q3BoundingBox_UnionRationalPoint4D", "Q3BoundingBox_SetFromPoints3D", "Q3BoundingBox_SetFromRationalPoints4D", "Q3BoundingSphere_Copy", "Q3BoundingSphere_Union", "Q3BoundingSphere_Set", "Q3BoundingSphere_UnionPoint3D", "Q3BoundingSphere_UnionRationalPoint4D", "Q3BoundingSphere_SetFromPoints3D", "Q3BoundingSphere_SetFromRationalPoints4D"));

define constant anonymous-169
  = constrain-c-function(find-c-function("Q3Point2D_Set", file: anonymous-168), #(), #t, list(<TQ3Point2D>));
define method Q3Point2D-Set
    (arg1 :: <TQ3Point2D>, arg2 :: <float>, arg3 :: <float>)
 => (result :: <TQ3Point2D>);
  let result-value
    = anonymous-169(arg1, arg2, arg3);
  values(result-value);
end method Q3Point2D-Set;

define constant anonymous-170
  = constrain-c-function(find-c-function("Q3Param2D_Set", file: anonymous-168), #(), #t, list(<TQ3Param2D>));
define method Q3Param2D-Set
    (arg1 :: <TQ3Param2D>, arg2 :: <float>, arg3 :: <float>)
 => (result :: <TQ3Param2D>);
  let result-value
    = anonymous-170(arg1, arg2, arg3);
  values(result-value);
end method Q3Param2D-Set;

define constant anonymous-171
  = constrain-c-function(find-c-function("Q3Point3D_Set", file: anonymous-168), #(), #t, list(<TQ3Point3D>));
define method Q3Point3D-Set
    (arg1 :: <TQ3Point3D>, arg2 :: <float>, arg3 :: <float>, arg4 :: <float>)
 => (result :: <TQ3Point3D>);
  let result-value
    = anonymous-171(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Point3D-Set;

define constant anonymous-172
  = constrain-c-function(find-c-function("Q3RationalPoint3D_Set", file: anonymous-168), #(), #t, list(<TQ3RationalPoint3D>));
define method Q3RationalPoint3D-Set
    (arg1 :: <TQ3RationalPoint3D>, arg2 :: <float>, arg3 :: <float>, arg4 :: <float>)
 => (result :: <TQ3RationalPoint3D>);
  let result-value
    = anonymous-172(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3RationalPoint3D-Set;

define constant anonymous-173
  = constrain-c-function(find-c-function("Q3RationalPoint4D_Set", file: anonymous-168), #(), #t, list(<TQ3RationalPoint4D>));
define method Q3RationalPoint4D-Set
    (arg1 :: <TQ3RationalPoint4D>, arg2 :: <float>, arg3 :: <float>, arg4 :: <float>, arg5 :: <float>)
 => (result :: <TQ3RationalPoint4D>);
  let result-value
    = anonymous-173(arg1, arg2, arg3, arg4, arg5);
  values(result-value);
end method Q3RationalPoint4D-Set;

define constant anonymous-174
  = constrain-c-function(find-c-function("Q3Vector2D_Set", file: anonymous-168), #(), #t, list(<TQ3Vector2D>));
define method Q3Vector2D-Set
    (arg1 :: <TQ3Vector2D>, arg2 :: <float>, arg3 :: <float>)
 => (result :: <TQ3Vector2D>);
  let result-value
    = anonymous-174(arg1, arg2, arg3);
  values(result-value);
end method Q3Vector2D-Set;

define constant anonymous-175
  = constrain-c-function(find-c-function("Q3Vector3D_Set", file: anonymous-168), #(), #t, list(<TQ3Vector3D>));
define method Q3Vector3D-Set
    (arg1 :: <TQ3Vector3D>, arg2 :: <float>, arg3 :: <float>, arg4 :: <float>)
 => (result :: <TQ3Vector3D>);
  let result-value
    = anonymous-175(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Vector3D-Set;

define constant anonymous-176
  = constrain-c-function(find-c-function("Q3PolarPoint_Set", file: anonymous-168), #(), #t, list(<TQ3PolarPoint>));
define method Q3PolarPoint-Set
    (arg1 :: <TQ3PolarPoint>, arg2 :: <float>, arg3 :: <float>)
 => (result :: <TQ3PolarPoint>);
  let result-value
    = anonymous-176(arg1, arg2, arg3);
  values(result-value);
end method Q3PolarPoint-Set;

define constant anonymous-177
  = constrain-c-function(find-c-function("Q3SphericalPoint_Set", file: anonymous-168), #(), #t, list(<TQ3SphericalPoint>));
define method Q3SphericalPoint-Set
    (arg1 :: <TQ3SphericalPoint>, arg2 :: <float>, arg3 :: <float>, arg4 :: <float>)
 => (result :: <TQ3SphericalPoint>);
  let result-value
    = anonymous-177(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3SphericalPoint-Set;

define constant anonymous-178
  = constrain-c-function(find-c-function("Q3Point2D_To3D", file: anonymous-168), #(), #t, list(<TQ3Point3D>));
define method Q3Point2D-To3D
    (arg1 :: <TQ3Point2D>, arg2 :: <TQ3Point3D>)
 => (result :: <TQ3Point3D>);
  let result-value
    = anonymous-178(arg1, arg2);
  values(result-value);
end method Q3Point2D-To3D;

define constant anonymous-179
  = constrain-c-function(find-c-function("Q3RationalPoint3D_To2D", file: anonymous-168), #(), #t, list(<TQ3Point2D>));
define method Q3RationalPoint3D-To2D
    (arg1 :: <TQ3RationalPoint3D>, arg2 :: <TQ3Point2D>)
 => (result :: <TQ3Point2D>);
  let result-value
    = anonymous-179(arg1, arg2);
  values(result-value);
end method Q3RationalPoint3D-To2D;

define constant anonymous-180
  = constrain-c-function(find-c-function("Q3Point3D_To4D", file: anonymous-168), #(), #t, list(<TQ3RationalPoint4D>));
define method Q3Point3D-To4D
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3RationalPoint4D>)
 => (result :: <TQ3RationalPoint4D>);
  let result-value
    = anonymous-180(arg1, arg2);
  values(result-value);
end method Q3Point3D-To4D;

define constant anonymous-181
  = constrain-c-function(find-c-function("Q3RationalPoint4D_To3D", file: anonymous-168), #(), #t, list(<TQ3Point3D>));
define method Q3RationalPoint4D-To3D
    (arg1 :: <TQ3RationalPoint4D>, arg2 :: <TQ3Point3D>)
 => (result :: <TQ3Point3D>);
  let result-value
    = anonymous-181(arg1, arg2);
  values(result-value);
end method Q3RationalPoint4D-To3D;

define constant anonymous-182
  = constrain-c-function(find-c-function("Q3Vector2D_To3D", file: anonymous-168), #(), #t, list(<TQ3Vector3D>));
define method Q3Vector2D-To3D
    (arg1 :: <TQ3Vector2D>, arg2 :: <TQ3Vector3D>)
 => (result :: <TQ3Vector3D>);
  let result-value
    = anonymous-182(arg1, arg2);
  values(result-value);
end method Q3Vector2D-To3D;

define constant anonymous-183
  = constrain-c-function(find-c-function("Q3Vector3D_To2D", file: anonymous-168), #(), #t, list(<TQ3Vector2D>));
define method Q3Vector3D-To2D
    (arg1 :: <TQ3Vector3D>, arg2 :: <TQ3Vector2D>)
 => (result :: <TQ3Vector2D>);
  let result-value
    = anonymous-183(arg1, arg2);
  values(result-value);
end method Q3Vector3D-To2D;

define constant anonymous-184
  = constrain-c-function(find-c-function("Q3Point2D_Subtract", file: anonymous-168), #(), #t, list(<TQ3Vector2D>));
define method Q3Point2D-Subtract
    (arg1 :: <TQ3Point2D>, arg2 :: <TQ3Point2D>, arg3 :: <TQ3Vector2D>)
 => (result :: <TQ3Vector2D>);
  let result-value
    = anonymous-184(arg1, arg2, arg3);
  values(result-value);
end method Q3Point2D-Subtract;

define constant anonymous-185
  = constrain-c-function(find-c-function("Q3Param2D_Subtract", file: anonymous-168), #(), #t, list(<TQ3Vector2D>));
define method Q3Param2D-Subtract
    (arg1 :: <TQ3Param2D>, arg2 :: <TQ3Param2D>, arg3 :: <TQ3Vector2D>)
 => (result :: <TQ3Vector2D>);
  let result-value
    = anonymous-185(arg1, arg2, arg3);
  values(result-value);
end method Q3Param2D-Subtract;

define constant anonymous-186
  = constrain-c-function(find-c-function("Q3Point3D_Subtract", file: anonymous-168), #(), #t, list(<TQ3Vector3D>));
define method Q3Point3D-Subtract
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3Point3D>, arg3 :: <TQ3Vector3D>)
 => (result :: <TQ3Vector3D>);
  let result-value
    = anonymous-186(arg1, arg2, arg3);
  values(result-value);
end method Q3Point3D-Subtract;

define constant anonymous-187
  = constrain-c-function(find-c-function("Q3Point2D_Distance", file: anonymous-168), #(), #t, list(<float>));
define method Q3Point2D-Distance
    (arg1 :: <TQ3Point2D>, arg2 :: <TQ3Point2D>)
 => (result :: <float>);
  let result-value
    = anonymous-187(arg1, arg2);
  values(result-value);
end method Q3Point2D-Distance;

define constant anonymous-188
  = constrain-c-function(find-c-function("Q3Point2D_DistanceSquared", file: anonymous-168), #(), #t, list(<float>));
define method Q3Point2D-DistanceSquared
    (arg1 :: <TQ3Point2D>, arg2 :: <TQ3Point2D>)
 => (result :: <float>);
  let result-value
    = anonymous-188(arg1, arg2);
  values(result-value);
end method Q3Point2D-DistanceSquared;

define constant anonymous-189
  = constrain-c-function(find-c-function("Q3Param2D_Distance", file: anonymous-168), #(), #t, list(<float>));
define method Q3Param2D-Distance
    (arg1 :: <TQ3Param2D>, arg2 :: <TQ3Param2D>)
 => (result :: <float>);
  let result-value
    = anonymous-189(arg1, arg2);
  values(result-value);
end method Q3Param2D-Distance;

define constant anonymous-190
  = constrain-c-function(find-c-function("Q3Param2D_DistanceSquared", file: anonymous-168), #(), #t, list(<float>));
define method Q3Param2D-DistanceSquared
    (arg1 :: <TQ3Param2D>, arg2 :: <TQ3Param2D>)
 => (result :: <float>);
  let result-value
    = anonymous-190(arg1, arg2);
  values(result-value);
end method Q3Param2D-DistanceSquared;

define constant anonymous-191
  = constrain-c-function(find-c-function("Q3RationalPoint3D_Distance", file: anonymous-168), #(), #t, list(<float>));
define method Q3RationalPoint3D-Distance
    (arg1 :: <TQ3RationalPoint3D>, arg2 :: <TQ3RationalPoint3D>)
 => (result :: <float>);
  let result-value
    = anonymous-191(arg1, arg2);
  values(result-value);
end method Q3RationalPoint3D-Distance;

define constant anonymous-192
  = constrain-c-function(find-c-function("Q3RationalPoint3D_DistanceSquared", file: anonymous-168), #(), #t, list(<float>));
define method Q3RationalPoint3D-DistanceSquared
    (arg1 :: <TQ3RationalPoint3D>, arg2 :: <TQ3RationalPoint3D>)
 => (result :: <float>);
  let result-value
    = anonymous-192(arg1, arg2);
  values(result-value);
end method Q3RationalPoint3D-DistanceSquared;

define constant anonymous-193
  = constrain-c-function(find-c-function("Q3Point3D_Distance", file: anonymous-168), #(), #t, list(<float>));
define method Q3Point3D-Distance
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3Point3D>)
 => (result :: <float>);
  let result-value
    = anonymous-193(arg1, arg2);
  values(result-value);
end method Q3Point3D-Distance;

define constant anonymous-194
  = constrain-c-function(find-c-function("Q3Point3D_DistanceSquared", file: anonymous-168), #(), #t, list(<float>));
define method Q3Point3D-DistanceSquared
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3Point3D>)
 => (result :: <float>);
  let result-value
    = anonymous-194(arg1, arg2);
  values(result-value);
end method Q3Point3D-DistanceSquared;

define constant anonymous-195
  = constrain-c-function(find-c-function("Q3RationalPoint4D_Distance", file: anonymous-168), #(), #t, list(<float>));
define method Q3RationalPoint4D-Distance
    (arg1 :: <TQ3RationalPoint4D>, arg2 :: <TQ3RationalPoint4D>)
 => (result :: <float>);
  let result-value
    = anonymous-195(arg1, arg2);
  values(result-value);
end method Q3RationalPoint4D-Distance;

define constant anonymous-196
  = constrain-c-function(find-c-function("Q3RationalPoint4D_DistanceSquared", file: anonymous-168), #(), #t, list(<float>));
define method Q3RationalPoint4D-DistanceSquared
    (arg1 :: <TQ3RationalPoint4D>, arg2 :: <TQ3RationalPoint4D>)
 => (result :: <float>);
  let result-value
    = anonymous-196(arg1, arg2);
  values(result-value);
end method Q3RationalPoint4D-DistanceSquared;

define constant anonymous-197
  = constrain-c-function(find-c-function("Q3Point2D_RRatio", file: anonymous-168), #(), #t, list(<TQ3Point2D>));
define method Q3Point2D-RRatio
    (arg1 :: <TQ3Point2D>, arg2 :: <TQ3Point2D>, arg3 :: <float>, arg4 :: <float>, arg5 :: <TQ3Point2D>)
 => (result :: <TQ3Point2D>);
  let result-value
    = anonymous-197(arg1, arg2, arg3, arg4, arg5);
  values(result-value);
end method Q3Point2D-RRatio;

define constant anonymous-198
  = constrain-c-function(find-c-function("Q3Param2D_RRatio", file: anonymous-168), #(), #t, list(<TQ3Param2D>));
define method Q3Param2D-RRatio
    (arg1 :: <TQ3Param2D>, arg2 :: <TQ3Param2D>, arg3 :: <float>, arg4 :: <float>, arg5 :: <TQ3Param2D>)
 => (result :: <TQ3Param2D>);
  let result-value
    = anonymous-198(arg1, arg2, arg3, arg4, arg5);
  values(result-value);
end method Q3Param2D-RRatio;

define constant anonymous-199
  = constrain-c-function(find-c-function("Q3Point3D_RRatio", file: anonymous-168), #(), #t, list(<TQ3Point3D>));
define method Q3Point3D-RRatio
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3Point3D>, arg3 :: <float>, arg4 :: <float>, arg5 :: <TQ3Point3D>)
 => (result :: <TQ3Point3D>);
  let result-value
    = anonymous-199(arg1, arg2, arg3, arg4, arg5);
  values(result-value);
end method Q3Point3D-RRatio;

define constant anonymous-200
  = constrain-c-function(find-c-function("Q3RationalPoint4D_RRatio", file: anonymous-168), #(), #t, list(<TQ3RationalPoint4D>));
define method Q3RationalPoint4D-RRatio
    (arg1 :: <TQ3RationalPoint4D>, arg2 :: <TQ3RationalPoint4D>, arg3 :: <float>, arg4 :: <float>, arg5 :: <TQ3RationalPoint4D>)
 => (result :: <TQ3RationalPoint4D>);
  let result-value
    = anonymous-200(arg1, arg2, arg3, arg4, arg5);
  values(result-value);
end method Q3RationalPoint4D-RRatio;

define constant anonymous-201
  = constrain-c-function(find-c-function("Q3Point2D_Vector2D_Add", file: anonymous-168), #(), #t, list(<TQ3Point2D>));
define method Q3Point2D-Vector2D-Add
    (arg1 :: <TQ3Point2D>, arg2 :: <TQ3Vector2D>, arg3 :: <TQ3Point2D>)
 => (result :: <TQ3Point2D>);
  let result-value
    = anonymous-201(arg1, arg2, arg3);
  values(result-value);
end method Q3Point2D-Vector2D-Add;

define constant anonymous-202
  = constrain-c-function(find-c-function("Q3Param2D_Vector2D_Add", file: anonymous-168), #(), #t, list(<TQ3Param2D>));
define method Q3Param2D-Vector2D-Add
    (arg1 :: <TQ3Param2D>, arg2 :: <TQ3Vector2D>, arg3 :: <TQ3Param2D>)
 => (result :: <TQ3Param2D>);
  let result-value
    = anonymous-202(arg1, arg2, arg3);
  values(result-value);
end method Q3Param2D-Vector2D-Add;

define constant anonymous-203
  = constrain-c-function(find-c-function("Q3Point3D_Vector3D_Add", file: anonymous-168), #(), #t, list(<TQ3Point3D>));
define method Q3Point3D-Vector3D-Add
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3Vector3D>, arg3 :: <TQ3Point3D>)
 => (result :: <TQ3Point3D>);
  let result-value
    = anonymous-203(arg1, arg2, arg3);
  values(result-value);
end method Q3Point3D-Vector3D-Add;

define constant anonymous-204
  = constrain-c-function(find-c-function("Q3Point2D_Vector2D_Subtract", file: anonymous-168), #(), #t, list(<TQ3Point2D>));
define method Q3Point2D-Vector2D-Subtract
    (arg1 :: <TQ3Point2D>, arg2 :: <TQ3Vector2D>, arg3 :: <TQ3Point2D>)
 => (result :: <TQ3Point2D>);
  let result-value
    = anonymous-204(arg1, arg2, arg3);
  values(result-value);
end method Q3Point2D-Vector2D-Subtract;

define constant anonymous-205
  = constrain-c-function(find-c-function("Q3Param2D_Vector2D_Subtract", file: anonymous-168), #(), #t, list(<TQ3Param2D>));
define method Q3Param2D-Vector2D-Subtract
    (arg1 :: <TQ3Param2D>, arg2 :: <TQ3Vector2D>, arg3 :: <TQ3Param2D>)
 => (result :: <TQ3Param2D>);
  let result-value
    = anonymous-205(arg1, arg2, arg3);
  values(result-value);
end method Q3Param2D-Vector2D-Subtract;

define constant anonymous-206
  = constrain-c-function(find-c-function("Q3Point3D_Vector3D_Subtract", file: anonymous-168), #(), #t, list(<TQ3Point3D>));
define method Q3Point3D-Vector3D-Subtract
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3Vector3D>, arg3 :: <TQ3Point3D>)
 => (result :: <TQ3Point3D>);
  let result-value
    = anonymous-206(arg1, arg2, arg3);
  values(result-value);
end method Q3Point3D-Vector3D-Subtract;

define constant anonymous-207
  = constrain-c-function(find-c-function("Q3Vector2D_Scale", file: anonymous-168), #(), #t, list(<TQ3Vector2D>));
define method Q3Vector2D-Scale
    (arg1 :: <TQ3Vector2D>, arg2 :: <float>, arg3 :: <TQ3Vector2D>)
 => (result :: <TQ3Vector2D>);
  let result-value
    = anonymous-207(arg1, arg2, arg3);
  values(result-value);
end method Q3Vector2D-Scale;

define constant anonymous-208
  = constrain-c-function(find-c-function("Q3Vector3D_Scale", file: anonymous-168), #(), #t, list(<TQ3Vector3D>));
define method Q3Vector3D-Scale
    (arg1 :: <TQ3Vector3D>, arg2 :: <float>, arg3 :: <TQ3Vector3D>)
 => (result :: <TQ3Vector3D>);
  let result-value
    = anonymous-208(arg1, arg2, arg3);
  values(result-value);
end method Q3Vector3D-Scale;

define constant anonymous-209
  = constrain-c-function(find-c-function("Q3Vector2D_Length", file: anonymous-168), #(), #t, list(<float>));
define method Q3Vector2D-Length
    (arg1 :: <TQ3Vector2D>)
 => (result :: <float>);
  let result-value
    = anonymous-209(arg1);
  values(result-value);
end method Q3Vector2D-Length;

define constant anonymous-210
  = constrain-c-function(find-c-function("Q3Vector3D_Length", file: anonymous-168), #(), #t, list(<float>));
define method Q3Vector3D-Length
    (arg1 :: <TQ3Vector3D>)
 => (result :: <float>);
  let result-value
    = anonymous-210(arg1);
  values(result-value);
end method Q3Vector3D-Length;

define constant anonymous-211
  = constrain-c-function(find-c-function("Q3Vector2D_Normalize", file: anonymous-168), #(), #t, list(<TQ3Vector2D>));
define method Q3Vector2D-Normalize
    (arg1 :: <TQ3Vector2D>, arg2 :: <TQ3Vector2D>)
 => (result :: <TQ3Vector2D>);
  let result-value
    = anonymous-211(arg1, arg2);
  values(result-value);
end method Q3Vector2D-Normalize;

define constant anonymous-212
  = constrain-c-function(find-c-function("Q3Vector3D_Normalize", file: anonymous-168), #(), #t, list(<TQ3Vector3D>));
define method Q3Vector3D-Normalize
    (arg1 :: <TQ3Vector3D>, arg2 :: <TQ3Vector3D>)
 => (result :: <TQ3Vector3D>);
  let result-value
    = anonymous-212(arg1, arg2);
  values(result-value);
end method Q3Vector3D-Normalize;

define constant anonymous-213
  = constrain-c-function(find-c-function("Q3Vector2D_Add", file: anonymous-168), #(), #t, list(<TQ3Vector2D>));
define method Q3Vector2D-Add
    (arg1 :: <TQ3Vector2D>, arg2 :: <TQ3Vector2D>, arg3 :: <TQ3Vector2D>)
 => (result :: <TQ3Vector2D>);
  let result-value
    = anonymous-213(arg1, arg2, arg3);
  values(result-value);
end method Q3Vector2D-Add;

define constant anonymous-214
  = constrain-c-function(find-c-function("Q3Vector3D_Add", file: anonymous-168), #(), #t, list(<TQ3Vector3D>));
define method Q3Vector3D-Add
    (arg1 :: <TQ3Vector3D>, arg2 :: <TQ3Vector3D>, arg3 :: <TQ3Vector3D>)
 => (result :: <TQ3Vector3D>);
  let result-value
    = anonymous-214(arg1, arg2, arg3);
  values(result-value);
end method Q3Vector3D-Add;

define constant anonymous-215
  = constrain-c-function(find-c-function("Q3Vector2D_Subtract", file: anonymous-168), #(), #t, list(<TQ3Vector2D>));
define method Q3Vector2D-Subtract
    (arg1 :: <TQ3Vector2D>, arg2 :: <TQ3Vector2D>, arg3 :: <TQ3Vector2D>)
 => (result :: <TQ3Vector2D>);
  let result-value
    = anonymous-215(arg1, arg2, arg3);
  values(result-value);
end method Q3Vector2D-Subtract;

define constant anonymous-216
  = constrain-c-function(find-c-function("Q3Vector3D_Subtract", file: anonymous-168), #(), #t, list(<TQ3Vector3D>));
define method Q3Vector3D-Subtract
    (arg1 :: <TQ3Vector3D>, arg2 :: <TQ3Vector3D>, arg3 :: <TQ3Vector3D>)
 => (result :: <TQ3Vector3D>);
  let result-value
    = anonymous-216(arg1, arg2, arg3);
  values(result-value);
end method Q3Vector3D-Subtract;

define constant anonymous-217
  = constrain-c-function(find-c-function("Q3Vector2D_Cross", file: anonymous-168), #(), #t, list(<float>));
define method Q3Vector2D-Cross
    (arg1 :: <TQ3Vector2D>, arg2 :: <TQ3Vector2D>)
 => (result :: <float>);
  let result-value
    = anonymous-217(arg1, arg2);
  values(result-value);
end method Q3Vector2D-Cross;

define constant anonymous-218
  = constrain-c-function(find-c-function("Q3Vector3D_Cross", file: anonymous-168), #(), #t, list(<TQ3Vector3D>));
define method Q3Vector3D-Cross
    (arg1 :: <TQ3Vector3D>, arg2 :: <TQ3Vector3D>, arg3 :: <TQ3Vector3D>)
 => (result :: <TQ3Vector3D>);
  let result-value
    = anonymous-218(arg1, arg2, arg3);
  values(result-value);
end method Q3Vector3D-Cross;

define constant anonymous-219
  = constrain-c-function(find-c-function("Q3Point3D_CrossProductTri", file: anonymous-168), #(), #t, list(<TQ3Vector3D>));
define method Q3Point3D-CrossProductTri
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3Point3D>, arg3 :: <TQ3Point3D>, arg4 :: <TQ3Vector3D>)
 => (result :: <TQ3Vector3D>);
  let result-value
    = anonymous-219(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Point3D-CrossProductTri;

define constant anonymous-220
  = constrain-c-function(find-c-function("Q3Vector2D_Dot", file: anonymous-168), #(), #t, list(<float>));
define method Q3Vector2D-Dot
    (arg1 :: <TQ3Vector2D>, arg2 :: <TQ3Vector2D>)
 => (result :: <float>);
  let result-value
    = anonymous-220(arg1, arg2);
  values(result-value);
end method Q3Vector2D-Dot;

define constant anonymous-221
  = constrain-c-function(find-c-function("Q3Vector3D_Dot", file: anonymous-168), #(), #t, list(<float>));
define method Q3Vector3D-Dot
    (arg1 :: <TQ3Vector3D>, arg2 :: <TQ3Vector3D>)
 => (result :: <float>);
  let result-value
    = anonymous-221(arg1, arg2);
  values(result-value);
end method Q3Vector3D-Dot;

define constant <anonymous-1> = <float-vector>;

define constant <anonymous-3> = <anonymous-1>;

define constant anonymous-222
  = constrain-c-function(find-c-function("Q3Vector2D_Transform", file: anonymous-168), #(), #t, list(<TQ3Vector2D>));
define method Q3Vector2D-Transform
    (arg1 :: <TQ3Vector2D>, arg2 :: <TQ3Matrix3x3>, arg3 :: <TQ3Vector2D>)
 => (result :: <TQ3Vector2D>);
  let result-value
    = anonymous-222(arg1, arg2, arg3);
  values(result-value);
end method Q3Vector2D-Transform;

define constant <anonymous-4> = <float-vector>;

define constant <anonymous-5> = <anonymous-4>;

define constant anonymous-223
  = constrain-c-function(find-c-function("Q3Vector3D_Transform", file: anonymous-168), #(), #t, list(<TQ3Vector3D>));
define method Q3Vector3D-Transform
    (arg1 :: <TQ3Vector3D>, arg2 :: <TQ3Matrix4x4>, arg3 :: <TQ3Vector3D>)
 => (result :: <TQ3Vector3D>);
  let result-value
    = anonymous-223(arg1, arg2, arg3);
  values(result-value);
end method Q3Vector3D-Transform;

define constant anonymous-224
  = constrain-c-function(find-c-function("Q3Point2D_Transform", file: anonymous-168), #(), #t, list(<TQ3Point2D>));
define method Q3Point2D-Transform
    (arg1 :: <TQ3Point2D>, arg2 :: <TQ3Matrix3x3>, arg3 :: <TQ3Point2D>)
 => (result :: <TQ3Point2D>);
  let result-value
    = anonymous-224(arg1, arg2, arg3);
  values(result-value);
end method Q3Point2D-Transform;

define constant anonymous-225
  = constrain-c-function(find-c-function("Q3Param2D_Transform", file: anonymous-168), #(), #t, list(<TQ3Param2D>));
define method Q3Param2D-Transform
    (arg1 :: <TQ3Param2D>, arg2 :: <TQ3Matrix3x3>, arg3 :: <TQ3Param2D>)
 => (result :: <TQ3Param2D>);
  let result-value
    = anonymous-225(arg1, arg2, arg3);
  values(result-value);
end method Q3Param2D-Transform;

define constant anonymous-226
  = constrain-c-function(find-c-function("Q3Point3D_Transform", file: anonymous-168), #(), #t, list(<TQ3Point3D>));
define method Q3Point3D-Transform
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3Matrix4x4>, arg3 :: <TQ3Point3D>)
 => (result :: <TQ3Point3D>);
  let result-value
    = anonymous-226(arg1, arg2, arg3);
  values(result-value);
end method Q3Point3D-Transform;

define constant anonymous-227
  = constrain-c-function(find-c-function("Q3RationalPoint4D_Transform", file: anonymous-168), #(), #t, list(<TQ3RationalPoint4D>));
define method Q3RationalPoint4D-Transform
    (arg1 :: <TQ3RationalPoint4D>, arg2 :: <TQ3Matrix4x4>, arg3 :: <TQ3RationalPoint4D>)
 => (result :: <TQ3RationalPoint4D>);
  let result-value
    = anonymous-227(arg1, arg2, arg3);
  values(result-value);
end method Q3RationalPoint4D-Transform;

define constant anonymous-228
  = constrain-c-function(find-c-function("Q3Point3D_To3DTransformArray", file: anonymous-168), #(), #t, list(<TQ3Status>));
define method Q3Point3D-To3DTransformArray
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3Matrix4x4>, arg3 :: <TQ3Point3D>, arg4 :: <integer>, arg5 :: <integer>, arg6 :: <integer>)
 => (result :: <TQ3Status>);
  let result-value
    = anonymous-228(arg1, arg2, arg3, arg4, arg5, arg6);
  values(result-value);
end method Q3Point3D-To3DTransformArray;

define constant anonymous-229
  = constrain-c-function(find-c-function("Q3Point3D_To4DTransformArray", file: anonymous-168), #(), #t, list(<TQ3Status>));
define method Q3Point3D-To4DTransformArray
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3Matrix4x4>, arg3 :: <TQ3RationalPoint4D>, arg4 :: <integer>, arg5 :: <integer>, arg6 :: <integer>)
 => (result :: <TQ3Status>);
  let result-value
    = anonymous-229(arg1, arg2, arg3, arg4, arg5, arg6);
  values(result-value);
end method Q3Point3D-To4DTransformArray;

define constant anonymous-230
  = constrain-c-function(find-c-function("Q3RationalPoint4D_To4DTransformArray", file: anonymous-168), #(), #t, list(<TQ3Status>));
define method Q3RationalPoint4D-To4DTransformArray
    (arg1 :: <TQ3RationalPoint4D>, arg2 :: <TQ3Matrix4x4>, arg3 :: <TQ3RationalPoint4D>, arg4 :: <integer>, arg5 :: <integer>, arg6 :: <integer>)
 => (result :: <TQ3Status>);
  let result-value
    = anonymous-230(arg1, arg2, arg3, arg4, arg5, arg6);
  values(result-value);
end method Q3RationalPoint4D-To4DTransformArray;

define constant anonymous-231
  = constrain-c-function(find-c-function("Q3Vector2D_Negate", file: anonymous-168), #(), #t, list(<TQ3Vector2D>));
define method Q3Vector2D-Negate
    (arg1 :: <TQ3Vector2D>, arg2 :: <TQ3Vector2D>)
 => (result :: <TQ3Vector2D>);
  let result-value
    = anonymous-231(arg1, arg2);
  values(result-value);
end method Q3Vector2D-Negate;

define constant anonymous-232
  = constrain-c-function(find-c-function("Q3Vector3D_Negate", file: anonymous-168), #(), #t, list(<TQ3Vector3D>));
define method Q3Vector3D-Negate
    (arg1 :: <TQ3Vector3D>, arg2 :: <TQ3Vector3D>)
 => (result :: <TQ3Vector3D>);
  let result-value
    = anonymous-232(arg1, arg2);
  values(result-value);
end method Q3Vector3D-Negate;

define constant anonymous-233
  = constrain-c-function(find-c-function("Q3Point2D_ToPolar", file: anonymous-168), #(), #t, list(<TQ3PolarPoint>));
define method Q3Point2D-ToPolar
    (arg1 :: <TQ3Point2D>, arg2 :: <TQ3PolarPoint>)
 => (result :: <TQ3PolarPoint>);
  let result-value
    = anonymous-233(arg1, arg2);
  values(result-value);
end method Q3Point2D-ToPolar;

define constant anonymous-234
  = constrain-c-function(find-c-function("Q3PolarPoint_ToPoint2D", file: anonymous-168), #(), #t, list(<TQ3Point2D>));
define method Q3PolarPoint-ToPoint2D
    (arg1 :: <TQ3PolarPoint>, arg2 :: <TQ3Point2D>)
 => (result :: <TQ3Point2D>);
  let result-value
    = anonymous-234(arg1, arg2);
  values(result-value);
end method Q3PolarPoint-ToPoint2D;

define constant anonymous-235
  = constrain-c-function(find-c-function("Q3Point3D_ToSpherical", file: anonymous-168), #(), #t, list(<TQ3SphericalPoint>));
define method Q3Point3D-ToSpherical
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3SphericalPoint>)
 => (result :: <TQ3SphericalPoint>);
  let result-value
    = anonymous-235(arg1, arg2);
  values(result-value);
end method Q3Point3D-ToSpherical;

define constant anonymous-236
  = constrain-c-function(find-c-function("Q3SphericalPoint_ToPoint3D", file: anonymous-168), #(), #t, list(<TQ3Point3D>));
define method Q3SphericalPoint-ToPoint3D
    (arg1 :: <TQ3SphericalPoint>, arg2 :: <TQ3Point3D>)
 => (result :: <TQ3Point3D>);
  let result-value
    = anonymous-236(arg1, arg2);
  values(result-value);
end method Q3SphericalPoint-ToPoint3D;

define constant anonymous-237
  = constrain-c-function(find-c-function("Q3Point2D_AffineComb", file: anonymous-168), #(), #t, list(<TQ3Point2D>));
define method Q3Point2D-AffineComb
    (arg1 :: <TQ3Point2D>, arg2 :: <float-vector>, arg3 :: <integer>, arg4 :: <TQ3Point2D>)
 => (result :: <TQ3Point2D>);
  let result-value
    = anonymous-237(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Point2D-AffineComb;

define constant anonymous-238
  = constrain-c-function(find-c-function("Q3Param2D_AffineComb", file: anonymous-168), #(), #t, list(<TQ3Param2D>));
define method Q3Param2D-AffineComb
    (arg1 :: <TQ3Param2D>, arg2 :: <float-vector>, arg3 :: <integer>, arg4 :: <TQ3Param2D>)
 => (result :: <TQ3Param2D>);
  let result-value
    = anonymous-238(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Param2D-AffineComb;

define constant anonymous-239
  = constrain-c-function(find-c-function("Q3RationalPoint3D_AffineComb", file: anonymous-168), #(), #t, list(<TQ3RationalPoint3D>));
define method Q3RationalPoint3D-AffineComb
    (arg1 :: <TQ3RationalPoint3D>, arg2 :: <float-vector>, arg3 :: <integer>, arg4 :: <TQ3RationalPoint3D>)
 => (result :: <TQ3RationalPoint3D>);
  let result-value
    = anonymous-239(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3RationalPoint3D-AffineComb;

define constant anonymous-240
  = constrain-c-function(find-c-function("Q3Point3D_AffineComb", file: anonymous-168), #(), #t, list(<TQ3Point3D>));
define method Q3Point3D-AffineComb
    (arg1 :: <TQ3Point3D>, arg2 :: <float-vector>, arg3 :: <integer>, arg4 :: <TQ3Point3D>)
 => (result :: <TQ3Point3D>);
  let result-value
    = anonymous-240(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Point3D-AffineComb;

define constant anonymous-241
  = constrain-c-function(find-c-function("Q3RationalPoint4D_AffineComb", file: anonymous-168), #(), #t, list(<TQ3RationalPoint4D>));
define method Q3RationalPoint4D-AffineComb
    (arg1 :: <TQ3RationalPoint4D>, arg2 :: <float-vector>, arg3 :: <integer>, arg4 :: <TQ3RationalPoint4D>)
 => (result :: <TQ3RationalPoint4D>);
  let result-value
    = anonymous-241(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3RationalPoint4D-AffineComb;

define constant anonymous-242
  = constrain-c-function(find-c-function("Q3Matrix3x3_Copy", file: anonymous-168), #(), #t, list(<TQ3Matrix3x3>));
define method Q3Matrix3x3-Copy
    (arg1 :: <TQ3Matrix3x3>, arg2 :: <TQ3Matrix3x3>)
 => (result :: <TQ3Matrix3x3>);
  let result-value
    = anonymous-242(arg1, arg2);
  values(result-value);
end method Q3Matrix3x3-Copy;

define constant anonymous-243
  = constrain-c-function(find-c-function("Q3Matrix4x4_Copy", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-Copy
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <TQ3Matrix4x4>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-243(arg1, arg2);
  values(result-value);
end method Q3Matrix4x4-Copy;

define constant anonymous-244
  = constrain-c-function(find-c-function("Q3Matrix3x3_SetIdentity", file: anonymous-168), #(), #t, list(<TQ3Matrix3x3>));
define method Q3Matrix3x3-SetIdentity
    (arg1 :: <TQ3Matrix3x3>)
 => (result :: <TQ3Matrix3x3>);
  let result-value
    = anonymous-244(arg1);
  values(result-value);
end method Q3Matrix3x3-SetIdentity;

define constant anonymous-245
  = constrain-c-function(find-c-function("Q3Matrix4x4_SetIdentity", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-SetIdentity
    (arg1 :: <TQ3Matrix4x4>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-245(arg1);
  values(result-value);
end method Q3Matrix4x4-SetIdentity;

define constant anonymous-246
  = constrain-c-function(find-c-function("Q3Matrix3x3_Transpose", file: anonymous-168), #(), #t, list(<TQ3Matrix3x3>));
define method Q3Matrix3x3-Transpose
    (arg1 :: <TQ3Matrix3x3>, arg2 :: <TQ3Matrix3x3>)
 => (result :: <TQ3Matrix3x3>);
  let result-value
    = anonymous-246(arg1, arg2);
  values(result-value);
end method Q3Matrix3x3-Transpose;

define constant anonymous-247
  = constrain-c-function(find-c-function("Q3Matrix4x4_Transpose", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-Transpose
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <TQ3Matrix4x4>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-247(arg1, arg2);
  values(result-value);
end method Q3Matrix4x4-Transpose;

define constant anonymous-248
  = constrain-c-function(find-c-function("Q3Matrix3x3_Invert", file: anonymous-168), #(), #t, list(<TQ3Matrix3x3>));
define method Q3Matrix3x3-Invert
    (arg1 :: <TQ3Matrix3x3>, arg2 :: <TQ3Matrix3x3>)
 => (result :: <TQ3Matrix3x3>);
  let result-value
    = anonymous-248(arg1, arg2);
  values(result-value);
end method Q3Matrix3x3-Invert;

define constant anonymous-249
  = constrain-c-function(find-c-function("Q3Matrix4x4_Invert", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-Invert
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <TQ3Matrix4x4>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-249(arg1, arg2);
  values(result-value);
end method Q3Matrix4x4-Invert;

define constant anonymous-250
  = constrain-c-function(find-c-function("Q3Matrix3x3_Adjoint", file: anonymous-168), #(), #t, list(<TQ3Matrix3x3>));
define method Q3Matrix3x3-Adjoint
    (arg1 :: <TQ3Matrix3x3>, arg2 :: <TQ3Matrix3x3>)
 => (result :: <TQ3Matrix3x3>);
  let result-value
    = anonymous-250(arg1, arg2);
  values(result-value);
end method Q3Matrix3x3-Adjoint;

define constant anonymous-251
  = constrain-c-function(find-c-function("Q3Matrix3x3_Multiply", file: anonymous-168), #(), #t, list(<TQ3Matrix3x3>));
define method Q3Matrix3x3-Multiply
    (arg1 :: <TQ3Matrix3x3>, arg2 :: <TQ3Matrix3x3>, arg3 :: <TQ3Matrix3x3>)
 => (result :: <TQ3Matrix3x3>);
  let result-value
    = anonymous-251(arg1, arg2, arg3);
  values(result-value);
end method Q3Matrix3x3-Multiply;

define constant anonymous-252
  = constrain-c-function(find-c-function("Q3Matrix4x4_Multiply", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-Multiply
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <TQ3Matrix4x4>, arg3 :: <TQ3Matrix4x4>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-252(arg1, arg2, arg3);
  values(result-value);
end method Q3Matrix4x4-Multiply;

define constant anonymous-253
  = constrain-c-function(find-c-function("Q3Matrix3x3_SetTranslate", file: anonymous-168), #(), #t, list(<TQ3Matrix3x3>));
define method Q3Matrix3x3-SetTranslate
    (arg1 :: <TQ3Matrix3x3>, arg2 :: <float>, arg3 :: <float>)
 => (result :: <TQ3Matrix3x3>);
  let result-value
    = anonymous-253(arg1, arg2, arg3);
  values(result-value);
end method Q3Matrix3x3-SetTranslate;

define constant anonymous-254
  = constrain-c-function(find-c-function("Q3Matrix3x3_SetScale", file: anonymous-168), #(), #t, list(<TQ3Matrix3x3>));
define method Q3Matrix3x3-SetScale
    (arg1 :: <TQ3Matrix3x3>, arg2 :: <float>, arg3 :: <float>)
 => (result :: <TQ3Matrix3x3>);
  let result-value
    = anonymous-254(arg1, arg2, arg3);
  values(result-value);
end method Q3Matrix3x3-SetScale;

define constant anonymous-255
  = constrain-c-function(find-c-function("Q3Matrix3x3_SetRotateAboutPoint", file: anonymous-168), #(), #t, list(<TQ3Matrix3x3>));
define method Q3Matrix3x3-SetRotateAboutPoint
    (arg1 :: <TQ3Matrix3x3>, arg2 :: <TQ3Point2D>, arg3 :: <float>)
 => (result :: <TQ3Matrix3x3>);
  let result-value
    = anonymous-255(arg1, arg2, arg3);
  values(result-value);
end method Q3Matrix3x3-SetRotateAboutPoint;

define constant anonymous-256
  = constrain-c-function(find-c-function("Q3Matrix4x4_SetTranslate", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-SetTranslate
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <float>, arg3 :: <float>, arg4 :: <float>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-256(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Matrix4x4-SetTranslate;

define constant anonymous-257
  = constrain-c-function(find-c-function("Q3Matrix4x4_SetScale", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-SetScale
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <float>, arg3 :: <float>, arg4 :: <float>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-257(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Matrix4x4-SetScale;

define constant anonymous-258
  = constrain-c-function(find-c-function("Q3Matrix4x4_SetRotateAboutPoint", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-SetRotateAboutPoint
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <TQ3Point3D>, arg3 :: <float>, arg4 :: <float>, arg5 :: <float>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-258(arg1, arg2, arg3, arg4, arg5);
  values(result-value);
end method Q3Matrix4x4-SetRotateAboutPoint;

define constant anonymous-259
  = constrain-c-function(find-c-function("Q3Matrix4x4_SetRotateAboutAxis", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-SetRotateAboutAxis
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <TQ3Point3D>, arg3 :: <TQ3Vector3D>, arg4 :: <float>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-259(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Matrix4x4-SetRotateAboutAxis;

define constant anonymous-260
  = constrain-c-function(find-c-function("Q3Matrix4x4_SetRotate_X", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-SetRotate-X
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <float>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-260(arg1, arg2);
  values(result-value);
end method Q3Matrix4x4-SetRotate-X;

define constant anonymous-261
  = constrain-c-function(find-c-function("Q3Matrix4x4_SetRotate_Y", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-SetRotate-Y
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <float>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-261(arg1, arg2);
  values(result-value);
end method Q3Matrix4x4-SetRotate-Y;

define constant anonymous-262
  = constrain-c-function(find-c-function("Q3Matrix4x4_SetRotate_Z", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-SetRotate-Z
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <float>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-262(arg1, arg2);
  values(result-value);
end method Q3Matrix4x4-SetRotate-Z;

define constant anonymous-263
  = constrain-c-function(find-c-function("Q3Matrix4x4_SetRotate_XYZ", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-SetRotate-XYZ
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <float>, arg3 :: <float>, arg4 :: <float>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-263(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Matrix4x4-SetRotate-XYZ;

define constant anonymous-264
  = constrain-c-function(find-c-function("Q3Matrix4x4_SetRotateVectorToVector", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-SetRotateVectorToVector
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <TQ3Vector3D>, arg3 :: <TQ3Vector3D>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-264(arg1, arg2, arg3);
  values(result-value);
end method Q3Matrix4x4-SetRotateVectorToVector;

define constant anonymous-265
  = constrain-c-function(find-c-function("Q3Matrix4x4_SetQuaternion", file: anonymous-168), #(), #t, list(<TQ3Matrix4x4>));
define method Q3Matrix4x4-SetQuaternion
    (arg1 :: <TQ3Matrix4x4>, arg2 :: <TQ3Quaternion>)
 => (result :: <TQ3Matrix4x4>);
  let result-value
    = anonymous-265(arg1, arg2);
  values(result-value);
end method Q3Matrix4x4-SetQuaternion;

define constant anonymous-266
  = constrain-c-function(find-c-function("Q3Matrix3x3_Determinant", file: anonymous-168), #(), #t, list(<float>));
define method Q3Matrix3x3-Determinant
    (arg1 :: <TQ3Matrix3x3>)
 => (result :: <float>);
  let result-value
    = anonymous-266(arg1);
  values(result-value);
end method Q3Matrix3x3-Determinant;

define constant anonymous-267
  = constrain-c-function(find-c-function("Q3Matrix4x4_Determinant", file: anonymous-168), #(), #t, list(<float>));
define method Q3Matrix4x4-Determinant
    (arg1 :: <TQ3Matrix4x4>)
 => (result :: <float>);
  let result-value
    = anonymous-267(arg1);
  values(result-value);
end method Q3Matrix4x4-Determinant;

define constant anonymous-268
  = constrain-c-function(find-c-function("Q3Quaternion_Set", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-Set
    (arg1 :: <TQ3Quaternion>, arg2 :: <float>, arg3 :: <float>, arg4 :: <float>, arg5 :: <float>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-268(arg1, arg2, arg3, arg4, arg5);
  values(result-value);
end method Q3Quaternion-Set;

define constant anonymous-269
  = constrain-c-function(find-c-function("Q3Quaternion_SetIdentity", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-SetIdentity
    (arg1 :: <TQ3Quaternion>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-269(arg1);
  values(result-value);
end method Q3Quaternion-SetIdentity;

define constant anonymous-270
  = constrain-c-function(find-c-function("Q3Quaternion_Copy", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-Copy
    (arg1 :: <TQ3Quaternion>, arg2 :: <TQ3Quaternion>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-270(arg1, arg2);
  values(result-value);
end method Q3Quaternion-Copy;

define constant <TQ3Boolean> = <boolean>;

define constant anonymous-271
  = constrain-c-function(find-c-function("Q3Quaternion_IsIdentity", file: anonymous-168), #(), #t, list(<TQ3Boolean>));
define method Q3Quaternion-IsIdentity
    (arg1 :: <TQ3Quaternion>)
 => (result :: <TQ3Boolean>);
  let result-value
    = anonymous-271(arg1);
  values(result-value);
end method Q3Quaternion-IsIdentity;

define constant anonymous-272
  = constrain-c-function(find-c-function("Q3Quaternion_Invert", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-Invert
    (arg1 :: <TQ3Quaternion>, arg2 :: <TQ3Quaternion>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-272(arg1, arg2);
  values(result-value);
end method Q3Quaternion-Invert;

define constant anonymous-273
  = constrain-c-function(find-c-function("Q3Quaternion_Normalize", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-Normalize
    (arg1 :: <TQ3Quaternion>, arg2 :: <TQ3Quaternion>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-273(arg1, arg2);
  values(result-value);
end method Q3Quaternion-Normalize;

define constant anonymous-274
  = constrain-c-function(find-c-function("Q3Quaternion_Dot", file: anonymous-168), #(), #t, list(<float>));
define method Q3Quaternion-Dot
    (arg1 :: <TQ3Quaternion>, arg2 :: <TQ3Quaternion>)
 => (result :: <float>);
  let result-value
    = anonymous-274(arg1, arg2);
  values(result-value);
end method Q3Quaternion-Dot;

define constant anonymous-275
  = constrain-c-function(find-c-function("Q3Quaternion_Multiply", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-Multiply
    (arg1 :: <TQ3Quaternion>, arg2 :: <TQ3Quaternion>, arg3 :: <TQ3Quaternion>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-275(arg1, arg2, arg3);
  values(result-value);
end method Q3Quaternion-Multiply;

define constant anonymous-276
  = constrain-c-function(find-c-function("Q3Quaternion_SetRotateAboutAxis", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-SetRotateAboutAxis
    (arg1 :: <TQ3Quaternion>, arg2 :: <TQ3Vector3D>, arg3 :: <float>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-276(arg1, arg2, arg3);
  values(result-value);
end method Q3Quaternion-SetRotateAboutAxis;

define constant anonymous-277
  = constrain-c-function(find-c-function("Q3Quaternion_SetRotateXYZ", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-SetRotateXYZ
    (arg1 :: <TQ3Quaternion>, arg2 :: <float>, arg3 :: <float>, arg4 :: <float>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-277(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Quaternion-SetRotateXYZ;

define constant anonymous-278
  = constrain-c-function(find-c-function("Q3Quaternion_SetRotateX", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-SetRotateX
    (arg1 :: <TQ3Quaternion>, arg2 :: <float>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-278(arg1, arg2);
  values(result-value);
end method Q3Quaternion-SetRotateX;

define constant anonymous-279
  = constrain-c-function(find-c-function("Q3Quaternion_SetRotateY", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-SetRotateY
    (arg1 :: <TQ3Quaternion>, arg2 :: <float>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-279(arg1, arg2);
  values(result-value);
end method Q3Quaternion-SetRotateY;

define constant anonymous-280
  = constrain-c-function(find-c-function("Q3Quaternion_SetRotateZ", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-SetRotateZ
    (arg1 :: <TQ3Quaternion>, arg2 :: <float>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-280(arg1, arg2);
  values(result-value);
end method Q3Quaternion-SetRotateZ;

define constant anonymous-281
  = constrain-c-function(find-c-function("Q3Quaternion_SetMatrix", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-SetMatrix
    (arg1 :: <TQ3Quaternion>, arg2 :: <TQ3Matrix4x4>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-281(arg1, arg2);
  values(result-value);
end method Q3Quaternion-SetMatrix;

define constant anonymous-282
  = constrain-c-function(find-c-function("Q3Quaternion_SetRotateVectorToVector", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-SetRotateVectorToVector
    (arg1 :: <TQ3Quaternion>, arg2 :: <TQ3Vector3D>, arg3 :: <TQ3Vector3D>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-282(arg1, arg2, arg3);
  values(result-value);
end method Q3Quaternion-SetRotateVectorToVector;

define constant anonymous-283
  = constrain-c-function(find-c-function("Q3Quaternion_MatchReflection", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-MatchReflection
    (arg1 :: <TQ3Quaternion>, arg2 :: <TQ3Quaternion>, arg3 :: <TQ3Quaternion>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-283(arg1, arg2, arg3);
  values(result-value);
end method Q3Quaternion-MatchReflection;

define constant anonymous-284
  = constrain-c-function(find-c-function("Q3Quaternion_InterpolateFast", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-InterpolateFast
    (arg1 :: <TQ3Quaternion>, arg2 :: <TQ3Quaternion>, arg3 :: <float>, arg4 :: <TQ3Quaternion>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-284(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Quaternion-InterpolateFast;

define constant anonymous-285
  = constrain-c-function(find-c-function("Q3Quaternion_InterpolateLinear", file: anonymous-168), #(), #t, list(<TQ3Quaternion>));
define method Q3Quaternion-InterpolateLinear
    (arg1 :: <TQ3Quaternion>, arg2 :: <TQ3Quaternion>, arg3 :: <float>, arg4 :: <TQ3Quaternion>)
 => (result :: <TQ3Quaternion>);
  let result-value
    = anonymous-285(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3Quaternion-InterpolateLinear;

define constant anonymous-286
  = constrain-c-function(find-c-function("Q3Vector3D_TransformQuaternion", file: anonymous-168), #(), #t, list(<TQ3Vector3D>));
define method Q3Vector3D-TransformQuaternion
    (arg1 :: <TQ3Vector3D>, arg2 :: <TQ3Quaternion>, arg3 :: <TQ3Vector3D>)
 => (result :: <TQ3Vector3D>);
  let result-value
    = anonymous-286(arg1, arg2, arg3);
  values(result-value);
end method Q3Vector3D-TransformQuaternion;

define constant anonymous-287
  = constrain-c-function(find-c-function("Q3Point3D_TransformQuaternion", file: anonymous-168), #(), #t, list(<TQ3Point3D>));
define method Q3Point3D-TransformQuaternion
    (arg1 :: <TQ3Point3D>, arg2 :: <TQ3Quaternion>, arg3 :: <TQ3Point3D>)
 => (result :: <TQ3Point3D>);
  let result-value
    = anonymous-287(arg1, arg2, arg3);
  values(result-value);
end method Q3Point3D-TransformQuaternion;

define constant anonymous-288
  = constrain-c-function(find-c-function("Q3BoundingBox_Copy", file: anonymous-168), #(), #t, list(<TQ3BoundingBox>));
define method Q3BoundingBox-Copy
    (arg1 :: <TQ3BoundingBox>, arg2 :: <TQ3BoundingBox>)
 => (result :: <TQ3BoundingBox>);
  let result-value
    = anonymous-288(arg1, arg2);
  values(result-value);
end method Q3BoundingBox-Copy;

define constant anonymous-289
  = constrain-c-function(find-c-function("Q3BoundingBox_Union", file: anonymous-168), #(), #t, list(<TQ3BoundingBox>));
define method Q3BoundingBox-Union
    (arg1 :: <TQ3BoundingBox>, arg2 :: <TQ3BoundingBox>, arg3 :: <TQ3BoundingBox>)
 => (result :: <TQ3BoundingBox>);
  let result-value
    = anonymous-289(arg1, arg2, arg3);
  values(result-value);
end method Q3BoundingBox-Union;

define constant anonymous-290
  = constrain-c-function(find-c-function("Q3BoundingBox_Set", file: anonymous-168), #(), #t, list(<TQ3BoundingBox>));
define method Q3BoundingBox-Set
    (arg1 :: <TQ3BoundingBox>, arg2 :: <TQ3Point3D>, arg3 :: <TQ3Point3D>, arg4 :: <TQ3Boolean>)
 => (result :: <TQ3BoundingBox>);
  let result-value
    = anonymous-290(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3BoundingBox-Set;

define constant anonymous-291
  = constrain-c-function(find-c-function("Q3BoundingBox_UnionPoint3D", file: anonymous-168), #(), #t, list(<TQ3BoundingBox>));
define method Q3BoundingBox-UnionPoint3D
    (arg1 :: <TQ3BoundingBox>, arg2 :: <TQ3Point3D>, arg3 :: <TQ3BoundingBox>)
 => (result :: <TQ3BoundingBox>);
  let result-value
    = anonymous-291(arg1, arg2, arg3);
  values(result-value);
end method Q3BoundingBox-UnionPoint3D;

define constant anonymous-292
  = constrain-c-function(find-c-function("Q3BoundingBox_UnionRationalPoint4D", file: anonymous-168), #(), #t, list(<TQ3BoundingBox>));
define method Q3BoundingBox-UnionRationalPoint4D
    (arg1 :: <TQ3BoundingBox>, arg2 :: <TQ3RationalPoint4D>, arg3 :: <TQ3BoundingBox>)
 => (result :: <TQ3BoundingBox>);
  let result-value
    = anonymous-292(arg1, arg2, arg3);
  values(result-value);
end method Q3BoundingBox-UnionRationalPoint4D;

define constant anonymous-293
  = constrain-c-function(find-c-function("Q3BoundingBox_SetFromPoints3D", file: anonymous-168), #(), #t, list(<TQ3BoundingBox>));
define method Q3BoundingBox-SetFromPoints3D
    (arg1 :: <TQ3BoundingBox>, arg2 :: <TQ3Point3D>, arg3 :: <integer>, arg4 :: <integer>)
 => (result :: <TQ3BoundingBox>);
  let result-value
    = anonymous-293(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3BoundingBox-SetFromPoints3D;

define constant anonymous-294
  = constrain-c-function(find-c-function("Q3BoundingBox_SetFromRationalPoints4D", file: anonymous-168), #(), #t, list(<TQ3BoundingBox>));
define method Q3BoundingBox-SetFromRationalPoints4D
    (arg1 :: <TQ3BoundingBox>, arg2 :: <TQ3RationalPoint4D>, arg3 :: <integer>, arg4 :: <integer>)
 => (result :: <TQ3BoundingBox>);
  let result-value
    = anonymous-294(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3BoundingBox-SetFromRationalPoints4D;

define constant anonymous-295
  = constrain-c-function(find-c-function("Q3BoundingSphere_Copy", file: anonymous-168), #(), #t, list(<TQ3BoundingSphere>));
define method Q3BoundingSphere-Copy
    (arg1 :: <TQ3BoundingSphere>, arg2 :: <TQ3BoundingSphere>)
 => (result :: <TQ3BoundingSphere>);
  let result-value
    = anonymous-295(arg1, arg2);
  values(result-value);
end method Q3BoundingSphere-Copy;

define constant anonymous-296
  = constrain-c-function(find-c-function("Q3BoundingSphere_Union", file: anonymous-168), #(), #t, list(<TQ3BoundingSphere>));
define method Q3BoundingSphere-Union
    (arg1 :: <TQ3BoundingSphere>, arg2 :: <TQ3BoundingSphere>, arg3 :: <TQ3BoundingSphere>)
 => (result :: <TQ3BoundingSphere>);
  let result-value
    = anonymous-296(arg1, arg2, arg3);
  values(result-value);
end method Q3BoundingSphere-Union;

define constant anonymous-297
  = constrain-c-function(find-c-function("Q3BoundingSphere_Set", file: anonymous-168), #(), #t, list(<TQ3BoundingSphere>));
define method Q3BoundingSphere-Set
    (arg1 :: <TQ3BoundingSphere>, arg2 :: <TQ3Point3D>, arg3 :: <float>, arg4 :: <TQ3Boolean>)
 => (result :: <TQ3BoundingSphere>);
  let result-value
    = anonymous-297(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3BoundingSphere-Set;

define constant anonymous-298
  = constrain-c-function(find-c-function("Q3BoundingSphere_UnionPoint3D", file: anonymous-168), #(), #t, list(<TQ3BoundingSphere>));
define method Q3BoundingSphere-UnionPoint3D
    (arg1 :: <TQ3BoundingSphere>, arg2 :: <TQ3Point3D>, arg3 :: <TQ3BoundingSphere>)
 => (result :: <TQ3BoundingSphere>);
  let result-value
    = anonymous-298(arg1, arg2, arg3);
  values(result-value);
end method Q3BoundingSphere-UnionPoint3D;

define constant anonymous-299
  = constrain-c-function(find-c-function("Q3BoundingSphere_UnionRationalPoint4D", file: anonymous-168), #(), #t, list(<TQ3BoundingSphere>));
define method Q3BoundingSphere-UnionRationalPoint4D
    (arg1 :: <TQ3BoundingSphere>, arg2 :: <TQ3RationalPoint4D>, arg3 :: <TQ3BoundingSphere>)
 => (result :: <TQ3BoundingSphere>);
  let result-value
    = anonymous-299(arg1, arg2, arg3);
  values(result-value);
end method Q3BoundingSphere-UnionRationalPoint4D;

define constant anonymous-300
  = constrain-c-function(find-c-function("Q3BoundingSphere_SetFromPoints3D", file: anonymous-168), #(), #t, list(<TQ3BoundingSphere>));
define method Q3BoundingSphere-SetFromPoints3D
    (arg1 :: <TQ3BoundingSphere>, arg2 :: <TQ3Point3D>, arg3 :: <integer>, arg4 :: <integer>)
 => (result :: <TQ3BoundingSphere>);
  let result-value
    = anonymous-300(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3BoundingSphere-SetFromPoints3D;

define constant anonymous-301
  = constrain-c-function(find-c-function("Q3BoundingSphere_SetFromRationalPoints4D", file: anonymous-168), #(), #t, list(<TQ3BoundingSphere>));
define method Q3BoundingSphere-SetFromRationalPoints4D
    (arg1 :: <TQ3BoundingSphere>, arg2 :: <TQ3RationalPoint4D>, arg3 :: <integer>, arg4 :: <integer>)
 => (result :: <TQ3BoundingSphere>);
  let result-value
    = anonymous-301(arg1, arg2, arg3, arg4);
  values(result-value);
end method Q3BoundingSphere-SetFromRationalPoints4D;

