module: QD3DMisc

define module QD3DMisc
	use Dylan;							// all programs need this.
	use Extensions;						// imports "main"
	use Toolbox;						// imports <OSErr>, etc.
	use Extern;							// so we can use get-c-function.
	use QD3DTypes;

	export
		$kQ3ViewStatusDone, $kQ3ViewStatusRetraverse,
		$kQ3ViewStatusError, $kQ3ViewStatusCancelled,
		Q3View-StartRendering, Q3View-EndRendering, Q3MatrixTransform-Submit
end module QD3DMisc;

define constant *QuickDraw3DLib* = load-object-file(#("QuickDraw 3D"));

// support for rendering views.

define constant $kQ3ViewStatusDone = 0;
define constant $kQ3ViewStatusRetraverse = 1;
define constant $kQ3ViewStatusError = 2;
define constant $kQ3ViewStatusCancelled = 3;

define constant Q3View-StartRendering = get-c-function("Q3View_StartRendering",
	args: list(<TQ3ViewObject>), result: <TQ3Status>, file: *QuickDraw3DLib*);

define constant Q3View-EndRendering = get-c-function("Q3View_EndRendering",
	args: list(<TQ3ViewObject>), result: <TQ3Status>, file: *QuickDraw3DLib*);

define constant Q3MatrixTransform-Submit = get-c-function("Q3MatrixTransform_Submit",
	args: list(<TQ3Matrix4x4>, <TQ3ViewObject>), result: <TQ3Status>, file: *QuickDraw3DLib*);
