module: QD3DViewer

define module QD3DViewer
	use Dylan;
	use Extern;							// imports "load-object-file", etc.
	use Extensions;						// for <boolean>.
	use Toolbox;						// Point, Rect, CGrafPtr, EventRecord.
	use QD3DTypes;
	
	export
		<TQ3ViewerObject>,
		$kQ3ViewerShowBadge,
		$kQ3ViewerActive,
		$kQ3ViewerControllerVisible,
		$kQ3ViewerDrawFrame,
		$kQ3ViewerDraggingOff,
		$kQ3ViewerButtonCamera,
		$kQ3ViewerButtonTruck,
		$kQ3ViewerButtonOrbit,
		$kQ3ViewerButtonZoom,
		$kQ3ViewerButtonDolly,
		$kQ3ViewerDefault,
		$kQ3ViewerEmpty,
		$kQ3ViewerHasModel,
		$gestaltQD3DViewerNotPresent,
		$gestaltQD3DViewerAvailable,
		Q3ViewerNew,
		Q3ViewerDispose,
		Q3ViewerUseFile,
		Q3ViewerUseData,
		Q3ViewerWriteFile,
		Q3ViewerWriteData,
		Q3ViewerDraw,
		Q3ViewerEvent,
		Q3ViewerGetPict,
		Q3ViewerGetButtonRect,
		Q3ViewerGetCurrentButton,
		Q3ViewerSetCurrentButton,
		Q3ViewerUseGroup,
		Q3ViewerGetGroup,
		Q3ViewerSetBackgroundColor,
		Q3ViewerGetBackgroundColor,
		Q3ViewerGetView,
		Q3ViewerRestoreView,
		Q3ViewerSetFlags,
		Q3ViewerGetFlags,
		Q3ViewerSetBounds,
		Q3ViewerGetBounds,
		Q3ViewerGetDimension,
		Q3ViewerSetPort,
		Q3ViewerGetPort,
		Q3ViewerAdjustCursor,
		Q3ViewerGetState,
		Q3ViewerClear,
		Q3ViewerCut,
		Q3ViewerCopy,
		Q3ViewerPaste
end module QD3DViewer;

define constant anonymous-106
  = load-object-file(#("QD3DViewerLib"), include: #("Q3ViewerNew", "Q3ViewerDispose", "Q3ViewerUseFile", "Q3ViewerUseData", "Q3ViewerWriteFile", "Q3ViewerWriteData", "Q3ViewerDraw", "Q3ViewerEvent", "Q3ViewerGetPict", "Q3ViewerGetButtonRect", "Q3ViewerGetCurrentButton", "Q3ViewerSetCurrentButton", "Q3ViewerUseGroup", "Q3ViewerGetGroup", "Q3ViewerSetBackgroundColor", "Q3ViewerGetBackgroundColor", "Q3ViewerGetView", "Q3ViewerRestoreView", "Q3ViewerSetFlags", "Q3ViewerGetFlags", "Q3ViewerSetBounds", "Q3ViewerGetBounds", "Q3ViewerGetDimension", "Q3ViewerSetPort", "Q3ViewerGetPort", "Q3ViewerAdjustCursor", "Q3ViewerGetState", "Q3ViewerClear", "Q3ViewerCut", "Q3ViewerCopy", "Q3ViewerPaste"));

define constant <TQ3ViewerObject> = <machine-pointer>;

define constant <anonymous-71> = limited(<integer>, min: 1, max: 742);
define constant $kQ3ViewerShowBadge :: <anonymous-71> = 1;
define constant $kQ3ViewerActive :: <anonymous-71> = 2;
define constant $kQ3ViewerControllerVisible :: <anonymous-71> = 4;
define constant $kQ3ViewerDrawFrame :: <anonymous-71> = 8;
define constant $kQ3ViewerDraggingOff :: <anonymous-71> = 16;
define constant $kQ3ViewerButtonCamera :: <anonymous-71> = 32;
define constant $kQ3ViewerButtonTruck :: <anonymous-71> = 64;
define constant $kQ3ViewerButtonOrbit :: <anonymous-71> = 128;
define constant $kQ3ViewerButtonZoom :: <anonymous-71> = 256;
define constant $kQ3ViewerButtonDolly :: <anonymous-71> = 512;
define constant $kQ3ViewerDefault :: <anonymous-71> = 742;

define constant <anonymous-72> = limited(<integer>, min: 0, max: 1);
define constant $kQ3ViewerEmpty :: <anonymous-72> = 0;
define constant $kQ3ViewerHasModel :: <anonymous-72> = 1;

define constant <anonymous-73> = limited(<integer>, min: 0, max: 1);
define constant $gestaltQD3DViewerNotPresent :: <anonymous-73> = 0;
define constant $gestaltQD3DViewerAvailable :: <anonymous-73> = 1;

define constant anonymous-107
  = constrain-c-function(find-c-function("Q3ViewerNew", file: anonymous-106), #(), #t, list(<TQ3ViewerObject>));
define method Q3ViewerNew
    (arg1 :: <CGrafPtr>, arg2 :: <Rect>, arg3 :: <integer>)
 => (result :: <TQ3ViewerObject>);
  let result-value
    = anonymous-107(arg1, arg2, arg3);
  values(result-value);
end method Q3ViewerNew;

define constant anonymous-108
  = constrain-c-function(find-c-function("Q3ViewerDispose", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerDispose
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-108(arg1);
  values(result-value);
end method Q3ViewerDispose;

define constant anonymous-109
  = constrain-c-function(find-c-function("Q3ViewerUseFile", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerUseFile
    (arg1 :: <TQ3ViewerObject>, arg2 :: <integer>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-109(arg1, arg2);
  values(result-value);
end method Q3ViewerUseFile;

define constant anonymous-110
  = constrain-c-function(find-c-function("Q3ViewerUseData", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerUseData
    (arg1 :: <TQ3ViewerObject>, arg2 :: <machine-pointer>, arg3 :: <integer>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-110(arg1, arg2, arg3);
  values(result-value);
end method Q3ViewerUseData;

define constant anonymous-111
  = constrain-c-function(find-c-function("Q3ViewerWriteFile", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerWriteFile
    (arg1 :: <TQ3ViewerObject>, arg2 :: <integer>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-111(arg1, arg2);
  values(result-value);
end method Q3ViewerWriteFile;

define class <anonymous-79> (<statically-typed-pointer>) end;

define method pointer-value
    (ptr :: <anonymous-79>, #key index = 0)
 => (result :: <machine-pointer>);
  pointer-at(ptr, offset: index * 4, class: <machine-pointer>);
end method pointer-value;

define method pointer-value-setter
    (value :: <machine-pointer>, ptr :: <anonymous-79>, #key index = 0)
 => (result :: <machine-pointer>);
  pointer-at(ptr, offset: index * 4, class: <machine-pointer>) := value;
  value;
end method pointer-value-setter;

define method content-size (value :: limited(<class>, subclass-of: <anonymous-79>)) => (result :: <integer>);
  4;
end method content-size;

define constant anonymous-112
  = constrain-c-function(find-c-function("Q3ViewerWriteData", file: anonymous-106), #(), #t, list(<integer>));
define method Q3ViewerWriteData
    (arg1 :: <TQ3ViewerObject>, arg2 :: <anonymous-79>)
 => (result :: <integer>);
  let result-value
    = anonymous-112(arg1, arg2);
  values(result-value);
end method Q3ViewerWriteData;

define constant anonymous-113
  = constrain-c-function(find-c-function("Q3ViewerDraw", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerDraw
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-113(arg1);
  values(result-value);
end method Q3ViewerDraw;

define constant anonymous-114
  = constrain-c-function(find-c-function("Q3ViewerEvent", file: anonymous-106), #(), #t, list(<boolean>));
define method Q3ViewerEvent
    (arg1 :: <TQ3ViewerObject>, arg2 :: <EventRecord>)
 => (result :: <boolean>);
  let result-value
    = anonymous-114(arg1, arg2);
  values(result-value);
end method Q3ViewerEvent;

define constant anonymous-115
  = constrain-c-function(find-c-function("Q3ViewerGetPict", file: anonymous-106), #(), #t, list(<PicHandle>));
define method Q3ViewerGetPict
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <PicHandle>);
  let result-value
    = anonymous-115(arg1);
  values(result-value);
end method Q3ViewerGetPict;

define constant anonymous-116
  = constrain-c-function(find-c-function("Q3ViewerGetButtonRect", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerGetButtonRect
    (arg1 :: <TQ3ViewerObject>, arg2 :: <integer>, arg3 :: <Rect>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-116(arg1, arg2, arg3);
  values(result-value);
end method Q3ViewerGetButtonRect;

define constant anonymous-117
  = constrain-c-function(find-c-function("Q3ViewerGetCurrentButton", file: anonymous-106), #(), #t, list(<integer>));
define method Q3ViewerGetCurrentButton
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <integer>);
  let result-value
    = anonymous-117(arg1);
  values(result-value);
end method Q3ViewerGetCurrentButton;

define constant anonymous-118
  = constrain-c-function(find-c-function("Q3ViewerSetCurrentButton", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerSetCurrentButton
    (arg1 :: <TQ3ViewerObject>, arg2 :: <integer>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-118(arg1, arg2);
  values(result-value);
end method Q3ViewerSetCurrentButton;

define constant anonymous-119
  = constrain-c-function(find-c-function("Q3ViewerUseGroup", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerUseGroup
    (arg1 :: <TQ3ViewerObject>, arg2 :: <TQ3GroupObject>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-119(arg1, arg2);
  values(result-value);
end method Q3ViewerUseGroup;

define constant anonymous-120
  = constrain-c-function(find-c-function("Q3ViewerGetGroup", file: anonymous-106), #(), #t, list(<TQ3GroupObject>));
define method Q3ViewerGetGroup
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <TQ3GroupObject>);
  let result-value
    = anonymous-120(arg1);
  values(result-value);
end method Q3ViewerGetGroup;

define constant anonymous-121
  = constrain-c-function(find-c-function("Q3ViewerSetBackgroundColor", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerSetBackgroundColor
    (arg1 :: <TQ3ViewerObject>, arg2 :: <TQ3ColorARGB>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-121(arg1, arg2);
  values(result-value);
end method Q3ViewerSetBackgroundColor;

define constant anonymous-122
  = constrain-c-function(find-c-function("Q3ViewerGetBackgroundColor", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerGetBackgroundColor
    (arg1 :: <TQ3ViewerObject>, arg2 :: <TQ3ColorARGB>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-122(arg1, arg2);
  values(result-value);
end method Q3ViewerGetBackgroundColor;

define constant anonymous-123
  = constrain-c-function(find-c-function("Q3ViewerGetView", file: anonymous-106), #(), #t, list(<TQ3ViewObject>));
define method Q3ViewerGetView
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <TQ3ViewObject>);
  let result-value
    = anonymous-123(arg1);
  values(result-value);
end method Q3ViewerGetView;

define constant anonymous-124
  = constrain-c-function(find-c-function("Q3ViewerRestoreView", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerRestoreView
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-124(arg1);
  values(result-value);
end method Q3ViewerRestoreView;

define constant anonymous-125
  = constrain-c-function(find-c-function("Q3ViewerSetFlags", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerSetFlags
    (arg1 :: <TQ3ViewerObject>, arg2 :: <integer>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-125(arg1, arg2);
  values(result-value);
end method Q3ViewerSetFlags;

define constant anonymous-126
  = constrain-c-function(find-c-function("Q3ViewerGetFlags", file: anonymous-106), #(), #t, list(<integer>));
define method Q3ViewerGetFlags
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <integer>);
  let result-value
    = anonymous-126(arg1);
  values(result-value);
end method Q3ViewerGetFlags;

define constant anonymous-127
  = constrain-c-function(find-c-function("Q3ViewerSetBounds", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerSetBounds
    (arg1 :: <TQ3ViewerObject>, arg2 :: <Rect>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-127(arg1, arg2);
  values(result-value);
end method Q3ViewerSetBounds;

define constant anonymous-128
  = constrain-c-function(find-c-function("Q3ViewerGetBounds", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerGetBounds
    (arg1 :: <TQ3ViewerObject>, arg2 :: <Rect>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-128(arg1, arg2);
  values(result-value);
end method Q3ViewerGetBounds;

define class <anonymous-18> (<statically-typed-pointer>) end;

define method pointer-value
    (ptr :: <anonymous-18>, #key index = 0)
 => (result :: <integer>);
  unsigned-long-at(ptr, offset: index * 4);
end method pointer-value;

define method pointer-value-setter
    (value :: <integer>, ptr :: <anonymous-18>, #key index = 0)
 => (result :: <integer>);
  unsigned-long-at(ptr, offset: index * 4) := value;
  value;
end method pointer-value-setter;

define method content-size (value :: limited(<class>, subclass-of: <anonymous-18>)) => (result :: <integer>);
  4;
end method content-size;

define constant anonymous-129
  = constrain-c-function(find-c-function("Q3ViewerGetDimension", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerGetDimension
    (arg1 :: <TQ3ViewerObject>, arg2 :: <anonymous-18>, arg3 :: <anonymous-18>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-129(arg1, arg2, arg3);
  values(result-value);
end method Q3ViewerGetDimension;

define constant anonymous-130
  = constrain-c-function(find-c-function("Q3ViewerSetPort", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerSetPort
    (arg1 :: <TQ3ViewerObject>, arg2 :: <CGrafPtr>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-130(arg1, arg2);
  values(result-value);
end method Q3ViewerSetPort;

define constant anonymous-131
  = constrain-c-function(find-c-function("Q3ViewerGetPort", file: anonymous-106), #(), #t, list(<CGrafPtr>));
define method Q3ViewerGetPort
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <CGrafPtr>);
  let result-value
    = anonymous-131(arg1);
  values(result-value);
end method Q3ViewerGetPort;

define constant anonymous-132
  = constrain-c-function(find-c-function("Q3ViewerAdjustCursor", file: anonymous-106), #(), #t, list(<boolean>));
define method Q3ViewerAdjustCursor
    (arg1 :: <TQ3ViewerObject>, arg2 :: <Point>)
 => (result :: <boolean>);
  let result-value
    = anonymous-132(arg1, arg2);
  values(result-value);
end method Q3ViewerAdjustCursor;

define constant anonymous-133
  = constrain-c-function(find-c-function("Q3ViewerGetState", file: anonymous-106), #(), #t, list(<integer>));
define method Q3ViewerGetState
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <integer>);
  let result-value
    = anonymous-133(arg1);
  values(result-value);
end method Q3ViewerGetState;

define constant anonymous-134
  = constrain-c-function(find-c-function("Q3ViewerClear", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerClear
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-134(arg1);
  values(result-value);
end method Q3ViewerClear;

define constant anonymous-135
  = constrain-c-function(find-c-function("Q3ViewerCut", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerCut
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-135(arg1);
  values(result-value);
end method Q3ViewerCut;

define constant anonymous-136
  = constrain-c-function(find-c-function("Q3ViewerCopy", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerCopy
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-136(arg1);
  values(result-value);
end method Q3ViewerCopy;

define constant anonymous-137
  = constrain-c-function(find-c-function("Q3ViewerPaste", file: anonymous-106), #(), #t, list(<OSErr>));
define method Q3ViewerPaste
    (arg1 :: <TQ3ViewerObject>)
 => (result :: <OSErr>);
  let result-value
    = anonymous-137(arg1);
  values(result-value);
end method Q3ViewerPaste;

