#include "fail.h"
#include "mlvalues.h"

/* These functions are defined in an other file if HAS_UI is defined.
   But we still want them to appear in the list of primitives.
*/
#ifndef HAS_UI

static void fail ()
{
	raise_with_arg (GRAPHIC_FAILURE_EXN,
	                copy_string ("graphic functions are not implemented"));
}

value gr_open_graph (value str)    /* ML */
{
#pragma unused(str)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_close_graph (void)    /* ML */
{
	fail ();
	return Atom(0);  /* not reached */
}

value gr_clear_graph (void)    /* ML */
{
	fail ();
	return Atom(0);  /* not reached */
}

value gr_size_x (void)    /* ML */
{
	fail ();
	return Atom(0);  /* not reached */
}

value gr_size_y (void)    /* ML */
{
	fail ();
	return Atom(0);  /* not reached */
}

value gr_set_color (value color)    /* ML */
{
#pragma unused (color)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_plot (value x, value y)    /* ML */
{
#pragma unused (x, y)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_point_color (value x, value y)    /* ML */
{
#pragma unused (x, y)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_moveto (value x, value y)    /* ML */
{
#pragma unused (x, y)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_current_point (void)    /* ML */
{
	fail ();
	return Atom(0);  /* not reached */
}

value gr_lineto (value x, value y)    /* ML */
{
#pragma unused (x, y)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_draw_arc (value argv, value argn)    /* ML */
{
#pragma unused(argv, argn)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_set_line_width (value width)    /* ML */
{
#pragma unused (width)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_draw_char (value ch)    /* ML */
{
#pragma unused (ch)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_draw_string (value str)    /* ML */
{
#pragma unused (str)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_set_font (value str)    /* ML */
{
#pragma unused (str)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_set_text_size (value size)    /* ML */
{
#pragma unused (size)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_text_size (value str)    /* ML */
{
#pragma unused (str)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_fill_rect (value x, value y, value wdth, value hght)    /* ML */
{
#pragma unused (x, y, wdth, hght)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_fill_arc (value *argv, int argn)    /* ML */
{
#pragma unused(argv, argn)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_fill_poly (value vect)    /* ML */
{
#pragma unused (vect)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_make_image (value mat)    /* ML */
{
#pragma unused (mat)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_dump_image (value image)    /* ML */
{
#pragma unused (image)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_draw_image (value image, value x, value y)    /* ML */
{
#pragma unused (image, x, y)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_create_image (value w, value h) 	/* ML */
{
#pragma unused (w, h)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_blit_image (value i, value x, value y)    /* ML */
{
#pragma unused (i, x, y)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_wait_event (value l)		/* ML */
{
#pragma unused (l)
	fail ();
	return Atom(0);  /* not reached */
}

value gr_sound (value freq, value delay)    /* ML */
{
#pragma unused (freq, delay)
	fail ();
	return Atom(0);  /* not reached */
}

#endif /* !HAS_UI */
