#ifndef _spin_
#define _spin_


#include <CursorCtl.h>

/* Does not work with Metrowerks C because of "memory.h" vs. <Memory.h>
#include <LowMem.h>
   We have to do the following instead, and pray that it works:
*/
#if powerc
extern pascal long LMGetTicks (void);
#else
#define LMGetTicks() (* (long *) 0x016A)
#endif

#if powerc
#define PERIODIC_ACTION_FREQ 3000
#else
#define PERIODIC_ACTION_FREQ 300
#endif

static unsigned long ui_next_tick = 0;

/* We'll try to do 20 [SpinCursor]s per second */
#define SPINPERIOD 3

#define ui_periodic_action() {                 \
  if (LMGetTicks () >= ui_next_tick){          \
    SpinCursor ((short) 32);                   \
	ui_next_tick = LMGetTicks () + SPINPERIOD; \
  }                                            \
}


#endif /* _spin_ */
