MODULE FRead;

  IMPORT SYSTEM, StdIO;

  CONST
    BS*  = 08X;
	CR*  = 0DX;
	DEL* = 7FX;
	EOF* =  0X;
	EOL* = 0DX;
	ESC* = 1BX;
	FF*  = 0CX;
	LF*  = 0AX;
  TYPE
    Text* = POINTER TO ARRAY OF CHAR;
  VAR
    Done*: BOOLEAN;
	termCh*: CHAR;

  PROCEDURE Open*(name: ARRAY OF CHAR): StdIO.File;
    VAR
	  file: StdIO.File;
  BEGIN
    file:=StdIO.Open(name, "r"); Done:=fileNIL; RETURN file
  END Open;

  PROCEDURE Char*(file: StdIO.File; VAR ch: CHAR);
  BEGIN
    ch:=StdIO.GetChar(file); Done:=StdIO.EOF(file);
	IF Done THEN
	  (* Either there was an error during the read operation or *)
	  (* the end of the file has been reached. For both cases the *)
	  (* character returned will be 0X. *)
	  ch:=EOF
	END
  END Char;

  PROCEDURE String*(file: StdIO.File; VAR s: ARRAY OF CHAR);
    VAR
	  i: LONGINT;
	  ch: CHAR;
  BEGIN
    i:=0;
	REPEAT
	  Char(file, ch);
	UNTIL ch#" ";
	WHILE ch>" " DO
	  IF i<LEN(s) THEN
	    s[i]:=ch; INC(i)
	  END;
	  Char(file, ch)
	END;
	termCh:=ch; s[i]:=0X
  END String;

  PROCEDURE Int*(file: StdIO.File; VAR val: INTEGER);
    VAR
      i, x: INTEGER;
      s: ARRAY 80 OF CHAR;
  BEGIN
    String(file, s); x:=0; val:=0; i:=0;
    IF s[0]="-" THEN i:=1 END;
    LOOP
      IF s[i]=0X THEN
	    Done:=TRUE; EXIT
      ELSIF (s[i]<"0") OR (s[i]>"9") THEN
	    Done:=FALSE; EXIT
      ELSIF (x>3276) OR ((x=3276) AND (s[i]>"8")) THEN
	    Done:=FALSE; EXIT
	  END;
      x:=10*x+ORD(s[i])-ORD("0"); INC(i)
    END;
    IF Done THEN
      IF x<=32767 THEN
	    IF s[0]="-" THEN x:=-x END;
		val:=x
      ELSIF s[0]="-" THEN
	    val:=MIN(INTEGER)
      ELSE
	    Done:=FALSE
      END
    END
  END Int;

  PROCEDURE Bytes*(file: StdIO.File; VAR buf: ARRAY OF SYSTEM.BYTE;
                   VAR len: LONGINT);
  BEGIN
    len:=StdIO.Read(file, len, 1, SYSTEM.ADR(buf));
	Done:=len>=0
  END Bytes;

  PROCEDURE Close*(file: StdIO.File);
  BEGIN
    Done:=StdIO.Close(file)=0
  END Close;

  PROCEDURE From*(file: StdIO.File; offset: LONGINT);
  BEGIN
    Done:=StdIO.Seek(file, offset, StdIO.SeekSet)>=0
  END From;

  PROCEDURE Length*(file: StdIO.File): LONGINT;
    VAR
      len, pos: LONGINT;
      dummy: BOOLEAN;
  BEGIN
    len:=0; Done:=FALSE;
    IF StdIO.GetPos(file, pos) THEN
      IF StdIO.Seek(file, 0, StdIO.SeekEnd)=0 THEN
        len:=StdIO.Tell(file); Done:=TRUE
      END;
      dummy:=StdIO.SetPos(file, pos)
    END;
    RETURN len
  END Length;

  PROCEDURE Load*(name: ARRAY OF CHAR): Text;
    VAR
	  file: StdIO.File;
	  length: LONGINT;
	  content: Text;
  BEGIN
    content:=NIL; file:=Open(name);
	IF Done THEN
	  length:=Length(file); NEW(content, length+1);
	  IF contentNIL THEN
	    Bytes(file, content^, length);
		IF Done THEN
		  DISPOSE(content); content:=NIL
		ELSE
		  content[length]:=0X (* terminate file *)
		END
	  END;
	  Close(file)
	END;
	RETURN content
  END Load;

BEGIN
  Done:=FALSE
END FRead.
