(*
	File:		MathL.mod

	Desc:		Interface between MPW-Oberon and the MC68881
	
	Author:		Oliver Schirpf
	
	Date:		29.06.1994
	
	
*)
MODULE MathL;

IMPORT SYSTEM;
	
(*$Parameter ACos(FP0):FP0 *)
PROCEDURE ACos*(x: LONGREAL):LONGREAL;INLINE $F200, $001C;

(*$Parameter ASin(FP0):FP0 *)
PROCEDURE ASin*(x: LONGREAL):LONGREAL;INLINE $F200, $000C;

(*$Parameter ATan(FP0):FP0 *)
PROCEDURE ATan*(x: LONGREAL):LONGREAL;INLINE $F200, $000A;

(*$Parameter ATanH(FP0):FP0 *)
PROCEDURE ATanH*(x: LONGREAL):LONGREAL;INLINE $F200, $000D;

(*$Parameter Cos(FP0):FP0 *)
PROCEDURE Cos*(x: LONGREAL):LONGREAL;INLINE $F200, $001D;

(*$Parameter CosH(FP0):FP0 *)
PROCEDURE CosH*(x: LONGREAL):LONGREAL;INLINE $F200, $0019;

(*$Parameter Exp(FP0):FP0 *)
PROCEDURE Exp*(x: LONGREAL):LONGREAL;INLINE $F200, $0010; (* e^X *)

(*$Parameter ExpM1(FP0):FP0 *)
PROCEDURE ExpM1*(x: LONGREAL):LONGREAL;INLINE $F200, $0008; (* e^x-1 *)

(*$Parameter Ln(FP0):FP0 *) 
PROCEDURE Ln*(x: LONGREAL):LONGREAL;INLINE $F200, $0014; (* log(e) (x) *)

(*$Parameter LnP1(FP0):FP0 *) 
PROCEDURE LnP1*(x: LONGREAL):LONGREAL;INLINE $F200, $0006; (* log(e) (x+1) *)

(*$Parameter Log10(FP0):FP0 *)
PROCEDURE Log10*(x: LONGREAL):LONGREAL;INLINE $F200, $0015; (* log(10) (x) *)

(*$Parameter Log2(FP0):FP0 *)
PROCEDURE Log2*(x: LONGREAL):LONGREAL;INLINE $F200, $0016; (* log(2) (x) *)

(*$Parameter Power10(FP0):FP0 *)
PROCEDURE Power10*(x: LONGREAL):LONGREAL;INLINE $F200, $0012; (* 10^X *)

(*$Parameter Power2(FP0):FP0 *)
PROCEDURE Power2*(x: LONGREAL):LONGREAL;INLINE $F200, $0011; (* 2^X *)

(*$Parameter Sin(FP0):FP0 *)
PROCEDURE Sin*(x: LONGREAL):LONGREAL;INLINE $F200, $000E;

(*$Parameter SinH(FP0):FP0 *)
PROCEDURE SinH*(x: LONGREAL):LONGREAL;INLINE $F200, $0002;

(*$Parameter Sqrt(FP0):FP0 *)
PROCEDURE Sqrt*(x: LONGREAL):LONGREAL;INLINE $F200, $0004;

(*$Parameter Tan(FP0):FP0 *)
PROCEDURE Tan*(x: LONGREAL):LONGREAL;INLINE $F200, $000F;

(*$Parameter TanH(FP0):FP0 *)
PROCEDURE TanH*(x: LONGREAL):LONGREAL;INLINE $F200, $0009;

END MathL.