MODULE Read;

  IMPORT SYSTEM, StdIO, FRead;

  CONST
    BS*  = 08X;
	CR*  = 0DX;
	DEL* = 7FX;
	EOF* =  0X;
	EOL* = 0DX;
	ESC* = 1BX;
	FF*  = 0CX;
	LF*  = 0AX;
  TYPE
    Text* = POINTER TO ARRAY OF CHAR;
  VAR
    Done*: BOOLEAN;
	termCh*: CHAR;

  PROCEDURE Char*(VAR ch: CHAR);
  BEGIN
    FRead.Char(StdIO.stdin, ch); Done:=FRead.Done
  END Char;

  PROCEDURE String*(VAR s: ARRAY OF CHAR);
  BEGIN
    FRead.String(StdIO.stdin, s); Done:=FRead.Done
  END String;

  PROCEDURE Int*(VAR val: INTEGER);
  BEGIN
    FRead.Int(StdIO.stdin, val); Done:=FRead.Done
  END Int;

  PROCEDURE Bytes*(VAR buf: ARRAY OF SYSTEM.BYTE;
                   VAR len: LONGINT);
  BEGIN
    len:=StdIO.Read(StdIO.stdin, len, 1, SYSTEM.ADR(buf));
	Done:=len>=0
  END Bytes;

  PROCEDURE From*(offset: LONGINT);
  BEGIN
    Done:=StdIO.Seek(StdIO.stdin, offset, StdIO.SeekSet)>=0
  END From;

  PROCEDURE Length*(): LONGINT;
  BEGIN
    RETURN FRead.Length(StdIO.stdin)
  END Length;

  PROCEDURE Load*(): Text;
    VAR
	  length: LONGINT;
	  content: Text;
  BEGIN
	length:=Length(); NEW(content, length+1);
	IF contentNIL THEN
	  Bytes(content^, length);
      IF Done THEN
		DISPOSE(content); content:=NIL
	  ELSE
		content[length+1]:=0X (* terminate file *)
	  END
	END;
	RETURN content
  END Load;

BEGIN
  Done:=FALSE
END Read.
