#include <stdio.h>
#include <stdlib.h>
#include <events.h>
#include <Types.h>

#define	bubblebase  1.61
#define	dnfbase  3.5
#define	permbase  1.75
#define	queensbase  1.83
#define	towersbase  2.39
#define	quickbase  1.92
#define	intmmbase  1.46
#define	treebase   2.5
#define	mmbase  0.0 
#define	fpmmbase 2.92
#define	puzzlebase  0.5
#define	fftbase 0.0
#define	fpfftbase  4.44

#define	maxcells  18
#define	stackrange  3

#define	rowsize 40
#define	size  511
#define	classmax  3
#define	typemax  12
#define	d  8

#define	sortelements  5000
#define	srtelements  500

#define	fftsize  256
#define	fftsize2  129

#define	permrange  10

typedef struct
{
	int discsize;
	int next;
} element;
	
typedef int intmatrix[rowsize+1][rowsize+1];
typedef double realmatrix[rowsize+1][rowsize+1];

typedef struct
{
	double rp, ip;
}complex ;

typedef complex carray[fftsize+1];
typedef complex c2array[fftsize2+1];
	

double	fixed,floated;
int seed, permarray[permrange+1], pctr, stack[stackrange+1];
element cellspace[maxcells+1];
int freelist,movesdone;

intmatrix *ima, *imb, *imr;
realmatrix *rma, *rmb, *rmr;

int piececount[classmax+1];
int	class[typemax+1];
int piecemax[typemax+1];
char	puzzl[size+1];
char p[typemax+1][size+1];
int n, kount;

int	*sortlist, biggest, littlest, top;

carray	z, w;
c2array  e;
double zr,zi;



void Initrand()
{
	seed=74755;
}

int Rand()
{
	seed = (seed * 1309 + 13849) % 65535;
	return seed;
}

void Swap(int *a, int*b)	
{
	int t;
	
	t=*a; *a=*b; *b=t;	
}

void Initialize()
{
	int i;	
	
	i=1;
	while(i<=7)
	{
		permarray[i] = i-1;
		i++;
	}
}
	
void Permute(int n)
{
	int k;
	
	pctr = pctr + 1;
	if(n!=1)
	{
		Permute(n-1);
		k = n-1;
		while(k>=1)
		{
			Swap(&permarray[n], &permarray[k]);
			Permute(n-1);
			Swap(&permarray[n], &permarray[k]);
			k--;
		}
	}
}
	
void Perm()
{
	int i;

	pctr = 0; i = 1;
	while( i <= 5 )
	{
		Initialize();
		Permute(7);
		i++;
	}
	if( pctr != 43300 ) printf("\nError in Perm.");
}

void Makenull(int s)
{
	 stack[s] = 0;
}

int Getelement()
{
	int temp;

	if(freelist>0)
	{
		temp = freelist;
		freelist = cellspace[freelist].next;
	}
	else printf("\nout of space");
	return (temp);
}
	
void Push(int i, int s)
{
	int localel;
	char errorfound;

	errorfound = 0;
	if( stack[s] > 0 )
	{
			if( cellspace[stack[s]].discsize<=i )
			{
				errorfound = 1;
				printf("\ndisc size error$");
			} 
	}
	if(!errorfound)
	{
			localel = Getelement();
			cellspace[localel].next = stack[s];
			stack[s] = localel;
			cellspace[localel].discsize = i;
	}
}
	
void Init(int s, int n)
{
	int discctr;
	
	Makenull(s); discctr = n;
	while( discctr >= 1)
	{
		Push(discctr,s);
		discctr--;
	}
}

int Pop(int s)
{
	int temp, temp1;

	if( stack[s] > 0 )
	{
			temp1 = cellspace[stack[s]].discsize;
			temp = cellspace[stack[s]].next;
			cellspace[stack[s]].next = freelist;
			freelist = stack[s];
			stack[s] = temp;
			return  (temp1);
	}
	else
	{
			printf("\nnothing to pop ");
			return 0;
	}
}

void MyMove(int s1, int s2)
{
	Push(Pop(s1),s2);
	movesdone = movesdone+1;
}

void tower(int i,int j,int k)
{
	int other;

	if( k==1 ) 
		MyMove(i,j);
	else
	{
		other = 6-i-j;
		tower(i,other,k-1);
		MyMove(i,j);
		tower(other,j,k-1);
	}
}

void Towers()
{
	int i;
	
	i = 1;
	while( i <= maxcells)
	{
		cellspace[i].next = i-1;
		i++;
	}
	freelist = maxcells;
	Init(1,14);
	Makenull(2);
	Makenull(3);
	movesdone = 0;
	tower(1,2,14);
	if( movesdone != 16383 ) printf("\nError in Towers.");
}

/*
  type
      doubleboard =   2..16;
      doublenorm  =   -7..7;
      boardrange  =   1..8;
      aarray      =   array [boardrange] of boolean;
      barray      =   array [doubleboard] of boolean;
      carray      =   array [doublenorm] of boolean;
      xarray      =   array [boardrange] of boardrange;
*/

void Try(int i,char *q, char *a, char *b, char *c, int  *x)
{
	int j;
	
	j = 0;
	*q = 0;
	while((!*q)&&(j!=8))
	{
		j = j + 1;
		*q = 0;
		if(b[j]&&a[i+j]&&c[i-j+7])
		{
			x[i] = j;
			b[j] = 0;
			a[i+j] = 0;
			c[i-j+7] = 0;
			if(i<8)
			{
				Try(i+1,q,a,b,c,x);
				if(!*q)
				{
					b[j] = 1;
					a[i+j] = 1;
					c[i-j+7] = 1;
				}
			}
			else  *q = 1;
		}
	}
}

void Doit()
{
	int i;  char q;
	char a[9], b[17], c[15];
	int x[9];

	i = 0 - 7;
	while( i <= 16)
	{
		if((i >= 1) && (i <= 8))  a[i] = 1 ;
			if( i >= 2 ) b[i] = 1 ;
			if( i <= 7 ) c[i+7] = 1 ;
			i = i + 1;
	}
	Try(1, &q, b, a, c, x);
	if(!q)  printf("\nError in Queens.");
}

void Queens ()
{
	int i;
	
 	i  = 1;
	while( i <= 50)
	{
		Doit(); i++;
	}
}

void Initmatrix ( intmatrix m)
{
	int i,j,temp;

	i = 1;
	while(i<=rowsize)
	{
		j = 1;
		while( j <= rowsize )
		{
			temp = Rand();
			m[i][j] = temp - (temp / 120)*120 - 60;
			j++;
		}
		i++;
	}
}

void Innerproduct(int *result, intmatrix a, intmatrix b,int  row,int column)
{
	int i;
	
	result = 0; i = 1;
	while( i <= rowsize )
	{
		*result = *result+a[row][i]*b[i][column];
		i++;
	}
}

void Intmm()
{
	int i,j;

	ima=malloc(sizeof(intmatrix));
	if(ima==NULL) Debugger();
	imb=malloc(sizeof(intmatrix));
	if(imb==NULL) Debugger();
	imr=malloc(sizeof(intmatrix));
	if(imr==NULL) Debugger();
	Initrand();
	Initmatrix(*ima);
	Initmatrix(*imb);
	i = 1;
	while(i<=rowsize)
	{
		j=1;
		while(j<=rowsize)
		{
			Innerproduct(&((*imr)[i][j]),*ima,*imb,i,j); 
			j++;
		}
		i++;
	}
	free(ima); free(imb); free(imr);
}


void rInitmatrix( realmatrix m)
{
	int temp, i, j;

	 i = 1;
	 while(i<=rowsize)
	 {
	 	j=1;
		while(j<=rowsize)
		{
			temp = Rand();
			m[i][j] = (temp - (temp / 120)*120 - 60) / 3;
			j++;
		}
		i++;
	}
}

void rInnerproduct(double *result,realmatrix a, realmatrix b, int row, int column)
{
	int i;
	
	*result = 0.0; i = 1;
	while(i<=rowsize)
	{
		*result = *result+a[row][i]*b[i][column]; 
		i++;
	}
}

void Mm()
{
	int i,j;
	
	Initrand();
	rInitmatrix(*rma);
	rInitmatrix(*rmb);
	i = 1;
	while(i<=rowsize)
	{
		j=1;
		while(j<=rowsize)
		{
			rInnerproduct(&((*rmr)[i][j]),*rma,*rmb,i,j); 
			j++;
		}
		i++;
	}
}

char Fit(int i,int j)
{
	int k;
	
	k = 0;
	while(k<=piecemax[i])
	{
		if( p[i][k] )
			if ( puzzl[j+k] ) return 0;
		k++;
	}
	return 1;
}

int Place (int i, int j)
{
	int k;
	
	k = 0;
	while( k <= piecemax[i]) 
	{
		if ( p[i][k] )  puzzl[j+k] = 1;
		k++;
	}
	piececount[class[i]] = piececount[class[i]] - 1;
	k = j;
	while( k <= size )
	{
		if( !puzzl[k] ) return (k);
		k++;
	}
	return 0;
}
	
void Remove(int i, int j)
{
	int k;
	
	 k = 0;
	 while( k <= piecemax[i] )
	 {
			if( p[i][k] )  puzzl[j+k] = 0 ;
			k++;
	 }
	 piececount[class[i]] = piececount[class[i]] + 1;
}

char Trial(int j)
{
	int i,k;
	
	i = 0;
	kount = kount + 1;
	while( i <= typemax )
	{
		if ( piececount[class[i]] != 0 ) 
			if ( Fit (i, j) )
			{
				k = Place (i, j);
				if(Trial(k) || (k == 0))  return 1;
				else Remove(i, j);
			}
		i++;
	}
	return 0;
}
	
void Puzzle()
{
	int i, j, k, m;

	m = 0;
	while( m <= size )
	{	
		puzzl[m] = 1; m++;
	}
	i = 1;
	while(i<=5)
	{
		j=1;
		while( j <= 5 )
		{
			k = 1;
			while( k <= 5 )
			{
				puzzl[i+d*(j+d*k)] = 0; k++;
			}
			j++;
		}
		i++;
	}
	
	i = 0; 
	while( i <= typemax )
	{
		m = 0;
		while( m<= size)
		{
			p[i][m] = 0;
			m++;
		}
		i++;
	}
	
	i = 0;
	while( i <= 3 )
	{
		j = 0;
		while( j <= 1)
		{
			k = 0;
			while( k <= 0 )
			{
				p[0][i+d*(j+d*k)] = 1;
				k++;
			}
			j++;
		}
		i++;
	}
	
	class[0] = 0;
	piecemax[0] = 3+d*1+d*d*0;
	
	i = 0;
	while( i <= 1) 
	{
		j = 0;
		while( j <= 0)
		{
			k = 0;
			while( k <= 3 )
			{
				p[1][i+d*(j+d*k)] = 1; k++;
			}
			j++;
		}
		i++;
	}
	class[1] = 0;
	piecemax[1] = 1+d*0+d*d*3;
	
	i = 0;
	while(i<=0)
	{
		j=0;
		while( j <= 3 )
		{
			k = 0;
			while( k <= 1 )
			{
				p[2][i+d*(j+d*k)] = 1; k++;
			}
			j++;
		}
		i++;
	}
	class[2] = 0;
	piecemax[2] = 0+d*3+d*d*1;
	
	i = 0;
	while( i <= 1 )
	{
		j = 0;
		while( j <= 3 )
		{
			k = 0;
			while( k <= 0 )
			{
				p[3][i+d*(j+d*k)] = 1; k++;
			}
			j++;
		}
		i++;
	}
	class[3] = 0;
	piecemax[3] = 1+d*3+d*d*0;

	i = 0;
	while( i <= 3 )
	{
		j = 0;
		while( j <= 0 )
		{
			k=0;
			while( k <= 1 )
			{
				p[4][i+d*(j+d*k)] = 1; k++;
			}
			j++;
		}
		i++;
	}
	class[4] = 0;
	piecemax[4] = 3+d*0+d*d*1;
	
	i = 0;
	while( i <= 0 )
	{
		j = 0;
		while( j <= 1)
		{
			k = 0;
			while( k <= 3 )
			{
				p[5][i+d*(j+d*k)] = 1; k++;
			}
			j++;
		}
		i++;
	}

	class[5] = 0;
	piecemax[5] = 0+d*1+d*d*3;
	
	i = 0;
	while(i<=2)
	{
		j=0;
		while(j<=0)
		{
			k=0;
			while(k <= 0)
			{
				p[6][i+d*(j+d*k)] = 1; k++;
			}
			j++;
		}
		i++;
	}
	class[6] = 1;
	piecemax[6] = 2+d*0+d*d*0;
	
	i = 0;
	while( i <= 0 )
	{
		j = 0;
		while( j <= 2 )
		{
			k = 0;
			while( k <= 0 )
			{
				p[7][i+d*(j+d*k)] = 1; k++;
			}
			j++;
		}
		i++;
	}
	
	class[7] = 1;
	piecemax[7] = 0+d*2+d*d*0;
	
	i = 0;
	while( i <= 0 )
	{
		j = 0;
		while( j <= 0 )
		{
			k = 0;
			while(k <= 2 )
			{
				p[8][i+d*(j+d*k)] = 1; k++;
			}
			j++;
		}
		i++;
	}
	
	class[8] = 1;
    piecemax[8] = 0+d*0+d*d*2;
	
	i = 0;
	while( i <= 1 )
	{
		j = 0;
		while( j <= 1 )
		{
			k = 0;
			while( k <= 0 )
			{
				p[9][i+d*(j+d*k)] = 1; k++;
			}
			j++;
		}
		i++;
	}
	class[9] = 2;
	piecemax[9] = 1+d*1+d*d*0;
	
	i = 0;
	while( i <= 1 )
	{
		j = 0;
		while( j <= 0 )
		{
			k = 0;
			while( k <= 1 )
			{
				p[10][i+d*(j+d*k)] = 1; k++;
			}
			j++;
		}
		i++;
	}
	class[10] = 2;
	piecemax[10] = 1+d*0+d*d*1;
	
	i = 0;
	while( i <= 0)
	{
		j = 0;
		while( j <= 1 )
		{
			k = 0;
			while( k <= 1 )
			{
				p[11][i+d*(j+d*k)] = 1; k++;
			}
			j++;
		}
		i++;
	}
	class[11] = 2;
	piecemax[11] = 0+d*1+d*d*1;
	
	i = 0;
	while( i <= 1)
	{
		j = 0;
		while( j <= 1 )
		{
			k = 0;
			while( k <= 1 )
			{
				p[12][i+d*(j+d*k)] = 1; k++;
			}
			j++;
		}
		i++;
	}
	class[12] = 3;
	piecemax[12] = 1+d*1+d*d*1;
	
	piececount[0] = 13;
	piececount[1] = 3;
	piececount[2] = 1;
	piececount[3] = 1;
	m = 1+d*(1+d*1);
	kount = 0;
	if( Fit(0, m) )  n = Place(0, m);
	else printf("\nError1 in Puzzle");

	if(! Trial(n)) printf("\nError2 in Puzzle.");
	else if( kount != 2005)  printf("\nError3 in Puzzle.");
}

void Initarr()
{
	int i, temp;

	Initrand();
	biggest = 0; littlest = 0; i = 1;
	while( i <= sortelements)
	{
		temp = Rand();
		sortlist[i] = temp - (temp / 100000)*100000 - 50000;
		if( sortlist[i] > biggest ) biggest = sortlist[i];
		else if( sortlist[i] < littlest)  littlest = sortlist[i];
		i++;
	}
}

void Quicksort(int *a, int l, int r)
{
	int i, j, x, w;
		
	i=l; j=r;
	x=a[(l+r) / 2];
	do
	{
		while( a[i]<x)  i=i+1;
		while( x<a[j])  j=j-1;
		if(i<=j)
		{
			w = a[i];
			a[i] = a[j];
			a[j] = w;
			i = i+1;  j = j-1;
		}
	}while(!( i > j));
	if(l<j)  Quicksort(a,l,j) ;
	if(i<r)  Quicksort(a,i,r) ;
}

void Quick()
{

	sortlist=malloc((sortelements+1)*sizeof(int));
	if(sortlist==NULL) Debugger();
    Initarr();
    Quicksort(sortlist,1,sortelements);
    if( (sortlist[1] != littlest) || (sortlist[sortelements] != biggest) )  printf("\nError in Quick.") ;
	free(sortlist);
}

void bInitarr()
{
	int i,temp;

	Initrand();
	biggest = 0; littlest = 0; i = 1;
	while( i <= srtelements )
	{
		temp = Rand();
		sortlist[i] = temp - (temp / 100000)*100000 - 50000;
		if( sortlist[i] > biggest )  biggest = sortlist[i];
		else if( sortlist[i] < littlest)  littlest = sortlist[i];
		i++;
	}
}

void Bubble()
{
	int i, j;

	sortlist=malloc((sortelements+1)*sizeof(int));
	if(sortlist==NULL) Debugger();
	bInitarr();
	top=srtelements;
	while( top>1 )
	{
		i=1;
		while( i<top)
		{
			if(sortlist[i] > sortlist[i+1]) 
			{
				j = sortlist[i];
				sortlist[i] = sortlist[i+1];
				sortlist[i+1] = j;
			}
			i=i+1;
		}
		top=top-1;
	}
	if( (sortlist[1] != littlest) || (sortlist[srtelements] != biggest) ) printf("\nError3 in Bubble.") ;
	free(sortlist);
}


double Cos(double x)
{
	int i, factor;
	double result,power;
	
	result = 1.0; factor = 1;  power = x; i = 2;
	while( i <= 10 )
	{
		factor = factor * i;  power = power*x;
		if( (i % 2) == 0) 
		{
			if( (i % 4) == 0)  result = result + power/factor;
			else result = result - power/factor;
		}
		i++;
	}
	return result;
}
	
int Min0(int arg1, int arg2)
{
	if( arg1 < arg2 )  return arg1;
	else  return arg2;
}

void Uniform11(int iy, double yfl)
{
		iy = (4855*iy + 1731) % 8192;
		yfl = iy/8192.0;
}

void Exptab(int n, c2array e)
{
	double theta, divisor, h[26];
	int i, j, k, l, m;
	
	theta = 3.1415926536;
	divisor = 4.0; i=1;
	while( i <= 25 )
	{
		h[i] = 1/(2*Cos( theta/divisor ));
		divisor = divisor + divisor;
		i++;
	}
	m = n / 2 ;
	l = m / 2 ;
	j = 1 ;
	e[1].rp = 1.0 ;
	e[1].ip = 0.0;
	e[l+1].rp = 0.0;
	e[l+1].ip = 1.0 ;
	e[m+1].rp = -1.0 ;
	e[m+1].ip = 0.0 ;
	do
	{
		i = l / 2 ;
		k = i ;
		do
		{
			e[k+1].rp = h[j]*(e[k+i+1].rp+e[k-i+1].rp) ;
			e[k+1].ip = h[j]*(e[k+i+1].ip+e[k-i+1].ip) ;
			k = k+l ;
		}while(! ( k > m ));
		j = Min0( j+1, 25);
		l = i ;
	}while(! ( l <= 1 ));
}

void Fft(int n, carray z, carray w, c2array e, double sqrinv)
{
	int i, j, k, l, m, index;
	double h;

	m = n / 2 ;
	l = 1 ;
	do
	{
		k = 0 ;
		j = l ;
		i = 1 ;
		do
		{
			do
			{
				w[i+k].rp = z[i].rp+z[m+i].rp ;
				w[i+k].ip = z[i].ip+z[m+i].ip ;
				h = e[k+1].rp*(z[i].rp-z[i+m].rp);
				w[i+j].rp = h-e[k+1].ip*(z[i].ip-z[i+m].ip) ;
				h = e[k+1].rp*(z[i].ip-z[i+m].ip);
				w[i+j].ip = h+e[k+1].ip*(z[i].rp-z[i+m].rp) ;
				i = i+1 ;
			}while(! ( i > j ));
			k = j ;
			j = k+l ;
		}while(! ( j > m ));
		index = 1;
		do
		{
			z[index] = w[index];
			index = index+1;
		}while(! ( index > n ));
		l = l+l ;
	}while(! ( l > m ));
	i = 1;
	while( i <= n )
	{
		z[i].rp = sqrinv*z[i].rp ;
		z[i].ip = -sqrinv*z[i].ip;
		i++;
	}
}
	
void Oscar ()
{
	int i;

	Exptab(fftsize,e) ;
	seed = 5767 ; i = 1;
	while( i <= fftsize )
	{
		Uniform11( seed, zr );
		Uniform11( seed, zi );
		z[i].rp = 20.0*zr - 10.0;
		z[i].ip = 20.0*zi - 10.0;
		i++;
	}
	i = 1;
	while( i <= 20)
	{
		Fft(fftsize,z,w,&e,0.0625); i++;
	}
}

void JustDoIt()
{
	int time;

	rma=malloc(sizeof(realmatrix)); if(rma==NULL) Debugger();
	rmb=malloc(sizeof(realmatrix)); if(rmb==NULL) Debugger();
	rmr=malloc(sizeof(realmatrix)); if(rmr==NULL) Debugger();
	
	time=TickCount();printf("\nPerm ");Perm(); time=TickCount()-time; printf("%d",time);
	time=TickCount();printf("\nTowers ");Towers(); time=TickCount()-time; printf("%d",time);
	time=TickCount();printf("\nQueens ");Queens(); time=TickCount()-time; printf("%d",time);
	time=TickCount();printf("\nIntmm ");Intmm(); time=TickCount()-time; printf("%d",time);
	/*time=TickCount();printf("\nMm ");Mm(); time=TickCount()-time; printf("%d",time);
	*/time=TickCount();printf("\nPuzzle ");Puzzle(); time=TickCount()-time; printf("%d",time);
	time=TickCount();printf("\nQuick ");Quick(); time=TickCount()-time; printf("%d",time);
	time=TickCount();printf("\nBubble ");Bubble(); time=TickCount()-time; printf("%d",time);
	/*time=TickCount();printf("\nFFT ");Oscar(); time=TickCount()-time; printf("%d",time);
*/
}

main()
{
	JustDoIt();
	return 0;
}
