UNIT Clock;

  INTERFACE

    PROCEDURE ClockStart;

    FUNCTION ClockStop: LONGINT;

    PROCEDURE ClockInit;

  IMPLEMENTATION

    USES Timer;

    CONST
      minLong = $80000000;
    VAR
      gTask: TMTask;
      gOverhead: LONGINT;
      gStart: LONGINT;

    PROCEDURE ClockStart;
    BEGIN
      gStart:=minLong;
      WITH gTask DO BEGIN
        tmAddr:=NIL; tmWakeUp:=0; tmReserved:=0
      END;
      InsTime(@gTask); PrimeTime(@gTask, gStart);
    END; {ClockStart}

    FUNCTION ClockStop: LONGINT;
    BEGIN
      RmvTime(@gTask);
      IF gTask.tmCount<0 THEN
        ClockStop:=ABS(gStart-gTask.tmCount)-gOverhead
      ELSE
        ClockStop:=ABS(gStart+(gTask.tmCount*1000))-gOverhead
    END; {ClockStop}

    PROCEDURE ClockInit;
    BEGIN
      gStart:=minLong;
      WITH gTask DO BEGIN
        tmAddr:=NIL; tmWakeUp:=0; tmReserved:=0
      END;
      InsTime(@gTask); PrimeTime(@gTask, gStart);
      RmvTime(@gTask); gOverhead:=-(gStart-gTask.tmCount)
    END; {ClockInit}

END. {Clock}
