MODULE IMatMult;

  IMPORT Clock, Write;

  CONST
    rowSize = 40;
  TYPE
    Index = INTEGER;
    MatrixPtr = POINTER TO Matrix;
    Matrix = ARRAY rowSize,rowSize OF LONGINT;
  VAR
    a, b, r: MatrixPtr;
    i, j: Index;
    seed: LONGINT;

  PROCEDURE InitRandom;
  BEGIN
    seed:=74755
  END InitRandom;

  PROCEDURE Random(): LONGINT;
  BEGIN
    seed:=(seed*1309+13849) MOD 65535;
    RETURN seed
  END Random;

  PROCEDURE InitMatrix(VAR m: Matrix);
    VAR
      temp: LONGINT;
      i, j: Index;
  BEGIN
    FOR i:=0 TO rowSize-1 DO
      FOR j:=0 TO rowSize-1 DO
        temp:=Random(); m[i,j]:=temp-(temp DIV 120)*120-60
      END
    END
  END InitMatrix;

  PROCEDURE InnerProduct(VAR result: LONGINT; a, b: MatrixPtr; row, column: Index);
  (* computes the inner product of A[row,*] and B[*,column] *)
    VAR
      i: Index;
  BEGIN
    result:=0;
    FOR i:=0 TO rowSize-1 DO INC(result, a[row,i]*b[i,column]) END
  END InnerProduct;

(*$MAIN+*)
BEGIN
  NEW(a); NEW(b); NEW(r);
  Clock.Start;
  InitRandom; InitMatrix(a^); InitMatrix(b^);
  FOR i:=0 TO rowSize-1 DO
    FOR j:=0 TO rowSize-1 DO
      InnerProduct(r^[i,j], a, b, i, j)
    END
  END;
  Write.Int(Clock.Stop() DIV 1000, 1);
  DISPOSE(a); DISPOSE(b); DISPOSE(r)
END IMatMult.
