#include <stdio.h>
#include <Math.h>
#include "Clock.h"

#define epsilon 1.0E-8

typedef double (*Operand)(double x);

double f(double x)
{
  return ((x/7+2)*x+1.5)*x+2;
}

double Simpson(double a, double b, Operand f)
{
  long i, n;
  double s, ss, s1, s2, s4, h;

  n=2; h=(b-a)*0.5;
  s1=h*((*f)(a)+(*f)(b)); s2=0; s4=4*h*(*f)(a+h); s=s1+s2+s4;
  do {
    ss=s; n=2*n; h=h*0.5;
    s1=0.5*s1; s2=0.5*s2+0.25*s4; s4=0;
    for(i=1; i<=n; i+=2)
      s4=s4+(*f)(a+i*h);
    s4=4.0*h*s4; s=s1+s2+s4;
  } while (fabs(s-ss)>=epsilon*fabs(s));
  return s/3;
}

main()
{
  double result;
  long count;

  ClockInit(); ClockStart(); count=1;
  do {
    result=Simpson(0, 10, &f); count++;
  } while (count<=100000);
  printf("%ld", ClockStop()/1000);
  return 0;
}
