MODULE Integrate;

  IMPORT Clock, Write;

  CONST
    epsilon = 1.0E-8;
  TYPE
    Operand = PROCEDURE(x:REAL): REAL;
  VAR
    result: REAL;
    count: LONGINT;

  PROCEDURE f(x: REAL): REAL;
  BEGIN
    RETURN ((x/7+2)*x+1.5)*x+2
  END f;

  PROCEDURE Simpson(a, b: REAL; f: Operand): REAL;
    VAR
      i, n: LONGINT;
      s, ss, s1, s2, s4, h: REAL;
  BEGIN
    n:=2; h:=(b-a)*0.5;
    s1:=(f(a)+f(b))*h; s2:=0; s4:=4*h*f(a+h); s:=s1+s2+s4;
    REPEAT
      ss:=s; n:=2*n; h:=h/2;
      s1:=0.5*s1; s2:=0.5*s2+0.25*s4; s4:=0;
      FOR i:=1 TO n BY 2 DO
        s4:=s4+f(a+i*h)
      END;
      s4:=4*h*s4; s:=s1+s2+s4
    UNTIL ABS(s-ss)<epsilon*ABS(s);
    RETURN s/3
  END Simpson;

(*$MAIN+*)
BEGIN
  Clock.Start; count:=1;
  REPEAT
    result:=Simpson(0, 10, f); INC(count)
  UNTIL count>100000;
  Write.Int(Clock.Stop() DIV 1000, 1)
END Integrate.
