PROGRAM KnightsTour;

  USES Clock;

  CONST
    n = 6;
    s = [1..n];
  TYPE
    Index = 1..n;
  VAR
    a, b: ARRAY [1..8] OF INTEGER;
    board: ARRAY [Index,Index] OF INTEGER;

  PROCEDURE SetKnightVecs;
  BEGIN
    a[1]:= 2; b[1]:= 1;
    a[2]:= 1; b[2]:= 2;
    a[3]:=-1; b[3]:= 2;
    a[4]:=-2; b[4]:= 1;
    a[5]:=-2; b[5]:=-1;
    a[6]:=-1; b[6]:=-2;
    a[7]:= 1; b[7]:=-2;
    a[8]:= 2; b[8]:=-1;
  END; {SetKnightVecs}

  PROCEDURE PrintTour;
    VAR
      i, j: INTEGER;
  BEGIN
    FOR i:=1 TO n DO BEGIN
      FOR j:=1 TO n DO {?? Write(board[i,j]:5)};
      {?? WriteLn}
    END
  END; {PrintTour}

  FUNCTION Try(i, x, y: INTEGER): BOOLEAN;
    VAR
      k, u, v: INTEGER;
      q1: BOOLEAN;
  BEGIN
    k:=1;
    REPEAT
      q1:=FALSE; u:=x+a[k]; v:=y+b[k];
      IF (u IN s) AND (v IN s) THEN
        IF board[u,v]=0 THEN BEGIN
          board[u,v]:=i;
          IF i<n*n THEN BEGIN
            q1:=Try(i+1, u, v);
            IF NOT q1 THEN board[u,v]:=0
          END
          ELSE q1:=TRUE
        END;
      k:=k+1
    UNTIL q1 OR (k=9);
    Try:=q1
  END; {Try}

  PROCEDURE Tour(x, y: INTEGER);
    VAR
      i, j: INTEGER;
  BEGIN
    FOR i:=1 TO n DO FOR j:=1 TO n DO board[i,j]:=0;
    board[x,y]:=1;
    IF Try(2, x, y) THEN PrintTour
  END; {Tour}

BEGIN
  SetKnightVecs; ClockInit; ClockStart;
  Tour(1, 1); Write(ClockStop DIV 1000:1)
END. {KnightsTour}