#include <stdio.h>
#include "Types.h"
#include "Clock.h"

#define n 8

typedef char Man;
typedef char Woman;
typedef char Rank;

Woman wmr[][]={
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 7, 2, 6, 5, 1, 3, 8, 4},
  {0, 4, 3, 2, 6, 8, 1, 7, 5},
  {0, 3, 2, 4, 1, 8, 5, 7, 6},
  {0, 3, 8, 4, 2, 5, 6, 7, 1},
  {0, 8, 3, 4, 5, 6, 1, 7, 2},
  {0, 8, 7, 5, 2, 4, 3, 1, 6},
  {0, 2, 4, 6, 3, 1, 7, 5, 8},
  {0, 6, 1, 4, 2, 7, 5, 3, 8}};
Man mwr[][]={
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 4, 6, 2, 5, 8, 1, 3, 7},
  {0, 8, 5, 3, 1, 6, 7, 4, 2},
  {0, 6, 8, 1, 2, 3, 4, 7, 5},
  {0, 3, 2, 4, 7, 6, 8, 5, 1},
  {0, 6, 3, 1, 4, 5, 7, 2, 8},
  {0, 2, 1, 3, 8, 7, 4, 6, 5},
  {0, 3, 5, 7, 2, 4, 1, 8, 6},
  {0, 7, 2, 8, 4, 5, 6, 3, 1}};
Rank rmw[n+1][n+1], rwm[n+1][n+1];
Woman x[n+1];
Man y[n+1];
Boolean single[n+1];

void Print(void)
{
  Man m;
  short rm, rw;

  rm=0; rw=0;
  for(m=1; m<=n; m++) {
    /*?? printf("%4ld", (long)x[m]);*/ rm=rm+rmw[m][x[m]]; rw=rw+rwm[x[m]][m];
  }
  /*?? printf("%8ld%4ld\n", rm, rw);*/
}

Boolean stable(Rank r, Woman w, Man m)
{
  Man pm;
  Woman pw;
  Rank i, lim;
  Boolean s;

  s=true; i=1;
  while ((i<r) && s) {
    pw=wmr[m][i]; i++;
    if (!single[pw])
      s=(rwm[pw][m]>rwm[pw][y[pw]]);
  }
  i=1; lim=rwm[w][m];
  while ((i<lim) && s) {
    pm=mwr[w][i]; i++;
    if (pm<m)
      s=(rmw[pm][w]>rmw[pm][x[pm]]);
  }
  return s;
}

void Try(short m)
{
  Rank r;
  Woman w;

  for(r=1; r<=n; r++) {
    w=wmr[m][r];
    if (single[w])
      if (stable(r, w, m)) {
        x[m]=w; y[w]=m; single[w]=false;
        if (m<n)
          Try(m+1);
        else
          Print();
        single[w]=true;
      }
  }
}

void Search(void)
{
  Man m;
  Woman w;
  Rank r;

  for(m=1; m<=n; m++)
    for(r=1; r<=n; r++)
      rmw[m][wmr[m][r]]=r;
  for(w=1; w<=n; w++)
    for(r=1; r<=n; r++)
      rwm[w][mwr[w][r]]=r;
  for(w=1; w<=n; w++)
    single[w]=true;
  Try(1);
}

main()
{
  long count;

  ClockInit(); ClockStart(); count=1;
  do {
    Search(); count=count+1;
  } while (count<=50);
  printf("%ld", ClockStop()/1000);
  return 0;
}