#include <StdIO.h>
#include <StdLib.h>
#include "Clock.h"

#define rowSize 40

typedef short Index;
typedef double Matrix[rowSize][rowSize];
typedef Matrix *MatrixPtr;

long seed;

void InitRandom()
{
    seed=74755;
}

long Random(void)
{
  seed=(seed*1309+13849)%65535; return seed;
}

void InitMatrix(MatrixPtr m)
{
  long temp, i, j;

  for(i=0; i<rowSize; i++)
    for(j=0; j<rowSize; j++) {
      temp=Random(); (*m)[i][j]=temp-(temp/120)*120-60;
    }
}

void InnerProduct(double *result, MatrixPtr a, MatrixPtr b, Index row, Index column)
// computes the inner product of A[row,*] and B[*,column]
{
  Index i;

  *result=0.0;
  for(i=0; i<rowSize; i++)
    *result+=(*a)[row][i]*(*b)[i][column];
}

main()
{
  MatrixPtr a, b, r;
  Index i, j;

  a=malloc(sizeof(Matrix)); b=malloc(sizeof(Matrix)); r=malloc(sizeof(Matrix));
  ClockInit(); ClockStart();
  InitRandom(); InitMatrix(a); InitMatrix(b);
  for(i=0; i<rowSize; i++)
    for(j=0; j<rowSize; j++)
      InnerProduct(&((*r)[i][j]), a, b, i, j);
  printf("%ld", ClockStop()/1000);
  free(a); free(b); free(r);
  return 0;
}
