PROGRAM IMatMult;

  USES Clock;

  CONST
    rowSize = 40;
  TYPE
    Index = 1..rowSize;
    MatrixPtr = ^Matrix;
    Matrix = ARRAY [Index,Index] OF Double;
  VAR
    a, b, r: MatrixPtr;
    i, j: Index;
    seed: LONGINT;

  PROCEDURE InitRandom;
  BEGIN
    seed:=74755
  END; {InitRandom}

  FUNCTION Random: LONGINT;
  BEGIN
    seed:=(seed*1309+13849) MOD 65535;
    Random:=seed
  END; {Random}

  PROCEDURE InitMatrix(VAR m: Matrix);
    VAR
      temp: LONGINT;
      i, j: Index;
  BEGIN
    FOR i:=1 TO rowSize DO
      FOR j:=1 TO rowSize DO BEGIN
        temp:=Random; m[i,j]:=temp-(temp DIV 120)*120-60;
      END
  END; {InitMatrix}

  PROCEDURE Innerproduct(VAR result: Double; a, b: MatrixPtr; row, column: Index);
  (* computes the inner product of A[row,*] and B[*,column] *)
    VAR
      i: Index;
  BEGIN
    result:=0.0;
    FOR i:=1 TO rowsize DO result:=result+a^[row,i]*b^[i,column]
  END; {Innerproduct}

BEGIN
  New(a); New(b); New(r);
  ClockInit; ClockStart;
  InitRandom; InitMatrix(a^); InitMatrix(b^);
  FOR i:=1 TO rowSize DO
    FOR j:=1 TO rowSize DO InnerProduct(r^[i,j], a, b, i, j);
  Write(ClockStop DIV 1000:1);
  Dispose(a); Dispose(b); Dispose(r)
END. {IMatMult}
