(*
 	File:		AERegistry.mod
 
 	Contains:	AppleEvents Registry Interface.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE AERegistry;

IMPORT Types;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	cAEList*						= LONG("list");						(*  0x6c697374  *)
	cApplication*				= LONG("capp");						(*  0x63617070  *)
	cArc*						= LONG("carc");						(*  0x63617263  *)
	cBoolean*					= LONG("bool");						(*  0x626f6f6c  *)
	cCell*						= LONG("ccel");						(*  0x6363656c  *)
	cChar*						= LONG("cha ");						(*  0x63686120  *)
	cColorTable*					= LONG("clrt");						(*  0x636c7274  *)
	cColumn*						= LONG("ccol");						(*  0x63636f6c  *)
	cDocument*					= LONG("docu");						(*  0x646f6375  *)
	cDrawingArea*				= LONG("cdrw");						(*  0x63647277  *)
	cEnumeration*				= LONG("enum");						(*  0x656e756d  *)
	cFile*						= LONG("file");						(*  0x66696c65  *)
	cFixed*						= LONG("fixd");						(*  0x66697864  *)
	cFixedPoint*					= LONG("fpnt");						(*  0x66706e74  *)
	cFixedRectangle*				= LONG("frct");						(*  0x66726374  *)
	cGraphicLine*				= LONG("glin");						(*  0x676c696e  *)
	cGraphicObject*				= LONG("cgob");						(*  0x63676f62  *)
	cGraphicShape*				= LONG("cgsh");						(*  0x63677368  *)
	cGraphicText*				= LONG("cgtx");						(*  0x63677478  *)
	cGroupedGraphic*				= LONG("cpic");

	cInsertionLoc*				= LONG("insl");						(*  0x696e736c  *)
	cInsertionPoint*				= LONG("cins");						(*  0x63696e73  *)
	cIntlText*					= LONG("itxt");						(*  0x69747874  *)
	cIntlWritingCode*			= LONG("intl");						(*  0x696e746c  *)
	cItem*						= LONG("citm");						(*  0x6369746d  *)
	cLine*						= LONG("clin");						(*  0x636c696e  *)
	cLongDateTime*				= LONG("ldt ");						(*  0x6c647420  *)
	cLongFixed*					= LONG("lfxd");						(*  0x6c667864  *)
	cLongFixedPoint*				= LONG("lfpt");						(*  0x6c667074  *)
	cLongFixedRectangle*			= LONG("lfrc");						(*  0x6c667263  *)
	cLongInteger*				= LONG("long");						(*  0x6c6f6e67  *)
	cLongPoint*					= LONG("lpnt");						(*  0x6c706e74  *)
	cLongRectangle*				= LONG("lrct");						(*  0x6c726374  *)
	cMachineLoc*					= LONG("mLoc");						(*  0x6d4c6f63  *)
	cMenu*						= LONG("cmnu");						(*  0x636d6e75  *)
	cMenuItem*					= LONG("cmen");						(*  0x636d656e  *)
	cObject*						= LONG("cobj");						(*  0x636f626a  *)
	cObjectSpecifier*			= LONG("obj ");						(*  0x6f626a20  *)
	cOpenableObject*				= LONG("coob");						(*  0x636f6f62  *)
	cOval*						= LONG("covl");

	cParagraph*					= LONG("cpar");						(*  0x63706172  *)
	cPICT*						= LONG("PICT");						(*  0x50494354  *)
	cPixel*						= LONG("cpxl");						(*  0x6370786c  *)
	cPixelMap*					= LONG("cpix");						(*  0x63706978  *)
	cPolygon*					= LONG("cpgn");						(*  0x6370676e  *)
	cProperty*					= LONG("prop");						(*  0x70726f70  *)
	cQDPoint*					= LONG("QDpt");						(*  0x51447074  *)
	cQDRectangle*				= LONG("qdrt");						(*  0x71647274  *)
	cRectangle*					= LONG("crec");						(*  0x63726563  *)
	cRGBColor*					= LONG("cRGB");						(*  0x63524742  *)
	cRotation*					= LONG("trot");						(*  0x74726f74  *)
	cRoundedRectangle*			= LONG("crrc");						(*  0x63727263  *)
	cRow*						= LONG("crow");						(*  0x63726f77  *)
	cSelection*					= LONG("csel");						(*  0x6373656c  *)
	cShortInteger*				= LONG("shor");						(*  0x73686f72  *)
	cTable*						= LONG("ctbl");						(*  0x6374626c  *)
	cText*						= LONG("ctxt");						(*  0x63747874  *)
	cTextFlow*					= LONG("cflo");						(*  0x63666c6f  *)
	cTextStyles*					= LONG("tsty");						(*  0x74737479  *)
	cType*						= LONG("type");

	cVersion*					= LONG("vers");						(*  0x76657273  *)
	cWindow*						= LONG("cwin");						(*  0x6377696e  *)
	cWord*						= LONG("cwor");						(*  0x63776f72  *)
	enumArrows*					= LONG("arro");						(*  0x6172726f  *)
	enumJustification*			= LONG("just");						(*  0x6a757374  *)
	enumKeyForm*					= LONG("kfrm");						(*  0x6b66726d  *)
	enumPosition*				= LONG("posi");						(*  0x706f7369  *)
	enumProtection*				= LONG("prtn");						(*  0x7072746e  *)
	enumQuality*					= LONG("qual");						(*  0x7175616c  *)
	enumSaveOptions*				= LONG("savo");						(*  0x7361766f  *)
	enumStyle*					= LONG("styl");						(*  0x7374796c  *)
	enumTransferMode*			= LONG("tran");						(*  0x7472616e  *)
	formUniqueID*				= 'AIFF.ID  ';						(*  0x49442020  *)
	kAEAbout*					= LONG("abou");						(*  0x61626f75  *)
	kAEAfter*					= LONG("afte");						(*  0x61667465  *)
	kAEAliasSelection*			= LONG("sali");						(*  0x73616c69  *)
	kAEAllCaps*					= LONG("alcp");						(*  0x616c6370  *)
	kAEArrowAtEnd*				= LONG("aren");						(*  0x6172656e  *)
	kAEArrowAtStart*				= LONG("arst");						(*  0x61727374  *)
	kAEArrowBothEnds*			= LONG("arbo");

	kAEAsk*						= LONG("ask ");						(*  0x61736b20  *)
	kAEBefore*					= LONG("befo");						(*  0x6265666f  *)
	kAEBeginning*				= LONG("bgng");						(*  0x62676e67  *)
	kAEBeginsWith*				= LONG("bgwt");						(*  0x62677774  *)
	kAEBeginTransaction*			= LONG("begi");						(*  0x62656769  *)
	kAEBold*						= LONG("bold");						(*  0x626f6c64  *)
	kAECaseSensEquals*			= LONG("cseq");						(*  0x63736571  *)
	kAECentered*					= LONG("cent");						(*  0x63656e74  *)
	kAEChangeView*				= LONG("view");						(*  0x76696577  *)
	kAEClone*					= LONG("clon");						(*  0x636c6f6e  *)
	kAEClose*					= LONG("clos");						(*  0x636c6f73  *)
	kAECondensed*				= LONG("cond");						(*  0x636f6e64  *)
	kAEContains*					= LONG("cont");						(*  0x636f6e74  *)
	kAECopy*						= LONG("copy");						(*  0x636f7079  *)
	kAECoreSuite*				= LONG("core");						(*  0x636f7265  *)
	kAECountElements*			= LONG("cnte");						(*  0x636e7465  *)
	kAECreateElement*			= LONG("crel");						(*  0x6372656c  *)
	kAECreatePublisher*			= LONG("cpub");						(*  0x63707562  *)
	kAECut*						= LONG("cut ");						(*  0x63757420  *)
	kAEDelete*					= LONG("delo");

	kAEDoObjectsExist*			= LONG("doex");						(*  0x646f6578  *)
	kAEDoScript*					= LONG("dosc");						(*  0x646f7363  *)
	kAEDrag*						= LONG("drag");						(*  0x64726167  *)
	kAEDuplicateSelection*		= LONG("sdup");						(*  0x73647570  *)
	kAEEditGraphic*				= LONG("edit");						(*  0x65646974  *)
	kAEEmptyTrash*				= LONG("empt");						(*  0x656d7074  *)
	kAEEnd*						= LONG("end ");						(*  0x656e6420  *)
	kAEEndsWith*					= LONG("ends");						(*  0x656e6473  *)
	kAEEndTransaction*			= LONG("endt");						(*  0x656e6474  *)
	kAEEquals*					= LONG("=   ");						(*  0x3d202020  *)
	kAEExpanded*					= LONG("pexp");						(*  0x70657870  *)
	kAEFast*						= LONG("fast");						(*  0x66617374  *)
	kAEFinderEvents*				= LONG("FNDR");						(*  0x464e4452  *)
	kAEFormulaProtect*			= LONG("fpro");						(*  0x6670726f  *)
	kAEFullyJustified*			= LONG("full");						(*  0x66756c6c  *)
	kAEGetClassInfo*				= LONG("qobj");						(*  0x716f626a  *)
	kAEGetData*					= LONG("getd");						(*  0x67657464  *)
	kAEGetDataSize*				= LONG("dsiz");						(*  0x6473697a  *)
	kAEGetEventInfo*				= LONG("gtei");						(*  0x67746569  *)
	kAEGetInfoSelection*			= LONG("sinf");

	kAEGetPrivilegeSelection*	= LONG("sprv");						(*  0x73707276  *)
	kAEGetSuiteInfo*				= LONG("gtsi");						(*  0x67747369  *)
	kAEGreaterThan*				= LONG(">   ");						(*  0x3e202020  *)
	kAEGreaterThanEquals*		= LONG(">=  ");						(*  0x3e3d2020  *)
	kAEGrow*						= LONG("grow");						(*  0x67726f77  *)
	kAEHidden*					= LONG("hidn");						(*  0x6869646e  *)
	kAEHiQuality*				= LONG("hiqu");						(*  0x68697175  *)
	kAEImageGraphic*				= LONG("imgr");						(*  0x696d6772  *)
	kAEIsUniform*				= LONG("isun");						(*  0x6973756e  *)
	kAEItalic*					= LONG("ital");						(*  0x6974616c  *)
	kAELeftJustified*			= LONG("left");						(*  0x6c656674  *)
	kAELessThan*					= LONG("<   ");						(*  0x3c202020  *)
	kAELessThanEquals*			= LONG("<=  ");						(*  0x3c3d2020  *)
	kAELowercase*				= LONG("lowc");						(*  0x6c6f7763  *)
	kAEMakeObjectsVisible*		= LONG("mvis");						(*  0x6d766973  *)
	kAEMiscStandards*			= LONG("misc");						(*  0x6d697363  *)
	kAEModifiable*				= LONG("modf");						(*  0x6d6f6466  *)
	kAEMove*						= LONG("move");						(*  0x6d6f7665  *)
	kAENo*						= LONG("no  ");						(*  0x6e6f2020  *)
	kAENoArrow*					= LONG("arno");

	kAENonmodifiable*			= LONG("nmod");						(*  0x6e6d6f64  *)
	kAEOpen*						= LONG("odoc");						(*  0x6f646f63  *)
	kAEOpenSelection*			= LONG("sope");						(*  0x736f7065  *)
	kAEOutline*					= LONG("outl");						(*  0x6f75746c  *)
	kAEPageSetup*				= LONG("pgsu");						(*  0x70677375  *)
	kAEPaste*					= LONG("past");						(*  0x70617374  *)
	kAEPlain*					= LONG("plan");						(*  0x706c616e  *)
	kAEPrint*					= LONG("pdoc");						(*  0x70646f63  *)
	kAEPrintSelection*			= LONG("spri");						(*  0x73707269  *)
	kAEPrintWindow*				= LONG("pwin");						(*  0x7077696e  *)
	kAEPutAwaySelection*			= LONG("sput");						(*  0x73707574  *)
	kAEQDAddOver*				= LONG("addo");						(*  0x6164646f  *)
	kAEQDAddPin*					= LONG("addp");						(*  0x61646470  *)
	kAEQDAdMax*					= LONG("admx");						(*  0x61646d78  *)
	kAEQDAdMin*					= LONG("admn");						(*  0x61646d6e  *)
	kAEQDBic*					= LONG("bic ");						(*  0x62696320  *)
	kAEQDBlend*					= LONG("blnd");						(*  0x626c6e64  *)
	kAEQDCopy*					= LONG("cpy ");						(*  0x63707920  *)
	kAEQDNotBic*					= LONG("nbic");						(*  0x6e626963  *)
	kAEQDNotCopy*				= LONG("ncpy");

	kAEQDNotOr*					= LONG("ntor");						(*  0x6e746f72  *)
	kAEQDNotXor*					= LONG("nxor");						(*  0x6e786f72  *)
	kAEQDOr*						= LONG("or  ");						(*  0x6f722020  *)
	kAEQDSubOver*				= LONG("subo");						(*  0x7375626f  *)
	kAEQDSubPin*					= LONG("subp");						(*  0x73756270  *)
	kAEQDSupplementalSuite*		= LONG("qdsp");						(*  0x71647370  *)
	kAEQDXor*					= LONG("xor ");						(*  0x786f7220  *)
	kAEQuickdrawSuite*			= LONG("qdrw");						(*  0x71647277  *)
	kAEQuitAll*					= LONG("quia");						(*  0x71756961  *)
	kAERedo*						= LONG("redo");						(*  0x7265646f  *)
	kAERegular*					= LONG("regl");						(*  0x7265676c  *)
	kAEReplace*					= LONG("rplc");						(*  0x72706c63  *)
	kAERequiredSuite*			= LONG("reqd");						(*  0x72657164  *)
	kAERestart*					= LONG("rest");						(*  0x72657374  *)
	kAERevealSelection*			= LONG("srev");						(*  0x73726576  *)
	kAERevert*					= LONG("rvrt");						(*  0x72767274  *)
	kAERightJustified*			= LONG("rght");						(*  0x72676874  *)
	kAESave*						= LONG("save");						(*  0x73617665  *)
	kAESelect*					= LONG("slct");						(*  0x736c6374  *)
	kAESetData*					= LONG("setd");

	kAESetPosition*				= LONG("posn");						(*  0x706f736e  *)
	kAEShadow*					= LONG("shad");						(*  0x73686164  *)
	kAEShowClipboard*			= LONG("shcl");						(*  0x7368636c  *)
	kAEShutDown*					= LONG("shut");						(*  0x73687574  *)
	kAESleep*					= LONG("slep");						(*  0x736c6570  *)
	kAESmallCaps*				= LONG("smcp");						(*  0x736d6370  *)
	kAESpecialClassProperties*	= LONG("c.#!");						(*  0x63402321  *)
	kAEStrikethrough*			= LONG("strk");						(*  0x7374726b  *)
	kAESubscript*				= LONG("sbsc");						(*  0x73627363  *)
	kAESuperscript*				= LONG("spsc");						(*  0x73707363  *)
	kAETableSuite*				= LONG("tbls");						(*  0x74626c73  *)
	kAETextSuite*				= LONG("TEXT");						(*  0x54455854  *)
	kAETransactionTerminated*	= LONG("ttrm");						(*  0x7474726d  *)
	kAEUnderline*				= LONG("undl");						(*  0x756e646c  *)
	kAEUndo*						= LONG("undo");						(*  0x756e646f  *)
	kAEWholeWordEquals*			= LONG("wweq");						(*  0x77776571  *)
	kAEYes*						= LONG("yes ");						(*  0x79657320  *)
	kAEZoom*						= LONG("zoom");						(*  0x7a6f6f6d  *)
	keyAEAngle*					= LONG("kang");						(*  0x6b616e67  *)
	keyAEArcAngle*				= LONG("parc");

	keyAEBaseAddr*				= LONG("badd");						(*  0x62616464  *)
	keyAEBestType*				= LONG("pbst");						(*  0x70627374  *)
	keyAEBgndColor*				= LONG("kbcl");						(*  0x6b62636c  *)
	keyAEBgndPattern*			= LONG("kbpt");						(*  0x6b627074  *)
	keyAEBounds*					= LONG("pbnd");						(*  0x70626e64  *)
	keyAECellList*				= LONG("kclt");						(*  0x6b636c74  *)
	keyAEClassID*				= LONG("clID");						(*  0x636c4944  *)
	keyAEColor*					= LONG("colr");						(*  0x636f6c72  *)
	keyAEColorTable*				= LONG("cltb");						(*  0x636c7462  *)
	keyAECurveHeight*			= LONG("kchd");						(*  0x6b636864  *)
	keyAECurveWidth*				= LONG("kcwd");						(*  0x6b637764  *)
	keyAEDashStyle*				= LONG("pdst");						(*  0x70647374  *)
	keyAEData*					= LONG("data");						(*  0x64617461  *)
	keyAEDefaultType*			= LONG("deft");						(*  0x64656674  *)
	keyAEDefinitionRect*			= LONG("pdrt");						(*  0x70647274  *)
	keyAEDescType*				= LONG("dstp");						(*  0x64737470  *)
	keyAEDestination*			= LONG("dest");						(*  0x64657374  *)
	keyAEDoAntiAlias*			= LONG("anta");						(*  0x616e7461  *)
	keyAEDoDithered*				= LONG("gdit");						(*  0x67646974  *)
	keyAEDoRotate*				= LONG("kdrt");

	keyAEDoScale*				= LONG("ksca");						(*  0x6b736361  *)
	keyAEDoTranslate*			= LONG("ktra");						(*  0x6b747261  *)
	keyAEEditionFileLoc*			= LONG("eloc");						(*  0x656c6f63  *)
	keyAEElements*				= LONG("elms");						(*  0x656c6d73  *)
	keyAEEndPoint*				= LONG("pend");						(*  0x70656e64  *)
	keyAEEventClass*				= LONG("evcl");						(*  0x6576636c  *)
	keyAEEventID*				= LONG("evti");						(*  0x65767469  *)
	keyAEFile*					= LONG("kfil");						(*  0x6b66696c  *)
	keyAEFileType*				= LONG("fltp");						(*  0x666c7470  *)
	keyAEFillColor*				= LONG("flcl");						(*  0x666c636c  *)
	keyAEFillPattern*			= LONG("flpt");						(*  0x666c7074  *)
	keyAEFlipHorizontal*			= LONG("kfho");						(*  0x6b66686f  *)
	keyAEFlipVertical*			= LONG("kfvt");						(*  0x6b667674  *)
	keyAEFont*					= LONG("font");						(*  0x666f6e74  *)
	keyAEFormula*				= LONG("pfor");						(*  0x70666f72  *)
	keyAEGraphicObjects*			= LONG("gobs");						(*  0x676f6273  *)
	keyAEID*						= 'AIFF.ID  ';						(*  0x49442020  *)
	keyAEImageQuality*			= LONG("gqua");						(*  0x67717561  *)
	keyAEInsertHere*				= LONG("insh");						(*  0x696e7368  *)
	keyAEKeyForms*				= LONG("keyf");

	keyAEKeyword*				= LONG("kywd");						(*  0x6b797764  *)
	keyAELevel*					= LONG("levl");						(*  0x6c65766c  *)
	keyAELineArrow*				= LONG("arro");						(*  0x6172726f  *)
	keyAEName*					= LONG("pnam");						(*  0x706e616d  *)
	keyAENewElementLoc*			= LONG("pnel");						(*  0x706e656c  *)
	keyAEObject*					= LONG("kobj");						(*  0x6b6f626a  *)
	keyAEObjectClass*			= LONG("kocl");						(*  0x6b6f636c  *)
	keyAEOffStyles*				= LONG("ofst");						(*  0x6f667374  *)
	keyAEOnStyles*				= LONG("onst");						(*  0x6f6e7374  *)
	keyAEParameters*				= LONG("prms");						(*  0x70726d73  *)
	keyAEParamFlags*				= LONG("pmfg");						(*  0x706d6667  *)
	keyAEPenColor*				= LONG("ppcl");						(*  0x7070636c  *)
	keyAEPenPattern*				= LONG("pppa");						(*  0x70707061  *)
	keyAEPenWidth*				= LONG("ppwd");						(*  0x70707764  *)
	keyAEPixelDepth*				= LONG("pdpt");						(*  0x70647074  *)
	keyAEPixMapMinus*			= LONG("kpmm");						(*  0x6b706d6d  *)
	keyAEPMTable*				= LONG("kpmt");						(*  0x6b706d74  *)
	keyAEPointList*				= LONG("ptlt");						(*  0x70746c74  *)
	keyAEPointSize*				= LONG("ptsz");						(*  0x7074737a  *)
	keyAEPosition*				= LONG("kpos");

	keyAEPropData*				= LONG("prdt");						(*  0x70726474  *)
	keyAEProperties*				= LONG("qpro");						(*  0x7170726f  *)
	keyAEProperty*				= LONG("kprp");						(*  0x6b707270  *)
	keyAEPropFlags*				= LONG("prfg");						(*  0x70726667  *)
	keyAEPropID*					= LONG("prop");						(*  0x70726f70  *)
	keyAEProtection*				= LONG("ppro");						(*  0x7070726f  *)
	keyAERenderAs*				= LONG("kren");						(*  0x6b72656e  *)
	keyAERequestedType*			= LONG("rtyp");						(*  0x72747970  *)
	keyAEResult*					= LONG("----");						(*  0x2d2d2d2d  *)
	keyAEResultInfo*				= LONG("rsin");						(*  0x7273696e  *)
	keyAERotation*				= LONG("prot");						(*  0x70726f74  *)
	keyAERotPoint*				= LONG("krtp");						(*  0x6b727470  *)
	keyAERowList*				= LONG("krls");						(*  0x6b726c73  *)
	keyAESaveOptions*			= LONG("savo");						(*  0x7361766f  *)
	keyAEScale*					= LONG("pscl");						(*  0x7073636c  *)
	keyAEScriptTag*				= LONG("psct");						(*  0x70736374  *)
	keyAEShowWhere*				= LONG("show");						(*  0x73686f77  *)
	keyAEStartAngle*				= LONG("pang");						(*  0x70616e67  *)
	keyAEStartPoint*				= LONG("pstp");						(*  0x70737470  *)
	keyAEStyles*					= LONG("ksty");

	keyAESuiteID*				= LONG("suit");						(*  0x73756974  *)
	keyAEText*					= LONG("ktxt");						(*  0x6b747874  *)
	keyAETextColor*				= LONG("ptxc");						(*  0x70747863  *)
	keyAETextFont*				= LONG("ptxf");						(*  0x70747866  *)
	keyAETextPointSize*			= LONG("ptps");						(*  0x70747073  *)
	keyAETextStyles*				= LONG("txst");						(*  0x74787374  *)
	keyAETheText*				= LONG("thtx");						(*  0x74687478  *)
	keyAETransferMode*			= LONG("pptm");						(*  0x7070746d  *)
	keyAETranslation*			= LONG("ptrs");						(*  0x70747273  *)
	keyAETryAsStructGraf*		= LONG("toog");						(*  0x746f6f67  *)
	keyAEUniformStyles*			= LONG("ustl");						(*  0x7573746c  *)
	keyAEUpdateOn*				= LONG("pupd");						(*  0x70757064  *)
	keyAEUserTerm*				= LONG("utrm");						(*  0x7574726d  *)
	keyAEWindow*					= LONG("wndw");						(*  0x776e6477  *)
	keyAEWritingCode*			= LONG("wrcd");						(*  0x77726364  *)
	keyAETSMScriptTag*			= LONG("sclg");
	keyAETSMTextFont*			= LONG("ktxf");
	keyAETSMTextPointSize*		= LONG("ktps");
	keyMiscellaneous*			= LONG("fmsc");

	keySelection*				= LONG("fsel");						(*  0x6673656c  *)
	keyWindow*					= LONG("kwnd");

	pArcAngle*					= LONG("parc");						(*  0x70617263  *)
	pBackgroundColor*			= LONG("pbcl");						(*  0x7062636c  *)
	pBackgroundPattern*			= LONG("pbpt");						(*  0x70627074  *)
	pBestType*					= LONG("pbst");						(*  0x70627374  *)
	pBounds*						= LONG("pbnd");						(*  0x70626e64  *)
	pClass*						= LONG("pcls");						(*  0x70636c73  *)
	pClipboard*					= LONG("pcli");						(*  0x70636c69  *)
	pColor*						= LONG("colr");						(*  0x636f6c72  *)
	pColorTable*					= LONG("cltb");						(*  0x636c7462  *)
	pContents*					= LONG("pcnt");						(*  0x70636e74  *)
	pCornerCurveHeight*			= LONG("pchd");						(*  0x70636864  *)
	pCornerCurveWidth*			= LONG("pcwd");						(*  0x70637764  *)
	pDashStyle*					= LONG("pdst");						(*  0x70647374  *)
	pDefaultType*				= LONG("deft");						(*  0x64656674  *)
	pDefinitionRect*				= LONG("pdrt");						(*  0x70647274  *)
	pEnabled*					= LONG("enbl");						(*  0x656e626c  *)
	pEndPoint*					= LONG("pend");						(*  0x70656e64  *)
	pFillColor*					= LONG("flcl");						(*  0x666c636c  *)
	pFillPattern*				= LONG("flpt");						(*  0x666c7074  *)
	pFont*						= LONG("font");

	pFormula*					= LONG("pfor");						(*  0x70666f72  *)
	pGraphicObjects*				= LONG("gobs");						(*  0x676f6273  *)
	pHasCloseBox*				= LONG("hclb");						(*  0x68636c62  *)
	pHasTitleBar*				= LONG("ptit");						(*  0x70746974  *)
	pID*							= 'AIFF.ID  ';						(*  0x49442020  *)
	pIndex*						= LONG("pidx");						(*  0x70696478  *)
	pInsertionLoc*				= LONG("pins");						(*  0x70696e73  *)
	pIsFloating*					= LONG("isfl");						(*  0x6973666c  *)
	pIsFrontProcess*				= LONG("pisf");						(*  0x70697366  *)
	pIsModal*					= LONG("pmod");						(*  0x706d6f64  *)
	pIsModified*					= LONG("imod");						(*  0x696d6f64  *)
	pIsResizable*				= LONG("prsz");						(*  0x7072737a  *)
	pIsStationeryPad*			= LONG("pspd");						(*  0x70737064  *)
	pIsZoomable*					= LONG("iszm");						(*  0x69737a6d  *)
	pIsZoomed*					= LONG("pzum");						(*  0x707a756d  *)
	pItemNumber*					= LONG("itmn");						(*  0x69746d6e  *)
	pJustification*				= LONG("pjst");						(*  0x706a7374  *)
	pLineArrow*					= LONG("arro");						(*  0x6172726f  *)
	pMenuID*						= LONG("mnid");						(*  0x6d6e6964  *)
	pName*						= LONG("pnam");

	pNewElementLoc*				= LONG("pnel");						(*  0x706e656c  *)
	pPenColor*					= LONG("ppcl");						(*  0x7070636c  *)
	pPenPattern*					= LONG("pppa");						(*  0x70707061  *)
	pPenWidth*					= LONG("ppwd");						(*  0x70707764  *)
	pPixelDepth*					= LONG("pdpt");						(*  0x70647074  *)
	pPointList*					= LONG("ptlt");						(*  0x70746c74  *)
	pPointSize*					= LONG("ptsz");						(*  0x7074737a  *)
	pProtection*					= LONG("ppro");						(*  0x7070726f  *)
	pRotation*					= LONG("prot");						(*  0x70726f74  *)
	pScale*						= LONG("pscl");						(*  0x7073636c  *)
	pScript*						= LONG("scpt");						(*  0x73637074  *)
	pScriptTag*					= LONG("psct");						(*  0x70736374  *)
	pSelected*					= LONG("selc");						(*  0x73656c63  *)
	pSelection*					= LONG("sele");						(*  0x73656c65  *)
	pStartAngle*					= LONG("pang");						(*  0x70616e67  *)
	pStartPoint*					= LONG("pstp");						(*  0x70737470  *)
	pTextColor*					= LONG("ptxc");						(*  0x70747863  *)
	pTextFont*					= LONG("ptxf");						(*  0x70747866  *)
	pTextItemDelimiters*			= LONG("txdl");						(*  0x7478646c  *)
	pTextPointSize*				= LONG("ptps");

	pTextStyles*					= LONG("txst");						(*  0x74787374  *)
	pTransferMode*				= LONG("pptm");						(*  0x7070746d  *)
	pTranslation*				= LONG("ptrs");						(*  0x70747273  *)
	pUniformStyles*				= LONG("ustl");						(*  0x7573746c  *)
	pUpdateOn*					= LONG("pupd");						(*  0x70757064  *)
	pUserSelection*				= LONG("pusl");						(*  0x7075736c  *)
	pVersion*					= LONG("vers");						(*  0x76657273  *)
	pVisible*					= LONG("pvis");

	typeAEText*					= LONG("tTXT");						(*  0x74545854  *)
	typeArc*						= LONG("carc");						(*  0x63617263  *)
	typeBest*					= LONG("best");						(*  0x62657374  *)
	typeCell*					= LONG("ccel");						(*  0x6363656c  *)
	typeClassInfo*				= LONG("gcli");						(*  0x67636c69  *)
	typeColorTable*				= LONG("clrt");						(*  0x636c7274  *)
	typeColumn*					= LONG("ccol");						(*  0x63636f6c  *)
	typeDashStyle*				= LONG("tdas");						(*  0x74646173  *)
	typeData*					= LONG("tdta");						(*  0x74647461  *)
	typeDrawingArea*				= LONG("cdrw");						(*  0x63647277  *)
	typeElemInfo*				= LONG("elin");						(*  0x656c696e  *)
	typeEnumeration*				= LONG("enum");						(*  0x656e756d  *)
	typeEPS*						= LONG("EPS ");						(*  0x45505320  *)
	typeEventInfo*				= LONG("evin");

	typeFinderWindow*			= LONG("fwin");						(*  0x6677696e  *)
	typeFixedPoint*				= LONG("fpnt");						(*  0x66706e74  *)
	typeFixedRectangle*			= LONG("frct");						(*  0x66726374  *)
	typeGraphicLine*				= LONG("glin");						(*  0x676c696e  *)
	typeGraphicText*				= LONG("cgtx");						(*  0x63677478  *)
	typeGroupedGraphic*			= LONG("cpic");						(*  0x63706963  *)
	typeInsertionLoc*			= LONG("insl");						(*  0x696e736c  *)
	typeIntlText*				= LONG("itxt");						(*  0x69747874  *)
	typeIntlWritingCode*			= LONG("intl");						(*  0x696e746c  *)
	typeLongDateTime*			= LONG("ldt ");						(*  0x6c647420  *)
	typeLongFixed*				= LONG("lfxd");						(*  0x6c667864  *)
	typeLongFixedPoint*			= LONG("lfpt");						(*  0x6c667074  *)
	typeLongFixedRectangle*		= LONG("lfrc");						(*  0x6c667263  *)
	typeLongPoint*				= LONG("lpnt");						(*  0x6c706e74  *)
	typeLongRectangle*			= LONG("lrct");						(*  0x6c726374  *)
	typeMachineLoc*				= LONG("mLoc");						(*  0x6d4c6f63  *)
	typeOval*					= LONG("covl");						(*  0x636f766c  *)
	typeParamInfo*				= LONG("pmin");						(*  0x706d696e  *)
	typePict*					= LONG("PICT");

	typePixelMap*				= LONG("cpix");						(*  0x63706978  *)
	typePixMapMinus*				= LONG("tpmm");						(*  0x74706d6d  *)
	typePolygon*					= LONG("cpgn");						(*  0x6370676e  *)
	typePropInfo*				= LONG("pinf");						(*  0x70696e66  *)
	typeQDPoint*					= LONG("QDpt");						(*  0x51447074  *)
	typeRectangle*				= LONG("crec");						(*  0x63726563  *)
	typeRGB16*					= LONG("tr16");						(*  0x74723136  *)
	typeRGB96*					= LONG("tr96");						(*  0x74723936  *)
	typeRGBColor*				= LONG("cRGB");						(*  0x63524742  *)
	typeRotation*				= LONG("trot");						(*  0x74726f74  *)
	typeRoundedRectangle*		= LONG("crrc");						(*  0x63727263  *)
	typeRow*						= LONG("crow");						(*  0x63726f77  *)
	typeScrapStyles*				= LONG("styl");						(*  0x7374796c  *)
	typeScript*					= LONG("scpt");						(*  0x73637074  *)
	typeStyledText*				= LONG("STXT");						(*  0x53545854  *)
	typeSuiteInfo*				= LONG("suin");						(*  0x7375696e  *)
	typeTable*					= LONG("ctbl");						(*  0x6374626c  *)
	typeTextStyles*				= LONG("tsty");

	typeTIFF*					= LONG("TIFF");						(*  0x54494646  *)
	typeVersion*					= LONG("vers");

	kBySmallIcon*				= 0;
	kByIconView*					= 1;
	kByNameView*					= 2;
	kByDateView*					= 3;
	kBySizeView*					= 4;
	kByKindView*					= 5;
	kByCommentView*				= 6;
	kByLabelView*				= 7;
	kByVersionView*				= 8;

	kAEInfo*						= 11;
	kAEMain*						= 0;
	kAESharing*					= 13;

	kAEZoomIn*					= 7;
	kAEZoomOut*					= 8;


TYPE
	WritingCode* = RECORD
		theScriptCode*:			Types.ScriptCode;
		theLangCode*:			Types.LangCode;
	END;

	IntlText* = RECORD
		theScriptCode*:			Types.ScriptCode;
		theLangCode*:			Types.LangCode;
		theText*:				ARRAY 1 OF CHAR (*PACKED ARRAY [0..0] OF CHAR*);			(* variable length data *)
	END;


(* $ALIGN RESET*)
(* $POP*)

(* $SETC UsingIncludes := AERegistryIncludes*)

 END AERegistry.
