(*
 	File:		ASRegistry.mod
 
 	Contains:	AppleScript Registry constants.
 
 	Version:	Technology:	AppleScript 1.1
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE ASRegistry;

IMPORT AppleEvents, AERegistry, AEObjects;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	keyAETarget*					= LONG("targ");						(*  0x74617267  *)
	keySubjectAttr*				= LONG("subj");						(*  0x7375626a  *)
(* Magic 'returning' parameter*: *)
	keyASReturning*				= LONG("Krtn");						(*  0x4b72746e  *)
(* AppleScript Specific Codes*: *)
	kASAppleScriptSuite*			= LONG("ascr");						(*  0x61736372  *)
	kASTypeNamesSuite*			= LONG("tpnm");						(*  0x74706e6d  *)
(* dynamic terminologies *)
	typeAETE*					= LONG("aete");						(*  0x61657465  *)
	typeAEUT*					= LONG("aeut");						(*  0x61657574  *)
	kGetAETE*					= LONG("gdte");						(*  0x67647465  *)
	kGetAEUT*					= LONG("gdut");						(*  0x67647574  *)
	kUpdateAEUT*					= LONG("udut");						(*  0x75647574  *)
	kUpdateAETE*					= LONG("udte");						(*  0x75647465  *)
	kCleanUpAEUT*				= LONG("cdut");						(*  0x63647574  *)
	kASComment*					= LONG("cmnt");						(*  0x636d6e74  *)
	kASLaunchEvent*				= LONG("noop");						(*  0x6e6f6f70  *)
	keyScszResource*				= LONG("scsz");						(*  0x7363737A  *)
	typeScszResource*			= LONG("scsz");						(*  0x7363737A  *)
(* subroutine calls *)
	kASSubroutineEvent*			= LONG("psbr");						(*  0x70736272  *)
	keyASSubroutineName*			= LONG("snam");

(* Operator Events*: *)
(* Binary*: *)
	kASAdd*						= LONG("+   ");						(*  0x2b202020  *)
	kASSubtract*					= LONG("-   ");						(*  0x2d202020  *)
	kASMultiply*					= LONG("*   ");						(*  0x2a202020  *)
	kASDivide*					= LONG("/   ");						(*  0x2f202020  *)
	kASQuotient*					= LONG("div ");						(*  0x64697620  *)
	kASRemainder*				= LONG("mod ");						(*  0x6d6f6420  *)
	kASPower*					= LONG("^   ");						(*  0x5e202020  *)
	kASEqual*					= AERegistry.kAEEquals;
	kASNotEqual*					= LONG("   ");						(*  0xad202020  *)
	kASGreaterThan*				= AERegistry.kAEGreaterThan;
	kASGreaterThanOrEqual*		= AERegistry.kAEGreaterThanEquals;
	kASLessThan*					= AERegistry.kAELessThan;
	kASLessThanOrEqual*			= AERegistry.kAELessThanEquals;
	kASComesBefore*				= LONG("cbfr");						(*  0x63626672  *)
	kASComesAfter*				= LONG("cafr");						(*  0x63616672  *)
	kASConcatenate*				= LONG("ccat");						(*  0x63636174  *)
	kASStartsWith*				= AERegistry.kAEBeginsWith;
	kASEndsWith*					= AERegistry.kAEEndsWith;
	kASContains*					= AERegistry.kAEContains;

	kASAnd*						= AEObjects.kAEAND;
	kASOr*						= AEObjects.kAEOR;
(* Unary*: *)
	kASNot*						= AEObjects.kAENOT;
	kASNegate*					= LONG("neg ");						(*  0x6e656720  *)
	keyASArg*					= LONG("arg ");

(* event code for the 'error' statement *)
	kASErrorEventCode*			= LONG("err ");						(*  0x65727220  *)
	kOSAErrorArgs*				= LONG("erra");						(*  0x65727261  *)
(* Properties*: *)
	pLength*						= LONG("leng");						(*  0x6c656e67  *)
	pReverse*					= LONG("rvse");						(*  0x72767365  *)
	pRest*						= LONG("rest");						(*  0x72657374  *)
	pInherits*					= LONG("c.#POINTER TO ");						(*  0x6340235e  *)
(* User-Defined Record Fields*: *)
	keyASUserRecordFields*		= LONG("usrf");						(*  0x75737266  *)
	typeUserRecordFields*		= AppleEvents.typeAEList;

(* Prepositions*: *)
	keyASPrepositionAt*			= LONG("at  ");						(*  0x61742020  *)
	keyASPrepositionIn*			= LONG("in  ");						(*  0x696e2020  *)
	keyASPrepositionFrom*		= LONG("from");						(*  0x66726f6d  *)
	keyASPrepositionFor*			= LONG("for ");						(*  0x666f7220  *)
	keyASPrepositionTo*			= LONG("to  ");						(*  0x746f2020  *)
	keyASPrepositionThru*		= LONG("thru");						(*  0x74687275  *)
	keyASPrepositionThrough*		= LONG("thgh");						(*  0x74686768  *)
	keyASPrepositionBy*			= LONG("by  ");						(*  0x62792020  *)
	keyASPrepositionOn*			= LONG("on  ");						(*  0x6f6e2020  *)
	keyASPrepositionInto*		= LONG("into");						(*  0x696e746f  *)
	keyASPrepositionOnto*		= LONG("onto");						(*  0x6f6e746f  *)
	keyASPrepositionBetween*		= LONG("btwn");						(*  0x6274776e  *)
	keyASPrepositionAgainst*		= LONG("agst");						(*  0x61677374  *)
	keyASPrepositionOutOf*		= LONG("outo");						(*  0x6f75746f  *)
	keyASPrepositionInsteadOf*	= LONG("isto");						(*  0x6973746f  *)
	keyASPrepositionAsideFrom*	= LONG("asdf");						(*  0x61736466  *)
	keyASPrepositionAround*		= LONG("arnd");						(*  0x61726e64  *)
	keyASPrepositionBeside*		= LONG("bsid");						(*  0x62736964  *)
	keyASPrepositionBeneath*		= LONG("bnth");						(*  0x626e7468  *)
	keyASPrepositionUnder*		= LONG("undr");

	keyASPrepositionOver*		= LONG("over");						(*  0x6f766572  *)
	keyASPrepositionAbove*		= LONG("abve");						(*  0x61627665  *)
	keyASPrepositionBelow*		= LONG("belw");						(*  0x62656c77  *)
	keyASPrepositionApartFrom*	= LONG("aprt");						(*  0x61707274  *)
	keyASPrepositionGiven*		= LONG("givn");						(*  0x6769766e  *)
	keyASPrepositionWith*		= LONG("with");						(*  0x77697468  *)
	keyASPrepositionWithout*		= LONG("wout");						(*  0x776f7574  *)
	keyASPrepositionAbout*		= LONG("abou");						(*  0x61626f75  *)
	keyASPrepositionSince*		= LONG("snce");						(*  0x736e6365  *)
	keyASPrepositionUntil*		= LONG("till");

(* Terminology & Dialect things*: *)
	kDialectBundleResType*		= LONG("Dbdl");						(*  0x4462646c  *)
(* AppleScript Classes and Enums*: *)
	cConstant*					= AppleEvents.typeEnumerated;
	cClassIdentifier*			= AERegistry.pClass;
	cObjectBeingExamined*		= AEObjects.typeObjectBeingExamined;
	cList*						= AppleEvents.typeAEList;
	cSmallReal*					= AppleEvents.typeSMFloat;
	cReal*						= AppleEvents.typeFloat;
	cRecord*						= AppleEvents.typeAERecord;
	cReference*					= AERegistry.cObjectSpecifier;
	cUndefined*					= LONG("undf");						(*  0x756e6466  *)
	cSymbol*						= LONG("symb");						(*  0x73796d62  *)
	cLinkedList*					= LONG("llst");						(*  0x6c6c7374  *)
	cVector*						= LONG("vect");						(*  0x76656374  *)
	cEventIdentifier*			= LONG("evnt");						(*  0x65766e74  *)
	cKeyIdentifier*				= LONG("kyid");						(*  0x6b796964  *)
	cUserIdentifier*				= LONG("uid ");						(*  0x75696420  *)
	cPreposition*				= LONG("prep");						(*  0x70726570  *)
	cKeyForm*					= AERegistry.enumKeyForm;
	cScript*						= LONG("scpt");						(*  0x73637074  *)
	cHandler*					= LONG("hand");						(*  0x68616e64  *)
	cProcedure*					= LONG("proc");

	cClosure*					= LONG("clsr");						(*  0x636c7372  *)
	cRawData*					= LONG("rdat");						(*  0x72646174  *)
	cString*						= AppleEvents.typeChar;
	cStringClass*				= AppleEvents.typeChar;
	cNumber*						= LONG("nmbr");						(*  0x6e6d6272  *)
	cListOrRecord*				= LONG("lr  ");						(*  0x6c722020  *)
	cListOrString*				= LONG("ls  ");						(*  0x6c732020  *)
	cListRecordOrString*			= LONG("lrs ");						(*  0x6c727320  *)
	cNumberOrDateTime*			= LONG("nd  ");						(*  0x6e642020  *)
	cNumberDateTimeOrString*		= LONG("nds ");						(*  0x6e647320  *)
	cSeconds*					= LONG("scnd");						(*  0x73636e64  *)
	enumBooleanValues*			= LONG("boov");						(*  0x626f6f76  *)
	kAETrue*						= AppleEvents.typeTrue;
	kAEFalse*					= AppleEvents.typeFalse;
	enumMiscValues*				= LONG("misc");						(*  0x6d697363  *)
	kASCurrentApplication*		= LONG("cura");						(*  0x63757261  *)
(* User-defined property ospecs*: *)
	formUserPropertyID*			= LONG("usrp");

(* Global properties*: *)
	pASIt*						= LONG("it  ");						(*  0x69742020  *)
	pASMe*						= LONG("me  ");						(*  0x6d652020  *)
	pASResult*					= LONG("rslt");						(*  0x72736c74  *)
	pASSpace*					= LONG("spac");						(*  0x73706163  *)
	pASReturn*					= LONG("ret ");						(*  0x72657420  *)
	pASTab*						= LONG("tab ");						(*  0x74616220  *)
	pASPi*						= LONG("pi  ");						(*  0x70692020  *)
	pASParent*					= LONG("pare");						(*  0x70617265  *)
	kASInitializeEventCode*		= LONG("init");						(*  0x696e6974  *)
	pASPrintLength*				= LONG("prln");						(*  0x70726c6e  *)
	pASPrintDepth*				= LONG("prdp");						(*  0x70726470  *)
	pASTopLevelScript*			= LONG("ascr");

(* Considerations *)
	kAECase*						= LONG("case");						(*  0x63617365  *)
	kAEDiacritic*				= LONG("diac");						(*  0x64696163  *)
	kAEWhiteSpace*				= LONG("whit");						(*  0x77686974  *)
	kAEHyphens*					= LONG("hyph");						(*  0x68797068  *)
	kAEExpansion*				= LONG("expa");						(*  0x65787061  *)
	kAEPunctuation*				= LONG("punc");						(*  0x70756e63  *)
	kAEZenkakuHankaku*			= LONG("zkhk");						(*  0x7a6b686b  *)
	kAESmallKana*				= LONG("skna");						(*  0x736b6e61  *)
	kAEKataHiragana*				= LONG("hika");						(*  0x68696b61  *)
(* AppleScript considerations*: *)
	kASConsiderReplies*			= LONG("rmte");						(*  0x726d7465  *)
	enumConsiderations*			= LONG("cons");

	cCoercion*					= LONG("coec");						(*  0x636f6563  *)
	cCoerceUpperCase*			= LONG("txup");						(*  0x74787570  *)
	cCoerceLowerCase*			= LONG("txlo");						(*  0x74786c6f  *)
	cCoerceRemoveDiacriticals*	= LONG("txdc");						(*  0x74786463  *)
	cCoerceRemovePunctuation*	= LONG("txpc");						(*  0x74787063  *)
	cCoerceRemoveHyphens*		= LONG("txhy");						(*  0x74786879  *)
	cCoerceOneByteToTwoByte*		= LONG("txex");						(*  0x74786578  *)
	cCoerceRemoveWhiteSpace*		= LONG("txws");						(*  0x74787773  *)
	cCoerceSmallKana*			= LONG("txsk");						(*  0x7478736b  *)
	cCoerceZenkakuhankaku*		= LONG("txze");						(*  0x74787a65  *)
	cCoerceKataHiragana*			= LONG("txkh");						(*  0x74786b68  *)
(* Lorax things*: *)
	cZone*						= LONG("zone");						(*  0x7a6f6e65  *)
	cMachine*					= LONG("mach");						(*  0x6d616368  *)
	cAddress*					= LONG("addr");						(*  0x61646472  *)
	cRunningAddress*				= LONG("radd");						(*  0x72616464  *)
	cStorage*					= LONG("stor");

(* DateTime things*: *)
	pASWeekday*					= LONG("wkdy");						(*  0x776b6479  *)
	pASMonth*					= LONG("mnth");						(*  0x6d6e7468  *)
	pASDay*						= LONG("day ");						(*  0x64617920  *)
	pASYear*						= LONG("year");						(*  0x79656172  *)
	pASTime*						= LONG("time");						(*  0x74696d65  *)
	pASDateString*				= LONG("dstr");						(*  0x64737472  *)
	pASTimeString*				= LONG("tstr");						(*  0x74737472  *)
(* Months *)
	cMonth*						= pASMonth;
	cJanuary*					= LONG("jan ");						(*  0x6a616e20  *)
	cFebruary*					= LONG("feb ");						(*  0x66656220  *)
	cMarch*						= LONG("mar ");						(*  0x6d617220  *)
	cApril*						= LONG("apr ");						(*  0x61707220  *)
	cMay*						= LONG("may ");						(*  0x6d617920  *)
	cJune*						= LONG("jun ");						(*  0x6a756e20  *)
	cJuly*						= LONG("jul ");						(*  0x6a756c20  *)
	cAugust*						= LONG("aug ");						(*  0x61756720  *)
	cSeptember*					= LONG("sep ");						(*  0x73657020  *)
	cOctober*					= LONG("oct ");						(*  0x6f637420  *)
	cNovember*					= LONG("nov ");						(*  0x6e6f7620  *)
	cDecember*					= LONG("dec ");

(* Weekdays *)
	cWeekday*					= pASWeekday;
	cSunday*						= LONG("sun ");						(*  0x73756e20  *)
	cMonday*						= LONG("mon ");						(*  0x6d6f6e20  *)
	cTuesday*					= LONG("tue ");						(*  0x74756520  *)
	cWednesday*					= LONG("wed ");						(*  0x77656420  *)
	cThursday*					= LONG("thu ");						(*  0x74687520  *)
	cFriday*						= LONG("fri ");						(*  0x66726920  *)
	cSaturday*					= LONG("sat ");						(*  0x73617420  *)
(* AS 1.1 Globals*: *)
	pASQuote*					= LONG("quot");						(*  0x71756f74  *)
	pASSeconds*					= LONG("secs");						(*  0x73656373  *)
	pASMinutes*					= LONG("min ");						(*  0x6d696e20  *)
	pASHours*					= LONG("hour");						(*  0x686f7572  *)
	pASDays*						= LONG("days");						(*  0x64617973  *)
	pASWeeks*					= LONG("week");						(*  0x7765656b  *)
(* Writing Code things*: *)
	cWritingCodeInfo*			= LONG("citl");						(*  0x6369746c  *)
	pScriptCode*					= LONG("pscd");						(*  0x70736364  *)
	pLangCode*					= LONG("plcd");						(*  0x706c6364  *)
(* Magic Tell and End Tell events for logging*: *)
	kASMagicTellEvent*			= LONG("tell");						(*  0x74656c6c  *)
	kASMagicEndTellEvent*		= LONG("tend");


(* $ALIGN RESET*)
(* $POP*)

 END ASRegistry.
