(*
 	File:		CMConversions.mod
 
 	Contains:	ColorSync base <-> derived color space conversion Components.Component interface
 
 	Version:	Technology:	ColorSync 2.0
 				Package:	Universal Interfaces 2.11 in MPW Prerelease on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE CMConversions;

IMPORT SYSTEM, Components, CMICCProfile, CMApplication;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	CMConversionInterfaceVersion* = 1;

(* Components.Component function selectors *)
	kCMXYZToLab*					= 0;
	kCMLabToXYZ*					= 1;
	kCMXYZToLuv*					= 2;
	kCMLuvToXYZ*					= 3;
	kCMXYZToYxy*					= 4;
	kCMYxyToXYZ*					= 5;
	kCMRGBToHLS*					= 6;
	kCMHLSToRGB*					= 7;
	kCMRGBToHSV*					= 8;
	kCMHSVToRGB*					= 9;
	kCMRGBToGRAY*				= 10;
	kCMXYZToFixedXYZ*			= 11;
	kCMFixedXYZToXYZ*			= 12;


PROCEDURE CMXYZToLab*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMApplication.CMColor; (*CONST*)VAR white: CMICCProfile.CMXYZColor; VAR dst: CMApplication.CMColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 16, 0, $7000, $A82A;
	(*$END*)
PROCEDURE CMLabToXYZ*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMApplication.CMColor; (*CONST*)VAR white: CMICCProfile.CMXYZColor; VAR dst: CMApplication.CMColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 16, 1, $7000, $A82A;
	(*$END*)
PROCEDURE CMXYZToLuv*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMApplication.CMColor; (*CONST*)VAR white: CMICCProfile.CMXYZColor; VAR dst: CMApplication.CMColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 16, 2, $7000, $A82A;
	(*$END*)
PROCEDURE CMLuvToXYZ*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMApplication.CMColor; (*CONST*)VAR white: CMICCProfile.CMXYZColor; VAR dst: CMApplication.CMColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 16, 3, $7000, $A82A;
	(*$END*)
PROCEDURE CMXYZToYxy*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMApplication.CMColor; VAR dst: CMApplication.CMColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 4, $7000, $A82A;
	(*$END*)
PROCEDURE CMYxyToXYZ*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMApplication.CMColor; VAR dst: CMApplication.CMColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 5, $7000, $A82A;
	(*$END*)
PROCEDURE CMRGBToHLS*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMApplication.CMColor; VAR dst: CMApplication.CMColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 6, $7000, $A82A;
	(*$END*)
PROCEDURE CMHLSToRGB*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMApplication.CMColor; VAR dst: CMApplication.CMColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 7, $7000, $A82A;
	(*$END*)
PROCEDURE CMRGBToHSV*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMApplication.CMColor; VAR dst: CMApplication.CMColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 8, $7000, $A82A;
	(*$END*)
PROCEDURE CMHSVToRGB*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMApplication.CMColor; VAR dst: CMApplication.CMColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 9, $7000, $A82A;
	(*$END*)
PROCEDURE CMRGBToGray*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMApplication.CMColor; VAR dst: CMApplication.CMColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 10, $7000, $A82A;
	(*$END*)
PROCEDURE CMXYZToFixedXYZ*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMICCProfile.CMXYZColor; VAR dst: CMICCProfile.CMFixedXYZColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 11, $7000, $A82A;
	(*$END*)
PROCEDURE CMFixedXYZToXYZ*(ci: Components.ComponentInstance; (*CONST*)VAR src: CMICCProfile.CMFixedXYZColor; VAR dst: CMICCProfile.CMXYZColor; count: LONGINT): Components.ComponentResult;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 12, $7000, $A82A;
	(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END CMConversions.
