(*
 	File:		CMMComponent.mod
 
 	Contains:	ColorSync CMM Components
 
 	Version:	Technology:	ColorSync 2.0
 				Package:	Universal Interfaces 2.11 in MPW Prerelease on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE CMMComponent;

IMPORT SYSTEM, Types, Quickdraw, Files, Components, CMICCProfile, CMApplication;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	CMMInterfaceVersion*			= 1;

(* Components.Component function selectors *)
(* Required *)
	kCMMInit*					= 0;
	kNCMMInit*					= 6;
	kCMMMatchColors*				= 1;
	kCMMCheckColors*				= 2;

(* Optional *)
	kCMMValidateProfile*			= 8;
	kCMMFlattenProfile*			= 14;
	kCMMUnflattenProfile*		= 15;
	kCMMMatchBitmap*				= 9;
	kCMMCheckBitmap*				= 10;
	kCMMMatchPixMap*				= 3;
	kCMMCheckPixMap*				= 4;
	kCMMConcatenateProfiles*		= 5;
	kCMMConcatInit*				= 7;
	kCMMNewLinkProfile*			= 16;
	kCMMGetPS2ColorSpace*		= 11;
	kCMMGetPS2ColorRenderingIntent* = 12;
	kCMMGetPS2ColorRendering*	= 13;
	kCMMGetPS2ColorRenderingVMSize* = 17;


PROCEDURE NCMInit*(CMSession: Components.ComponentInstance; srcProfile: CMApplication.CMProfileRef; dstProfile: CMApplication.CMProfileRef): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 8, 6, $7000, $A82A;
	(*$END*)
PROCEDURE CMInit*(CMSession: Components.ComponentInstance; srcProfile: CMICCProfile.CMProfileHandle; dstProfile: CMICCProfile.CMProfileHandle): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 8, 0, $7000, $A82A;
	(*$END*)
PROCEDURE CMMatchColors*(CMSession: Components.ComponentInstance; VAR myColors: CMApplication.CMColor; count: LONGINT): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 8, 1, $7000, $A82A;
	(*$END*)
PROCEDURE CMCheckColors*(CMSession: Components.ComponentInstance; VAR myColors: CMApplication.CMColor; count: LONGINT; VAR result: LONGINT): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 2, $7000, $A82A;
	(*$END*)
(* Optional functions *)
PROCEDURE CMMValidateProfile*(CMSession: Components.ComponentInstance; prof: CMApplication.CMProfileRef; VAR valid: BOOLEAN): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 8, 8, $7000, $A82A;
	(*$END*)
PROCEDURE CMMFlattenProfile*(CMSession: Components.ComponentInstance; prof: CMApplication.CMProfileRef; flags: LONGINT; proc: CMApplication.CMFlattenUPP; refCon: (*UNIV*) Types.Ptr): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 16, 14, $7000, $A82A;
	(*$END*)
PROCEDURE CMMUnflattenProfile*(CMSession: Components.ComponentInstance; VAR resultFileSpec: Files.FSSpec; proc: CMApplication.CMFlattenUPP; refCon: (*UNIV*) Types.Ptr): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 15, $7000, $A82A;
	(*$END*)
PROCEDURE CMMatchBitmap*(CMSession: Components.ComponentInstance; (*CONST*)VAR bitmap: CMApplication.CMBitmap; progressProc: CMApplication.CMBitmapCallBackUPP; refCon: (*UNIV*) Types.Ptr; VAR matchedBitmap: CMApplication.CMBitmap): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 16, 9, $7000, $A82A;
	(*$END*)
PROCEDURE CMCheckBitmap*(CMSession: Components.ComponentInstance; (*CONST*)VAR bitmap: CMApplication.CMBitmap; progressProc: CMApplication.CMBitmapCallBackUPP; refCon: (*UNIV*) Types.Ptr; VAR resultBitmap: CMApplication.CMBitmap): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 16, 10, $7000, $A82A;
	(*$END*)
PROCEDURE CMMatchPixMap*(CMSession: Components.ComponentInstance; VAR myPixMap: Quickdraw.PixMap; progressProc: CMApplication.CMBitmapCallBackUPP; refCon: (*UNIV*) Types.Ptr): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 3, $7000, $A82A;
	(*$END*)
PROCEDURE CMCheckPixMap*(CMSession: Components.ComponentInstance; (*CONST*)VAR myPixMap: Quickdraw.PixMap; progressProc: CMApplication.CMBitmapCallBackUPP; VAR myBitMap: Quickdraw.BitMap; refCon: (*UNIV*) Types.Ptr): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 16, 4, $7000, $A82A;
	(*$END*)
PROCEDURE CMConcatInit*(CMSession: Components.ComponentInstance; VAR profileSet: CMApplication.CMConcatProfileSet): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 4, 7, $7000, $A82A;
	(*$END*)
PROCEDURE CMNewLinkProfile*(CMSession: Components.ComponentInstance; VAR prof: CMApplication.CMProfileRef; (*CONST*)VAR targetLocation: CMApplication.CMProfileLocation; VAR profileSet: CMApplication.CMConcatProfileSet): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 16, $7000, $A82A;
	(*$END*)
PROCEDURE CMMGetPS2ColorSpace*(CMSession: Components.ComponentInstance; srcProf: CMApplication.CMProfileRef; flags: LONGINT; proc: CMApplication.CMFlattenUPP; refCon: (*UNIV*) Types.Ptr): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 16, 11, $7000, $A82A;
	(*$END*)
PROCEDURE CMMGetPS2ColorRenderingIntent*(CMSession: Components.ComponentInstance; srcProf: CMApplication.CMProfileRef; flags: LONGINT; proc: CMApplication.CMFlattenUPP; refCon: (*UNIV*) Types.Ptr): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 16, 12, $7000, $A82A;
	(*$END*)
PROCEDURE CMMGetPS2ColorRendering*(CMSession: Components.ComponentInstance; srcProf: CMApplication.CMProfileRef; dstProf: CMApplication.CMProfileRef; flags: LONGINT; proc: CMApplication.CMFlattenUPP; refCon: (*UNIV*) Types.Ptr): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 20, 13, $7000, $A82A;
	(*$END*)
PROCEDURE CMMGetPS2ColorRenderingVMSize*(CMSession: Components.ComponentInstance; srcProf: CMApplication.CMProfileRef; dstProf: CMApplication.CMProfileRef; VAR vmSize: LONGINT): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 17, $7000, $A82A;
	(*$END*)
PROCEDURE CMConcatenateProfiles*(CMSession: Components.ComponentInstance; thru: CMICCProfile.CMProfileHandle; dst: CMICCProfile.CMProfileHandle; VAR newDst: CMICCProfile.CMProfileHandle): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 5, $7000, $A82A;
	(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END CMMComponent.
