(*
 	File:		CMPRComponent.mod
 
 	Contains:	ColorSync ProfileResponder Components Interface 
 
 	Version:	Technology:	ColorSync 2.0
 				Package:	Universal Interfaces 2.11 in MPW Prerelease on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE CMPRComponent;

IMPORT SYSTEM, Components, CMICCProfile, CMApplication;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	CMPRInterfaceVersion*		= 0;

(* Components.Component function selectors *)
	kCMPRGetProfile*				= 0;
	kCMPRSetProfile*				= 1;
	kCMPRSetProfileDescription*	= 2;
	kCMPRGetIndexedProfile*		= 3;
	kCMPRDeleteDeviceProfile*	= 4;


PROCEDURE CMGetProfile*(pr: Components.ComponentInstance; aProfile: CMICCProfile.CMProfileHandle; VAR returnedProfile: CMICCProfile.CMProfileHandle): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 8, 0, $7000, $A82A;
	(*$END*)
PROCEDURE CMSetProfile*(pr: Components.ComponentInstance; newProfile: CMICCProfile.CMProfileHandle): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 4, 1, $7000, $A82A;
	(*$END*)
PROCEDURE CMSetProfileDescription*(pr: Components.ComponentInstance; DeviceData: LONGINT; hProfile: CMICCProfile.CMProfileHandle): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 8, 2, $7000, $A82A;
	(*$END*)
PROCEDURE CMGetIndexedProfile*(pr: Components.ComponentInstance; search: CMApplication.CMProfileSearchRecordHandle; VAR returnProfile: CMICCProfile.CMProfileHandle; VAR index: LONGINT): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 12, 3, $7000, $A82A;
	(*$END*)
PROCEDURE CMDeleteDeviceProfile*(pr: Components.ComponentInstance; deleteMe: CMICCProfile.CMProfileHandle): CMApplication.CMError;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $2F3C, 4, 4, $7000, $A82A;
	(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END CMPRComponent.
