(*
 	File:		CRMSerialDevices.mod
 
 	Contains:	Communications Resource Manager Serial Device interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE CRMSerialDevices;

IMPORT SYSTEM, Types;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
(* 	for the crmDeviceType field of the CommResources.CRMRec data structure	*)
	crmSerialDevice*				= 1;
(*	version of the CRMSerialRecord below	*)
	curCRMSerRecVers*			= 1;

(* Maintains compatibility w/ apps & tools that expect an old style icon	*)

TYPE
	CRMIconRecord* = RECORD
		oldIcon*:				ARRAY 32 (*[0..31]*) OF LONGINT;				(* ICN#	*)
		oldMask*:				ARRAY 32 (*[0..31]*) OF LONGINT;
		theSuite*:				Types.Handle;									(* Types.Handle to an IconSuite	*)
		reserved*:				LONGINT;
	END;

	CRMIconPtr* = POINTER TO CRMIconRecord;
	CRMIconHandle* = HANDLE TO CRMIconRecord (* POINTER TO CRMIconRecordPtr*);

	CRMSerialRecord* = RECORD
		version*:				INTEGER;
		inputDriverName*:		Types.StringHandle;
		outputDriverName*:		Types.StringHandle;
		name*:					Types.StringHandle;
		deviceIcon*:				CRMIconHandle;
		ratedSpeed*:				LONGINT;
		maxSpeed*:				LONGINT;
		reserved*:				LONGINT;
	END;

	CRMSerialPtr* = POINTER TO CRMSerialRecord;


(* $ALIGN RESET*)
(* $POP*)

 END CRMSerialDevices.
