(*
 	File:		CTBUtilities.mod
 
 	Contains:	Communications Toolbox Utilities interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$IF UNDEFINED OLDROUTINENAMES*)
(*$SET OLDROUTINENAMES FALSE*)
(*$END*)
(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE CTBUtilities;

IMPORT SYSTEM, Types, Dialogs, AppleTalk;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
(*	version of Comm Toolbox Utilities	*)
	curCTBUVersion*				= 2;
(*    Error codes/types    *)
	ctbuGenericError*			= -1;
	ctbuNoErr*					= 0;

	
TYPE
	CTBUErr* = Types.OSErr;


CONST
	chooseDisaster*				= -2;
	chooseFailed*				= -1;
	chooseAborted*				= 0;
	chooseOKMinor*				= 1;
	chooseOKMajor*				= 2;
	chooseCancel*				= 3;

	
TYPE
	ChooseReturnCode* = INTEGER;


CONST
	nlOk*						= 0;
	nlCancel*					= 1;
	nlEject*						= 2;

	
TYPE
	NuLookupReturnCode* = INTEGER;


CONST
	nameInclude*					= 1;
	nameDisable*					= 2;
	nameReject*					= 3;

	
TYPE
	NameFilterReturnCode* = INTEGER;


CONST
	zoneInclude*					= 1;
	zoneDisable*					= 2;
	zoneReject*					= 3;

	
TYPE
	ZoneFilterReturnCode* = INTEGER;

	DialogHookProcPtr* = (*Types.ProcPtr;*) PROCEDURE (item: INTEGER; theDialog: Dialogs.DialogPtr): INTEGER;
	DialogHookUPP* = Types.UniversalProcPtr;

CONST
	uppDialogHookProcInfo* = $000003A0; (* PROCEDURE (2 byte param, 4 byte param): 2 byte result; *)

PROCEDURE NewDialogHookProc*(userRoutine: DialogHookProcPtr): DialogHookUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallDialogHookProc*(item: INTEGER; theDialog: Dialogs.DialogPtr; userRoutine: DialogHookUPP): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

CONST
(*	Values for hookProc items		*)
	hookOK*						= 1;
	hookCancel*					= 2;
	hookOutline*					= 3;
	hookTitle*					= 4;
	hookItemList*				= 5;
	hookZoneTitle*				= 6;
	hookZoneList*				= 7;
	hookLine*					= 8;
	hookVersion*					= 9;
	hookReserved1*				= 10;
	hookReserved2*				= 11;
	hookReserved3*				= 12;
	hookReserved4*				= 13;
(*	"virtual" hookProc items	*)
	hookNull*					= 100;
	hookItemRefresh*				= 101;
	hookZoneRefresh*				= 102;
	hookEject*					= 103;
	hookPreflight*				= 104;
	hookPostflight*				= 105;
	hookKeyBase*					= 1000;

(*	NuLookup structures/constants	*)

TYPE
	NLTypeEntry* = RECORD
		hIcon*:					Types.Handle;
		typeStr*:				Types.Str32;
	END;

	NLType* = ARRAY 4 (*[0..3]*) OF NLTypeEntry;

	NBPReply* = RECORD
		theEntity*:				AppleTalk.EntityName;
		theAddr*:				AppleTalk.AddrBlock;
	END;

	NameFilterProcPtr* = (*Types.ProcPtr;*) PROCEDURE (VAR theEntity: AppleTalk.EntityName): INTEGER;
	NameFilterUPP* = Types.UniversalProcPtr;

CONST
	uppNameFilterProcInfo* = $000000E0; (* PROCEDURE (4 byte param): 2 byte result; *)

PROCEDURE NewNameFilterProc*(userRoutine: NameFilterProcPtr): NameFilterUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallNameFilterProc*(VAR theEntity: AppleTalk.EntityName; userRoutine: NameFilterUPP): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)
TYPE
	ZoneFilterProcPtr* = (*Types.ProcPtr;*) PROCEDURE (theZone: Types.ConstStr32Param): INTEGER;
	ZoneFilterUPP* = Types.UniversalProcPtr;

CONST
	uppZoneFilterProcInfo* = $000000E0; (* PROCEDURE (4 byte param): 2 byte result; *)

PROCEDURE NewZoneFilterProc*(userRoutine: ZoneFilterProcPtr): ZoneFilterUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallZoneFilterProc*(theZone: Types.ConstStr32Param; userRoutine: ZoneFilterUPP): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE InitCTBUtilities*(): CTBUErr;
	EXTERNAL PASCAL;
PROCEDURE CTBGetCTBVersion*(): INTEGER;
	EXTERNAL PASCAL;
PROCEDURE StandardNBP*(where: Types.Point; prompt: Types.ConstStr255Param; numTypes: INTEGER; VAR typeList: NLType; nameFilter: NameFilterUPP; zoneFilter: ZoneFilterUPP; hook: DialogHookUPP; VAR theReply: NBPReply): INTEGER;
	EXTERNAL PASCAL;
PROCEDURE CustomNBP*(where: Types.Point; prompt: Types.ConstStr255Param; numTypes: INTEGER; VAR typeList: NLType; nameFilter: NameFilterUPP; zoneFilter: ZoneFilterUPP; hook: DialogHookUPP; userData: LONGINT; dialogID: INTEGER; filter: Dialogs.ModalFilterUPP; VAR theReply: NBPReply): INTEGER;
	EXTERNAL PASCAL;
(*$IF OLDROUTINENAMES *)
PROCEDURE NuLookup*(where: Types.Point; prompt: Types.ConstStr255Param; numTypes: INTEGER; VAR typeList: NLType; nameFilter: NameFilterUPP; zoneFilter: ZoneFilterUPP; hook: DialogHookUPP; VAR theReply: NBPReply): INTEGER;
	EXTERNAL PASCAL;
PROCEDURE NuPLookup*(where: Types.Point; prompt: Types.ConstStr255Param; numTypes: INTEGER; VAR typeList: NLType; nameFilter: NameFilterUPP; zoneFilter: ZoneFilterUPP; hook: DialogHookUPP; userData: LONGINT; dialogID: INTEGER; filter: Dialogs.ModalFilterUPP; VAR theReply: NBPReply): INTEGER;
	EXTERNAL PASCAL;
(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END CTBUtilities.
