(*
 	File:		ColorPickerComponents.mod
 
 	Contains:	Color Picker Components.Component Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE ColorPickerComponents;

IMPORT SYSTEM, Types, Dialogs, ColorPicker, Components, CMICCProfile;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	kPickerComponentType*		= LONG("cpkr");

	kInitPicker*					= 0;
	kTestGraphicsWorld*			= 1;
	kGetDialog*					= 2;
	kGetItemList*				= 3;
	kGetColor*					= 4;
	kSetColor*					= 5;
	kEvent*						= 6;
	kEdit*						= 7;
	kSetVisibility*				= 8;
	kDrawPicker*					= 9;
	kItemHit*					= 10;
	kSetBaseItem*				= 11;
	kGetProfile*					= 12;
	kSetProfile*					= 13;
	kGetPrompt*					= 14;
	kSetPrompt*					= 15;
	kGetIconData*				= 16;
	kGetEditMenuState*			= 17;
	kSetOrigin*					= 18;
	kExtractHelpItem*			= 19;


PROCEDURE InitPicker*(thePicker: Components.ComponentInstance; VAR data: ColorPicker.PickerInitData): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE GetDialog*(thePicker: Components.ComponentInstance): Dialogs.DialogPtr;
	EXTERNAL PASCAL;
PROCEDURE TestGraphicsWorld*(thePicker: Components.ComponentInstance; VAR data: ColorPicker.PickerInitData): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE GetTheColor*(thePicker: Components.ComponentInstance; whichColor: ColorPicker.ColorType; color: ColorPicker.PMColorPtr): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE SetTheColor*(thePicker: Components.ComponentInstance; whichColor: ColorPicker.ColorType; color: ColorPicker.PMColorPtr): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE DoEvent*(thePicker: Components.ComponentInstance; VAR data: ColorPicker.EventData): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE DoEdit*(thePicker: Components.ComponentInstance; VAR data: ColorPicker.EditData): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE SetVisibility*(thePicker: Components.ComponentInstance; visible: BOOLEAN): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE DisplayPicker*(thePicker: Components.ComponentInstance): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE ItemHit*(thePicker: Components.ComponentInstance; VAR data: ColorPicker.ItemHitData): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE GetItemList*(thePicker: Components.ComponentInstance): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE SetBaseItem*(thePicker: Components.ComponentInstance; baseItem: INTEGER): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE GetTheProfile*(thePicker: Components.ComponentInstance): CMICCProfile.CMProfileHandle;
	EXTERNAL PASCAL;
PROCEDURE SetTheProfile*(thePicker: Components.ComponentInstance; profile: CMICCProfile.CMProfileHandle): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE GetPrompt*(thePicker: Components.ComponentInstance; VAR prompt: Types.Str255): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE SetPrompt*(thePicker: Components.ComponentInstance; VAR prompt: Types.Str255): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE GetIconData*(thePicker: Components.ComponentInstance; VAR data: ColorPicker.PickerIconData): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE GetEditMenuState*(thePicker: Components.ComponentInstance; VAR mState: ColorPicker.PickerMenuState): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE SetTheOrigin*(thePicker: Components.ComponentInstance; where: Types.Point): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE ExtractHelpItem*(thePicker: Components.ComponentInstance; itemNo: INTEGER; whichMsg: INTEGER; VAR helpInfo: ColorPicker.HelpItemInfo): LONGINT;
	EXTERNAL PASCAL;

(* $ALIGN RESET*)
(* $POP*)

 END ColorPickerComponents.
