(*
 	File:		CommResources.mod
 
 	Contains:	Communications Toolbox Resource Manager Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE CommResources;

IMPORT SYSTEM, Types, OSUtils;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
(*	tool classes (also the tool file types)	*)
	classCM*						= LONG("cbnd");
	classFT*						= LONG("fbnd");
	classTM*						= LONG("tbnd");

(*	version of the Comm Resource Manager	*)
	curCRMVersion*				= 2;
(* constants general to the use of the Communications Resource Manager *)
	crmType*						= 9;							(* queue type	*)
	crmRecVersion*				= 1;							(* version of queue structure *)
(*	error codes *)
	crmGenericError*				= -1;
	crmNoErr*					= 0;

(* data structures general to the use of the Communications Resource Manager *)
	
TYPE
	CRMErr* = Types.OSErr;

	CRMRec* = RECORD
		qLink*:					OSUtils.QElemPtr;								(*reserved*)
		qType*:					INTEGER;								(*queue type -- ORD(crmType)* = 9*)
		crmVersion*:				INTEGER;								(*version of queue element data structure*)
		crmPrivate*:				LONGINT;								(*reserved*)
		crmReserved*:			INTEGER;								(*reserved*)
		crmDeviceType*:			LONGINT;								(*type of device, assigned by DTS*)
		crmDeviceID*:			LONGINT;								(*device AIFF.ID; assigned when CRMInstall is called*)
		crmAttributes*:			LONGINT;								(*pointer to attribute block*)
		crmStatus*:				LONGINT;								(*status variable - device specific*)
		crmRefCon*:				LONGINT;								(*for device private use*)
	END;

	CRMRecPtr* = POINTER TO CRMRec;


PROCEDURE InitCRM*(): CRMErr;
	EXTERNAL PASCAL;
PROCEDURE CRMGetHeader*(): OSUtils.QHdrPtr;
	EXTERNAL PASCAL;
PROCEDURE CRMInstall*(crmReqPtr: CRMRecPtr);
	EXTERNAL PASCAL;
PROCEDURE CRMRemove*(crmReqPtr: CRMRecPtr): Types.OSErr;
	EXTERNAL PASCAL;
PROCEDURE CRMSearch*(crmReqPtr: CRMRecPtr): CRMRecPtr;
	EXTERNAL PASCAL;
PROCEDURE CRMGetCRMVersion*(): INTEGER;
	EXTERNAL PASCAL;
PROCEDURE CRMGetResource*(theType: Types.ResType; theID: INTEGER): Types.Handle;
	EXTERNAL PASCAL;
PROCEDURE CRMGet1Resource*(theType: Types.ResType; theID: INTEGER): Types.Handle;
	EXTERNAL PASCAL;
PROCEDURE CRMGetIndResource*(theType: Types.ResType; index: INTEGER): Types.Handle;
	EXTERNAL PASCAL;
PROCEDURE CRMGet1IndResource*(theType: Types.ResType; index: INTEGER): Types.Handle;
	EXTERNAL PASCAL;
PROCEDURE CRMGetNamedResource*(theType: Types.ResType; name: Types.ConstStr255Param): Types.Handle;
	EXTERNAL PASCAL;
PROCEDURE CRMGet1NamedResource*(theType: Types.ResType; name: Types.ConstStr255Param): Types.Handle;
	EXTERNAL PASCAL;
PROCEDURE CRMReleaseResource*(theHandle: Types.Handle);
	EXTERNAL PASCAL;
PROCEDURE CRMGetToolResource*(procID: INTEGER; theType: Types.ResType; theID: INTEGER): Types.Handle;
	EXTERNAL PASCAL;
PROCEDURE CRMGetToolNamedResource*(procID: INTEGER; theType: Types.ResType; name: Types.ConstStr255Param): Types.Handle;
	EXTERNAL PASCAL;
PROCEDURE CRMReleaseToolResource*(procID: INTEGER; theHandle: Types.Handle);
	EXTERNAL PASCAL;
PROCEDURE CRMGetIndex*(theHandle: Types.Handle): LONGINT;
	EXTERNAL PASCAL;
PROCEDURE CRMLocalToRealID*(bundleType: Types.ResType; toolID: INTEGER; theType: Types.ResType; localID: INTEGER): INTEGER;
	EXTERNAL PASCAL;
PROCEDURE CRMRealToLocalID*(bundleType: Types.ResType; toolID: INTEGER; theType: Types.ResType; realID: INTEGER): INTEGER;
	EXTERNAL PASCAL;
PROCEDURE CRMGetIndToolName*(bundleType: Types.OSType; index: INTEGER; VAR toolName: Types.Str255): Types.OSErr;
	EXTERNAL PASCAL;
PROCEDURE CRMFindCommunications*(VAR vRefNum: INTEGER; VAR dirID: LONGINT): Types.OSErr;
	EXTERNAL PASCAL;
PROCEDURE CRMIsDriverOpen*(driverName: Types.ConstStr255Param): BOOLEAN;
	EXTERNAL PASCAL;
PROCEDURE CRMParseCAPSResource*(theHandle: Types.Handle; selector: Types.ResType; VAR value: LONGINT): CRMErr;
	EXTERNAL PASCAL;
PROCEDURE CRMReserveRF*(refNum: INTEGER): Types.OSErr;
	EXTERNAL PASCAL;
PROCEDURE CRMReleaseRF*(refNum: INTEGER): Types.OSErr;
	EXTERNAL PASCAL;

(* $ALIGN RESET*)
(* $POP*)

 END CommResources.
