(*
 	File:		ConnectionTools.mod
 
 	Contains:	Communications Toolbox Connection Tools Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE ConnectionTools;

IMPORT SYSTEM, Types, Dialogs, Connections;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
(* messages for DefProc *)
	cmInitMsg*					= 0;
	cmDisposeMsg*				= 1;
	cmSuspendMsg*				= 2;
	cmResumeMsg*					= 3;
	cmMenuMsg*					= 4;
	cmEventMsg*					= 5;
	cmActivateMsg*				= 6;
	cmDeactivateMsg*				= 7;
	cmIdleMsg*					= 50;
	cmResetMsg*					= 51;
	cmAbortMsg*					= 52;
	cmReadMsg*					= 100;
	cmWriteMsg*					= 101;
	cmStatusMsg*					= 102;
	cmListenMsg*					= 103;
	cmAcceptMsg*					= 104;
	cmCloseMsg*					= 105;
	cmOpenMsg*					= 106;
	cmBreakMsg*					= 107;
	cmIOKillMsg*					= 108;
	cmEnvironsMsg*				= 109;
(* new connection tool messages for ctb 1.1 *)
	cmNewIOPBMsg*				= 110;
	cmDisposeIOPBMsg*			= 111;
	cmGetErrorStringMsg*			= 112;
	cmPBReadMsg*					= 113;
	cmPBWriteMsg*				= 114;
	cmPBIOKillMsg*				= 115;
(*	messages for validate DefProc	*)
	cmValidateMsg*				= 0;
	cmDefaultMsg*				= 1;
(*	messages for Setup DefProc	*)
	cmSpreflightMsg*				= 0;
	cmSsetupMsg*					= 1;
	cmSitemMsg*					= 2;
	cmSfilterMsg*				= 3;
	cmScleanupMsg*				= 4;
(*	messages for scripting defProc	*)
	cmMgetMsg*					= 0;
	cmMsetMsg*					= 1;
(*	messages for localization defProc	*)
	cmL2English*					= 0;
	cmL2Intl*					= 1;

(* private data constants *)
	cdefType*					= LONG("cdef");						(* main connection definition procedure *)
	cvalType*					= LONG("cval");						(* validation definition procedure *)
	csetType*					= LONG("cset");						(* connection setup definition procedure *)
	clocType*					= LONG("cloc");						(* connection configuration localization defProc *)
	cscrType*					= LONG("cscr");						(* connection scripting defProc interfaces *)
	cbndType*					= LONG("cbnd");						(* bundle type for connection *)
	cverType*					= LONG("vers");


TYPE
	CMDataBuffer* = RECORD
		thePtr*:					Types.Ptr;
		count*:					LONGINT;
		channel*:				Connections.CMChannel;
		flags*:					Connections.CMFlags;
	END;

	CMDataBufferPtr* = POINTER TO CMDataBuffer;

	CMCompletorRecord* = RECORD
		async*:					BOOLEAN;
		completionRoutine*:		Connections.ConnectionCompletionUPP;
	END;

	CMCompletorPtr* = POINTER TO CMCompletorRecord;

(*	Private Data Structure	*)
	CMSetupStruct* = RECORD
		theDialog*:				Dialogs.DialogPtr;
		count*:					INTEGER;
		theConfig*:				Types.Ptr;
		procID*:					INTEGER;								(* procID of the tool	*)
	END;

	CMSetupPtr* = POINTER TO CMSetupStruct;


(* $ALIGN RESET*)
(* $POP*)

 END ConnectionTools.
