(*
 	File:		Dialogs.mod
 
 	Contains:	Dialog Manager interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0.1 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$IF UNDEFINED OLDROUTINENAMES*)
  (*$SET OLDROUTINENAMES FALSE*)
(*$END*)
(*$IF UNDEFINED STRICT_WINDOWS*)
  (*$SET STRICT_WINDOWS FALSE*)
(*$END*)
(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE Dialogs;

IMPORT SYSTEM, Types, Quickdraw, Windows, TextEdit, Events;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	ctrlItem*					= 4;
	btnCtrl*						= 0;
	chkCtrl*						= 1;
	radCtrl*						= 2;
	resCtrl*						= 3;
	statText*					= 8;
	editText*					= 16;
	iconItem*					= 32;
	picItem*						= 64;
	userItem*					= 0;
	itemDisable*					= 128;
	ok*							= 1;
	cancel*						= 2;
	stopIcon*					= 0;
	noteIcon*					= 1;
	cautionIcon*					= 2;

(* new, more standard names for dialog item constants *)
	kControlDialogItem*			= ctrlItem;
	kButtonDialogItem*			= ctrlItem + btnCtrl;
	kCheckBoxDialogITem*			= ctrlItem + chkCtrl;
	kRadioButtonDialogItem*		= ctrlItem + radCtrl;
	kResourceControlDialogItem*	= ctrlItem + resCtrl;
	kStaticTextDialogItem*		= statText;
	kEditTextDialogItem*			= editText;
	kIconDialogItem*				= iconItem;
	kPictureDialogItem*			= picItem;
	kUserDialogItem*				= userItem;
	kItemDisableBit*				= itemDisable;
	kStdOkItemIndex*				= ok;
	kStdCancelItemIndex*			= cancel;
	kStopIcon*					= stopIcon;
	kNoteIcon*					= noteIcon;
	kCautionIcon*				= cautionIcon;
	
(*$IF OLDROUTINENAMES*)
	kOkItemIndex* 				= kStdOkItemIndex;
	kCancelItemIndex* 			= kStdCancelItemIndex;
(*$END*)

	
TYPE
	DITLMethod* = INTEGER;


CONST
	overlayDITL*					= 0;
	appendDITLRight*				= 1;
	appendDITLBottom*			= 2;

	
TYPE
	StageList* = INTEGER;

	DialogPropertyTag* = Types.OSType;

(*$IF STRICT_WINDOWS *)
	DialogPtr* = Types.Ptr;

	DialogRef* = Types.Ptr;

(*$ELSE*)
	DialogPtr* = Quickdraw.WindowPtr;

	DialogRef* = DialogPtr;

(*$END*)
	SoundProcPtr* = (*Types.ProcPtr;*) PROCEDURE (soundNumber: INTEGER);
	ModalFilterProcPtr* = (*Types.ProcPtr;*) PROCEDURE (theDialog: DialogPtr; VAR theEvent: Events.EventRecord; VAR itemHit: INTEGER): BOOLEAN;
	UserItemProcPtr* = (*Types.ProcPtr;*) PROCEDURE (theWindow: Quickdraw.WindowPtr; itemNo: INTEGER);
	SoundUPP* = Types.UniversalProcPtr;
	ModalFilterUPP* = Types.UniversalProcPtr;
	UserItemUPP* = Types.UniversalProcPtr;

CONST
	uppSoundProcInfo* = $00000080; (* PROCEDURE (2 byte param); *)
	uppModalFilterProcInfo* = $00000FD0; (* PROCEDURE (4 byte param, 4 byte param, 4 byte param): 1 byte result; *)
	uppUserItemProcInfo* = $000002C0; (* PROCEDURE (4 byte param, 2 byte param); *)

PROCEDURE NewSoundProc*(userRoutine: SoundProcPtr): SoundUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewModalFilterProc*(userRoutine: ModalFilterProcPtr): ModalFilterUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewUserItemProc*(userRoutine: UserItemProcPtr): UserItemUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallSoundProc*(soundNumber: INTEGER; userRoutine: SoundUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallModalFilterProc*(theDialog: DialogPtr; VAR theEvent: Events.EventRecord; VAR itemHit: INTEGER; userRoutine: ModalFilterUPP): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallUserItemProc*(theWindow: Quickdraw.WindowPtr; itemNo: INTEGER; userRoutine: UserItemUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)
(*$IF NOT STRICT_WINDOWS *)

TYPE
	DialogRecord* = RECORD
		window*:					Windows.WindowRecord;
		items*:					Types.Handle;
		textH*:					TextEdit.TEHandle;
		editField*:				INTEGER;
		editOpen*:				INTEGER;
		aDefItem*:				INTEGER;
	END;

	DialogPeek* = POINTER TO DialogRecord;

(*$END*)

TYPE
	DialogTemplate* = RECORD
		boundsRect*:				Types.Rect;
		procID*:					INTEGER;
		visible*:				BOOLEAN;
		filler1*:				BOOLEAN;
		goAwayFlag*:				BOOLEAN;
		filler2*:				BOOLEAN;
		refCon*:					LONGINT;
		itemsID*:				INTEGER;
		title*:					Types.Str255;
	END;

	DialogTPtr* = POINTER TO DialogTemplate;
	DialogTHndl* = HANDLE TO DialogTemplate (*POINTER TO DialogTPtr*);

	AlertTemplate* = RECORD
		boundsRect*:				Types.Rect;
		itemsID*:				INTEGER;
		stages*:					StageList;
	END;

	AlertTPtr* = POINTER TO AlertTemplate;
	AlertTHndl* = HANDLE TO AlertTemplate (* POINTER TO AlertTPtr*);


PROCEDURE InitDialogs*(ignored: (*UNIV*) Types.Ptr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A97B;
	(*$END*)
PROCEDURE ErrorSound*(soundProc: SoundUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A98C;
	(*$END*)
PROCEDURE NewDialog*(wStorage: (*UNIV*) Types.Ptr; (*CONST*)VAR boundsRect: Types.Rect; title: Types.ConstStr255Param; visible: BOOLEAN; procID: INTEGER; behind: Quickdraw.WindowRef; goAwayFlag: BOOLEAN; refCon: LONGINT; itmLstHndl: Types.Handle): DialogRef;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A97D;
	(*$END*)
PROCEDURE GetNewDialog*(dialogID: INTEGER; dStorage: (*UNIV*) Types.Ptr; behind: Quickdraw.WindowRef): DialogRef;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A97C;
	(*$END*)
PROCEDURE CloseDialog*(theDialog: DialogRef);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A982;
	(*$END*)
PROCEDURE DisposeDialog*(theDialog: DialogRef);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A983;
	(*$END*)
PROCEDURE ParamText*(param0: Types.ConstStr255Param; param1: Types.ConstStr255Param; param2: Types.ConstStr255Param; param3: Types.ConstStr255Param);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A98B;
	(*$END*)
PROCEDURE ModalDialog*(modalFilter: ModalFilterUPP; VAR itemHit: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A991;
	(*$END*)
PROCEDURE IsDialogEvent*((*CONST*)VAR theEvent: Events.EventRecord): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A97F;
	(*$END*)
PROCEDURE DialogSelect*((*CONST*)VAR theEvent: Events.EventRecord; VAR theDialog: DialogRef; VAR itemHit: INTEGER): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A980;
	(*$END*)
PROCEDURE DrawDialog*(theDialog: DialogRef);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A981;
	(*$END*)
PROCEDURE UpdateDialog*(theDialog: DialogRef; updateRgn: Quickdraw.RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A978;
	(*$END*)
PROCEDURE Alert*(alertID: INTEGER; modalFilter: ModalFilterUPP): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A985;
	(*$END*)
PROCEDURE StopAlert*(alertID: INTEGER; modalFilter: ModalFilterUPP): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A986;
	(*$END*)
PROCEDURE NoteAlert*(alertID: INTEGER; modalFilter: ModalFilterUPP): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A987;
	(*$END*)
PROCEDURE CautionAlert*(alertID: INTEGER; modalFilter: ModalFilterUPP): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A988;
	(*$END*)
PROCEDURE GetDialogItem*(theDialog: DialogRef; itemNo: INTEGER; VAR itemType: INTEGER; VAR item: Types.Handle; VAR box: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A98D;
	(*$END*)
PROCEDURE SetDialogItem*(theDialog: DialogRef; itemNo: INTEGER; itemType: INTEGER; item: Types.Handle; (*CONST*)VAR box: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A98E;
	(*$END*)
PROCEDURE HideDialogItem*(theDialog: DialogRef; itemNo: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A827;
	(*$END*)
PROCEDURE ShowDialogItem*(theDialog: DialogRef; itemNo: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A828;
	(*$END*)
PROCEDURE SelectDialogItemText*(theDialog: DialogRef; itemNo: INTEGER; strtSel: INTEGER; endSel: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A97E;
	(*$END*)
PROCEDURE GetDialogItemText*(item: Types.Handle; VAR text: Types.Str255);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A990;
	(*$END*)
PROCEDURE SetDialogItemText*(item: Types.Handle; text: Types.ConstStr255Param);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A98F;
	(*$END*)
PROCEDURE FindDialogItem*(theDialog: DialogRef; thePt: Types.Point): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A984;
	(*$END*)
PROCEDURE NewColorDialog*(dStorage: (*UNIV*) Types.Ptr; (*CONST*)VAR boundsRect: Types.Rect; title: Types.ConstStr255Param; visible: BOOLEAN; procID: INTEGER; behind: Quickdraw.WindowRef; goAwayFlag: BOOLEAN; refCon: LONGINT; items: Types.Handle): DialogRef;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA4B;
	(*$END*)
PROCEDURE GetAlertStage*(): INTEGER;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0A9A;			(* MOVE.w $0A9A,(SP) *)
	(*$END*)

PROCEDURE ResetAlertStage*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $4278, $0A9A;
	(*$END*)
PROCEDURE DialogCut*(theDialog: DialogRef);
	EXTERNAL PASCAL;
PROCEDURE DialogPaste*(theDialog: DialogRef);
	EXTERNAL PASCAL;
PROCEDURE DialogCopy*(theDialog: DialogRef);
	EXTERNAL PASCAL;
PROCEDURE DialogDelete*(theDialog: DialogRef);
	EXTERNAL PASCAL;
PROCEDURE SetDialogFont*(value: INTEGER);
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0AFA;			(* MOVE.w (SP)+,$0AFA *)
	(*$END*)

PROCEDURE AppendDITL*(theDialog: DialogRef; theHandle: Types.Handle; method: DITLMethod);
	EXTERNAL PASCAL;
PROCEDURE CountDITL*(theDialog: DialogRef): INTEGER;
	EXTERNAL PASCAL;
PROCEDURE ShortenDITL*(theDialog: DialogRef; numberItems: INTEGER);
	EXTERNAL PASCAL;
PROCEDURE StdFilterProc*(theDialog: DialogRef; VAR event: Events.EventRecord; VAR itemHit: INTEGER): BOOLEAN;
	EXTERNAL PASCAL;
PROCEDURE GetStdFilterProc*(VAR theProc: ModalFilterUPP): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0203, $AA68;
	(*$END*)
PROCEDURE SetDialogDefaultItem*(theDialog: DialogRef; newItem: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0304, $AA68;
	(*$END*)
PROCEDURE SetDialogCancelItem*(theDialog: DialogRef; newItem: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0305, $AA68;
	(*$END*)
PROCEDURE SetDialogTracksCursor*(theDialog: DialogRef; tracks: BOOLEAN): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0306, $AA68;
	(*$END*)
(*$IF OLDROUTINENAMES *)
(*$IF NOT GENERATINGCFM *)
PROCEDURE CouldDialog*(dialogID: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A979;
	(*$END*)
PROCEDURE FreeDialog*(dialogID: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A97A;
	(*$END*)
PROCEDURE CouldAlert*(alertID: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A989;
	(*$END*)
PROCEDURE FreeAlert*(alertID: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A98A;
	(*$END*)
(*$END*)
PROCEDURE DisposDialog*(theDialog: DialogRef);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A983;
	(*$END*)
PROCEDURE UpdtDialog*(theDialog: DialogRef; updateRgn: Quickdraw.RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A978;
	(*$END*)
PROCEDURE GetDItem*(theDialog: DialogRef; itemNo: INTEGER; VAR itemType: INTEGER; VAR item: Types.Handle; VAR box: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A98D;
	(*$END*)
PROCEDURE SetDItem*(theDialog: DialogRef; itemNo: INTEGER; itemType: INTEGER; item: Types.Handle; (*CONST*)VAR box: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A98E;
	(*$END*)
PROCEDURE HideDItem*(theDialog: DialogRef; itemNo: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A827;
	(*$END*)
PROCEDURE ShowDItem*(theDialog: DialogRef; itemNo: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A828;
	(*$END*)
PROCEDURE SelIText*(theDialog: DialogRef; itemNo: INTEGER; strtSel: INTEGER; endSel: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A97E;
	(*$END*)
PROCEDURE GetIText*(item: Types.Handle; VAR text: Types.Str255);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A990;
	(*$END*)
PROCEDURE SetIText*(item: Types.Handle; text: Types.ConstStr255Param);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A98F;
	(*$END*)
PROCEDURE FindDItem*(theDialog: DialogRef; thePt: Types.Point): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A984;
	(*$END*)
PROCEDURE NewCDialog*(dStorage: (*UNIV*) Types.Ptr; (*CONST*)VAR boundsRect: Types.Rect; title: Types.ConstStr255Param; visible: BOOLEAN; procID: INTEGER; behind: Quickdraw.WindowRef; goAwayFlag: BOOLEAN; refCon: LONGINT; items: Types.Handle): DialogRef;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA4B;
	(*$END*)
PROCEDURE DlgCut*(theDialog: DialogRef);
	EXTERNAL PASCAL;
PROCEDURE DlgPaste*(theDialog: DialogRef);
	EXTERNAL PASCAL;
PROCEDURE DlgCopy*(theDialog: DialogRef);
	EXTERNAL PASCAL;
PROCEDURE DlgDelete*(theDialog: DialogRef);
	EXTERNAL PASCAL;
PROCEDURE SetDAFont*(fontNum: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $31DF, $0AFA;
	(*$END*)
(*$ELSE*)
(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END Dialogs.
