(*
 	File:		DiskInit.mod
 
 	Contains:	Disk Initialization Package (LONG("PACK") 2) Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$IF UNDEFINED SystemSevenFiveOrLater *)
  (*$SET SystemSevenFiveOrLater FALSE*)
(*$END*)
(*$IF UNDEFINED SystemSevenOrLater *)
  (*$IF GENERATINGCFM *)
    (*$SET SystemSevenOrLater TRUE*)
  (*$ELSE*)
    (*$SET SystemSevenOrLater SystemSevenFiveOrLater*)
  (*$END*)
(*$END*)
(*$IF UNDEFINED SystemSixOrLater *)
  (*$SET SystemSixOrLater SystemSevenOrLater*)
(*$END*)
(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE DiskInit;
IMPORT SYSTEM, Types;


(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

TYPE
	HFSDefaults* = RECORD
		sigWord*:				(*PACKED*) ARRAY 2 (*[0..1]*) OF CHAR;			(* signature word *)
		abSize*:					LONGINT;								(* allocation block size in bytes *)
		clpSize*:				LONGINT;								(* clump size in bytes *)
		nxFreeFN*:				LONGINT;								(* next free file number *)
		btClpSize*:				LONGINT;								(* B-Tree clump size in bytes *)
		rsrv1*:					INTEGER;								(* reserved *)
		rsrv2*:					INTEGER;								(* reserved *)
		rsrv3*:					INTEGER;								(* reserved *)
	END;

(*$IF SystemSevenOrLater *)

PROCEDURE DILoad*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $7002, $3F00, $A9E9;
	(*$END*)
PROCEDURE DIUnload*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $7004, $3F00, $A9E9;
	(*$END*)
PROCEDURE DIBadMount*(where: Types.Point; evtMessage: LONGINT): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $7000, $3F00, $A9E9;
	(*$END*)
PROCEDURE DIFormat*(drvNum: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $7006, $3F00, $A9E9;
	(*$END*)
PROCEDURE DIVerify*(drvNum: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $7008, $3F00, $A9E9;
	(*$END*)
PROCEDURE DIZero*(drvNum: INTEGER; volName: ConstStr255Param): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $700A, $3F00, $A9E9;
	(*$END*)
PROCEDURE DIXFormat*(drvNum: INTEGER; fmtFlag: BOOLEAN; fmtArg: LONGINT; VAR actSize: LONGINT): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $700C, $3F00, $A9E9;
	(*$END*)
PROCEDURE DIXZero*(drvNum: INTEGER; volName: ConstStr255Param; fsid: INTEGER; mediaStatus: INTEGER; volTypeSelector: INTEGER; volSize: LONGINT; extendedInfoPtr: UNIV Types.Ptr): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $700E, $3F00, $A9E9;
	(*$END*)
PROCEDURE DIReformat*(drvNum: INTEGER; fsid: INTEGER; volName: ConstStr255Param; msgText: ConstStr255Param): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $7010, $3F00, $A9E9;
	(*$END*)
(*$ELSE*)

PROCEDURE DILoad*;
	EXTERNAL PASCAL;
PROCEDURE DIUnload*;
	EXTERNAL PASCAL;
PROCEDURE DIBadMount*(where: Types.Point; evtMessage: LONGINT): INTEGER;
	EXTERNAL PASCAL;
PROCEDURE DIFormat*(drvNum: INTEGER): Types.OSErr;
	EXTERNAL PASCAL;
PROCEDURE DIVerify*(drvNum: INTEGER): Types.OSErr;
	EXTERNAL PASCAL;
PROCEDURE DIZero*(drvNum: INTEGER; volName: Types.ConstStr255Param): Types.OSErr;
	EXTERNAL PASCAL;
(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END DiskInit.
