(*
 	File:		Disks.mod
 
 	Contains:	Disk Driver Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE Disks;

IMPORT SYSTEM, Types, OSUtils;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	sony*						= 0;
	hard20*						= 1;


TYPE
	DrvSts* = RECORD
		track*:					INTEGER;								(* current track *)
		writeProt*:				Types.SignedByte;								(* bit 7* = 1 if volume is locked *)
		diskInPlace*:			Types.SignedByte;								(* disk in drive *)
		installed*:				Types.SignedByte;								(* drive installed *)
		sides*:					Types.SignedByte;								(* -1 for 2-sided, 0 for 1-sided *)
		qLink*:					OSUtils.QElemPtr;								(* next queue entry *)
		qType*:					INTEGER;								(* 1 for HD20 *)
		dQDrive*:				INTEGER;								(* drive number *)
		dQRefNum*:				INTEGER;								(* driver reference number *)
		dQFSID*:					INTEGER;								(* file system AIFF.ID *)
		(* CASE INTEGER OF
		0: ( *)
	END;
	DrvStsSony* = RECORD(DrvSts)
			twoSideFmt*:					Types.SignedByte;							(* after 1st rd/wrt: 0=1 side, -1=2 side *)
			needsFlush*:					Types.SignedByte;							(* -1 for MacPlus drive *)
			diskErrs*:					INTEGER;							(* soft error count *)
		   (*);
		1: ( *)
	END;
	DrvStsHD20* = RECORD(DrvSts)
			driveSize*:					INTEGER;
			driveS1*:					INTEGER;
			driveType*:					INTEGER;
			driveManf*:					INTEGER;
			driveChar*:					INTEGER;
			driveMisc*:					Types.SignedByte;
		   (* );*)
	END;


PROCEDURE DiskEject*(drvNum: INTEGER): Types.OSErr;
	EXTERNAL PASCAL;
PROCEDURE SetTagBuffer*(buffPtr: (*UNIV*) Types.Ptr): Types.OSErr;
	EXTERNAL PASCAL;
PROCEDURE DriveStatus*(drvNum: INTEGER; VAR status: DrvSts): Types.OSErr;
	EXTERNAL PASCAL;

(* $ALIGN RESET*)
(* $POP*)

 END Disks.
