(*
 	File:		EPPC.mod
 
 	Contains:	High Level Event Manager Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE EPPC;

IMPORT SYSTEM, Types, PPCToolbox, Processes, Events;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	kHighLevelEvent*				= 23;
(* postOptions currently supported *)
	receiverIDMask*				= $0000F000;
	receiverIDisPSN*				= $00008000;
	receiverIDisSignature*		= $00007000;
	receiverIDisSessionID*		= $00006000;
	receiverIDisTargetID*		= $00005000;
	systemOptionsMask*			= $00000F00;
	nReturnReceipt*				= $00000200;
	priorityMask*				= $000000FF;
	nAttnMsg*					= $00000001;
(* constant for return receipts *)
	HighLevelEventMsgClass*		= LONG("jaym");
	rtrnReceiptMsgID*			= LONG("rtrn");
	msgWasPartiallyAccepted*		= 2;
	msgWasFullyAccepted*			= 1;
	msgWasNotAccepted*			= 0;


TYPE
	TargetID* = RECORD
		sessionID*:				LONGINT;
		name*:					PPCToolbox.PPCPortRec;
		location*:				PPCToolbox.LocationNameRec;
		recvrName*:				PPCToolbox.PPCPortRec;
	END;

	TargetIDPtr* = POINTER TO TargetID;
	TargetIDHandle* = HANDLE TO TargetID (* POINTER TO TargetIDPtr*);
	TargetIDHdl* = HANDLE TO TargetID (* POINTER TO TargetIDPtr*);

	SenderID* = TargetID;

	SenderIDPtr* = POINTER TO SenderID;

	HighLevelEventMsg* = RECORD
		HighLevelEventMsgHeaderLength*: INTEGER;
		version*:				INTEGER;
		reserved1*:				LONGINT;
		theMsgEvent*:			Events.EventRecord;
		userRefcon*:				LONGINT;
		postingOptions*:			LONGINT;
		msgLength*:				LONGINT;
	END;

	HighLevelEventMsgPtr* = POINTER TO HighLevelEventMsg;
	HighLevelEventMsgHandle* = HANDLE TO HighLevelEventMsg (* POINTER TO HighLevelEventMsgPtr*);
	HighLevelEventMsgHdl* = HANDLE TO HighLevelEventMsg (* POINTER TO HighLevelEventMsgPtr*);

	GetSpecificFilterProcPtr* = (*Types.ProcPtr;*) PROCEDURE (yourDataPtr: (*UNIV*) Types.Ptr; msgBuff: HighLevelEventMsgPtr; (*CONST*)VAR sender: TargetID): BOOLEAN;
	GetSpecificFilterUPP* = Types.UniversalProcPtr;

CONST
	uppGetSpecificFilterProcInfo* = $00000FD0; (* PROCEDURE (4 byte param, 4 byte param, 4 byte param): 1 byte result; *)

PROCEDURE NewGetSpecificFilterProc*(userRoutine: GetSpecificFilterProcPtr): GetSpecificFilterUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallGetSpecificFilterProc*(yourDataPtr: (*UNIV*) Types.Ptr; msgBuff: HighLevelEventMsgPtr; (*CONST*)VAR sender: TargetID; userRoutine: GetSpecificFilterUPP): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE PostHighLevelEvent*((*CONST*)VAR theEvent: Events.EventRecord; receiverID: Types.Ptr; msgRefcon: LONGINT; msgBuff: Types.Ptr; msgLen: LONGINT; postingOptions: LONGINT): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $3F3C, $0034, $A88F;
	(*$END*)
PROCEDURE AcceptHighLevelEvent*(VAR sender: TargetID; VAR msgRefcon: LONGINT; msgBuff: Types.Ptr; VAR msgLen: LONGINT): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $3F3C, $0033, $A88F;
	(*$END*)
PROCEDURE GetProcessSerialNumberFromPortName*((*CONST*)VAR portName: PPCToolbox.PPCPortRec; VAR pPSN: Processes.ProcessSerialNumber): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $3F3C, $0035, $A88F;
	(*$END*)
PROCEDURE GetPortNameFromProcessSerialNumber*(VAR portName: PPCToolbox.PPCPortRec; (*CONST*)VAR pPSN: Processes.ProcessSerialNumber): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $3F3C, $0046, $A88F;
	(*$END*)
PROCEDURE GetSpecificHighLevelEvent*(aFilter: GetSpecificFilterUPP; yourDataPtr: (*UNIV*) Types.Ptr; VAR err: Types.OSErr): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $3F3C, $0045, $A88F;
	(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END EPPC.
