(*
 	File:		FileTypesAndCreators.mod
 
 	Contains:	Symbolic constants for FileTypes and signatures of popular documents.
 
 	Version:	Technology:	Macintosh Easy Open 1.1
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE FileTypesAndCreators;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
(* Mac word processors *)
	sigWord*						= LONG("MSWD");
	ftWord3Document*				= LONG("MSW3");
	ftWord4Document*				= LONG("MSW4");
	ftWord5Document*				= LONG("MSW5");
	ftWordDocument*				= LONG("WDBN");
	ftWordDocumentPC*			= LONG("MWPC");						(* not registered *)
	ftWord1DocumentWindows*		= LONG("WW1 ");						(* not registered *)
	ftWord2DocumentWindows*		= LONG("WW2 ");						(* not registered *)
	ftRTFDocument*				= LONG("RTF ");						(* not registered *)
	sigWordPerfect*				= LONG("SSIW");
	ftWordPerfectDocument*		= LONG("WPD0");
	sigWordPerfect2*				= LONG("WPC2");
	ftWordPerfect2Document*		= LONG("WPD1");
	ftWordPerfect21Document*		= LONG("WPD2");
	ftWordPerfect42DocumentPC*	= LONG(".WP4");						(* not registered *)
	ftWordPerfect50DocumentPC*	= LONG(".WP5");						(* not registered *)
	ftWordPerfect51DocumentPC*	= LONG("WP51");						(* not registered *)
	ftWordPerfectGraphicsPC*		= LONG("WPGf");						(* not registered *)
	sigMacWriteII*				= LONG("MWII");
	ftMacWriteIIDocument*		= LONG("MW2D");
	sigWriteNow*					= LONG("nXPOINTER TO n");
	ftWriteNow2Document*			= LONG("nXPOINTER TO d");
	ftWriteNow3Document*			= LONG("nXPOINTER TO 2");
	sigMacWrite*					= LONG("MACA");
	ftMacWrite5Document*			= LONG("WORD");
	sigFrameMaker*				= LONG("Fram");
	ftFrameMakerDocument*		= LONG("FASL");
	ftFrameMakerMIFDocument*		= LONG("MIF ");
	ftFrameMakerMIF2Document*	= LONG("MIF2");
	ftFrameMakerMIF3Document*	= LONG("MIF3");
	sigMSWrite*					= LONG("MSWT");
	sigActa*						= LONG("ACTA");
	sigTHINKPascal*				= LONG("PJMM");
	sigTHINKC*					= LONG("KAHL");
	sigFullWrite*				= LONG("FWRT");
	sigTeachText*				= LONG("ttxt");
	ftTeachTextDocument*			= LONG("ttro");
	sigSimpleText*				= LONG("ttxt");
	ftSimpleTextDocument*		= LONG("ttro");
	sigMPWShell*					= LONG("MPS ");
	sigQuarkXPress*				= LONG("XPR3");
	sigNisus*					= LONG("NISI");
	sigOmniPage*					= LONG("PRTC");
	sigPersonalPress*			= LONG("SCPG");
	sigPublishItEZ*				= LONG("2CTY");
	sigReadySetGo*				= LONG("MEMR");
	sigRagTime*					= LONG("R#+A");
	sigLetraStudio*				= LONG("LSTP");
	sigLetterPerfect*			= LONG("WPCI");
	sigTheWritingCenter*			= $0A1A5750;					(* this 'unprintable unprintable WP' One of the unprintables is a line feed.  *)
	sigInstantUpdate*			= LONG("IUA0");

(* databases *)
	sig4thDimension*				= LONG("4D03");
	ft4thDimensionDB*			= LONG("BAS3");
	sigFileMakerPro*				= LONG("FMPR");
	ftFileMakerProDatabase*		= LONG("FMPR");
	sigHyperCard*				= LONG("WILD");
	ftHyperCard*					= LONG("STAK");
	sigSmartFormAsst*			= LONG("KCFM");
	ftSmartFormAsst*				= LONG("STCK");
	sigSmartFormDesign*			= LONG("KCFD");
	ftSmartFormDesign*			= LONG("CFRM");
	sigFileForce*				= LONG("4D93");
	ftFileForceDatabase*			= LONG("FIL3");
	sigFileMaker2*				= LONG("FMK4");
	ftFileMaker2Database*		= LONG("FMK$");
	sigSuperCard*				= LONG("RUNT");
	sigDoubleHelix*				= LONG("HELX");
	sigGeoQuery*					= LONG("RGgq");
	sigFoxBASE*					= LONG("FOX+");
	sigINSPIRATION*				= LONG("CER3");
	sigPanorama*					= LONG("KAS1");
	sigSilverrunLDM*				= LONG("CDML");
	sigSilverrunDFD*				= LONG("CDDF");
(* finance *)
	sigQuicken*					= LONG("INTU");
	sigMacInTax91*				= LONG("MIT1");
	ftMacInTax91*				= LONG("MITF");
	sigAccountantInc*			= LONG("APRO");
	sigAtOnce*					= LONG("KISS");
	sigCAT3*						= LONG("tCat");
	sigDollarsNSense*			= LONG("EAGP");
	sigInsightExpert*			= LONG("LSGL");
	sigMYOB*						= LONG("MYOB");
	sigMacMoney*					= LONG("SSLA");
	sigManagingYourMoney*		= LONG("MYMC");
	sigPlainsAndSimple*			= LONG("PEGG");
(* scheduling *)
	sigMacProject2*				= LONG("MPRX");
	ftMacProject*				= LONG("MPRD");
	sigMSProject*				= LONG("MSPJ");
	sigMacProjectPro*			= LONG("MPRP");
(* utilities *)
	sigStuffIt*					= LONG("SIT!");
	ftStuffItArchive*			= LONG("SIT!");
	sigCompactPro*				= LONG("CPCT");
	ftCompactProArchive*			= LONG("PACT");
	sigFontographer*				= LONG("aCa2");
	sigMetamorphosis*			= LONG("MEtP");
	sigCorrectGrammar*			= LONG("LsCG");
	sigDynodex*					= LONG("DYNO");
	sigMariah*					= LONG("MarH");
	sigAddressBook*				= LONG("AdBk");
	sigThePrintShop*				= LONG("PSHP");
	sigQuicKeys2*				= LONG("Qky2");
	sigReadStar2Plus*			= LONG("INOV");
	sigSoftPC*					= LONG("PCXT");
	sigMacMenlo*					= LONG("MNLO");
	sigDisinfectant*				= LONG("D2CT");
(* communications *)
	sigSmartcom2*				= LONG("SCOM");
	sigVersaTermPRO*				= LONG("VPRO");
	sigVersaTerm*				= LONG("VATM");
	sigWhiteKnight*				= LONG("WK11");
	sigNCSATelnet*				= LONG("NCSA");
	sigDynaComm*					= LONG("PAR2");
	sigQMForms*					= LONG("MLTM");
(* math and statistics *)
	sigMathematica*				= LONG("OMEG");
	sigMathCAD*					= LONG("MCAD");
	sigStatView2*				= LONG("STAT");
	sigDataDesk*					= LONG("DDSK");
	sigPowerMath2*				= LONG("MATH");
	sigSuperANOVA*				= LONG("SupA");
	sigSystat*					= LONG("SYT1");
	sigTheorist*					= LONG("Theo");

(* spreadsheets *)
	sigExcel*					= LONG("XCEL");
	ftExcel2Spreadsheet*			= LONG("XLS ");
	ftExcel2Macro*				= LONG("XLM ");
	ftExcel2Chart*				= LONG("XLC ");
	ftExcel3Spreadsheet*			= LONG("XLS3");
	ftExcel3Macro*				= LONG("XLM3");
	ftExcel3Chart*				= LONG("XLC3");
	ftExcel4Spreadsheet*			= LONG("XLS4");
	ftExcel4Macro*				= LONG("XLM4");
	ftSYLKSpreadsheet*			= LONG("SYLK");
	sigLotus123*					= LONG("L123");
	ft123Spreadsheet*			= LONG("LWKS");
	sigWingz*					= LONG("WNGZ");
	ftWingzSpreadsheet*			= LONG("WZSS");
	ftWingzScript*				= LONG("WZSC");
	sigResolve*					= LONG("Rslv");
	ftResolve*					= LONG("RsWs");
	ftResolveScript*				= LONG("RsWc");
	sigFullImpact2*				= LONG("Flv2");

(* graphics *)
	sigIllustrator*				= LONG("ART3");
	ftPostScriptMac*				= LONG("EPSF");
	sigMacPaint*					= LONG("MPNT");
	ftMacPaintGraphic*			= LONG("PNTG");
	sigSuperPaint*				= LONG("SPNT");
	ftSuperPaintGraphic*			= LONG("SPTG");
	sigCanvas*					= LONG("DAD2");
	ftCanvasGraphic*				= LONG("drw2");
	sigUltraPaint*				= LONG("ULTR");
	ftUltraPaint*				= LONG("UPNT");
	sigPhotoshop*				= LONG("8BIM");
	ftPhotoshopGraphic*			= LONG("8BIM");
	sigMacDrawPro*				= LONG("dPro");
	ftMacDrawProDrawing*			= LONG("dDoc");
	sigPageMaker*				= LONG("ALD4");
	ftPageMakerPublication*		= LONG("ALB4");
	sigFreeHand*					= LONG("FHA3");
	ftFreeHandDrawing*			= LONG("FHD3");
	sigClarisCAD*				= LONG("CCAD");
	ftClarisCAD*					= LONG("CAD2");
	sigMacDrawII*				= LONG("MDPL");
	ftMacDrawIIDrawing*			= LONG("DRWG");
	sigMacroMindDirector*		= LONG("MMDR");
	ftMMDirectorMovie*			= LONG("VWMD");
	ftMMDirectorSound*			= LONG("MMSD");
	sigPixelPaintPro*			= LONG("PIXL");
	sigPixelPaint*				= LONG("PIXR");
	ftPixelPaint*				= LONG("PX01");
	sigAldusSuper3D*				= LONG("SP3D");
	ftSuper3DDrawing*			= LONG("3DBX");
	sigSwivel3D*					= LONG("SWVL");
	ftSwivel3DDrawing*			= LONG("SMDL");
	sigCricketDraw*				= LONG("CRDW");
	ftCricketDrawing*			= LONG("CKDT");
	sigCricketGraph*				= LONG("CGRF");
	ftCricketChart*				= LONG("CGPC");
	sigDesignCAD*				= LONG("ASBC");
	ftDesignCADDrawing*			= LONG("DCAD");
	sigImageStudio*				= LONG("FSPE");
	ftImageStudioGraphic*		= LONG("RIFF");
	sigVersaCad*					= LONG("VCAD");
	ftVersaCADDrawing*			= LONG("2D  ");
	sigAdobePremier*				= LONG("PrMr");
	ftAdobePremierMovie*			= LONG("MooV");
	sigAfterDark*				= LONG("ADrk");
	ftAfterDarkModule*			= LONG("ADgm");
	sigClip3D*					= LONG("EZ3E");
	ftClip3Dgraphic*				= LONG("EZ3D");
	sigKaleidaGraph*				= LONG("QKPT");
	ftKaleidaGraphGraphic*		= LONG("QPCT");
	sigMacFlow*					= LONG("MCFL");
	ftMacFlowChart*				= LONG("FLCH");
	sigMoviePlayer*				= LONG("TVOD");
	ftMoviePlayerMovie*			= LONG("MooV");
	sigMacSpin*					= LONG("D2SP");
	ftMacSpinDataSet*			= LONG("D2BN");
	sigAutoCAD*					= LONG("ACAD");
	sigLabVIEW*					= LONG("LBVW");
	sigColorMacCheese*			= LONG("CMC");
	sigMiniCad*					= LONG("CDP3");
	sigDreams*					= LONG("PHNX");
	sigOmnis5*					= LONG("Q2$$");
	sigPhotoMac*					= LONG("PMAC");
	sigGraphMaster*				= LONG("GRAM");
	sigInfiniD*					= LONG("SID");
	sigOfoto*					= LONG("APLS");
	sigMacDraw*					= LONG("MDRW");
	sigDeltagraphPro*			= LONG("DGRH");
	sigDesign2*					= LONG("DESG");
	sigDesignStudio*				= LONG("MRJN");
	sigDynaperspective*			= LONG("PERS");
	sigGenericCADD*				= LONG("CAD3");
	sigMacDraft*					= LONG("MD20");
	sigModelShop*				= LONG("MDSP");
	sigOasis*					= LONG("TAOA");
	sigOBJECTMASTER*				= LONG("BROW");
	sigMovieRecorder*			= LONG("mrcr");
	sigPictureCompressor*		= LONG("ppxi");
	sigPICTViewer*				= LONG("MDTS");
	sigSmoothie*					= LONG("Smoo");
	sigScreenPlay*				= LONG("SPLY");
	sigStudio1*					= LONG("ST/1");
	sigStudio32*					= LONG("ST32");
	sigStudio8*					= LONG("ST/8");
	sigKidPix*					= LONG("Kid2");
	sigDigDarkroom*				= LONG("DIDR");

(* presentations *)
	sigMore*						= LONG("MOR2");
	ftMore3Document*				= LONG("MOR3");
	ftMore2Document*				= LONG("MOR2");
	sigPersuasion*				= LONG("PLP2");
	ftPersuasion1Presentation*	= LONG("PRS1");
	ftPersuasion2Presentation*	= LONG("PRS2");
	sigPowerPoint*				= LONG("PPNT");
	ftPowerPointPresentation*	= LONG("SLDS");
	sigCricketPresents*			= LONG("CRPR");
	ftCricketPresentation*		= LONG("PRDF");
(* works *)
	sigMSWorks*					= LONG("PSI2");
	sigMSWorks3*					= LONG("MSWK");
	ftMSWorksWordProcessor*		= LONG("AWWP");
	ftMSWorksSpreadsheet*		= LONG("AWSS");
	ftMSWorksDataBase*			= LONG("AWDB");
	ftMSWorksComm*				= LONG("AWDC");
	ftMSWorksMacros*				= LONG("AWMC");
	ftMSWorks1WordProcessor*		= LONG("AWW1");						(* not registered *)
	ftMSWorks1Spreadsheet*		= LONG("AWS1");						(* not registered *)
	ftMSWorks1DataBase*			= LONG("AWD1");						(* not registered *)
	ftMSWorks2WordProcessor*		= LONG("AWW2");						(* not registered *)
	ftMSWorks2Spreadsheet*		= LONG("AWS2");						(* not registered *)
	ftMSWorks2DataBase*			= LONG("AWD2");						(* not registered *)
	ftMSWorks3WordProcessor*		= LONG("AWW3");						(* not registered *)
	ftMSWorks3Spreadsheet*		= LONG("AWS3");						(* not registered *)
	ftMSWorks3DataBase*			= LONG("AWD3");						(* not registered *)
	ftMSWorks3Comm*				= LONG("AWC3");						(* not registered *)
	ftMSWorks3Macro*				= LONG("AWM3");						(* not registered *)
	ftMSWorks3Draw*				= LONG("AWR3");						(* not registered *)
	ftMSWorks2WordProcessorPC*	= LONG("PWW2");						(* not registered *)
	ftMSWorks2DatabasePC*		= LONG("PWDB");						(* not registered *)
	sigGreatWorks*				= LONG("ZEBR");
	ftGreatWorksWordProcessor*	= LONG("ZWRT");
	ftGreatWorksSpreadsheet*		= LONG("ZCAL");
	ftGreatWorksPaint*			= LONG("ZPNT");
	sigClarisWorks*				= LONG("BOBO");
	ftClarisWorksWordProcessor*	= LONG("CWWP");
	ftClarisWorksSpreadsheet*	= LONG("CWSS");
	ftClarisWorksGraphics*		= LONG("CWGR");
	sigBeagleWorks*				= LONG("BWks");
	ftBeagleWorksWordProcessor*	= LONG("BWwp");
	ftBeagleWorksDatabase*		= LONG("BWdb");
	ftBeagleWorksSpreadsheet*	= LONG("BWss");
	ftBeagleWorksComm*			= LONG("BWcm");
	ftBeagleWorksDrawing*		= LONG("BWdr");
	ftBeagleWorksGraphic*		= LONG("BWpt");
	ftPICTFile*					= LONG("PICT");

(* entertainment *)
	sigPGATourGolf*				= LONG("gOLF");
	sigSimCity*					= LONG("MCRP");
	sigHellCats*					= LONG("HELL");
(* education *)
	sigReaderRabbit3*			= LONG("RDR3");
(* Translation applications *)
	sigDataVizDesktop*			= LONG("DVDT");
	sigSotwareBridge*			= LONG("mdos");
	sigWordForWord*				= LONG("MSTR");
	sigAppleFileExchange*		= LONG("PSPT");
(* Apple software *)
	sigAppleLink*				= LONG("GEOL");
	ftAppleLinkAddressBook*		= LONG("ADRS");
	ftAppleLinkImageFile*		= LONG("SIMA");
	ftAppleLinkPackage*			= LONG("HBSF");
	ftAppleLinkConnFile*			= LONG("PETE");
	ftAppleLinkHelp*				= LONG("HLPF");
	sigInstaller*				= LONG("bjbc");
	ftInstallerScript*			= LONG("bjbc");
	sigDiskCopy*					= LONG("dCpy");
	ftDiskCopyImage*				= LONG("dImg");
	sigResEdit*					= LONG("RSED");
	ftResEditResourceFile*		= LONG("rsrc");
	sigAardvark*					= LONG("AARD");
	sigCompatibilityChkr*		= LONG("wkrp");
	sigMacTerminal*				= LONG("Term");
	sigSADE*						= LONG("sade");
	sigCurare*					= LONG("Cura");
	sigPCXChange*				= LONG("dosa");
	sigAtEase*					= LONG("mfdr");
	sigStockItToMe*				= LONG("SITM");
	sigAppleSearch*				= LONG("asis");
	sigAppleSearchToo*			= LONG("hobs");
(* the following are files types for system files *)
	ftScriptSystemResourceCollection* = LONG("ifil");
	ftSoundFile*					= LONG("sfil");
	ftFontFile*					= LONG("ffil");
	ftTrueTypeFontFile*			= LONG("tfil");
	ftKeyboardLayout*			= LONG("kfil");
	ftFontSuitcase*				= LONG("FFIL");
	ftDASuitcase*				= LONG("DFIL");
	ftSystemExtension*			= LONG("INIT");
	ftDAMQueryDocument*			= LONG("qery");

(************** Special FileTypes and creators **************)
	ftApplicationName*			= LONG("apnm");						(* this is the type used to define the application name in a kind resource *)
	sigIndustryStandard*			= LONG("istd");						(* this is the creator used to define a kind string in a kind resource for a FileType that has many creators  *)
	ftXTND13TextImport*			= LONG("xt13");

(************** Apple][ applications and FileTypes **************)
	sigAppleProDOS*				= LONG("pdos");						(* not registered *)
	ftAppleWorksWordProcessor*	= LONG("1A  ");						(* not registered *)
	ftAppleWorks1WordProcessor*	= LONG("1A1 ");						(* not registered *)
	ftAppleWorks2WordProcessor*	= LONG("1A2 ");						(* not registered *)
	ftAppleWorks3WordProcessor*	= LONG("1A3 ");						(* not registered *)
	ftAppleWorksDataBase*		= LONG("19  ");						(* not registered *)
	ftAppleWorks1DataBase*		= LONG("191 ");						(* not registered *)
	ftAppleWorks2DataBase*		= LONG("192 ");						(* not registered *)
	ftAppleWorks3DataBase*		= LONG("193 ");						(* not registered *)
	ftAppleWorksSpreadsheet*		= LONG("1B  ");						(* not registered *)
	ftAppleWorks1Spreadsheet*	= LONG("1B1 ");						(* not registered *)
	ftAppleWorks2Spreadsheet*	= LONG("1B2 ");						(* not registered *)
	ftAppleWorks3Spreadsheet*	= LONG("1B3 ");						(* not registered *)
	ftAppleWorksWordProcessorGS*	= LONG("50  ");						(* not registered *)
	ftApple2GS_SuperHiRes*		= LONG("A2SU");						(* not registered *)
	ftApple2GS_SuperHiResPacked*	= LONG("A2SP");						(* not registered *)
	ftApple2GS_PaintWorks*		= LONG("A2PW");						(* not registered *)
	ftApple2_DoubleHiRes*		= LONG("A2DU");						(* not registered *)
	ftApple2_DoubleHiResPacked*	= LONG("A2DP");						(* not registered *)
	ftApple2_DoubleHiRes16colors* = LONG("A2DC");						(* not registered *)
	ftApple2_SingleHiRes*		= LONG("A2HU");						(* not registered *)
	ftApple2_SingleHiResPacked*	= LONG("A2HP");						(* not registered *)
	ftApple2_SingleHiRes8colors*	= LONG("A2HC");

(************** PC-DOS applications and FileTypes **************)
	sigPCDOS*					= LONG("mdos");						(* not registered *)
	ftGenericDocumentPC*			= LONG("TEXT");
(*	word processor formats *)
	ftWordStarDocumentPC*		= LONG("WStr");						(* not registered *)
	ftWordStar4DocumentPC*		= LONG("WSt4");						(* not registered *)
	ftWordStar5DocumentPC*		= LONG("WSt5");						(* not registered *)
	ftWordStar55DocumentPC*		= LONG("WS55");						(* not registered *)
	ftWordStar6DocumentPC*		= LONG("WSt6");						(* not registered *)
	ftWordStar2000DocumentPC*	= LONG("WS20");						(* not registered *)
	ftXyWriteIIIDocumentPC*		= LONG("XyWr");						(* registered??? *)
	ftDecDXDocumentPC*			= LONG("DX  ");						(* registered??? *)
	ftDecWPSPlusDocumentPC*		= LONG("WPS+");						(* registered??? *)
	ftDisplayWrite3DocumentPC*	= LONG("DW3 ");						(* registered??? *)
	ftDisplayWrite4DocumentPC*	= LONG("DW4 ");						(* registered??? *)
	ftDisplayWrite5DocumentPC*	= LONG("DW5 ");						(* registered??? *)
	ftIBMWritingAsstDocumentPC*	= LONG("ASST");						(* registered??? *)
	ftManuscript1DocumentPC*		= LONG("MAN1");						(* registered??? *)
	ftManuscript2DocumentPC*		= LONG("MAN2");						(* registered??? *)
	ftMass11PCDocumentPC*		= LONG("M11P");						(* registered??? *)
	ftMass11VaxDocumentPC*		= LONG("M11V");						(* registered??? *)
	ftMultiMateDocumentPC*		= LONG("MMAT");						(* registered??? *)
	ftMultiMate36DocumentPC*		= LONG("MM36");						(* registered??? *)
	ftMultiMate40DocumentPC*		= LONG("MM40");						(* registered??? *)
	ftMultiMateAdvDocumentPC*	= LONG("MMAD");						(* registered??? *)
	ftMultiMateNoteDocumentPC*	= LONG("MMNT");						(* registered??? *)
	ftOfficeWriterDocumentPC*	= LONG("OFFW");						(* registered??? *)
	ftPCFileLetterDocumentPC*	= LONG("PCFL");						(* registered??? *)
	ftPFSWriteADocumentPC*		= LONG("PFSA");						(* registered??? *)
	ftPFSWriteBDocumentPC*		= LONG("PFSB");						(* registered??? *)
	ftPFSPlanDocumentPC*			= LONG("PFSP");						(* registered??? *)
	ftProWrite1DocumentPC*		= LONG("PW1 ");						(* registered??? *)
	ftProWrite2DocumentPC*		= LONG("PW2 ");						(* registered??? *)
	ftProWritePlusDocumentPC*	= LONG("PW+ ");						(* registered??? *)
	ftFirstChoiceDocumentPC*		= LONG("FCH ");						(* registered??? *)
	ftFirstChoice3DocumentPC*	= LONG("FCH3");						(* registered??? *)
	ftDCARFTDocumentPC*			= LONG("RFT ");						(* registered??? *)
	ftSamnaDocumentPC*			= LONG("SAMN");						(* registered??? *)
	ftSmartDocumentPC*			= LONG("SMRT");						(* registered??? *)
	ftSprintDocumentPC*			= LONG("SPRT");						(* registered??? *)
	ftTotalWordDocumentPC*		= LONG("TOTL");						(* registered??? *)
	ftVolksWriterDocumentPC*		= LONG("VOLK");						(* registered??? *)
	ftWangWPSDocumentPC*			= LONG("WPS ");						(* registered??? *)
	ftWordMarcDocumentPC*		= LONG("MARC");						(* registered??? *)
	ftAmiDocumentPC*				= LONG("AMI ");						(* registered??? *)
	ftAmiProDocumentPC*			= LONG("APRO");						(* registered??? *)
	ftAmiPro2DocumentPC*			= LONG("APR2");						(* registered??? *)
	ftEnableDocumentPC*			= LONG("ENWP");						(* registered??? *)
(*	data base formats *)
	ftdBaseDatabasePC*			= LONG("DBF ");						(* registered??? *)
	ftdBase3DatabasePC*			= LONG("DB3 ");						(* registered??? *)
	ftdBase4DatabasePC*			= LONG("DB4 ");						(* registered??? *)
	ftDataEaseDatabasePC*		= LONG("DTEZ");						(* registered??? *)
	ftFrameWorkIIIDatabasePC*	= LONG("FWK3");						(* registered??? *)
	ftRBaseVDatabasePC*			= LONG("RBsV");						(* registered??? *)
	ftRBase5000DatabasePC*		= LONG("RB50");						(* registered??? *)
	ftRBaseFile1DatabasePC*		= LONG("RBs1");						(* registered??? *)
	ftRBaseFile3DatabasePC*		= LONG("RBs3");						(* registered??? *)
	ftReflexDatabasePC*			= LONG("RFLX");						(* registered??? *)
	ftQAWriteDatabasePC*			= LONG("QAWT");						(* registered??? *)
	ftQADBaseDatabasePC*			= LONG("QADB");						(* registered??? *)
	ftSmartDataBasePC*			= LONG("SMTD");						(* registered??? *)
	ftFirstChoiceDataBasePC*		= LONG("FCDB");

(*	spread sheet formats *)
	ftDIFSpreadsheetPC*			= LONG("DIF ");						(* registered??? *)
	ftEnableSpreadsheetPC*		= LONG("ENAB");						(* registered??? *)
	ft123R1SpreadsheetPC*		= LONG("WKS1");						(* registered??? *)
	ft123R2SpreadsheetPC*		= LONG("WKS2");						(* registered??? *)
	ft123R3SpreadsheetPC*		= LONG("WKS3");						(* registered??? *)
	ftParadox3SpreadsheetPC*		= LONG("PDX3");						(* registered??? *)
	ftParadox35SpreadsheetPC*	= LONG("PD35");						(* registered??? *)
	ftQuattroSpreadsheetPC*		= LONG("QTRO");						(* registered??? *)
	ftQuattroProSpreadsheetPC*	= LONG("QTR5");						(* registered??? *)
	ftSuperCalc5SpreadsheetPC*	= LONG("SPC5");						(* registered??? *)
	ftSymphony1SpreadsheetPC*	= LONG("SYM1");						(* registered??? *)
	ftTwinSpreadsheetPC*			= LONG("TWIN");						(* registered??? *)
	ftVPPlannerSpreadsheetPC*	= LONG("VPPL");						(* registered??? *)
	ftSmartSpeadsheetPC*			= LONG("SMSH");						(* registered??? *)
	ftFirstChoiceSpeadsheetPC*	= LONG("FCSS");						(* registered??? *)
(*	graphics formats *)
	ftPCPaintBrushGraphicPC*		= LONG("PCX ");						(* not registered *)
	ftLotusPICGraphicPC*			= LONG(".PIC");						(* not registered *)
	ftCGMGraphicPC*				= LONG(".CGM");						(* not registered *)
	ftGEMGraphicPC*				= LONG(".GEM");						(* not registered *)
	ftIMGGraphicPC*				= LONG(".IMG");						(* not registered *)
	ftDXFGraphicPC*				= LONG(".DXF");						(* not registered *)
	ftBitmapWindows*				= LONG(".BMP");						(* not registered *)
	ftMetaFileWindows*			= LONG(".WMF");						(* not registered *)
	ftTIFFGraphic*				= LONG("TIFF");						(* not registered *)
	ftPostScriptPC*				= LONG("EPSP");
	ftPostScriptWindows*			= LONG("EPSW");						(* not registered *)
	ftDigitalFX_TitleMan*		= LONG("TDIM");						(* registered??? *)
	ftDigitalFX_VideoFX*			= LONG("GRAF");						(* registered??? *)
	ftAutodeskFLIandFLC*			= LONG("FLIC");						(* registered??? *)
	ftGIF*						= LONG("GIFf");						(* registered??? *)
	ftIFF*						= LONG("ILBM");						(* registered??? *)
	ftMicrosoftPaint*			= LONG(".MSP");						(* registered??? *)
	ftPixar*						= LONG("PXAR");						(* registered??? *)
	ftQDV*						= LONG(".QDV");						(* registered??? *)
	ftRLE_Compuserve*			= LONG("RLEC");						(* registered??? *)
(*	Generic vector formats *)
	ftIGESGraphicPC*				= LONG("IGES");						(* not registered *)
	ftDDES2GraphicPC*			= LONG("DDES");						(* not registered *)
	ft3DGFGraphicPC*				= LONG("3DGF");						(* not registered *)
(*	Plotter formats *)
	ftHPGLGraphicPC*				= LONG("HPGL");						(* not registered *)
	ftDMPLGraphicPC*				= LONG("DMPL");						(* not registered *)
	ftCalComp906GraphicPC*		= LONG("C906");						(* not registered *)
	ftCalComp907GraphicPC*		= LONG("C907");						(* not registered *)
(*	Vendor-specific formats *)
	ftStereoLithographyGraphicPC* = LONG("STL ");						(*	3D Systems 	- not registered *)
	ftZoomGraphicPC*				= LONG("ZOOM");						(*	Abvent 			- not registered *)
	ftFocusGraphicPC*			= LONG("FOCS");						(*	Abvent 			- not registered *)
	ftWaveFrontGraphicPC*		= LONG("WOBJ");						(*	WaveFront 		- not registered *)
	ftSculpt4DGraphicPC*			= LONG("Scn2");						(*	Types.Byte By Types.Byte 	- not registered *)
	ftMiniPascal3GraphicPC*		= LONG("MPT3");						(*	Graphsoft 		- not registered *)
	ftMiniPascal4GraphicPC*		= LONG("MPT4");						(*	Graphsoft 		- not registered *)
	ftWalkThroughGraphicPC*		= LONG("VWLK");						(*	Virtus 			- not registered *)
	ftSiliconGraphics*			= LONG(".SGI");						(* registered??? *)
	ftSunRaster*					= LONG(".SUN");						(* registered??? *)
	ftTarga*						= LONG("TPIC");						(* registered??? *)
(* misc DOS  *)
	ftDOSComPC*					= LONG(".COM");						(* registered??? *)
	ftDOSExecutablePC*			= LONG(".EXE");						(* registered??? *)
	ftDOSArcPC*					= LONG(".ARC");						(* registered??? *)
	ftAbekas*					= LONG("ABEK");						(* registered??? *)
	ftDrHaloCUT*					= LONG(".CUT");						(* registered??? *)
(* misc Atari *)
	ftDegas*						= LONG("DEGA");						(* not registered *)
	ftNEO*						= LONG(".NEO");


(* $ALIGN RESET*)
(* $POP*)

 END FileTypesAndCreators.
