(*
 	File:		Finder.mod
 
 	Contains:	Finder flags and container types.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE Finder;


(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
(* Make only the following consts avaiable to resource files that include this file *)
	kCustomIconResource*			= -16455;						(* Custom icon family resource AIFF.ID *)
	kContainerFolderAliasType*	= LONG("fdrp");						(* type for folder aliases *)
	kContainerTrashAliasType*	= LONG("trsh");						(* type for trash folder aliases *)
	kContainerHardDiskAliasType*	= LONG("hdsk");						(* type for hard disk aliases *)
	kContainerFloppyAliasType*	= LONG("flpy");						(* type for floppy aliases *)
	kContainerServerAliasType*	= LONG("srvr");						(* type for server aliases *)
	kApplicationAliasType*		= LONG("adrp");						(* type for application aliases *)
	kContainerAliasType*			= LONG("drop");						(* type for all other containers *)
(* types for Special folder aliases *)
	kSystemFolderAliasType*		= LONG("fasy");
	kAppleMenuFolderAliasType*	= LONG("faam");
	kStartupFolderAliasType*		= LONG("fast");
	kPrintMonitorDocsFolderAliasType* = LONG("fapn");
	kPreferencesFolderAliasType*	= LONG("fapf");
	kControlPanelFolderAliasType* = LONG("fact");
	kExtensionFolderAliasType*	= LONG("faex");
(* types for AppleShare folder aliases *)
	kExportedFolderAliasType*	= LONG("faet");
	kDropFolderAliasType*		= LONG("fadr");
	kSharedFolderAliasType*		= LONG("fash");
	kMountedFolderAliasType*		= LONG("famn");

(* Finder Flags *)
	kIsOnDesk*					= $1;
	kColor*						= $E;
	kIsShared*					= $40;
	kHasBeenInited*				= $100;
	kHasCustomIcon*				= $400;
	kIsStationery*				= $800;
	kIsStationary*				= $800;
	kNameLocked*					= $1000;
	kHasBundle*					= $2000;
	kIsInvisible*				= $4000;
	kIsAlias*					= $8000;


(* $ALIGN RESET*)
(* $POP*)

 END Finder.
