(*
 	File:		Folders.mod
 
 	Contains:	Folder Manager Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$IF UNDEFINED SystemSevenFiveOrLater *)
  (*$SET SystemSevenFiveOrLater FALSE*)
(*$END*)
(*$IF UNDEFINED SystemSevenOrLater *)
  (*$IF GENERATINGCFM *)
    (*$SET SystemSevenOrLater TRUE*)
  (*$ELSE*)
    (*$SET SystemSevenOrLater SystemSevenFiveOrLater*)
  (*$END*)
(*$END*)
(*$IF UNDEFINED SystemSixOrLater *)
  (*$SET SystemSixOrLater SystemSevenOrLater*)
(*$END*)
(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE Folders;

IMPORT SYSTEM, Types;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	kOnSystemDisk*				= $8000;
	kCreateFolder*				= TRUE;
	kDontCreateFolder*			= FALSE;
	kSystemFolderType*			= LONG("macs");						(* the system folder *)
	kDesktopFolderType*			= LONG("desk");						(* the desktop folder; objects in this folder show on the desk top. *)
	kTrashFolderType*			= LONG("trsh");						(* the trash folder; objects in this folder show up in the trash *)
	kWhereToEmptyTrashFolderType* = LONG("empt");						(* the "empty trash" folder; Finder starts empty from here down *)
	kPrintMonitorDocsFolderType*	= LONG("prnt");						(* Print Monitor documents *)
	kStartupFolderType*			= LONG("strt");						(* Finder objects (applications, documents, DAs, aliases, to...) to open at startup go here *)
	kAppleMenuFolderType*		= LONG("amnu");						(* Finder objects to put into the Apple menu go here *)
	kControlPanelFolderType*		= LONG("ctrl");						(* Control Panels go here (may contain INITs) *)
	kExtensionFolderType*		= LONG("extn");						(* Finder extensions go here *)
	kFontsFolderType*			= LONG("font");						(* Fonts go here *)
	kPreferencesFolderType*		= LONG("pref");						(* preferences for applications go here *)
	kTemporaryFolderType*		= LONG("temp");

(*$IF SystemSevenOrLater *)

PROCEDURE FindFolder*(vRefNum: INTEGER; folderType: Types.OSType; createFolder: BOOLEAN; VAR foundVRefNum: INTEGER; VAR foundDirID: LONGINT): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $7000, $A823;
	(*$END*)
(*$ELSE*)

PROCEDURE FindFolder*(vRefNum: INTEGER; folderType: Types.OSType; createFolder: BOOLEAN; VAR foundVRefNum: INTEGER; VAR foundDirID: LONGINT): Types.OSErr;
	EXTERNAL PASCAL;
(*$END*)
PROCEDURE ReleaseFolder*(vRefNum: INTEGER; folderType: Types.OSType): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $700B, $A823;
	(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END Folders.
