(*
 	File:		GXFonts.mod
 
 	Contains:	QuickDraw GX font routine interfaces.
 
 	Version:	Technology:	Quickdraw GX 1.1
 				Package:	Universal Interfaces 2.11 in MPW Prerelease on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE GXFonts;

IMPORT SYSTEM, Types, GXTypes, ScalerTypes;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)
(*$SET fontRoutinesIncludes TRUE*)

PROCEDURE GXNewFont*(storage: GXTypes.gxFontStorageTag; reference: GXTypes.gxFontStorageReference; attributes: GXTypes.gxFontAttribute): GXTypes.gxFont; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetFont*(fontID: GXTypes.gxFont; VAR reference: GXTypes.gxFontStorageReference; VAR attributes: GXTypes.gxFontAttribute): GXTypes.gxFontStorageTag;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXFindFont*(storage: GXTypes.gxFontStorageTag; reference: GXTypes.gxFontStorageReference; VAR attributes: GXTypes.gxFontAttribute): GXTypes.gxFont;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetFont*(fontID: GXTypes.gxFont; storage: GXTypes.gxFontStorageTag; reference: GXTypes.gxFontStorageReference; attributes: GXTypes.gxFontAttribute);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeFont*(fontID: GXTypes.gxFont);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXChangedFont*(fontID: GXTypes.gxFont);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetFontFormat*(fontID: GXTypes.gxFont): GXTypes.gxFontFormatTag;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetDefaultFont*(): GXTypes.gxFont;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetDefaultFont*(fontID: GXTypes.gxFont): GXTypes.gxFont;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXFindFonts*(familyID: GXTypes.gxFont; name: GXTypes.gxFontName; platform: GXTypes.gxFontPlatform; script: GXTypes.gxFontScript; language: GXTypes.gxFontLanguage; length: LONGINT; text: Types.ByteParameter; index: LONGINT; count: LONGINT; fonts: GXTypes.gxFont): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCountFontGlyphs*(fontID: GXTypes.gxFont): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCountFontTables*(fontID: GXTypes.gxFont): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetFontTable*(fontID: GXTypes.gxFont; index: LONGINT; tableData: (*UNIV*) Types.Ptr; VAR tableTag: GXTypes.gxFontTableTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXFindFontTable*(fontID: GXTypes.gxFont; tableTag: GXTypes.gxFontTableTag; tableData: (*UNIV*) Types.Ptr; VAR index: LONGINT): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetFontTableParts*(fontID: GXTypes.gxFont; index: LONGINT; offset: LONGINT; length: LONGINT; tableData: (*UNIV*) Types.Ptr; VAR tableTag: GXTypes.gxFontTableTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXFindFontTableParts*(fontID: GXTypes.gxFont; tableTag: GXTypes.gxFontTableTag; offset: LONGINT; length: LONGINT; tableData: (*UNIV*) Types.Ptr; VAR index: LONGINT): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetFontTable*(fontID: GXTypes.gxFont; index: LONGINT; tableTag: GXTypes.gxFontTableTag; length: LONGINT; tableData: (*UNIV*) Types.Ptr): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetFontTableParts*(fontID: GXTypes.gxFont; index: LONGINT; tableTag: GXTypes.gxFontTableTag; offset: LONGINT; oldLength: LONGINT; newLength: LONGINT; tableData: (*UNIV*) Types.Ptr): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDeleteFontTable*(fontID: GXTypes.gxFont; index: LONGINT; tableTag: GXTypes.gxFontTableTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCountFontNames*(fontID: GXTypes.gxFont): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetFontName*(fontID: GXTypes.gxFont; index: LONGINT; VAR name: GXTypes.gxFontName; VAR platform: GXTypes.gxFontPlatform; VAR script: GXTypes.gxFontScript; VAR language: GXTypes.gxFontLanguage; text: Types.ByteParameter): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXFindFontName*(fontID: GXTypes.gxFont; name: GXTypes.gxFontName; platform: GXTypes.gxFontPlatform; script: GXTypes.gxFontScript; language: GXTypes.gxFontLanguage; text: Types.ByteParameter; VAR index: LONGINT): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetFontName*(fontID: GXTypes.gxFont; name: GXTypes.gxFontName; platform: GXTypes.gxFontPlatform; script: GXTypes.gxFontScript; language: GXTypes.gxFontLanguage; length: LONGINT; text: Types.ByteParameter): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDeleteFontName*(fontID: GXTypes.gxFont; index: LONGINT; name: GXTypes.gxFontName; platform: GXTypes.gxFontPlatform; script: GXTypes.gxFontScript; language: GXTypes.gxFontLanguage): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewFontNameID*(fontID: GXTypes.gxFont): GXTypes.gxFontName;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCountFontEncodings*(fontID: GXTypes.gxFont): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetFontEncoding*(fontID: GXTypes.gxFont; index: LONGINT; VAR script: GXTypes.gxFontScript; VAR language: GXTypes.gxFontLanguage): GXTypes.gxFontPlatform;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXFindFontEncoding*(fontID: GXTypes.gxFont; platform: GXTypes.gxFontPlatform; script: GXTypes.gxFontScript; language: GXTypes.gxFontLanguage): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXApplyFontEncoding*(fontID: GXTypes.gxFont; index: LONGINT; VAR length: LONGINT; text: Types.ByteParameter; count: LONGINT; glyphs: INTEGER; was16Bit: Types.ByteParameter): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCountFontVariations*(fontID: GXTypes.gxFont): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXFindFontVariation*(fontID: GXTypes.gxFont; variationTag: GXTypes.gxFontVariationTag; VAR minValue: Types.Fixed; VAR defaultValue: Types.Fixed; VAR maxValue: Types.Fixed; VAR name: GXTypes.gxFontName): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetFontVariation*(fontID: GXTypes.gxFont; index: LONGINT; VAR minValue: Types.Fixed; VAR defaultValue: Types.Fixed; VAR maxValue: Types.Fixed; VAR name: GXTypes.gxFontName): GXTypes.gxFontVariationTag;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCountFontInstances*(fontID: GXTypes.gxFont): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetFontInstance*(fontID: GXTypes.gxFont; index: LONGINT; variation: GXTypes.gxFontVariation): GXTypes.gxFontName;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetFontInstance*(fontID: GXTypes.gxFont; index: LONGINT; name: GXTypes.gxFontName; variation: GXTypes.gxFontVariation): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDeleteFontInstance*(fontID: GXTypes.gxFont; index: LONGINT; name: GXTypes.gxFontName): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCountFontDescriptors*(fontID: GXTypes.gxFont): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetFontDescriptor*(fontID: GXTypes.gxFont; index: LONGINT; VAR descriptorValue: Types.Fixed): GXTypes.gxFontDescriptorTag;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXFindFontDescriptor*(fontID: GXTypes.gxFont; descriptorTag: GXTypes.gxFontDescriptorTag; VAR descriptorValue: Types.Fixed): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetFontDescriptor*(fontID: GXTypes.gxFont; index: LONGINT; descriptorTag: GXTypes.gxFontDescriptorTag; descriptorValue: Types.Fixed): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDeleteFontDescriptor*(fontID: GXTypes.gxFont; index: LONGINT; descriptorTag: GXTypes.gxFontDescriptorTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCountFontFeatures*(fontID: GXTypes.gxFont): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetFontFeature*(fontID: GXTypes.gxFont; index: LONGINT; VAR flags: GXTypes.gxFontFeatureFlag; VAR settingCount: LONGINT; settings: GXTypes.gxFontFeatureSetting; VAR feature: GXTypes.gxFontFeature): GXTypes.gxFontName;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXFindFontFeature*(fontID: GXTypes.gxFont; feature: GXTypes.gxFontFeature; VAR flags: GXTypes.gxFontFeatureFlag; VAR settingCount: LONGINT; settings: GXTypes.gxFontFeatureSetting; VAR index: LONGINT): GXTypes.gxFontName;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetFontDefaultFeatures*(fontID: GXTypes.gxFont; features: GXTypes.gxRunFeature): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXFlattenFont*(source: GXTypes.gxFont; VAR stream: ScalerTypes.scalerStream; VAR block: GXTypes.gxSpoolBlock);  (*C;*)
	EXTERNAL (*C*);

(* $ALIGN RESET*)
(* $POP*)

 END GXFonts.
