(*
 	File:		GXGraphics.mod
 
 	Contains:	QuickDraw GX graphic routine interfaces.
 
 	Version:	Technology:	Quickdraw GX 1.1
 				Package:	Universal Interfaces 2.11 in MPW Prerelease on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE GXGraphics;

IMPORT SYSTEM, Types, GXTypes, GXMath, GXErrors;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)
(*$SET graphicsRoutinesIncludes TRUE*)

PROCEDURE GXNewGraphicsClient*(memoryStart: (*UNIV*) Types.Ptr; memoryLength: LONGINT; attributes: GXTypes.gxClientAttribute): GXTypes.gxGraphicsClient;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetGraphicsClient*(): GXTypes.gxGraphicsClient;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetGraphicsClient*(client: GXTypes.gxGraphicsClient);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeGraphicsClient*(client: GXTypes.gxGraphicsClient);  (*C;*)
	EXTERNAL (*C*);
(*returns the count *)
PROCEDURE GXGetGraphicsClients*(index: LONGINT; count: LONGINT; clients: GXTypes.gxGraphicsClient): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXEnterGraphics*;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXExitGraphics*;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetGraphicsError*(VAR stickyError: GXErrors.gxGraphicsError): GXErrors.gxGraphicsError;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetGraphicsNotice*(VAR stickyNotice: GXErrors.gxGraphicsNotice): GXErrors.gxGraphicsNotice;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetGraphicsWarning*(VAR stickyWarning: GXErrors.gxGraphicsWarning): GXErrors.gxGraphicsWarning;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXPostGraphicsError*(error: GXErrors.gxGraphicsError);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXPostGraphicsWarning*(warning: GXErrors.gxGraphicsWarning);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetUserGraphicsError*(VAR reference: LONGINT): GXErrors.gxUserErrorFunction;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetUserGraphicsNotice*(VAR reference: LONGINT): GXErrors.gxUserNoticeFunction;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetUserGraphicsWarning*(VAR reference: LONGINT): GXErrors.gxUserWarningFunction;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetUserGraphicsError*(userFunction: GXErrors.gxUserErrorFunction; reference: LONGINT);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetUserGraphicsNotice*(userFunction: GXErrors.gxUserNoticeFunction; reference: LONGINT);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetUserGraphicsWarning*(userFunction: GXErrors.gxUserWarningFunction; reference: LONGINT);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXIgnoreGraphicsWarning*(warning: GXErrors.gxGraphicsWarning);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXPopGraphicsWarning*;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewShapeVector*(aType: GXTypes.gxShapeType; vector: Types.Fixed): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeVector*(target: GXTypes.gxShape; vector: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewBitmap*((*CONST*)VAR data: GXTypes.gxBitmap; (*CONST*)VAR position: GXMath.gxPoint): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewCurve*((*CONST*)VAR data: GXTypes.gxCurve): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewGlyphs*(charCount: LONGINT; text: Types.ByteParameter; positions: GXMath.gxPoint; advance: LONGINT; tangents: GXMath.gxPoint; styleRuns: INTEGER; glyphStyles: GXTypes.gxStyle): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewLine*((*CONST*)VAR data: GXTypes.gxLine): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewPaths*((*CONST*)VAR data: GXTypes.gxPaths): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewPicture*(count: LONGINT; shapes: GXTypes.gxShape; styles: GXTypes.gxStyle; inks: GXTypes.gxInk; transforms: GXTypes.gxTransform): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewPoint*((*CONST*)VAR data: GXMath.gxPoint): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewPolygons*((*CONST*)VAR data: GXTypes.gxPolygons): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewRectangle*((*CONST*)VAR data: GXTypes.gxRectangle): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewText*(charCount: LONGINT; text: Types.ByteParameter; (*CONST*)VAR position: GXMath.gxPoint): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetBitmap*(source: GXTypes.gxShape; VAR data: GXTypes.gxBitmap; VAR position: GXMath.gxPoint)(* : GXTypes.gxBitmap*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetCurve*(source: GXTypes.gxShape; VAR data: GXTypes.gxCurve)(*: GXTypes.gxCurve*);  (*C;*)
	EXTERNAL (*C*);
(* returns byte length of glyphs *)
PROCEDURE GXGetGlyphs*(source: GXTypes.gxShape; VAR charCount: LONGINT; text: Types.ByteParameter; positions: GXMath.gxPoint; advance: LONGINT; tangents: GXMath.gxPoint; VAR runCount: LONGINT; styleRuns: INTEGER; glyphStyles: GXTypes.gxStyle): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLine*(source: GXTypes.gxShape; VAR data: GXTypes.gxLine)(* : GXTypes.gxLine*);  (*C;*)
	EXTERNAL (*C*);
(* returns byte length *)
PROCEDURE GXGetPaths*(source: GXTypes.gxShape; VAR data: GXTypes.gxPaths): LONGINT;  (*C;*)
	EXTERNAL (*C*);
(* returns count *)
PROCEDURE GXGetPicture*(source: GXTypes.gxShape; shapes: GXTypes.gxShape; styles: GXTypes.gxStyle; inks: GXTypes.gxInk; transforms: GXTypes.gxTransform): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetPoint*(source: GXTypes.gxShape; VAR data: GXMath.gxPoint)(* : GXMath.gxPoint*);  (*C;*)
	EXTERNAL (*C*);
(* returns byte length *)
PROCEDURE GXGetPolygons*(source: GXTypes.gxShape; VAR data: GXTypes.gxPolygons): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetRectangle*(source: GXTypes.gxShape; VAR data: GXTypes.gxRectangle)(* : GXTypes.gxRectangle*);  (*C;*)
	EXTERNAL (*C*);
(* returns byte length *)
PROCEDURE GXGetText*(source: GXTypes.gxShape; VAR charCount: LONGINT; text: Types.ByteParameter; VAR position: GXMath.gxPoint): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetBitmap*(target: GXTypes.gxShape; (*CONST*)VAR data: GXTypes.gxBitmap; (*CONST*)VAR position: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetCurve*(target: GXTypes.gxShape; (*CONST*)VAR data: GXTypes.gxCurve);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetGlyphs*(target: GXTypes.gxShape; charCount: LONGINT; text: Types.ByteParameter; positions: GXMath.gxPoint; advance: LONGINT; tangents: GXMath.gxPoint; styleRuns: INTEGER; glyphStyles: GXTypes.gxStyle);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetLine*(target: GXTypes.gxShape; (*CONST*)VAR data: GXTypes.gxLine);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetPaths*(target: GXTypes.gxShape; (*CONST*)VAR data: GXTypes.gxPaths);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetPicture*(target: GXTypes.gxShape; count: LONGINT; shapes: GXTypes.gxShape; styles: GXTypes.gxStyle; inks: GXTypes.gxInk; transforms: GXTypes.gxTransform);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetPoint*(target: GXTypes.gxShape; (*CONST*)VAR data: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetPolygons*(target: GXTypes.gxShape; (*CONST*)VAR data: GXTypes.gxPolygons);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetRectangle*(target: GXTypes.gxShape; (*CONST*)VAR data: GXTypes.gxRectangle);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetText*(target: GXTypes.gxShape; charCount: LONGINT; text: Types.ByteParameter; (*CONST*)VAR position: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDrawBitmap*((*CONST*)VAR data: GXTypes.gxBitmap; (*CONST*)VAR position: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDrawCurve*((*CONST*)VAR data: GXTypes.gxCurve);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDrawGlyphs*(charCount: LONGINT; text: Types.ByteParameter; positions: GXMath.gxPoint; advance: LONGINT; tangents: GXMath.gxPoint; styleRuns: INTEGER; glyphStyles: GXTypes.gxStyle);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDrawLine*((*CONST*)VAR data: GXTypes.gxLine);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDrawPaths*((*CONST*)VAR data: GXTypes.gxPaths; fill: GXTypes.gxShapeFill);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDrawPicture*(count: LONGINT; shapes: GXTypes.gxShape; styles: GXTypes.gxStyle; inks: GXTypes.gxInk; transforms: GXTypes.gxTransform);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDrawPoint*((*CONST*)VAR data: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDrawPolygons*((*CONST*)VAR data: GXTypes.gxPolygons; fill: GXTypes.gxShapeFill);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDrawRectangle*((*CONST*)VAR data: GXTypes.gxRectangle; fill: GXTypes.gxShapeFill);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDrawText*(charCount: LONGINT; text: Types.ByteParameter; (*CONST*)VAR position: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewColorProfile*(size: LONGINT; colorProfileData: (*UNIV*) Types.Ptr): GXTypes.gxColorProfile;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewColorSet*(space: GXTypes.gxColorSpace; count: LONGINT; colors: GXTypes.gxSetColor): GXTypes.gxColorSet;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewInk*(): GXTypes.gxInk;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewShape*(aType: GXTypes.gxShapeType): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewStyle*(): GXTypes.gxStyle;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewTag*(tagType: LONGINT; length: LONGINT; data: (*UNIV*) Types.Ptr): GXTypes.gxTag;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewTransform*(): GXTypes.gxTransform;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewViewDevice*(group: GXTypes.gxViewGroup; bitmapShape: GXTypes.gxShape): GXTypes.gxViewDevice;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewViewGroup*(): GXTypes.gxViewGroup;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewViewPort*(group: GXTypes.gxViewGroup): GXTypes.gxViewPort;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeColorProfile*(target: GXTypes.gxColorProfile);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeColorSet*(target: GXTypes.gxColorSet);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeInk*(target: GXTypes.gxInk);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeShape*(target: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeStyle*(target: GXTypes.gxStyle);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeTag*(target: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeTransform*(target: GXTypes.gxTransform);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeViewDevice*(target: GXTypes.gxViewDevice);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeViewGroup*(target: GXTypes.gxViewGroup);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeViewPort*(target: GXTypes.gxViewPort);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCloneColorProfile*(source: GXTypes.gxColorProfile): GXTypes.gxColorProfile;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCloneColorSet*(source: GXTypes.gxColorSet): GXTypes.gxColorSet;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCloneInk*(source: GXTypes.gxInk): GXTypes.gxInk;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCloneShape*(source: GXTypes.gxShape): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCloneStyle*(source: GXTypes.gxStyle): GXTypes.gxStyle;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCloneTag*(source: GXTypes.gxTag): GXTypes.gxTag;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCloneTransform*(source: GXTypes.gxTransform): GXTypes.gxTransform;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCopyToColorProfile*(target: GXTypes.gxColorProfile; source: GXTypes.gxColorProfile): GXTypes.gxColorProfile;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCopyToColorSet*(target: GXTypes.gxColorSet; source: GXTypes.gxColorSet): GXTypes.gxColorSet;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCopyToInk*(target: GXTypes.gxInk; source: GXTypes.gxInk): GXTypes.gxInk;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCopyToShape*(target: GXTypes.gxShape; source: GXTypes.gxShape): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCopyToStyle*(target: GXTypes.gxStyle; source: GXTypes.gxStyle): GXTypes.gxStyle;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCopyToTag*(target: GXTypes.gxTag; source: GXTypes.gxTag): GXTypes.gxTag;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCopyToTransform*(target: GXTypes.gxTransform; source: GXTypes.gxTransform): GXTypes.gxTransform;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCopyToViewDevice*(target: GXTypes.gxViewDevice; source: GXTypes.gxViewDevice): GXTypes.gxViewDevice;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCopyToViewPort*(target: GXTypes.gxViewPort; source: GXTypes.gxViewPort): GXTypes.gxViewPort;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXEqualColorProfile*(one: GXTypes.gxColorProfile; two: GXTypes.gxColorProfile): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXEqualColorSet*(one: GXTypes.gxColorSet; two: GXTypes.gxColorSet): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXEqualInk*(one: GXTypes.gxInk; two: GXTypes.gxInk): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXEqualShape*(one: GXTypes.gxShape; two: GXTypes.gxShape): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXEqualStyle*(one: GXTypes.gxStyle; two: GXTypes.gxStyle): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXEqualTag*(one: GXTypes.gxTag; two: GXTypes.gxTag): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXEqualTransform*(one: GXTypes.gxTransform; two: GXTypes.gxTransform): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXEqualViewDevice*(one: GXTypes.gxViewDevice; two: GXTypes.gxViewDevice): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXEqualViewPort*(one: GXTypes.gxViewPort; two: GXTypes.gxViewPort): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXResetInk*(target: GXTypes.gxInk);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXResetShape*(target: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXResetStyle*(target: GXTypes.gxStyle);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXResetTransform*(target: GXTypes.gxTransform);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXLoadColorProfile*(target: GXTypes.gxColorProfile);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXLoadColorSet*(target: GXTypes.gxColorSet);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXLoadInk*(target: GXTypes.gxInk);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXLoadShape*(target: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXLoadStyle*(target: GXTypes.gxStyle);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXLoadTag*(target: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXLoadTransform*(target: GXTypes.gxTransform);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnloadColorProfile*(target: GXTypes.gxColorProfile);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnloadColorSet*(target: GXTypes.gxColorSet);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnloadInk*(target: GXTypes.gxInk);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnloadShape*(target: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnloadStyle*(target: GXTypes.gxStyle);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnloadTag*(target: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnloadTransform*(target: GXTypes.gxTransform);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCacheShape*(source: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCopyDeepToShape*(target: GXTypes.gxShape; source: GXTypes.gxShape): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDrawShape*(source: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDisposeShapeCache*(target: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetDefaultColorProfile*(): GXTypes.gxColorProfile;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetDefaultShape*(aType: GXTypes.gxShapeType): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetDefaultColorSet*(pixelDepth: LONGINT): GXTypes.gxColorSet;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetDefaultShape*(target: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetDefaultColorSet*(target: GXTypes.gxColorSet; pixelDepth: LONGINT);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetTag*(source: GXTypes.gxTag; VAR tagType: LONGINT; data: (*UNIV*) Types.Ptr): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetTag*(target: GXTypes.gxTag; tagType: LONGINT; length: LONGINT; data: (*UNIV*) Types.Ptr);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeBounds*(source: GXTypes.gxShape; index: LONGINT; VAR bounds: GXTypes.gxRectangle)(* : GXTypes.gxRectangle*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeFill*(source: GXTypes.gxShape): GXTypes.gxShapeFill;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeInk*(source: GXTypes.gxShape): GXTypes.gxInk;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapePixel*(source: GXTypes.gxShape; x: LONGINT; y: LONGINT; VAR data: GXTypes.gxColor; VAR index: LONGINT): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeStyle*(source: GXTypes.gxShape): GXTypes.gxStyle;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeTransform*(source: GXTypes.gxShape): GXTypes.gxTransform;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeType*(source: GXTypes.gxShape): GXTypes.gxShapeType;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeTypographicBounds*(source: GXTypes.gxShape; VAR bounds: GXTypes.gxRectangle)(*: GXTypes.gxRectangle*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetBitmapParts*(source: GXTypes.gxShape; (*CONST*)VAR bounds: GXTypes.gxLongRectangle): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleFontMetrics*(sourceStyle: GXTypes.gxStyle; VAR before: GXMath.gxPoint; VAR after: GXMath.gxPoint; VAR caretAngle: GXMath.gxPoint; VAR caretOffset: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeFontMetrics*(source: GXTypes.gxShape; VAR before: GXMath.gxPoint; VAR after: GXMath.gxPoint; VAR caretAngle: GXMath.gxPoint; VAR caretOffset: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeBounds*(target: GXTypes.gxShape; (*CONST*)VAR newBounds: GXTypes.gxRectangle);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeFill*(target: GXTypes.gxShape; newFill: GXTypes.gxShapeFill);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeInk*(target: GXTypes.gxShape; newInk: GXTypes.gxInk);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapePixel*(target: GXTypes.gxShape; x: LONGINT; y: LONGINT; (*CONST*)VAR newColor: GXTypes.gxColor; newIndex: LONGINT);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeStyle*(target: GXTypes.gxShape; newStyle: GXTypes.gxStyle);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeTransform*(target: GXTypes.gxShape; newTransform: GXTypes.gxTransform);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeType*(target: GXTypes.gxShape; newType: GXTypes.gxShapeType);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetBitmapParts*(target: GXTypes.gxShape; (*CONST*)VAR bounds: GXTypes.gxLongRectangle; bitmapShape: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeGeometry*(target: GXTypes.gxShape; geometry: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeCurveError*(source: GXTypes.gxShape): Types.Fixed;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeDash*(source: GXTypes.gxShape; VAR dash: GXTypes.gxDashRecord)(* : GXTypes.gxDashRecord*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeCap*(source: GXTypes.gxShape; VAR cap: GXTypes.gxCapRecord)(* : GXTypes.gxCapRecord*);  (*C;*)
	EXTERNAL (*C*);
(* returns the number of layers *)
PROCEDURE GXGetShapeFace*(source: GXTypes.gxShape; VAR face: GXTypes.gxTextFace): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeFont*(source: GXTypes.gxShape): GXTypes.gxFont;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeJoin*(source: GXTypes.gxShape; VAR join: GXTypes.gxJoinRecord)(* : GXTypes.gxJoinRecord*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeJustification*(source: GXTypes.gxShape): Types.Fract;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapePattern*(source: GXTypes.gxShape; VAR pattern: GXTypes.gxPatternRecord)(* : GXTypes.gxPatternRecord*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapePen*(source: GXTypes.gxShape): Types.Fixed;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeEncoding*(source: GXTypes.gxShape; VAR script: GXTypes.gxFontScript; VAR language: GXTypes.gxFontLanguage): GXTypes.gxFontPlatform;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeTextSize*(source: GXTypes.gxShape): Types.Fixed;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeFontVariations*(source: GXTypes.gxShape; variations: GXTypes.gxFontVariation): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeFontVariationSuite*(source: GXTypes.gxShape; variations: GXTypes.gxFontVariation): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleCurveError*(source: GXTypes.gxStyle): Types.Fixed;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleDash*(source: GXTypes.gxStyle; VAR dash: GXTypes.gxDashRecord)(* : GXTypes.gxDashRecord*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleCap*(source: GXTypes.gxStyle; VAR cap: GXTypes.gxCapRecord)(*: GXTypes.gxCapRecord*);  (*C;*)
	EXTERNAL (*C*);
(* returns the number of layers *)
PROCEDURE GXGetStyleFace*(source: GXTypes.gxStyle; VAR face: GXTypes.gxTextFace): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleFont*(source: GXTypes.gxStyle): GXTypes.gxFont;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleJoin*(source: GXTypes.gxStyle; VAR join: GXTypes.gxJoinRecord)(* : GXTypes.gxJoinRecord*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleJustification*(source: GXTypes.gxStyle): Types.Fract;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStylePattern*(source: GXTypes.gxStyle; VAR pattern: GXTypes.gxPatternRecord)(*: GXTypes.gxPatternRecord*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStylePen*(source: GXTypes.gxStyle): Types.Fixed;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleEncoding*(source: GXTypes.gxStyle; VAR script: GXTypes.gxFontScript; VAR language: GXTypes.gxFontLanguage): GXTypes.gxFontPlatform;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleTextSize*(source: GXTypes.gxStyle): Types.Fixed;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleFontVariations*(source: GXTypes.gxStyle; variations: GXTypes.gxFontVariation): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleFontVariationSuite*(source: GXTypes.gxStyle; variations: GXTypes.gxFontVariation): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeCurveError*(target: GXTypes.gxShape; error: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeDash*(target: GXTypes.gxShape; (*CONST*)VAR dash: GXTypes.gxDashRecord);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeCap*(target: GXTypes.gxShape; (*CONST*)VAR cap: GXTypes.gxCapRecord);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeFace*(target: GXTypes.gxShape; (*CONST*)VAR face: GXTypes.gxTextFace);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeFont*(target: GXTypes.gxShape; aFont: GXTypes.gxFont);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeJoin*(target: GXTypes.gxShape; (*CONST*)VAR join: GXTypes.gxJoinRecord);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeJustification*(target: GXTypes.gxShape; justify: Types.Fract);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapePattern*(target: GXTypes.gxShape; (*CONST*)VAR pattern: GXTypes.gxPatternRecord);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapePen*(target: GXTypes.gxShape; pen: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeEncoding*(target: GXTypes.gxShape; platform: GXTypes.gxFontPlatform; script: GXTypes.gxFontScript; language: GXTypes.gxFontLanguage);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeTextSize*(target: GXTypes.gxShape; size: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeFontVariations*(target: GXTypes.gxShape; count: LONGINT; variations: GXTypes.gxFontVariation);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleCurveError*(target: GXTypes.gxStyle; error: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleDash*(target: GXTypes.gxStyle; (*CONST*)VAR dash: GXTypes.gxDashRecord);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleCap*(target: GXTypes.gxStyle; (*CONST*)VAR cap: GXTypes.gxCapRecord);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleFace*(target: GXTypes.gxStyle; (*CONST*)VAR face: GXTypes.gxTextFace);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleFont*(target: GXTypes.gxStyle; aFont: GXTypes.gxFont);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleJoin*(target: GXTypes.gxStyle; (*CONST*)VAR join: GXTypes.gxJoinRecord);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleJustification*(target: GXTypes.gxStyle; justify: Types.Fract);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStylePattern*(target: GXTypes.gxStyle; (*CONST*)VAR pattern: GXTypes.gxPatternRecord);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStylePen*(target: GXTypes.gxStyle; pen: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleEncoding*(target: GXTypes.gxStyle; platform: GXTypes.gxFontPlatform; script: GXTypes.gxFontScript; language: GXTypes.gxFontLanguage);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleTextSize*(target: GXTypes.gxStyle; size: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleFontVariations*(target: GXTypes.gxStyle; count: LONGINT; variations: GXTypes.gxFontVariation);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeColor*(source: GXTypes.gxShape; VAR data: GXTypes.gxColor)(* : GXTypes.gxColor*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeTransfer*(source: GXTypes.gxShape; VAR data: GXTypes.gxTransferMode)(* : GXTypes.gxTransferMode*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetInkColor*(source: GXTypes.gxInk; VAR data: GXTypes.gxColor)(*: GXTypes.gxColor*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetInkTransfer*(source: GXTypes.gxInk; VAR data: GXTypes.gxTransferMode)(*: GXTypes.gxTransferMode*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeColor*(target: GXTypes.gxShape; (*CONST*)VAR data: GXTypes.gxColor);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeTransfer*(target: GXTypes.gxShape; (*CONST*)VAR data: GXTypes.gxTransferMode);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetInkColor*(target: GXTypes.gxInk; (*CONST*)VAR data: GXTypes.gxColor);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetInkTransfer*(target: GXTypes.gxInk; (*CONST*)VAR data: GXTypes.gxTransferMode);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeClip*(source: GXTypes.gxShape): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeClipType*(source: GXTypes.gxShape): GXTypes.gxShapeType;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeMapping*(source: GXTypes.gxShape; VAR map: GXMath.gxMapping)(* : GXMath.gxMapping*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeHitTest*(source: GXTypes.gxShape; VAR tolerance: Types.Fixed): GXTypes.gxShapePart;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeViewPorts*(source: GXTypes.gxShape; list: GXTypes.gxViewPort): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetTransformClip*(source: GXTypes.gxTransform): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetTransformClipType*(source: GXTypes.gxTransform): GXTypes.gxShapeType;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetTransformMapping*(source: GXTypes.gxTransform; VAR map: GXMath.gxMapping)(* : GXMath.gxMapping*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetTransformHitTest*(source: GXTypes.gxTransform; VAR tolerance: Types.Fixed): GXTypes.gxShapePart;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetTransformViewPorts*(source: GXTypes.gxTransform; list: GXTypes.gxViewPort): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeClip*(target: GXTypes.gxShape; clip: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeMapping*(target: GXTypes.gxShape; (*CONST*)VAR map: GXMath.gxMapping);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeHitTest*(target: GXTypes.gxShape; mask: GXTypes.gxShapePart; tolerance: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeViewPorts*(target: GXTypes.gxShape; count: LONGINT; list: GXTypes.gxViewPort);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetTransformClip*(target: GXTypes.gxTransform; clip: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetTransformMapping*(target: GXTypes.gxTransform; (*CONST*)VAR map: GXMath.gxMapping);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetTransformHitTest*(target: GXTypes.gxTransform; mask: GXTypes.gxShapePart; tolerance: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetTransformViewPorts*(target: GXTypes.gxTransform; count: LONGINT; list: GXTypes.gxViewPort);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetColorSet*(source: GXTypes.gxColorSet; VAR space: GXTypes.gxColorSpace; colors: GXTypes.gxSetColor): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetColorProfile*(source: GXTypes.gxColorProfile; colorProfileData: (*UNIV*) Types.Ptr): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetColorSet*(target: GXTypes.gxColorSet; space: GXTypes.gxColorSpace; count: LONGINT; colors: GXTypes.gxSetColor);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetColorProfile*(target: GXTypes.gxColorProfile; size: LONGINT; colorProfileData: (*UNIV*) Types.Ptr);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewDeviceBitmap*(source: GXTypes.gxViewDevice): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewDeviceClip*(source: GXTypes.gxViewDevice): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewDeviceMapping*(source: GXTypes.gxViewDevice; VAR map: GXMath.gxMapping)(* : GXMath.gxMapping*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewDeviceViewGroup*(source: GXTypes.gxViewDevice): GXTypes.gxViewGroup;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewDeviceBitmap*(target: GXTypes.gxViewDevice; bitmapShape: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewDeviceClip*(target: GXTypes.gxViewDevice; clip: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewDeviceMapping*(target: GXTypes.gxViewDevice; (*CONST*)VAR map: GXMath.gxMapping);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewDeviceViewGroup*(target: GXTypes.gxViewDevice; group: GXTypes.gxViewGroup);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewPortChildren*(source: GXTypes.gxViewPort; list: GXTypes.gxViewPort): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewPortClip*(source: GXTypes.gxViewPort): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewPortDither*(source: GXTypes.gxViewPort): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewPortHalftone*(source: GXTypes.gxViewPort; VAR data: GXTypes.gxHalftone): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewPortMapping*(source: GXTypes.gxViewPort; VAR map: GXMath.gxMapping)(* : GXMath.gxMapping*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewPortParent*(source: GXTypes.gxViewPort): GXTypes.gxViewPort;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewPortViewGroup*(source: GXTypes.gxViewPort): GXTypes.gxViewGroup;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewPortHalftoneMatrix*(source: GXTypes.gxViewPort; sourceDevice: GXTypes.gxViewDevice; VAR theMatrix: GXTypes.gxHalftoneMatrix): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewPortChildren*(target: GXTypes.gxViewPort; count: LONGINT; list: GXTypes.gxViewPort);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewPortClip*(target: GXTypes.gxViewPort; clip: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewPortDither*(target: GXTypes.gxViewPort; level: LONGINT);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewPortHalftone*(target: GXTypes.gxViewPort; (*CONST*)VAR data: GXTypes.gxHalftone);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewPortMapping*(target: GXTypes.gxViewPort; (*CONST*)VAR map: GXMath.gxMapping);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewPortParent*(target: GXTypes.gxViewPort; parent: GXTypes.gxViewPort);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewPortViewGroup*(target: GXTypes.gxViewPort; group: GXTypes.gxViewGroup);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetColorProfileTags*(source: GXTypes.gxColorProfile; tagType: LONGINT; index: LONGINT; count: LONGINT; items: GXTypes.gxTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetColorSetTags*(source: GXTypes.gxColorSet; tagType: LONGINT; index: LONGINT; count: LONGINT; items: GXTypes.gxTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetInkTags*(source: GXTypes.gxInk; tagType: LONGINT; index: LONGINT; count: LONGINT; items: GXTypes.gxTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeTags*(source: GXTypes.gxShape; tagType: LONGINT; index: LONGINT; count: LONGINT; items: GXTypes.gxTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleTags*(source: GXTypes.gxStyle; tagType: LONGINT; index: LONGINT; count: LONGINT; items: GXTypes.gxTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetTransformTags*(source: GXTypes.gxTransform; tagType: LONGINT; index: LONGINT; count: LONGINT; items: GXTypes.gxTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewDeviceTags*(source: GXTypes.gxViewDevice; tagType: LONGINT; index: LONGINT; count: LONGINT; items: GXTypes.gxTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewPortTags*(source: GXTypes.gxViewPort; tagType: LONGINT; index: LONGINT; count: LONGINT; items: GXTypes.gxTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetColorProfileTags*(target: GXTypes.gxColorProfile; tagType: LONGINT; index: LONGINT; oldCount: LONGINT; newCount: LONGINT; items: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetColorSetTags*(target: GXTypes.gxColorSet; tagType: LONGINT; index: LONGINT; oldCount: LONGINT; newCount: LONGINT; items: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetInkTags*(target: GXTypes.gxInk; tagType: LONGINT; index: LONGINT; oldCount: LONGINT; newCount: LONGINT; items: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeTags*(target: GXTypes.gxShape; tagType: LONGINT; index: LONGINT; oldCount: LONGINT; newCount: LONGINT; items: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleTags*(target: GXTypes.gxStyle; tagType: LONGINT; index: LONGINT; oldCount: LONGINT; newCount: LONGINT; items: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetTransformTags*(target: GXTypes.gxTransform; tagType: LONGINT; index: LONGINT; oldCount: LONGINT; newCount: LONGINT; items: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewDeviceTags*(target: GXTypes.gxViewDevice; tagType: LONGINT; index: LONGINT; oldCount: LONGINT; newCount: LONGINT; items: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewPortTags*(target: GXTypes.gxViewPort; tagType: LONGINT; index: LONGINT; oldCount: LONGINT; newCount: LONGINT; items: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetInkAttributes*(source: GXTypes.gxInk): GXTypes.gxInkAttribute;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeAttributes*(source: GXTypes.gxShape): GXTypes.gxShapeAttribute;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeInkAttributes*(source: GXTypes.gxShape): GXTypes.gxInkAttribute;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeStyleAttributes*(source: GXTypes.gxShape): GXTypes.gxStyleAttribute;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleAttributes*(source: GXTypes.gxStyle): GXTypes.gxStyleAttribute;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeTextAttributes*(source: GXTypes.gxShape): GXTypes.gxTextAttribute;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleTextAttributes*(source: GXTypes.gxStyle): GXTypes.gxTextAttribute;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewDeviceAttributes*(source: GXTypes.gxViewDevice): GXTypes.gxDeviceAttribute;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewPortAttributes*(source: GXTypes.gxViewPort): GXTypes.gxPortAttribute;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetInkAttributes*(target: GXTypes.gxInk; attributes: GXTypes.gxInkAttribute);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeAttributes*(target: GXTypes.gxShape; attributes: GXTypes.gxShapeAttribute);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeInkAttributes*(target: GXTypes.gxShape; attributes: GXTypes.gxInkAttribute);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeStyleAttributes*(target: GXTypes.gxShape; attributes: GXTypes.gxStyleAttribute);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleAttributes*(target: GXTypes.gxStyle; attributes: GXTypes.gxStyleAttribute);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeTextAttributes*(target: GXTypes.gxShape; attributes: GXTypes.gxTextAttribute);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleTextAttributes*(target: GXTypes.gxStyle; attributes: GXTypes.gxTextAttribute);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewDeviceAttributes*(target: GXTypes.gxViewDevice; attributes: GXTypes.gxDeviceAttribute);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetViewPortAttributes*(target: GXTypes.gxViewPort; attributes: GXTypes.gxPortAttribute);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetColorProfileOwners*(source: GXTypes.gxColorProfile): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetColorSetOwners*(source: GXTypes.gxColorSet): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetInkOwners*(source: GXTypes.gxInk): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeOwners*(source: GXTypes.gxShape): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleOwners*(source: GXTypes.gxStyle): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetTagOwners*(source: GXTypes.gxTag): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetTransformOwners*(source: GXTypes.gxTransform): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXLockShape*(target: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXLockTag*(target: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnlockShape*(target: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnlockTag*(target: GXTypes.gxTag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeStructure*(source: GXTypes.gxShape; VAR length: LONGINT): Types.Ptr;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetTagStructure*(source: GXTypes.gxTag; VAR length: LONGINT): Types.Ptr;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetColorDistance*((*CONST*)VAR target: GXTypes.gxColor; (*CONST*)VAR source: GXTypes.gxColor): Types.Fixed;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXShapeLengthToPoint*(target: GXTypes.gxShape; index: LONGINT; length: Types.Fixed; VAR location: GXMath.gxPoint; VAR tangent: GXMath.gxPoint)(* : GXMath.gxPoint*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeArea*(source: GXTypes.gxShape; index: LONGINT; VAR area: Types.wide)(* : Types.wide*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeCacheSize*(source: GXTypes.gxShape): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeCenter*(source: GXTypes.gxShape; index: LONGINT; VAR center: GXMath.gxPoint)(*: GXMath.gxPoint*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeDirection*(source: GXTypes.gxShape; contour: LONGINT): GXTypes.gxContourDirection;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeIndex*(source: GXTypes.gxShape; contour: LONGINT; vector: LONGINT): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeLength*(source: GXTypes.gxShape; index: LONGINT; VAR length: Types.wide)(* : Types.wide*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeSize*(source: GXTypes.gxShape): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCountShapeContours*(source: GXTypes.gxShape): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCountShapePoints*(source: GXTypes.gxShape; contour: LONGINT): LONGINT;  (*C;*)
	EXTERNAL (*C*);
(* returns the number of positions *)
PROCEDURE GXGetShapeDashPositions*(source: GXTypes.gxShape; dashMappings: GXMath.gxMapping): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeDeviceArea*(source: GXTypes.gxShape; port: GXTypes.gxViewPort; device: GXTypes.gxViewDevice): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeDeviceBounds*(source: GXTypes.gxShape; port: GXTypes.gxViewPort; device: GXTypes.gxViewDevice; VAR bounds: GXTypes.gxRectangle): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeDeviceColors*(source: GXTypes.gxShape; port: GXTypes.gxViewPort; device: GXTypes.gxViewDevice; VAR width: LONGINT): GXTypes.gxColorSet;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeGlobalBounds*(source: GXTypes.gxShape; port: GXTypes.gxViewPort; group: GXTypes.gxViewGroup; VAR bounds: GXTypes.gxRectangle): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeGlobalViewDevices*(source: GXTypes.gxShape; port: GXTypes.gxViewPort; list: GXTypes.gxViewDevice): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeGlobalViewPorts*(source: GXTypes.gxShape; list: GXTypes.gxViewPort): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeLocalBounds*(source: GXTypes.gxShape; VAR bounds: GXTypes.gxRectangle)(*: GXTypes.gxRectangle*);  (*C;*)
	EXTERNAL (*C*);
(* returns the number of positions *)
PROCEDURE GXGetShapePatternPositions*(source: GXTypes.gxShape; positions: GXMath.gxPoint): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeLocalFontMetrics*(sourceShape: GXTypes.gxShape; VAR before: GXMath.gxPoint; VAR after: GXMath.gxPoint; VAR caretAngle: GXMath.gxPoint; VAR caretOffset: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeDeviceFontMetrics*(sourceShape: GXTypes.gxShape; port: GXTypes.gxViewPort; device: GXTypes.gxViewDevice; VAR before: GXMath.gxPoint; VAR after: GXMath.gxPoint; VAR caretAngle: GXMath.gxPoint; VAR caretOffset: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewGroupViewDevices*(source: GXTypes.gxViewGroup; list: GXTypes.gxViewDevice): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewGroupViewPorts*(source: GXTypes.gxViewGroup; list: GXTypes.gxViewPort): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewPortGlobalMapping*(source: GXTypes.gxViewPort; VAR map: GXMath.gxMapping)(*: GXMath.gxMapping*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetViewPortViewDevices*(source: GXTypes.gxViewPort; list: GXTypes.gxViewDevice): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXHitTestPicture*(target: GXTypes.gxShape; (*CONST*)VAR test: GXMath.gxPoint; VAR result: GXTypes.gxHitTestInfo; level: LONGINT; depth: LONGINT): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXIntersectRectangle*(VAR target: GXTypes.gxRectangle; (*CONST*)VAR source: GXTypes.gxRectangle; (*CONST*)VAR operand: GXTypes.gxRectangle): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnionRectangle*(VAR target: GXTypes.gxRectangle; (*CONST*)VAR source: GXTypes.gxRectangle; (*CONST*)VAR operand: GXTypes.gxRectangle)(*: GXTypes.gxRectangle*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXTouchesRectanglePoint*((*CONST*)VAR target: GXTypes.gxRectangle; (*CONST*)VAR test: GXMath.gxPoint): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXTouchesShape*(target: GXTypes.gxShape; test: GXTypes.gxShape): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXTouchesBoundsShape*((*CONST*)VAR target: GXTypes.gxRectangle; test: GXTypes.gxShape): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXContainsRectangle*((*CONST*)VAR container: GXTypes.gxRectangle; (*CONST*)VAR test: GXTypes.gxRectangle): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXContainsShape*(container: GXTypes.gxShape; test: GXTypes.gxShape): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXContainsBoundsShape*((*CONST*)VAR container: GXTypes.gxRectangle; test: GXTypes.gxShape; index: LONGINT): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXConvertColor*(VAR target: GXTypes.gxColor; space: GXTypes.gxColorSpace; aSet: GXTypes.gxColorSet; profile: GXTypes.gxColorProfile)(*: GXTypes.gxColor*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCombineColor*(VAR target: GXTypes.gxColor; operand: GXTypes.gxInk)(*: GXTypes.gxColor*);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCheckColor*((*CONST*)VAR source: GXTypes.gxColor; space: GXTypes.gxColorSpace; aSet: GXTypes.gxColorSet; profile: GXTypes.gxColorProfile): BOOLEAN;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXCheckBitmapColor*(source: GXTypes.gxShape; (*CONST*)VAR area: GXTypes.gxLongRectangle; space: GXTypes.gxColorSpace; aSet: GXTypes.gxColorSet; profile: GXTypes.gxColorProfile): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetHalftoneDeviceAngle*(source: GXTypes.gxViewDevice; (*CONST*)VAR data: GXTypes.gxHalftone): Types.Fixed;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetColorSetParts*(source: GXTypes.gxColorSet; index: LONGINT; count: LONGINT; VAR space: GXTypes.gxColorSpace; data: GXTypes.gxSetColor): LONGINT;  (*C;*)
	EXTERNAL (*C*);
(* returns the glyph count *)
PROCEDURE GXGetGlyphParts*(source: GXTypes.gxShape; index: LONGINT; charCount: LONGINT; VAR byteLength: LONGINT; text: Types.ByteParameter; positions: GXMath.gxPoint; advanceBits: LONGINT; tangents: GXMath.gxPoint; VAR runCount: LONGINT; styleRuns: INTEGER; styles: GXTypes.gxStyle): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetPathParts*(source: GXTypes.gxShape; index: LONGINT; count: LONGINT; VAR data: GXTypes.gxPaths): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetPictureParts*(source: GXTypes.gxShape; index: LONGINT; count: LONGINT; shapes: GXTypes.gxShape; styles: GXTypes.gxStyle; inks: GXTypes.gxInk; transforms: GXTypes.gxTransform): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetPolygonParts*(source: GXTypes.gxShape; index: LONGINT; count: LONGINT; VAR data: GXTypes.gxPolygons): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeParts*(source: GXTypes.gxShape; index: LONGINT; count: LONGINT; destination: GXTypes.gxShape): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetTextParts*(source: GXTypes.gxShape; index: LONGINT; charCount: LONGINT; text: Types.ByteParameter): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetColorSetParts*(target: GXTypes.gxColorSet; index: LONGINT; oldCount: LONGINT; newCount: LONGINT; data: GXTypes.gxSetColor);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetGlyphParts*(source: GXTypes.gxShape; index: LONGINT; oldCharCount: LONGINT; newCharCount: LONGINT; text: Types.ByteParameter; positions: GXMath.gxPoint; advanceBits: LONGINT; tangents: GXMath.gxPoint; styleRuns: INTEGER; styles: GXTypes.gxStyle);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetPathParts*(target: GXTypes.gxShape; index: LONGINT; count: LONGINT; (*CONST*)VAR data: GXTypes.gxPaths; flags: GXTypes.gxEditShapeFlag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetPictureParts*(target: GXTypes.gxShape; index: LONGINT; oldCount: LONGINT; newCount: LONGINT; shapes: GXTypes.gxShape; styles: GXTypes.gxStyle; inks: GXTypes.gxInk; transforms: GXTypes.gxTransform);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetPolygonParts*(target: GXTypes.gxShape; index: LONGINT; count: LONGINT; (*CONST*)VAR data: GXTypes.gxPolygons; flags: GXTypes.gxEditShapeFlag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeParts*(target: GXTypes.gxShape; index: LONGINT; count: LONGINT; insert: GXTypes.gxShape; flags: GXTypes.gxEditShapeFlag);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetTextParts*(target: GXTypes.gxShape; index: LONGINT; oldCharCount: LONGINT; newCharCount: LONGINT; text: Types.ByteParameter);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapePoints*(source: GXTypes.gxShape; index: LONGINT; count: LONGINT; data: GXMath.gxPoint): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapePoints*(target: GXTypes.gxShape; index: LONGINT; count: LONGINT; data: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetGlyphPositions*(source: GXTypes.gxShape; index: LONGINT; charCount: LONGINT; advance: LONGINT; positions: GXMath.gxPoint): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetGlyphTangents*(source: GXTypes.gxShape; index: LONGINT; charCount: LONGINT; tangents: GXMath.gxPoint): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetGlyphPositions*(target: GXTypes.gxShape; index: LONGINT; charCount: LONGINT; advance: LONGINT; positions: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetGlyphTangents*(target: GXTypes.gxShape; index: LONGINT; charCount: LONGINT; tangents: GXMath.gxPoint);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetGlyphMetrics*(source: GXTypes.gxShape; glyphOrigins: GXMath.gxPoint; boundingBoxes: GXTypes.gxRectangle; sideBearings: GXMath.gxPoint): LONGINT;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDifferenceShape*(target: GXTypes.gxShape; operand: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXExcludeShape*(target: GXTypes.gxShape; operand: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXIntersectShape*(target: GXTypes.gxShape; operand: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXMapShape*(target: GXTypes.gxShape; (*CONST*)VAR map: GXMath.gxMapping);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXMoveShape*(target: GXTypes.gxShape; deltaX: Types.Fixed; deltaY: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXMoveShapeTo*(target: GXTypes.gxShape; x: Types.Fixed; y: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXReverseDifferenceShape*(target: GXTypes.gxShape; operand: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXRotateShape*(target: GXTypes.gxShape; degrees: Types.Fixed; xOffset: Types.Fixed; yOffset: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXScaleShape*(target: GXTypes.gxShape; hScale: Types.Fixed; vScale: Types.Fixed; xOffset: Types.Fixed; yOffset: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSkewShape*(target: GXTypes.gxShape; xSkew: Types.Fixed; ySkew: Types.Fixed; xOffset: Types.Fixed; yOffset: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnionShape*(target: GXTypes.gxShape; operand: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDifferenceTransform*(target: GXTypes.gxTransform; operand: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXExcludeTransform*(target: GXTypes.gxTransform; operand: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXIntersectTransform*(target: GXTypes.gxTransform; operand: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXMapTransform*(target: GXTypes.gxTransform; (*CONST*)VAR map: GXMath.gxMapping);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXMoveTransform*(target: GXTypes.gxTransform; deltaX: Types.Fixed; deltaY: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXMoveTransformTo*(target: GXTypes.gxTransform; x: Types.Fixed; y: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXReverseDifferenceTransform*(target: GXTypes.gxTransform; operand: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXRotateTransform*(target: GXTypes.gxTransform; degrees: Types.Fixed; xOffset: Types.Fixed; yOffset: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXScaleTransform*(target: GXTypes.gxTransform; hScale: Types.Fixed; vScale: Types.Fixed; xOffset: Types.Fixed; yOffset: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSkewTransform*(target: GXTypes.gxTransform; xSkew: Types.Fixed; ySkew: Types.Fixed; xOffset: Types.Fixed; yOffset: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnionTransform*(target: GXTypes.gxTransform; operand: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXBreakShape*(target: GXTypes.gxShape; index: LONGINT);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXChangedShape*(target: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXHitTestShape*(target: GXTypes.gxShape; (*CONST*)VAR test: GXMath.gxPoint; VAR result: GXTypes.gxHitTestInfo): GXTypes.gxShapePart;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXHitTestDevice*(target: GXTypes.gxShape; port: GXTypes.gxViewPort; device: GXTypes.gxViewDevice; (*CONST*)VAR test: GXMath.gxPoint; (*CONST*)VAR tolerance: GXMath.gxPoint): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXInsetShape*(target: GXTypes.gxShape; inset: Types.Fixed);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXInvertShape*(target: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXPrimitiveShape*(target: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXReduceShape*(target: GXTypes.gxShape; contour: LONGINT);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXReverseShape*(target: GXTypes.gxShape; contour: LONGINT);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSimplifyShape*(target: GXTypes.gxShape);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXLockColorProfile*(source: GXTypes.gxColorProfile);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnlockColorProfile*(source: GXTypes.gxColorProfile);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetColorProfileStructure*(source: GXTypes.gxColorProfile; VAR length: LONGINT): Types.Ptr;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXFlattenShape*(source: GXTypes.gxShape; flags: GXTypes.gxFlattenFlag; VAR block: GXTypes.gxSpoolBlock);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXUnflattenShape*(VAR block: GXTypes.gxSpoolBlock; count: LONGINT; portList: GXTypes.gxViewPort): GXTypes.gxShape;  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXPostGraphicsNotice*(notice: GXErrors.gxGraphicsNotice);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXIgnoreGraphicsNotice*(notice: GXErrors.gxGraphicsNotice);  (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXPopGraphicsNotice*;  (*C;*)
	EXTERNAL (*C*);

(* $ALIGN RESET*)
(* $POP*)

 END GXGraphics.
