(*
 	File:		GXLayout.mod
 
 	Contains:	QuickDraw GX layout routine interfaces.
 
 	Version:	Technology:	Quickdraw GX 1.1
 				Package:	Universal Interfaces 2.11 in MPW Prerelease on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE GXLayout;

IMPORT SYSTEM, Types, GXTypes, GXMath;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)
(*$SET layoutRoutinesIncludes TRUE*)

PROCEDURE GXNewLayout*(textRunCount: LONGINT; textRunLengths: INTEGER; text: (*UNIV*) Types.Ptr; styleRunCount: LONGINT; styleRunLengths: INTEGER; styles: GXTypes.gxStyle; levelRunCount: LONGINT; levelRunLengths: INTEGER; levels: INTEGER; (*CONST*)VAR layoutOptions: GXTypes.gxLayoutOptions; (*CONST*)VAR position: GXMath.gxPoint): GXTypes.gxShape; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLayout*(layout: GXTypes.gxShape; text: (*UNIV*) Types.Ptr; VAR styleRunCount: LONGINT; styleRunLengths: INTEGER; styles: GXTypes.gxStyle; VAR levelRunCount: LONGINT; levelRunLengths: INTEGER; levels: INTEGER; VAR layoutOptions: GXTypes.gxLayoutOptions; VAR position: GXMath.gxPoint): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetLayout*(layout: GXTypes.gxShape; textRunCount: LONGINT; textRunLengths: INTEGER; text: (*UNIV*) Types.Ptr; styleRunCount: LONGINT; styleRunLengths: INTEGER; styles: GXTypes.gxStyle; levelRunCount: LONGINT; levelRunLengths: INTEGER; levels: INTEGER; (*CONST*)VAR layoutOptions: GXTypes.gxLayoutOptions; (*CONST*)VAR position: GXMath.gxPoint); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXDrawLayout*(textRunCount: LONGINT; textRunLengths: INTEGER; text: (*UNIV*) Types.Ptr; styleRunCount: LONGINT; styleRunLengths: INTEGER; styles: GXTypes.gxStyle; levelRunCount: LONGINT; levelRunLengths: INTEGER; levels: INTEGER; (*CONST*)VAR layoutOptions: GXTypes.gxLayoutOptions; (*CONST*)VAR position: GXMath.gxPoint); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetLayoutParts*(layout: GXTypes.gxShape; oldStartOffset: GXTypes.gxByteOffset; oldEndOffset: GXTypes.gxByteOffset; newTextRunCount: LONGINT; newTextRunLengths: INTEGER; newText: (*UNIV*) Types.Ptr; newStyleRunCount: LONGINT; newStyleRunLengths: INTEGER; newStyles: GXTypes.gxStyle; newLevelRunCount: LONGINT; newLevelRunLengths: INTEGER; newLevels: INTEGER); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetLayoutShapeParts*(layout: GXTypes.gxShape; startOffset: GXTypes.gxByteOffset; endOffset: GXTypes.gxByteOffset; insert: GXTypes.gxShape); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLayoutParts*(layout: GXTypes.gxShape; startOffset: GXTypes.gxByteOffset; endOffset: GXTypes.gxByteOffset; text: (*UNIV*) Types.Ptr; VAR styleRunCount: LONGINT; styleRunLengths: INTEGER; styles: GXTypes.gxStyle; VAR levelRunCount: LONGINT; levelRunLengths: INTEGER; levels: INTEGER): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLayoutShapeParts*(layout: GXTypes.gxShape; startOffset: GXTypes.gxByteOffset; endOffset: GXTypes.gxByteOffset; dest: GXTypes.gxShape): GXTypes.gxShape; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLayoutGlyphs*(layout: GXTypes.gxShape; VAR glyphs: GXTypes.gxGlyphcode; positions: GXMath.gxPoint; advance: LONGINT; tangents: GXMath.gxPoint; VAR runCount: LONGINT; styleRuns: INTEGER; glyphStyles: GXTypes.gxStyle): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXHitTestLayout*(layout: GXTypes.gxShape; (*CONST*)VAR hitDown: GXMath.gxPoint; highlightType: GXTypes.gxHighlightType; VAR hitInfo: GXTypes.gxLayoutHitInfo; hitTrackingArea: GXTypes.gxShape): GXTypes.gxByteOffset; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLayoutHighlight*(layout: GXTypes.gxShape; startOffset: GXTypes.gxByteOffset; endOffset: GXTypes.gxByteOffset; highlightType: GXTypes.gxHighlightType; highlight: GXTypes.gxShape): GXTypes.gxShape; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLayoutVisualHighlight*(layout: GXTypes.gxShape; startOffset: GXTypes.gxByteOffset; startLeadingEdge: LONGINT; endOffset: GXTypes.gxByteOffset; endLeadingEdge: LONGINT; highlightType: GXTypes.gxHighlightType; highlight: GXTypes.gxShape): GXTypes.gxShape; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLayoutCaret*(layout: GXTypes.gxShape; offset: GXTypes.gxByteOffset; highlightType: GXTypes.gxHighlightType; caretType: GXTypes.gxCaretType; caret: GXTypes.gxShape): GXTypes.gxShape; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLayoutBreakOffset*(layout: GXTypes.gxShape; startOffset: GXTypes.gxByteOffset; lineWidth: Types.Fixed; hyphenationCount: LONGINT; hyphenationPoints: GXTypes.gxByteOffset; VAR startIsStaked: BOOLEAN; VAR priorStake: GXTypes.gxByteOffset; VAR nextStake: GXTypes.gxByteOffset): GXTypes.gxByteOffset; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLayoutRangeWidth*(layout: GXTypes.gxShape; startOffset: GXTypes.gxByteOffset; endOffset: GXTypes.gxByteOffset; supplementaryText: GXTypes.gxShape): Types.Fixed; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXNewLayoutFromRange*(layout: GXTypes.gxShape; startOffset: GXTypes.gxByteOffset; endOffset: GXTypes.gxByteOffset; (*CONST*)VAR layoutOptions: GXTypes.gxLayoutOptions; supplementaryText: GXTypes.gxShape): GXTypes.gxShape; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetCaretAngleArea*(layout: GXTypes.gxShape; (*CONST*)VAR hitPoint: GXMath.gxPoint; highlightType: GXTypes.gxHighlightType; caretArea: GXTypes.gxShape; VAR returnedRise: INTEGER; VAR returnedRun: INTEGER): GXTypes.gxShape; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleBaselineDeltas*(baseStyle: GXTypes.gxStyle; baseType: GXTypes.gxBaselineType; VAR returnedDeltas: GXTypes.gxBaselineDeltas); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetRightVisualOffset*(layout: GXTypes.gxShape; currentOffset: GXTypes.gxByteOffset): GXTypes.gxByteOffset; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLeftVisualOffset*(layout: GXTypes.gxShape; currentOffset: GXTypes.gxByteOffset): GXTypes.gxByteOffset; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetCompoundCharacterLimits*(layout: GXTypes.gxShape; trial: GXTypes.gxByteOffset; VAR minOffset: GXTypes.gxByteOffset; VAR maxOffset: GXTypes.gxByteOffset; VAR onBoundary: BOOLEAN); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetOffsetGlyphs*(layout: GXTypes.gxShape; trial: GXTypes.gxByteOffset; leadingEdge: LONGINT; VAR offsetState: GXTypes.gxLayoutOffsetState; VAR firstGlyph: INTEGER; VAR secondGlyph: INTEGER); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetGlyphOffset*(layout: GXTypes.gxShape; trial: LONGINT; onLeftTop: LONGINT; VAR offset: GXTypes.gxByteOffset; VAR leadingEdge: BOOLEAN; VAR wasRealCharacter: BOOLEAN); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLayoutSpan*(layout: GXTypes.gxShape; VAR lineAscent: Types.Fixed; VAR lineDescent: Types.Fixed); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetLayoutSpan*(layout: GXTypes.gxShape; lineAscent: Types.Fixed; lineDescent: Types.Fixed); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetLayoutJustificationGap*(layout: GXTypes.gxShape): Types.Fixed; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleRunControls*(target: GXTypes.gxStyle; (*CONST*)VAR runControls: GXTypes.gxRunControls); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleRunPriorityJustOverride*(target: GXTypes.gxStyle; (*CONST*)VAR priorityJustificationOverride: GXTypes.gxPriorityJustificationOverride); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleRunGlyphJustOverrides*(target: GXTypes.gxStyle; count: LONGINT; glyphJustificationOverrides: GXTypes.gxGlyphJustificationOverride); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleRunGlyphSubstitutions*(target: GXTypes.gxStyle; count: LONGINT; glyphSubstitutions: GXTypes.gxGlyphSubstitution); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleRunFeatures*(target: GXTypes.gxStyle; count: LONGINT; runFeatures: GXTypes.gxRunFeature); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetStyleRunKerningAdjustments*(target: GXTypes.gxStyle; count: LONGINT; kerningAdjustments: GXTypes.gxKerningAdjustment); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeRunControls*(target: GXTypes.gxShape; (*CONST*)VAR runControls: GXTypes.gxRunControls); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeRunPriorityJustOverride*(target: GXTypes.gxShape; (*CONST*)VAR priorityJustificationOverride: GXTypes.gxPriorityJustificationOverride); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeRunGlyphJustOverrides*(target: GXTypes.gxShape; count: LONGINT; glyphJustificationOverrides: GXTypes.gxGlyphJustificationOverride); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeRunGlyphSubstitutions*(target: GXTypes.gxShape; count: LONGINT; glyphSubstitutions: GXTypes.gxGlyphSubstitution); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeRunFeatures*(target: GXTypes.gxShape; count: LONGINT; runFeatures: GXTypes.gxRunFeature); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXSetShapeRunKerningAdjustments*(target: GXTypes.gxShape; count: LONGINT; kerningAdjustments: GXTypes.gxKerningAdjustment); (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleRunControls*(source: GXTypes.gxStyle; VAR runControls: GXTypes.gxRunControls): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleRunPriorityJustOverride*(source: GXTypes.gxStyle; VAR priorityJustificationOverride: GXTypes.gxPriorityJustificationOverride): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleRunGlyphJustOverrides*(source: GXTypes.gxStyle; glyphJustificationOverrides: GXTypes.gxGlyphJustificationOverride): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleRunGlyphSubstitutions*(source: GXTypes.gxStyle; glyphSubstitutions: GXTypes.gxGlyphSubstitution): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleRunFeatures*(source: GXTypes.gxStyle; runFeatures: GXTypes.gxRunFeature): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetStyleRunKerningAdjustments*(source: GXTypes.gxStyle; kerningAdjustments: GXTypes.gxKerningAdjustment): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeRunControls*(source: GXTypes.gxShape; VAR runControls: GXTypes.gxRunControls): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeRunPriorityJustOverride*(source: GXTypes.gxShape; VAR priorityJustificationOverride: GXTypes.gxPriorityJustificationOverride): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeRunGlyphJustOverrides*(source: GXTypes.gxShape; glyphJustificationOverrides: GXTypes.gxGlyphJustificationOverride): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeRunGlyphSubstitutions*(source: GXTypes.gxShape; glyphSubstitutions: GXTypes.gxGlyphSubstitution): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeRunFeatures*(source: GXTypes.gxShape; runFeatures: GXTypes.gxRunFeature): LONGINT; (*C;*)
	EXTERNAL (*C*);
PROCEDURE GXGetShapeRunKerningAdjustments*(source: GXTypes.gxShape; kerningAdjustments: GXTypes.gxKerningAdjustment): LONGINT; (*C;*)
	EXTERNAL (*C*);

(* $ALIGN RESET*)
(* $POP*)

 END GXLayout.
