(*
 	File:		GestaltEqu.mod
 
 	Contains:	Gestalt Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
				(H.T.)
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$IF UNDEFINED SystemSevenFiveOrLater *)
  (*$SET SystemSevenFiveOrLater FALSE*)
(*$END*)
(*$IF UNDEFINED SystemSevenOrLater *)
  (*$IF GENERATINGCFM *)
    (*$SET SystemSevenOrLater TRUE*)
  (*$ELSE*)
    (*$SET SystemSevenOrLater SystemSevenFiveOrLater*)
  (*$END*)
(*$END*)
(*$IF UNDEFINED SystemSixOrLater *)
  (*$SET SystemSixOrLater SystemSevenOrLater*)
(*$END*)
(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE GestaltEqu;

IMPORT SYSTEM, Types;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	gestaltAddressingModeAttr*	= LONG("addr");						(* addressing mode attributes *)
	gestalt32BitAddressing*		= 0;							(* using 32-bit addressing mode *)
	gestalt32BitSysZone*			= 1;							(* 32-bit compatible system zone *)
	gestalt32BitCapable*			= 2;							(* Machine is 32-bit capable *)

	gestaltAliasMgrAttr*			= LONG("alis");						(* Alias Mgr Attributes *)
	gestaltAliasMgrPresent*		= 0;							(* True if the Alias Mgr is present *)
	gestaltAliasMgrSupportsRemoteAppletalk* = 1;					(* True if the Alias Mgr knows about Remote Appletalk *)

	gestaltAppleTalkVersion*		= LONG("atlk");

	gestaltAUXVersion*			= LONG("a/ux");

	gestaltCloseViewAttr*		= LONG("BSDa");						(* CloseView attributes *)
	gestaltCloseViewEnabled*		= 0;							(* Closeview enabled (dynamic bit - returns current state) *)
	gestaltCloseViewDisplayMgrFriendly* = 1;						(* Closeview compatible with Display Manager (FUTURE) *)

	gestaltCFMAttr*				= LONG("cfrg");						(* returns information about the Code Fragment Manager *)
	gestaltCFMPresent*			= 0;							(* true if the Code Fragment Manager is present *)

	gestaltColorMatchingAttr*	= LONG("cmta");						(* ColorSync attributes *)
	gestaltHighLevelMatching*	= 0;
	gestaltColorMatchingLibLoaded* = 1;

	gestaltColorMatchingVersion*	= LONG("cmtc");
	gestaltColorSync10*			= $0100;						(* 0x0100 & 0x0110 _Gestalt versions for 1.0-1.0.3 product *)
	gestaltColorSync11*			= $0110;						(*   0x0100 == low-level matching only *)
	gestaltColorSync104*			= $0104;						(* Real version, by popular demand *)
	gestaltColorSync105*			= $0105;

	gestaltConnMgrAttr*			= LONG("conn");						(* connection mgr attributes    *)
	gestaltConnMgrPresent*		= 0;
	gestaltConnMgrCMSearchFix*	= 1;							(* Fix to CMAddSearch?     *)
	gestaltConnMgrErrorString*	= 2;							(* has CMGetErrorString() *)
	gestaltConnMgrMultiAsyncIO*	= 3;							(* CMNewIOPB, CMDisposeIOPB, CMPBRead, CMPBWrite, CMPBIOKill *)

	gestaltComponentMgr*			= LONG("cpnt");

	gestaltColorPickerVersion*	= LONG("cpkr");						(* returns version of ColorPicker *)
	gestaltColorPicker*			= LONG("cpkr");

	gestaltNativeCPUtype*		= LONG("cput");						(* Native CPU type 									  *)
	gestaltCPU68000*				= 1;							(* Various 68k CPUs... 	*)
	gestaltCPU68010*				= 2;
	gestaltCPU68020*				= 3;
	gestaltCPU68030*				= 4;
	gestaltCPU68040*				= 5;
	gestaltCPU601*				= $101;							(* IBM 601 												*)
	gestaltCPU603*				= $103;
	gestaltCPU604*				= $104;

	gestaltCRMAttr*				= LONG("crm ");						(* comm resource mgr attributes *)
	gestaltCRMPresent*			= 0;
	gestaltCRMPersistentFix*		= 1;							(* fix for persistent tools *)
	gestaltCRMToolRsrcCalls*		= 2;							(* has CRMGetToolResource/ReleaseToolResource *)

	gestaltControlStripVersion*	= LONG("csvr");

	gestaltCTBVersion*			= LONG("ctbv");

	gestaltDBAccessMgrAttr*		= LONG("dbac");						(* Database Access Mgr attributes *)
	gestaltDBAccessMgrPresent*	= 0;							(* True if Database Access Mgr present *)

	gestaltDictionaryMgrAttr*	= LONG("dict");						(* Dictionary Manager attributes *)
	gestaltDictionaryMgrPresent*	= 0;							(* Dictionary Manager attributes *)

	gestaltDITLExtAttr*			= LONG("ditl");						(* AppenDITL, etc. calls from CTB *)
	gestaltDITLExtPresent*		= 0;							(* True if calls are present *)

	gestaltDisplayMgrAttr*		= LONG("dply");						(* Display Manager attributes *)
	gestaltDisplayMgrPresent*	= 0;							(* True if Display Mgr is present *)
	gestaltDisplayMgrCanSwitchMirrored* = 2;						(* True if Display Mgr can switch modes on mirrored displays *)
	gestaltDisplayMgrSetDepthNotifies* = 3;						(* True SetDepth generates displays mgr notification *)

	gestaltDisplayMgrVers*		= LONG("dplv");

	gestaltDragMgrAttr*			= LONG("drag");						(* Drag Manager attributes *)
	gestaltDragMgrPresent*		= 0;							(* Drag Manager is present *)
	gestaltDragMgrFloatingWind*	= 1;							(* Drag Manager supports floating windows *)
	gestaltPPCDragLibPresent*	= 2;							(* Drag Manager PPC DragLib is present *)

	gestaltEasyAccessAttr*		= LONG("easy");						(* Easy Access attributes *)
	gestaltEasyAccessOff*		= 0;							(* if Easy Access present, but off (no icon) *)
	gestaltEasyAccessOn*			= 1;							(* if Easy Access "On" *)
	gestaltEasyAccessSticky*		= 2;							(* if Easy Access "Sticky" *)
	gestaltEasyAccessLocked*		= 3;							(* if Easy Access "Locked" *)

	gestaltEditionMgrAttr*		= LONG("edtn");						(* Edition Mgr attributes *)
	gestaltEditionMgrPresent*	= 0;							(* True if Edition Mgr present *)
	gestaltEditionMgrTranslationAware* = 1;						(* True if edition manager is translation manager aware *)

	gestaltAppleEventsAttr*		= LONG("evnt");						(* Apple Events attributes *)
	gestaltAppleEventsPresent*	= 0;							(* True if Apple Events present *)
	gestaltScriptingSupport*		= 1;
	gestaltOSLInSystem*			= 2;							(* OSL is in system so dont use the one linked in to app *)

	gestaltFinderAttr*			= LONG("fndr");						(* Finder attributes *)
	gestaltFinderDropEvent*		= 0;							(* Finder recognizes drop event *)
	gestaltFinderMagicPlacement*	= 1;							(* Finder supports magic icon placement *)
	gestaltFinderCallsAEProcess*	= 2;							(* Finder calls AEProcessAppleEvent *)
	gestaltOSLCompliantFinder*	= 3;							(* Finder is scriptable and recordable *)
	gestaltFinderSupports4GBVolumes* = 4;						(* Finder correctly handles 4GB volumes *)
	gestaltFinderHasClippings*	= 6;							(* Finder supports Drag Manager clipping files *)

	gestaltFindFolderAttr*		= LONG("fold");						(* Folder Mgr attributes *)
	gestaltFindFolderPresent*	= 0;							(* True if Folder Mgr present *)

	gestaltFontMgrAttr*			= LONG("font");						(* Font Mgr attributes *)
	gestaltOutlineFonts*			= 0;							(* True if Outline Fonts supported *)

	gestaltFPUType*				= LONG("fpu ");						(* fpu type *)
	gestaltNoFPU*				= 0;							(* no FPU *)
	gestalt68881*				= 1;							(* 68881 FPU *)
	gestalt68882*				= 2;							(* 68882 FPU *)
	gestalt68040FPU*				= 3;							(* 68040 built-in FPU *)

	gestaltFSAttr*				= LONG("fs  ");						(* file system attributes *)
	gestaltFullExtFSDispatching*	= 0;							(* has really cool new HFSDispatch dispatcher *)
	gestaltHasFSSpecCalls*		= 1;							(* has Files.FSSpec calls *)
	gestaltHasFileSystemManager*	= 2;							(* has a file system manager *)
	gestaltFSMDoesDynamicLoad*	= 3;							(* file system manager supports dynamic loading *)
	gestaltFSSupports4GBVols*	= 4;							(* file system supports 4 gigabyte volumes *)
	gestaltFSSupports2TBVols*	= 5;							(* file system supports 2 terabyte volumes *)
	gestaltHasExtendedDiskInit*	= 6;							(* has extended Disk Initialization calls *)

	gestaltFXfrMgrAttr*			= LONG("fxfr");						(* file transfer manager attributes *)
	gestaltFXfrMgrPresent*		= 0;
	gestaltFXfrMgrMultiFile*		= 1;							(* supports FTSend and FTReceive *)
	gestaltFXfrMgrErrorString*	= 2;							(* supports FTGetErrorString *)

	gestaltGraphicsAttr*			= LONG("gfxa");						(* Quickdraw GX attributes selector *)
	gestaltGraphicsIsDebugging*	= $00000001;
	gestaltGraphicsIsLoaded*		= $00000002;
	gestaltGraphicsIsPowerPC*	= $00000004;

	gestaltGraphicsVersion*		= LONG("grfx");						(* Quickdraw GX version selector *)
	gestaltCurrentGraphicsVersion* = $00010000;					(* the version described in this set of headers *)

	gestaltHardwareAttr*			= LONG("hdwr");						(* hardware attributes *)
	gestaltHasVIA1*				= 0;							(* VIA1 exists *)
	gestaltHasVIA2*				= 1;							(* VIA2 exists *)
	gestaltHasASC*				= 3;							(* Apple Sound Chip exists *)
	gestaltHasSCC*				= 4;							(* SCC exists *)
	gestaltHasSCSI*				= 7;							(* SCSI exists *)
	gestaltHasSoftPowerOff*		= 19;							(* Capable of software power off *)
	gestaltHasSCSI961*			= 21;							(* 53C96 SCSI controller on internal bus *)
	gestaltHasSCSI962*			= 22;							(* 53C96 SCSI controller on external bus *)
	gestaltHasUniversalROM*		= 24;							(* Do we have a Universal ROM? *)
	gestaltHasEnhancedLtalk*		= 30;							(* Do we have Enhanced LocalTalk? *)

	gestaltHelpMgrAttr*			= LONG("help");						(* Help Mgr Attributes *)
	gestaltHelpMgrPresent*		= 0;							(* true if help mgr is present *)
	gestaltHelpMgrExtensions*	= 1;							(* true if help mgr extensions are installed *)

	gestaltCompressionMgr*		= LONG("icmp");

	gestaltIconUtilitiesAttr*	= LONG("icon");						(* Icon Utilities attributes  (Note: available in System 7.0, despite gestalt) *)
	gestaltIconUtilitiesPresent*	= 0;							(* true if icon utilities are present *)

	gestaltKeyboardType*			= LONG("kbd ");						(* keyboard type *)
	gestaltMacKbd*				= 1;
	gestaltMacAndPad*			= 2;
	gestaltMacPlusKbd*			= 3;
	gestaltExtADBKbd*			= 4;
	gestaltStdADBKbd*			= 5;
	gestaltPrtblADBKbd*			= 6;
	gestaltPrtblISOKbd*			= 7;
	gestaltStdISOADBKbd*			= 8;
	gestaltExtISOADBKbd*			= 9;
	gestaltADBKbdII*				= 10;
	gestaltADBISOKbdII*			= 11;
	gestaltPwrBookADBKbd*		= 12;
	gestaltPwrBookISOADBKbd*		= 13;
	gestaltAppleAdjustKeypad*	= 14;
	gestaltAppleAdjustADBKbd*	= 15;
	gestaltAppleAdjustISOKbd*	= 16;
	gestaltJapanAdjustADBKbd*	= 17;							(* Japan Adjustable Keyboard *)
	gestaltPwrBkExtISOKbd*		= 20;							(* PowerBook Extended International Keyboard with function keys *)
	gestaltPwrBkExtJISKbd*		= 21;							(* PowerBook Extended Japanese Keyboard with function keys 		*)
	gestaltPwrBkExtADBKbd*		= 24;							(* PowerBook Extended Domestic Keyboard with function keys 		*)

	gestaltLowMemorySize*		= LONG("lmem");

	gestaltLogicalRAMSize*		= LONG("lram");

	gestaltMachineType*			= LONG("mach");						(* machine type *)
	gestaltClassic*				= 1;
	gestaltMacXL*				= 2;
	gestaltMac512KE*				= 3;
	gestaltMacPlus*				= 4;
	gestaltMacSE*				= 5;
	gestaltMacII*				= 6;
	gestaltMacIIx*				= 7;
	gestaltMacIIcx*				= 8;
	gestaltMacSE030*				= 9;
	gestaltPortable*				= 10;
	gestaltMacIIci*				= 11;
	gestaltMacIIfx*				= 13;
	gestaltMacClassic*			= 17;
	gestaltMacIIsi*				= 18;
	gestaltMacLC*				= 19;
	gestaltQuadra900*			= 20;
	gestaltPowerBook170*			= 21;
	gestaltQuadra700*			= 22;
	gestaltClassicII*			= 23;
	gestaltPowerBook100*			= 24;
	gestaltPowerBook140*			= 25;
	gestaltQuadra950*			= 26;
	gestaltMacLCIII*				= 27;
	gestaltPerforma450*			= gestaltMacLCIII;
	gestaltPowerBookDuo210*		= 29;
	gestaltMacCentris650*		= 30;
	gestaltPowerBookDuo230*		= 32;
	gestaltPowerBook180*			= 33;
	gestaltPowerBook160*			= 34;
	gestaltMacQuadra800*			= 35;
	gestaltMacQuadra650*			= 36;
	gestaltMacLCII*				= 37;
	gestaltPowerBookDuo250*		= 38;
	gestaltAWS9150_80*			= 39;
	gestaltPowerMac8100_110*		= 40;
	gestaltAWS8150_110*			= gestaltPowerMac8100_110;
	gestaltMacIIvi*				= 44;
	gestaltMacIIvm*				= 45;
	gestaltPerforma600*			= gestaltMacIIvm;
	gestaltPowerMac7100_80*		= 47;
	gestaltMacIIvx*				= 48;
	gestaltMacColorClassic*		= 49;
	gestaltPerforma250*			= gestaltMacColorClassic;
	gestaltPowerBook165c*		= 50;
	gestaltMacCentris610*		= 52;
	gestaltMacQuadra610*			= 53;
	gestaltPowerBook145*			= 54;
	gestaltPowerMac8100_100*		= 55;
	gestaltMacLC520*				= 56;
	gestaltAWS9150_120*			= 57;
	gestaltMacCentris660AV*		= 60;
	gestaltPerforma46x*			= 62;
	gestaltPowerMac8100_80*		= 65;
	gestaltAWS8150_80*			= gestaltPowerMac8100_80;
	gestaltPowerBook180c*		= 71;
	gestaltPowerMac6100_60*		= 75;
	gestaltAWS6150_60*			= gestaltPowerMac6100_60;
	gestaltPowerBookDuo270c*		= 77;
	gestaltMacQuadra840AV*		= 78;
	gestaltPerforma550*			= 80;
	gestaltPowerBook165*			= 84;
	gestaltMacTV*				= 88;
	gestaltMacLC475*				= 89;
	gestaltPerforma47x*			= gestaltMacLC475;
	gestaltMacLC575*				= 92;
	gestaltMacQuadra605*			= 94;
	gestaltQuadra630*			= 98;
	gestaltPowerMac6100_66*		= 100;
	gestaltAWS6150_66*			= gestaltPowerMac6100_66;
	gestaltPowerBookDuo280*		= 102;
	gestaltPowerBookDuo280c*		= 103;
	gestaltPowerMac7100_66*		= 112;							(* Power Macintosh 7100/66 *)
	gestaltPowerBook150*			= 115;

	kMachineNameStrID*			= -16395;

	gestaltMachineIcon*			= LONG("micn");

	gestaltMiscAttr*				= LONG("misc");						(* miscellaneous attributes *)
	gestaltScrollingThrottle*	= 0;							(* true if scrolling throttle on *)
	gestaltSquareMenuBar*		= 2;							(* true if menu bar is square *)

(*
	The name gestaltMixedModeVersion for the LONG("mixd") selector is semantically incorrect.
	The same selector has been renamed gestaltMixedModeAttr to properly reflect the 
	Inside Mac*: PowerPC System Software documentation.  The gestaltMixedModeVersion
	symbol has been preserved only for backwards compatibility.
	
	Developers are forewarned that gestaltMixedModeVersion has a limited lifespan and 
	will be removed in a future release of the Interfaces.

	For the first version of Mixed Mode, both meanings of the LONG("mixd") selector are
	functionally identical.  They both return 0x00000001.  In subsequent versions
	of Mixed Mode, however, the LONG("mixd") selector will not respond with an increasing
	version number, but rather, with 32 attribute bits with various meanings.
*)
	gestaltMixedModeVersion*		= LONG("mixd");

	gestaltMixedModeAttr*		= LONG("mixd");						(* returns Mixed Mode attributes *)
	gestaltPowerPCAware*			= 0;							(* true if Mixed Mode Manager supports PowerPC *)

	gestaltMMUType*				= LONG("mmu ");						(* mmu type *)
	gestaltNoMMU*				= 0;							(* no MMU *)
	gestaltAMU*					= 1;							(* address management unit *)
	gestalt68851*				= 2;							(* 68851 PMMU *)
	gestalt68030MMU*				= 3;							(* 68030 built-in MMU *)
	gestalt68040MMU*				= 4;							(* 68040 built-in MMU *)
	gestaltEMMU1*				= 5;							(* Emulated MMU type 1  *)

	gestaltStdNBPAttr*			= LONG("nlup");						(* standard nbp attributes *)
	gestaltStdNBPPresent*		= 0;

	gestaltNotificationMgrAttr*	= LONG("nmgr");						(* notification manager attributes *)
	gestaltNotificationPresent*	= 0;							(* notification manager exists *)

	gestaltNameRegistryVersion*	= LONG("nreg");

	gestaltNuBusSlotCount*		= LONG("nubs");

	gestaltOpenFirmwareInfo*		= LONG("opfw");

	gestaltOSAttr*				= LONG("os  ");						(* o/s attributes *)
	gestaltSysZoneGrowable*		= 0;							(* system heap is growable *)
	gestaltLaunchCanReturn*		= 1;							(* can return from launch *)
	gestaltLaunchFullFileSpec*	= 2;							(* can launch from full file spec *)
	gestaltLaunchControl*		= 3;							(* launch control support available *)
	gestaltTempMemSupport*		= 4;							(* temp memory support *)
	gestaltRealTempMemory*		= 5;							(* temp memory handles are real *)
	gestaltTempMemTracked*		= 6;							(* temporary memory handles are tracked *)
	gestaltIPCSupport*			= 7;							(* IPC support is present *)
	gestaltSysDebuggerSupport*	= 8;							(* system debugger support is present *)

	gestaltOSTable*				= LONG("ostt");

	gestaltPCXAttr*				= LONG("pcxg");						(* PC Exchange attributes *)
	gestaltPCXHas8and16BitFAT*	= 0;							(* PC Exchange supports both 8 and 16 bit FATs *)
	gestaltPCXHasProDOS*			= 1;							(* PC Exchange supports ProDOS *)

	gestaltLogicalPageSize*		= LONG("pgsz");

	gestaltPopupAttr*			= LONG("pop!");						(* popup cdef attributes *)
	gestaltPopupPresent*			= 0;

	gestaltPowerMgrAttr*			= LONG("powr");						(* power manager attributes *)
	gestaltPMgrExists*			= 0;
	gestaltPMgrCPUIdle*			= 1;
	gestaltPMgrSCC*				= 2;
	gestaltPMgrSound*			= 3;
	gestaltPMgrDispatchExists*	= 4;

(*
 * PPC will return the combination of following bit fields.
 * e.g. gestaltPPCSupportsRealTime +gestaltPPCSupportsIncoming + gestaltPPCSupportsOutGoing
 * indicates PPC is cuurently is only supports real time delivery
 * and both incoming and outgoing network sessions are allowed.
 * By default local real time delivery is supported as long as PPCInit has been called.*)
	gestaltPPCToolboxAttr*		= LONG("ppc ");						(* PPC toolbox attributes *)
	gestaltPPCToolboxPresent*	= $0000;						(* PPC Toolbox is present  Requires PPCInit to be called *)
	gestaltPPCSupportsRealTime*	= $1000;						(* PPC Supports real-time delivery *)
	gestaltPPCSupportsIncoming*	= $0001;						(* PPC will deny incoming network requests *)
	gestaltPPCSupportsOutGoing*	= $0002;						(* PPC will deny outgoing network requests *)

	gestaltProcessorType*		= LONG("proc");						(* processor type *)
	gestalt68000*				= 1;
	gestalt68010*				= 2;
	gestalt68020*				= 3;
	gestalt68030*				= 4;
	gestalt68040*				= 5;

	gestaltParityAttr*			= LONG("prty");						(* parity attributes *)
	gestaltHasParityCapability*	= 0;							(* has ability to check parity *)
	gestaltParityEnabled*		= 1;							(* parity checking enabled *)

	gestaltQuickdrawVersion*		= LONG("qd  ");						(* quickdraw version *)
	gestaltOriginalQD*			= $000;							(* original 1-bit QD *)
	gestalt8BitQD*				= $100;							(* 8-bit color QD *)
	gestalt32BitQD*				= $200;							(* 32-bit color QD *)
	gestalt32BitQD11*			= $201;							(* 32-bit color QDv1.1 *)
	gestalt32BitQD12*			= $220;							(* 32-bit color QDv1.2 *)
	gestalt32BitQD13*			= $230;							(* 32-bit color QDv1.3 *)

	gestaltQuickdrawFeatures*	= LONG("qdrw");						(* quickdraw features *)
	gestaltHasColor*				= 0;							(* color quickdraw present *)
	gestaltHasDeepGWorlds*		= 1;							(* GWorlds can be deeper than 1-bit *)
	gestaltHasDirectPixMaps*		= 2;							(* PixMaps can be direct (16 or 32 bit) *)
	gestaltHasGrayishTextOr*		= 3;							(* supports text mode grayishTextOr *)
	gestaltSupportsMirroring*	= 4;							(* Supports video mirroring via the Display Manager. *)

	gestaltQuickTimeVersion*		= LONG("qtim");						(* returns version of QuickTime *)
	gestaltQuickTime*			= LONG("qtim");

	gestaltQuickTimeFeatures*	= LONG("qtrs");
	gestaltPPCQuickTimeLibPresent* = 0;							(* PowerPC QuickTime glue library is present *)

	gestaltPhysicalRAMSize*		= LONG("ram ");

	gestaltRBVAddr*				= LONG("rbv ");

	gestaltROMSize*				= LONG("rom ");

	gestaltROMVersion*			= LONG("romv");

	gestaltResourceMgrAttr*		= LONG("rsrc");						(* Resource Mgr attributes *)
	gestaltPartialRsrcs*			= 0;							(* True if partial resources exist *)

	gestaltRealtimeMgrAttr*		= LONG("rtmr");						(* Realtime manager attributes			*)
	gestaltRealtimeMgrPresent*	= 0;							(* true if the Realtime manager is present 	*)

	gestaltSCCReadAddr*			= LONG("sccr");

	gestaltSCCWriteAddr*			= LONG("sccw");

	gestaltScrapMgrAttr*			= LONG("scra");						(* Scrap Manager attributes *)
	gestaltScrapMgrTranslationAware* = 0;						(* True if scrap manager is translation aware *)

	gestaltScriptMgrVersion*		= LONG("scri");

	gestaltScriptCount*			= LONG("scr#");

	gestaltSCSI*					= LONG("scsi");						(* SCSI Manager attributes *)
	gestaltAsyncSCSI*			= 0;							(* Supports Asynchronous SCSI *)
	gestaltAsyncSCSIINROM*		= 1;							(* Async scsi is in ROM (available for booting) *)
	gestaltSCSISlotBoot*			= 2;							(* ROM supports Slot-style PRAM for SCSI boots (PDM and later) *)

	gestaltControlStripAttr*		= LONG("sdev");						(* Control Strip attributes *)
	gestaltControlStripExists*	= 0;
	gestaltControlStripVersionFixed* = 1;

	gestaltSerialAttr*			= LONG("ser ");						(* Serial attributes *)
	gestaltHasGPIaToDCDa*		= 0;							(* GPIa connected to DCDa*)
	gestaltHasGPIaToRTxCa*		= 1;							(* GPIa connected to RTxCa clock input*)
	gestaltHasGPIbToDCDb*		= 2;							(* GPIb connected to DCDb *)

	gestaltNuBusConnectors*		= LONG("sltc");

	gestaltSlotAttr*				= LONG("slot");						(* slot attributes  *)
	gestaltSlotMgrExists*		= 0;							(* true is slot mgr exists  *)
	gestaltNuBusPresent*			= 1;							(* NuBus slots are present  *)
	gestaltSESlotPresent*		= 2;							(* SE PDS slot present  *)
	gestaltSE30SlotPresent*		= 3;							(* SE/30 slot present  *)
	gestaltPortableSlotPresent*	= 4;							(* Portables slot present  *)

	gestaltFirstSlotNumber*		= LONG("slt1");

	gestaltSoundAttr*			= LONG("snd ");						(* sound attributes *)
	gestaltStereoCapability*		= 0;							(* sound hardware has stereo capability *)
	gestaltStereoMixing*			= 1;							(* stereo mixing on external speaker *)
	gestaltSoundIOMgrPresent*	= 3;							(* The Sound I/O Manager is present *)
	gestaltBuiltInSoundInput*	= 4;							(* built-in Sound Input hardware is present *)
	gestaltHasSoundInputDevice*	= 5;							(* Sound Input device available *)
	gestaltPlayAndRecord*		= 6;							(* built-in hardware can play and record simultaneously *)
	gestalt16BitSoundIO*			= 7;							(* sound hardware can play and record 16-bit samples *)
	gestaltStereoInput*			= 8;							(* sound hardware can record stereo *)
	gestaltLineLevelInput*		= 9;							(* sound input port requires line level *)
(* the following bits are not defined prior to Sound Mgr 3.0 *)
	gestaltSndPlayDoubleBuffer*	= 10;							(* SndPlayDoubleBuffer available, set by Sound Mgr 3.0 and later *)
	gestaltMultiChannels*		= 11;							(* multiple channel support, set by Sound Mgr 3.0 and later *)
	gestalt16BitAudioSupport*	= 12;							(* 16 bit audio data supported, set by Sound Mgr 3.0 and later *)

	gestaltStandardFileAttr*		= LONG("stdf");						(* Standard File attributes *)
	gestaltStandardFile58*		= 0;							(* True if selectors 5-8 (StandardPutFile-CustomGetFile) are supported *)
	gestaltStandardFileTranslationAware* = 1;					(* True if standard file is translation manager aware *)
	gestaltStandardFileHasColorIcons* = 2;						(* True if standard file has 16x16 color icons *)
	gestaltStandardFileUseGenericIcons* = 3;						(* Standard file LDEF to use only the system generic icons if true *)
	gestaltStandardFileHasDynamicVolumeAllocation* = 4;			(* True if standard file supports more than 20 volumes *)

	gestaltSysArchitecture*		= LONG("sysa");						(* Native System Architecture *)
	gestalt68k*					= 1;							(* Motorola MC68k architecture *)
	gestaltPowerPC*				= 2;							(* IBM PowerPC architecture *)

	gestaltSystemVersion*		= LONG("sysv");

	gestaltTSMgrVersion*			= LONG("tsmv");

	gestaltTSMgrAttr*			= LONG("tsma");						(* Text Services Mgr attributes, if present *)
	gestaltTSMDisplayMgrAwareBit* = 0;							(* TSM knows about display manager *)

	gestaltTextEditVersion*		= LONG("te  ");						(* TextEdit version number *)
	gestaltTE1*					= 1;							(* TextEdit in MacIIci ROM *)
	gestaltTE2*					= 2;							(* TextEdit with 6.0.4 Script Systems on MacIIci (Script bug fixes for MacIIci) *)
	gestaltTE3*					= 3;							(* TextEdit with 6.0.4 Script Systems all but MacIIci *)
	gestaltTE4*					= 4;							(* TextEdit in System 7.0 *)
	gestaltTE5*					= 5;							(* TextWidthHook available in TextEdit *)

	gestaltTEAttr*				= LONG("teat");						(* TextEdit attributes *)
	gestaltTEHasGetHiliteRgn*	= 0;							(* TextEdit has TEGetHiliteRgn *)

	gestaltTeleMgrAttr*			= LONG("tele");						(* Telephone manager attributes *)
	gestaltTeleMgrPresent*		= 0;
	gestaltTeleMgrPowerPCSupport* = 1;
	gestaltTeleMgrSoundStreams*	= 2;
	gestaltTeleMgrAutoAnswer*	= 3;
	gestaltTeleMgrIndHandset*	= 4;
	gestaltTeleMgrSilenceDetect*	= 5;

	gestaltTermMgrAttr*			= LONG("term");						(* terminal mgr attributes *)
	gestaltTermMgrPresent*		= 0;
	gestaltTermMgrErrorString*	= 2;

	gestaltTimeMgrVersion*		= LONG("tmgr");						(* time mgr version *)
	gestaltStandardTimeMgr*		= 1;							(* standard time mgr is present *)
	gestaltRevisedTimeMgr*		= 2;							(* revised time mgr is present *)
	gestaltExtendedTimeMgr*		= 3;							(* extended time mgr is present *)

	gestaltSpeechAttr*			= LONG("ttsc");						(* Speech Manager attributes *)
	gestaltSpeechMgrPresent*		= 0;							(* bit set indicates that Speech Manager exists *)
	gestaltSpeechHasPPCGlue*		= 1;							(* bit set indicates that native PPC glue for Speech Manager API exists *)

	gestaltToolboxTable*			= LONG("tbtt");

	gestaltThreadMgrAttr*		= LONG("thds");						(* Thread Manager attributes *)
	gestaltThreadMgrPresent*		= 0;							(* bit true if Thread Mgr is present *)
	gestaltSpecificMatchSupport*	= 1;							(* bit true if Thread Mgr supports exact match creation option *)
	gestaltThreadsLibraryPresent* = 2;							(* bit true if Thread Mgr shared library is present *)

	gestaltTVAttr*				= LONG("tv  ");						(* TV version										<EX16>	 *)
	gestaltHasTVTuner*			= 0;							(* supports Philips FL1236F video tuner				<EX16>	 *)
	gestaltHasSoundFader*		= 1;							(* supports Philips TEA6330 Sound Fader chip		<EX16>	 *)
	gestaltHasHWClosedCaptioning* = 2;							(* supports Philips SAA5252 Closed Captioning		<EX16>	 *)
	gestaltHasIRRemote*			= 3;							(* supports CyclopsII Infra Red Remote control		<EX16>	 *)
	gestaltHasVidDecoderScaler*	= 4;							(* supports Philips SAA7194 Video Decoder/Scaler	<EX16>	 *)
	gestaltHasStereoDecoder*		= 5;							(* supports Sony SBX1637A-01 stereo decoder			<EX16>	 *)

	gestaltVersion*				= LONG("vers");						(* gestalt version *)
	gestaltValueImplementedVers*	= 5;							(* version of gestalt where gestaltValue is implemented. *)

	gestaltVIA1Addr*				= LONG("via1");

	gestaltVIA2Addr*				= LONG("via2");

	gestaltVMAttr*				= LONG("vm  ");						(* virtual memory attributes *)
	gestaltVMPresent*			= 0;							(* true if virtual memory is present *)

	gestaltTranslationAttr*		= LONG("xlat");						(* Translation Manager attributes *)
	gestaltTranslationMgrExists*	= 0;							(* True if translation manager exists *)
	gestaltTranslationMgrHintOrder* = 1;							(* True if hint order reversal in effect *)
	gestaltTranslationPPCAvail*	= 2;
	gestaltTranslationGetPathAPIAvail* = 3;

	gestaltExtToolboxTable*		= LONG("xttt");

TYPE
	SelectorFunctionProcPtr* = (*Types.ProcPtr;*) PROCEDURE (selector: Types.OSType; VAR response: LONGINT): Types.OSErr;
	SelectorFunctionUPP* = Types.UniversalProcPtr;

CONST
	uppSelectorFunctionProcInfo* = $000003E0; (* PROCEDURE (4 byte param, 4 byte param): 2 byte result; *)

PROCEDURE NewSelectorFunctionProc*(userRoutine: SelectorFunctionProcPtr): SelectorFunctionUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallSelectorFunctionProc*(selector: Types.OSType; VAR response: LONGINT; userRoutine: SelectorFunctionUPP): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)
(*$IF SystemSevenOrLater *)

PROCEDURE Gestalt*(selector: Types.OSType; VAR response: LONGINT): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $225F, $201F, $A1AD, $2288, $3E80;
	(*$END*)
PROCEDURE ReplaceGestalt*(selector: Types.OSType; gestaltFunction: SelectorFunctionUPP; VAR oldGestaltFunction: SelectorFunctionUPP): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $225F, $205F, $201F, $2F09, $A5AD, $225F, $2288, $3E80;
	(*$END*)
PROCEDURE NewGestalt*(selector: Types.OSType; gestaltFunction: SelectorFunctionUPP): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $201F, $A3AD, $3E80;
	(*$END*)
(*$ELSE*)

PROCEDURE Gestalt*(selector: Types.OSType; VAR response: LONGINT): Types.OSErr;
	EXTERNAL PASCAL;
PROCEDURE NewGestalt*(selector: Types.OSType; gestaltFunction: SelectorFunctionUPP): Types.OSErr;
	EXTERNAL PASCAL;
PROCEDURE ReplaceGestalt*(selector: Types.OSType; gestaltFunction: SelectorFunctionUPP; VAR oldGestaltFunction: SelectorFunctionUPP): Types.OSErr;
	EXTERNAL PASCAL;
(*$END*)
(*$IF SystemSevenFiveOrLater *)
(* These functions are built into System 7.5, but not on earlier systems *)
PROCEDURE NewGestaltValue*(selector: Types.OSType; newValue: LONGINT): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0401, $ABF1;
	(*$END*)
PROCEDURE ReplaceGestaltValue*(selector: Types.OSType; replacementValue: LONGINT): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0402, $ABF1;
	(*$END*)
PROCEDURE SetGestaltValue*(selector: Types.OSType; newValue: LONGINT): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0404, $ABF1;
	(*$END*)
PROCEDURE DeleteGestaltValue*(selector: Types.OSType): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0203, $ABF1;
	(*$END*)
(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END GestaltEqu.
