(*
 	File:		Icons.mod
 
 	Contains:	Icon Utilities Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$IF UNDEFINED OLDROUTINELOCATIONS*)
(*$SET OLDROUTINELOCATIONS FALSE*)
(*$END*)
(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE Icons;

IMPORT SYSTEM, Types, Quickdraw;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
(* The following are icons for which there are both icon suites and SICNs. *)
	genericDocumentIconResource*	= -4000;
	genericStationeryIconResource* = -3985;
	genericEditionFileIconResource* = -3989;
	genericApplicationIconResource* = -3996;
	genericDeskAccessoryIconResource* = -3991;
	genericFolderIconResource*	= -3999;
	privateFolderIconResource*	= -3994;
	floppyIconResource*			= -3998;
	trashIconResource*			= -3993;
(* The following are icons for which there are SICNs only. *)
	desktopIconResource*			= -3992;
	openFolderIconResource*		= -3997;
	genericHardDiskIconResource*	= -3995;
	genericFileServerIconResource* = -3972;
	genericSuitcaseIconResource*	= -3970;
	genericMoverObjectIconResource* = -3969;
(* The following are icons for which there are icon suites only. *)
	genericPreferencesIconResource* = -3971;
	genericQueryDocumentIconResource* = -16506;
	genericExtensionIconResource* = -16415;
	systemFolderIconResource*	= -3983;
	appleMenuFolderIconResource*	= -3982;

	startupFolderIconResource*	= -3981;
	ownedFolderIconResource*		= -3980;
	dropFolderIconResource*		= -3979;
	sharedFolderIconResource*	= -3978;
	mountedFolderIconResource*	= -3977;
	controlPanelFolderIconResource* = -3976;
	printMonitorFolderIconResource* = -3975;
	preferencesFolderIconResource* = -3974;
	extensionsFolderIconResource* = -3973;
	fontsFolderIconResource*		= -3968;
	fullTrashIconResource*		= -3984;
	large1BitMask*				= LONG("ICN#");
	large4BitData*				= LONG("icl4");
	large8BitData*				= LONG("icl8");
	small1BitMask*				= LONG("ics#");
	small4BitData*				= LONG("ics4");
	small8BitData*				= LONG("ics8");
	mini1BitMask*				= LONG("icm#");
	mini4BitData*				= LONG("icm4");
	mini8BitData*				= LONG("icm8");

(*  alignment type values  *)
	atNone*						= $0;
	atVerticalCenter*			= $1;
	atTop*						= $2;
	atBottom*					= $3;
	atHorizontalCenter*			= $4;
	atAbsoluteCenter*			= atVerticalCenter + atHorizontalCenter;
	atCenterTop*					= atTop + atHorizontalCenter;
	atCenterBottom*				= atBottom + atHorizontalCenter;
	atLeft*						= $8;
	atCenterLeft*				= atVerticalCenter + atLeft;
	atTopLeft*					= atTop + atLeft;
	atBottomLeft*				= atBottom + atLeft;
	atRight*						= $C;
	atCenterRight*				= atVerticalCenter + atRight;
	atTopRight*					= atTop + atRight;
	atBottomRight*				= atBottom + atRight;

	
TYPE
	IconAlignmentType* = INTEGER;

(*  transform type values  *)

CONST
	ttNone*						= $0;
	ttDisabled*					= $1;
	ttOffline*					= $2;
	ttOpen*						= $3;
	ttLabel1*					= $0100;
	ttLabel2*					= $0200;
	ttLabel3*					= $0300;
	ttLabel4*					= $0400;
	ttLabel5*					= $0500;
	ttLabel6*					= $0600;
	ttLabel7*					= $0700;
	ttSelected*					= $4000;
	ttSelectedDisabled*			= ttSelected + ttDisabled;
	ttSelectedOffline*			= ttSelected + ttOffline;
	ttSelectedOpen*				= ttSelected + ttOpen;

	
TYPE
	IconTransformType* = INTEGER;

(*  Selector mask values  *)

CONST
	svLarge1Bit*					= $00000001;
	svLarge4Bit*					= $00000002;
	svLarge8Bit*					= $00000004;
	svSmall1Bit*					= $00000100;
	svSmall4Bit*					= $00000200;
	svSmall8Bit*					= $00000400;
	svMini1Bit*					= $00010000;
	svMini4Bit*					= $00020000;
	svMini8Bit*					= $00040000;
	svAllLargeData*				= $000000ff;
	svAllSmallData*				= $0000ff00;
	svAllMiniData*				= $00ff0000;
	svAll1BitData*				= svLarge1Bit + svSmall1Bit + svMini1Bit;
	svAll4BitData*				= svLarge4Bit + svSmall4Bit + svMini4Bit;
	svAll8BitData*				= svLarge8Bit + svSmall8Bit + svMini8Bit;
	svAllAvailableData*			= $ffffffff;

	
TYPE
	IconSelectorValue* = LONGINT;

	IconActionProcPtr* = (*Types.ProcPtr;*) PROCEDURE (theType: Types.ResType; VAR theIcon: Types.Handle; yourDataPtr: (*UNIV*) Types.Ptr): Types.OSErr;
	IconActionUPP* = Types.UniversalProcPtr;

CONST
	uppIconActionProcInfo* = $00000FE0; (* PROCEDURE (4 byte param, 4 byte param, 4 byte param): 2 byte result; *)

PROCEDURE NewIconActionProc*(userRoutine: IconActionProcPtr): IconActionUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallIconActionProc*(theType: Types.ResType; VAR theIcon: Types.Handle; yourDataPtr: (*UNIV*) Types.Ptr; userRoutine: IconActionUPP): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)
	
TYPE
	IconAction* = IconActionUPP;

	IconGetterProcPtr* = (*Types.ProcPtr;*) PROCEDURE (theType: Types.ResType; yourDataPtr: (*UNIV*) Types.Ptr): Types.Handle;
	IconGetterUPP* = Types.UniversalProcPtr;

CONST
	uppIconGetterProcInfo* = $000003F0; (* PROCEDURE (4 byte param, 4 byte param): 4 byte result; *)

PROCEDURE NewIconGetterProc*(userRoutine: IconGetterProcPtr): IconGetterUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallIconGetterProc*(theType: Types.ResType; yourDataPtr: (*UNIV*) Types.Ptr; userRoutine: IconGetterUPP): Types.Handle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)
	
TYPE
	IconGetter* = IconGetterUPP;

(*$IF NOT OLDROUTINELOCATIONS *)
	CIcon* = RECORD
		iconPMap*:				Quickdraw.PixMap;									(*the icon's pixMap*)
		iconMask*:				Quickdraw.BitMap;									(*the icon's mask*)
		iconBMap*:				Quickdraw.BitMap;									(*the icon's bitMap*)
		iconData*:				Types.Handle;									(*the icon's data*)
		iconMaskData*:			ARRAY 1 (*[0..0]*) OF INTEGER;				(*icon's mask and BitMap data*)
	END;

	CIconPtr* = POINTER TO CIcon;
	CIconHandle* = HANDLE TO CIcon (*POINTER TO CIconPtr*);


PROCEDURE GetCIcon*(iconID: INTEGER): CIconHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA1E;
	(*$END*)
PROCEDURE PlotCIcon*((*CONST*)VAR theRect: Types.Rect; theIcon: CIconHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA1F;
	(*$END*)
PROCEDURE DisposeCIcon*(theIcon: CIconHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA25;
	(*$END*)
PROCEDURE GetIcon*(iconID: INTEGER): Types.Handle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A9BB;
	(*$END*)
PROCEDURE PlotIcon*((*CONST*)VAR theRect: Types.Rect; theIcon: Types.Handle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A94B;
	(*$END*)
(*$END*)

PROCEDURE PlotIconID*((*CONST*)VAR theRect: Types.Rect; align: IconAlignmentType; transform: IconTransformType; theResID: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0500, $ABC9;
	(*$END*)
PROCEDURE NewIconSuite*(VAR theIconSuite: Types.Handle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0207, $ABC9;
	(*$END*)
PROCEDURE AddIconToSuite*(theIconData: Types.Handle; theSuite: Types.Handle; theType: Types.ResType): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0608, $ABC9;
	(*$END*)
PROCEDURE GetIconFromSuite*(VAR theIconData: Types.Handle; theSuite: Types.Handle; theType: Types.ResType): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0609, $ABC9;
	(*$END*)
PROCEDURE ForEachIconDo*(theSuite: Types.Handle; selector: IconSelectorValue; action: IconActionUPP; yourDataPtr: (*UNIV*) Types.Ptr): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $080A, $ABC9;
	(*$END*)
PROCEDURE GetIconSuite*(VAR theIconSuite: Types.Handle; theResID: INTEGER; selector: IconSelectorValue): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0501, $ABC9;
	(*$END*)
PROCEDURE DisposeIconSuite*(theIconSuite: Types.Handle; disposeData: BOOLEAN): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0302, $ABC9;
	(*$END*)
PROCEDURE PlotIconSuite*((*CONST*)VAR theRect: Types.Rect; align: IconAlignmentType; transform: IconTransformType; theIconSuite: Types.Handle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0603, $ABC9;
	(*$END*)
PROCEDURE MakeIconCache*(VAR theHandle: Types.Handle; makeIcon: IconGetterUPP; yourDataPtr: (*UNIV*) Types.Ptr): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0604, $ABC9;
	(*$END*)
PROCEDURE LoadIconCache*((*CONST*)VAR theRect: Types.Rect; align: IconAlignmentType; transform: IconTransformType; theIconCache: Types.Handle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0606, $ABC9;
	(*$END*)
PROCEDURE PlotIconMethod*((*CONST*)VAR theRect: Types.Rect; align: IconAlignmentType; transform: IconTransformType; theMethod: IconGetterUPP; yourDataPtr: (*UNIV*) Types.Ptr): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0805, $ABC9;
	(*$END*)
PROCEDURE GetLabel*(labelNumber: INTEGER; VAR labelColor: Quickdraw.RGBColor; VAR labelString: Types.Str255): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $050B, $ABC9;
	(*$END*)
PROCEDURE PtInIconID*(testPt: Types.Point; (*CONST*)VAR iconRect: Types.Rect; align: IconAlignmentType; iconID: INTEGER): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $060D, $ABC9;
	(*$END*)
PROCEDURE PtInIconSuite*(testPt: Types.Point; (*CONST*)VAR iconRect: Types.Rect; align: IconAlignmentType; theIconSuite: Types.Handle): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $070E, $ABC9;
	(*$END*)
PROCEDURE PtInIconMethod*(testPt: Types.Point; (*CONST*)VAR iconRect: Types.Rect; align: IconAlignmentType; theMethod: IconGetterUPP; yourDataPtr: (*UNIV*) Types.Ptr): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $090F, $ABC9;
	(*$END*)
PROCEDURE RectInIconID*((*CONST*)VAR testRect: Types.Rect; (*CONST*)VAR iconRect: Types.Rect; align: IconAlignmentType; iconID: INTEGER): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0610, $ABC9;
	(*$END*)
PROCEDURE RectInIconSuite*((*CONST*)VAR testRect: Types.Rect; (*CONST*)VAR iconRect: Types.Rect; align: IconAlignmentType; theIconSuite: Types.Handle): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0711, $ABC9;
	(*$END*)
PROCEDURE RectInIconMethod*((*CONST*)VAR testRect: Types.Rect; (*CONST*)VAR iconRect: Types.Rect; align: IconAlignmentType; theMethod: IconGetterUPP; yourDataPtr: (*UNIV*) Types.Ptr): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0912, $ABC9;
	(*$END*)
PROCEDURE IconIDToRgn*(theRgn: Quickdraw.RgnHandle; (*CONST*)VAR iconRect: Types.Rect; align: IconAlignmentType; iconID: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0613, $ABC9;
	(*$END*)
PROCEDURE IconSuiteToRgn*(theRgn: Quickdraw.RgnHandle; (*CONST*)VAR iconRect: Types.Rect; align: IconAlignmentType; theIconSuite: Types.Handle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0714, $ABC9;
	(*$END*)
PROCEDURE IconMethodToRgn*(theRgn: Quickdraw.RgnHandle; (*CONST*)VAR iconRect: Types.Rect; align: IconAlignmentType; theMethod: IconGetterUPP; yourDataPtr: (*UNIV*) Types.Ptr): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0915, $ABC9;
	(*$END*)
PROCEDURE SetSuiteLabel*(theSuite: Types.Handle; theLabel: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0316, $ABC9;
	(*$END*)
PROCEDURE GetSuiteLabel*(theSuite: Types.Handle): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0217, $ABC9;
	(*$END*)
PROCEDURE GetIconCacheData*(theCache: Types.Handle; theData: (*UNIV*) Types.Ptr): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $0419, $ABC9;
	(*$END*)
PROCEDURE SetIconCacheData*(theCache: Types.Handle; theData: (*UNIV*) Types.Ptr): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $041A, $ABC9;
	(*$END*)
PROCEDURE GetIconCacheProc*(theCache: Types.Handle; VAR theProc: IconGetterUPP): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $041B, $ABC9;
	(*$END*)
PROCEDURE SetIconCacheProc*(theCache: Types.Handle; theProc: IconGetterUPP): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $041C, $ABC9;
	(*$END*)
PROCEDURE PlotIconHandle*((*CONST*)VAR theRect: Types.Rect; align: IconAlignmentType; transform: IconTransformType; theIcon: Types.Handle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $061D, $ABC9;
	(*$END*)
PROCEDURE PlotSICNHandle*((*CONST*)VAR theRect: Types.Rect; align: IconAlignmentType; transform: IconTransformType; theSICN: Types.Handle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $061E, $ABC9;
	(*$END*)
PROCEDURE PlotCIconHandle*((*CONST*)VAR theRect: Types.Rect; align: IconAlignmentType; transform: IconTransformType; theCIcon: CIconHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, $061F, $ABC9;
	(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END Icons.
