(*
 	File:		LowMem.mod
 
 	Contains:	Low Memory Accessor Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$IF UNDEFINED STRICT_WINDOWS*)
  (*$SET STRICT_WINDOWS FALSE*)
(*$END*)
(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE LowMem;

IMPORT SYSTEM, Types, Events, Memory, Menus, Quickdraw, Resources, Windows;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)
PROCEDURE LMGetScrVRes*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0102;			(* MOVE.w $0102,(SP) *)
	(*$END*)

PROCEDURE LMSetScrVRes*(value: Types.SInt16);
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0102;			(* MOVE.w (SP)+,$0102 *)
	(*$END*)

PROCEDURE LMGetScrHRes*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0104;			(* MOVE.w $0104,(SP) *)
	(*$END*)

PROCEDURE LMSetScrHRes*(value: Types.SInt16);
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0104;			(* MOVE.w (SP)+,$0104 *)
	(*$END*)

PROCEDURE LMGetMemTop*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0108;			(* MOVE.l $0108,(SP) *)
	(*$END*)

PROCEDURE LMSetMemTop*(value: Types.Ptr);
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0108;			(* MOVE.l (SP)+,$0108 *)
	(*$END*)

PROCEDURE LMGetBufPtr*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $010C;			(* MOVE.l $010C,(SP) *)
	(*$END*)

PROCEDURE LMSetBufPtr*(value: Types.Ptr);
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $010C;			(* MOVE.l (SP)+,$010C *)
	(*$END*)

PROCEDURE LMGetStackLowPoint*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0110;			(* MOVE.l $0110,(SP) *)
	(*$END*)

PROCEDURE LMSetStackLowPoint*(value: Types.Ptr);
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0110;			(* MOVE.l (SP)+,$0110 *)
	(*$END*)

PROCEDURE LMGetHeapEnd*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0114;			(* MOVE.l $0114,(SP) *)
	(*$END*)

PROCEDURE LMSetHeapEnd*(value: Types.Ptr);
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0114;			(* MOVE.l (SP)+,$0114 *)
	(*$END*)

PROCEDURE LMGetTheZone*(): Memory.THz;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0118;			(* MOVE.l $0118,(SP) *)
	(*$END*)

PROCEDURE LMSetTheZone*(value: Memory.THz);
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0118;			(* MOVE.l (SP)+,$0118 *)
	(*$END*)

PROCEDURE LMGetUTableBase*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $011C;			(* MOVE.l $011C,(SP) *)
	(*$END*)

PROCEDURE LMSetUTableBase*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $011C;			(* MOVE.l (SP)+,$011C *)
	(*$END*)

PROCEDURE LMGetCPUFlag*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $012F;			(* MOVE.b $012F,(SP) *)
	(*$END*)

PROCEDURE LMSetCPUFlag*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $012F;			(* MOVE.b (SP)+,$012F *)
	(*$END*)

PROCEDURE LMGetApplLimit*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0130;			(* MOVE.l $0130,(SP) *)
	(*$END*)

PROCEDURE LMSetApplLimit*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0130;			(* MOVE.l (SP)+,$0130 *)
	(*$END*)

PROCEDURE LMGetSysEvtMask*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0144;			(* MOVE.w $0144,(SP) *)
	(*$END*)

PROCEDURE LMSetSysEvtMask*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0144;			(* MOVE.w (SP)+,$0144 *)
	(*$END*)

PROCEDURE LMGetRndSeed*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0156;			(* MOVE.l $0156,(SP) *)
	(*$END*)

PROCEDURE LMSetRndSeed*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0156;			(* MOVE.l (SP)+,$0156 *)
	(*$END*)

PROCEDURE LMGetSEvtEnb*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $015C;			(* MOVE.b $015C,(SP) *)
	(*$END*)

PROCEDURE LMSetSEvtEnb*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $015C;			(* MOVE.b (SP)+,$015C *)
	(*$END*)

PROCEDURE LMGetTicks*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $016A;			(* MOVE.l $016A,(SP) *)
	(*$END*)

PROCEDURE LMSetTicks*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $016A;			(* MOVE.l (SP)+,$016A *)
	(*$END*)

PROCEDURE LMGetKeyThresh*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $018E;			(* MOVE.w $018E,(SP) *)
	(*$END*)

PROCEDURE LMSetKeyThresh*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $018E;			(* MOVE.w (SP)+,$018E *)
	(*$END*)

PROCEDURE LMGetKeyRepThresh*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0190;			(* MOVE.w $0190,(SP) *)
	(*$END*)

PROCEDURE LMSetKeyRepThresh*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0190;			(* MOVE.w (SP)+,$0190 *)
	(*$END*)

PROCEDURE LMGetUnitTableEntryCount*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $01D2;			(* MOVE.w $01D2,(SP) *)
	(*$END*)

PROCEDURE LMSetUnitTableEntryCount*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $01D2;			(* MOVE.w (SP)+,$01D2 *)
	(*$END*)

PROCEDURE LMGetVIA*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $01D4;			(* MOVE.l $01D4,(SP) *)
	(*$END*)

PROCEDURE LMSetVIA*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $01D4;			(* MOVE.l (SP)+,$01D4 *)
	(*$END*)

PROCEDURE LMGetSCCRd*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $01D8;			(* MOVE.l $01D8,(SP) *)
	(*$END*)

PROCEDURE LMSetSCCRd*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $01D8;			(* MOVE.l (SP)+,$01D8 *)
	(*$END*)

PROCEDURE LMGetSCCWr*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $01DC;			(* MOVE.l $01DC,(SP) *)
	(*$END*)

PROCEDURE LMSetSCCWr*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $01DC;			(* MOVE.l (SP)+,$01DC *)
	(*$END*)

PROCEDURE LMGetSPValid*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $01F8;			(* MOVE.b $01F8,(SP) *)
	(*$END*)

PROCEDURE LMSetSPValid*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $01F8;			(* MOVE.b (SP)+,$01F8 *)
	(*$END*)

PROCEDURE LMGetSPATalkA*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $01F9;			(* MOVE.b $01F9,(SP) *)
	(*$END*)

PROCEDURE LMSetSPATalkA*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $01F9;			(* MOVE.b (SP)+,$01F9 *)
	(*$END*)

PROCEDURE LMGetSPATalkB*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $01FA;			(* MOVE.b $01FA,(SP) *)
	(*$END*)

PROCEDURE LMSetSPATalkB*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $01FA;			(* MOVE.b (SP)+,$01FA *)
	(*$END*)

PROCEDURE LMGetSPConfig*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $01FB;			(* MOVE.b $01FB,(SP) *)
	(*$END*)

PROCEDURE LMSetSPConfig*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $01FB;			(* MOVE.b (SP)+,$01FB *)
	(*$END*)

PROCEDURE LMGetSPPortA*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $01FC;			(* MOVE.w $01FC,(SP) *)
	(*$END*)

PROCEDURE LMSetSPPortA*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $01FC;			(* MOVE.w (SP)+,$01FC *)
	(*$END*)

PROCEDURE LMGetSPPortB*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $01FE;			(* MOVE.w $01FE,(SP) *)
	(*$END*)

PROCEDURE LMSetSPPortB*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $01FE;			(* MOVE.w (SP)+,$01FE *)
	(*$END*)

PROCEDURE LMGetSPAlarm*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0200;			(* MOVE.l $0200,(SP) *)
	(*$END*)

PROCEDURE LMSetSPAlarm*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0200;			(* MOVE.l (SP)+,$0200 *)
	(*$END*)

PROCEDURE LMGetSPFont*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0204;			(* MOVE.w $0204,(SP) *)
	(*$END*)

PROCEDURE LMSetSPFont*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0204;			(* MOVE.w (SP)+,$0204 *)
	(*$END*)

PROCEDURE LMGetSPKbd*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0206;			(* MOVE.b $0206,(SP) *)
	(*$END*)

PROCEDURE LMSetSPKbd*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0206;			(* MOVE.b (SP)+,$0206 *)
	(*$END*)

PROCEDURE LMGetSPPrint*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0207;			(* MOVE.b $0207,(SP) *)
	(*$END*)

PROCEDURE LMSetSPPrint*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0207;			(* MOVE.b (SP)+,$0207 *)
	(*$END*)

PROCEDURE LMGetSPVolCtl*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0208;			(* MOVE.b $0208,(SP) *)
	(*$END*)

PROCEDURE LMSetSPVolCtl*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0208;			(* MOVE.b (SP)+,$0208 *)
	(*$END*)

PROCEDURE LMGetSPClikCaret*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0209;			(* MOVE.b $0209,(SP) *)
	(*$END*)

PROCEDURE LMSetSPClikCaret*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0209;			(* MOVE.b (SP)+,$0209 *)
	(*$END*)

PROCEDURE LMGetSPMisc2*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $020B;			(* MOVE.b $020B,(SP) *)
	(*$END*)

PROCEDURE LMSetSPMisc2*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $020B;			(* MOVE.b (SP)+,$020B *)
	(*$END*)

PROCEDURE LMGetTime*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $020C;			(* MOVE.l $020C,(SP) *)
	(*$END*)

PROCEDURE LMSetTime*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $020C;			(* MOVE.l (SP)+,$020C *)
	(*$END*)

PROCEDURE LMGetBootDrive*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0210;			(* MOVE.w $0210,(SP) *)
	(*$END*)

PROCEDURE LMSetBootDrive*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0210;			(* MOVE.w (SP)+,$0210 *)
	(*$END*)

PROCEDURE LMGetSFSaveDisk*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0214;			(* MOVE.w $0214,(SP) *)
	(*$END*)

PROCEDURE LMSetSFSaveDisk*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0214;			(* MOVE.w (SP)+,$0214 *)
	(*$END*)

PROCEDURE LMGetKbdLast*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0218;			(* MOVE.b $0218,(SP) *)
	(*$END*)

PROCEDURE LMSetKbdLast*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0218;			(* MOVE.b (SP)+,$0218 *)
	(*$END*)

PROCEDURE LMGetKbdType*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $021E;			(* MOVE.b $021E,(SP) *)
	(*$END*)

PROCEDURE LMSetKbdType*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $021E;			(* MOVE.b (SP)+,$021E *)
	(*$END*)

PROCEDURE LMGetMemErr*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0220;			(* MOVE.w $0220,(SP) *)
	(*$END*)

PROCEDURE LMSetMemErr*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0220;			(* MOVE.w (SP)+,$0220 *)
	(*$END*)

PROCEDURE LMGetSdVolume*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0260;			(* MOVE.b $0260,(SP) *)
	(*$END*)

PROCEDURE LMSetSdVolume*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0260;			(* MOVE.b (SP)+,$0260 *)
	(*$END*)

PROCEDURE LMGetSoundPtr*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0262;			(* MOVE.l $0262,(SP) *)
	(*$END*)

PROCEDURE LMSetSoundPtr*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0262;			(* MOVE.l (SP)+,$0262 *)
	(*$END*)

PROCEDURE LMGetSoundBase*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0266;			(* MOVE.l $0266,(SP) *)
	(*$END*)

PROCEDURE LMSetSoundBase*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0266;			(* MOVE.l (SP)+,$0266 *)
	(*$END*)

PROCEDURE LMGetSoundLevel*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $027F;			(* MOVE.b $027F,(SP) *)
	(*$END*)

PROCEDURE LMSetSoundLevel*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $027F;			(* MOVE.b (SP)+,$027F *)
	(*$END*)

PROCEDURE LMGetCurPitch*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0280;			(* MOVE.w $0280,(SP) *)
	(*$END*)

PROCEDURE LMSetCurPitch*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0280;			(* MOVE.w (SP)+,$0280 *)
	(*$END*)

PROCEDURE LMGetROM85*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $028E;			(* MOVE.w $028E,(SP) *)
	(*$END*)

PROCEDURE LMSetROM85*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $028E;			(* MOVE.w (SP)+,$028E *)
	(*$END*)

PROCEDURE LMGetPortBUse*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0291;			(* MOVE.b $0291,(SP) *)
	(*$END*)

PROCEDURE LMSetPortBUse*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0291;			(* MOVE.b (SP)+,$0291 *)
	(*$END*)

PROCEDURE LMGetGNEFilter*(): Events.GNEFilterUPP;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $029A;			(* MOVE.l $029A,(SP) *)
	(*$END*)

PROCEDURE LMSetGNEFilter*( value: Events.GNEFilterUPP );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $029A;			(* MOVE.l (SP)+,$029A *)
	(*$END*)

PROCEDURE LMGetSysZone*(): Memory.THz;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $02A6;			(* MOVE.l $02A6,(SP) *)
	(*$END*)

PROCEDURE LMSetSysZone*( value: Memory.THz );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $02A6;			(* MOVE.l (SP)+,$02A6 *)
	(*$END*)

PROCEDURE LMGetApplZone*(): Memory.THz;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $02AA;			(* MOVE.l $02AA,(SP) *)
	(*$END*)

PROCEDURE LMSetApplZone*( value: Memory.THz );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $02AA;			(* MOVE.l (SP)+,$02AA *)
	(*$END*)

PROCEDURE LMGetROMBase*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $02AE;			(* MOVE.l $02AE,(SP) *)
	(*$END*)

PROCEDURE LMSetROMBase*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $02AE;			(* MOVE.l (SP)+,$02AE *)
	(*$END*)

PROCEDURE LMGetRAMBase*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $02B2;			(* MOVE.l $02B2,(SP) *)
	(*$END*)

PROCEDURE LMSetRAMBase*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $02B2;			(* MOVE.l (SP)+,$02B2 *)
	(*$END*)

PROCEDURE LMGetDSAlertTab*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $02BA;			(* MOVE.l $02BA,(SP) *)
	(*$END*)

PROCEDURE LMSetDSAlertTab*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $02BA;			(* MOVE.l (SP)+,$02BA *)
	(*$END*)

PROCEDURE LMGetDoubleTime*(): Types.UInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $02F0;			(* MOVE.l $02F0,(SP) *)
	(*$END*)

PROCEDURE LMSetDoubleTime*( value: Types.UInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $02F0;			(* MOVE.l (SP)+,$02F0 *)
	(*$END*)

PROCEDURE LMGetCaretTime*(): Types.UInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $02F4;			(* MOVE.l $02F4,(SP) *)
	(*$END*)

PROCEDURE LMSetCaretTime*( value: Types.UInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $02F4;			(* MOVE.l (SP)+,$02F4 *)
	(*$END*)

PROCEDURE LMGetScrDmpEnb*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $02F8;			(* MOVE.b $02F8,(SP) *)
	(*$END*)

PROCEDURE LMSetScrDmpEnb*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $02F8;			(* MOVE.b (SP)+,$02F8 *)
	(*$END*)

PROCEDURE LMGetBufTgFNum*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $02FC;			(* MOVE.l $02FC,(SP) *)
	(*$END*)

PROCEDURE LMSetBufTgFNum*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $02FC;			(* MOVE.l (SP)+,$02FC *)
	(*$END*)

PROCEDURE LMGetBufTgFFlg*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0300;			(* MOVE.w $0300,(SP) *)
	(*$END*)

PROCEDURE LMSetBufTgFFlg*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0300;			(* MOVE.w (SP)+,$0300 *)
	(*$END*)

PROCEDURE LMGetBufTgFBkNum*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0302;			(* MOVE.w $0302,(SP) *)
	(*$END*)

PROCEDURE LMSetBufTgFBkNum*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0302;			(* MOVE.w (SP)+,$0302 *)
	(*$END*)

PROCEDURE LMGetBufTgDate*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0304;			(* MOVE.l $0304,(SP) *)
	(*$END*)

PROCEDURE LMSetBufTgDate*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0304;			(* MOVE.l (SP)+,$0304 *)
	(*$END*)

PROCEDURE LMGetLo3Bytes*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $031A;			(* MOVE.l $031A,(SP) *)
	(*$END*)

PROCEDURE LMSetLo3Bytes*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $031A;			(* MOVE.l (SP)+,$031A *)
	(*$END*)

PROCEDURE LMGetMinStack*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $031E;			(* MOVE.l $031E,(SP) *)
	(*$END*)

PROCEDURE LMSetMinStack*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $031E;			(* MOVE.l (SP)+,$031E *)
	(*$END*)

PROCEDURE LMGetDefltStack*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0322;			(* MOVE.l $0322,(SP) *)
	(*$END*)

PROCEDURE LMSetDefltStack*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0322;			(* MOVE.l (SP)+,$0322 *)
	(*$END*)

PROCEDURE LMGetGZRootHnd*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0328;			(* MOVE.l $0328,(SP) *)
	(*$END*)

PROCEDURE LMSetGZRootHnd*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0328;			(* MOVE.l (SP)+,$0328 *)
	(*$END*)

PROCEDURE LMGetGZMoveHnd*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0330;			(* MOVE.l $0330,(SP) *)
	(*$END*)

PROCEDURE LMSetGZMoveHnd*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0330;			(* MOVE.l (SP)+,$0330 *)
	(*$END*)

PROCEDURE LMGetFCBSPtr*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $034E;			(* MOVE.l $034E,(SP) *)
	(*$END*)

PROCEDURE LMSetFCBSPtr*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $034E;			(* MOVE.l (SP)+,$034E *)
	(*$END*)

PROCEDURE LMGetDefVCBPtr*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0352;			(* MOVE.l $0352,(SP) *)
	(*$END*)

PROCEDURE LMSetDefVCBPtr*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0352;			(* MOVE.l (SP)+,$0352 *)
	(*$END*)

PROCEDURE LMGetCurDirStore*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0398;			(* MOVE.l $0398,(SP) *)
	(*$END*)

PROCEDURE LMSetCurDirStore*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0398;			(* MOVE.l (SP)+,$0398 *)
	(*$END*)

PROCEDURE LMGetToExtFS*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $03F2;			(* MOVE.l $03F2,(SP) *)
	(*$END*)

PROCEDURE LMSetToExtFS*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $03F2;			(* MOVE.l (SP)+,$03F2 *)
	(*$END*)

PROCEDURE LMGetFSFCBLen*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $03F6;			(* MOVE.w $03F6,(SP) *)
	(*$END*)

PROCEDURE LMSetFSFCBLen*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $03F6;			(* MOVE.w (SP)+,$03F6 *)
	(*$END*)

PROCEDURE LMGetScrnBase*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0824;			(* MOVE.l $0824,(SP) *)
	(*$END*)

PROCEDURE LMSetScrnBase*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0824;			(* MOVE.l (SP)+,$0824 *)
	(*$END*)

PROCEDURE LMGetMainDevice*(): Quickdraw.GDHandle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $08A4;			(* MOVE.l $08A4,(SP) *)
	(*$END*)

PROCEDURE LMSetMainDevice*( value: Quickdraw.GDHandle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $08A4;			(* MOVE.l (SP)+,$08A4 *)
	(*$END*)

PROCEDURE LMGetDeviceList*(): Quickdraw.GDHandle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $08A8;			(* MOVE.l $08A8,(SP) *)
	(*$END*)

PROCEDURE LMSetDeviceList*( value: Quickdraw.GDHandle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $08A8;			(* MOVE.l (SP)+,$08A8 *)
	(*$END*)

PROCEDURE LMGetQDColors*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $08B0;			(* MOVE.l $08B0,(SP) *)
	(*$END*)

PROCEDURE LMSetQDColors*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $08B0;			(* MOVE.l (SP)+,$08B0 *)
	(*$END*)

PROCEDURE LMGetCrsrBusy*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $08CD;			(* MOVE.b $08CD,(SP) *)
	(*$END*)

PROCEDURE LMSetCrsrBusy*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $08CD;			(* MOVE.b (SP)+,$08CD *)
	(*$END*)

PROCEDURE LMGetWidthListHand*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $08E4;			(* MOVE.l $08E4,(SP) *)
	(*$END*)

PROCEDURE LMSetWidthListHand*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $08E4;			(* MOVE.l (SP)+,$08E4 *)
	(*$END*)

PROCEDURE LMGetJournalRef*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $08E8;			(* MOVE.w $08E8,(SP) *)
	(*$END*)

PROCEDURE LMSetJournalRef*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $08E8;			(* MOVE.w (SP)+,$08E8 *)
	(*$END*)

PROCEDURE LMGetCrsrThresh*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $08EC;			(* MOVE.w $08EC,(SP) *)
	(*$END*)

PROCEDURE LMSetCrsrThresh*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $08EC;			(* MOVE.w (SP)+,$08EC *)
	(*$END*)

PROCEDURE LMGetJFetch*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $08F4;			(* MOVE.l $08F4,(SP) *)
	(*$END*)

PROCEDURE LMSetJFetch*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $08F4;			(* MOVE.l (SP)+,$08F4 *)
	(*$END*)

PROCEDURE LMGetJStash*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $08F8;			(* MOVE.l $08F8,(SP) *)
	(*$END*)

PROCEDURE LMSetJStash*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $08F8;			(* MOVE.l (SP)+,$08F8 *)
	(*$END*)

PROCEDURE LMGetJIODone*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $08FC;			(* MOVE.l $08FC,(SP) *)
	(*$END*)

PROCEDURE LMSetJIODone*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $08FC;			(* MOVE.l (SP)+,$08FC *)
	(*$END*)

PROCEDURE LMGetCurApRefNum*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0900;			(* MOVE.w $0900,(SP) *)
	(*$END*)

PROCEDURE LMSetCurApRefNum*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0900;			(* MOVE.w (SP)+,$0900 *)
	(*$END*)

PROCEDURE LMGetCurrentA5*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0904;			(* MOVE.l $0904,(SP) *)
	(*$END*)

PROCEDURE LMSetCurrentA5*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0904;			(* MOVE.l (SP)+,$0904 *)
	(*$END*)

PROCEDURE LMGetCurStackBase*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0908;			(* MOVE.l $0908,(SP) *)
	(*$END*)

PROCEDURE LMSetCurStackBase*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0908;			(* MOVE.l (SP)+,$0908 *)
	(*$END*)

PROCEDURE LMGetCurJTOffset*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0934;			(* MOVE.w $0934,(SP) *)
	(*$END*)

PROCEDURE LMSetCurJTOffset*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0934;			(* MOVE.w (SP)+,$0934 *)
	(*$END*)

PROCEDURE LMGetCurPageOption*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0936;			(* MOVE.w $0936,(SP) *)
	(*$END*)

PROCEDURE LMSetCurPageOption*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0936;			(* MOVE.w (SP)+,$0936 *)
	(*$END*)

PROCEDURE LMGetHiliteMode*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0938;			(* MOVE.b $0938,(SP) *)
	(*$END*)

PROCEDURE LMSetHiliteMode*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0938;			(* MOVE.b (SP)+,$0938 *)
	(*$END*)

PROCEDURE LMGetPrintErr*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0944;			(* MOVE.w $0944,(SP) *)
	(*$END*)

PROCEDURE LMSetPrintErr*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0944;			(* MOVE.w (SP)+,$0944 *)
	(*$END*)

PROCEDURE LMGetScrapSize*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0960;			(* MOVE.l $0960,(SP) *)
	(*$END*)

PROCEDURE LMSetScrapSize*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0960;			(* MOVE.l (SP)+,$0960 *)
	(*$END*)

PROCEDURE LMGetScrapHandle*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0964;			(* MOVE.l $0964,(SP) *)
	(*$END*)

PROCEDURE LMSetScrapHandle*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0964;			(* MOVE.l (SP)+,$0964 *)
	(*$END*)

PROCEDURE LMGetScrapCount*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0968;			(* MOVE.w $0968,(SP) *)
	(*$END*)

PROCEDURE LMSetScrapCount*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0968;			(* MOVE.w (SP)+,$0968 *)
	(*$END*)

PROCEDURE LMGetScrapState*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $096A;			(* MOVE.w $096A,(SP) *)
	(*$END*)

PROCEDURE LMSetScrapState*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $096A;			(* MOVE.w (SP)+,$096A *)
	(*$END*)

PROCEDURE LMGetScrapName*(): Types.StringPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $096C;			(* MOVE.l $096C,(SP) *)
	(*$END*)

PROCEDURE LMSetScrapName*( value: Types.StringPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $096C;			(* MOVE.l (SP)+,$096C *)
	(*$END*)

PROCEDURE LMGetROMFont0*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0980;			(* MOVE.l $0980,(SP) *)
	(*$END*)

PROCEDURE LMSetROMFont0*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0980;			(* MOVE.l (SP)+,$0980 *)
	(*$END*)

PROCEDURE LMGetApFontID*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0984;			(* MOVE.w $0984,(SP) *)
	(*$END*)

PROCEDURE LMSetApFontID*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0984;			(* MOVE.w (SP)+,$0984 *)
	(*$END*)

PROCEDURE LMGetWindowList*(): Quickdraw.WindowRef;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $09D6;			(* MOVE.l $09D6,(SP) *)
	(*$END*)

PROCEDURE LMGetSaveUpdate*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $09DA;			(* MOVE.w $09DA,(SP) *)
	(*$END*)

PROCEDURE LMSetSaveUpdate*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $09DA;			(* MOVE.w (SP)+,$09DA *)
	(*$END*)

PROCEDURE LMGetPaintWhite*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $09DC;			(* MOVE.w $09DC,(SP) *)
	(*$END*)

PROCEDURE LMSetPaintWhite*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $09DC;			(* MOVE.w (SP)+,$09DC *)
	(*$END*)

PROCEDURE LMGetWMgrPort*(): Quickdraw.GrafPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $09DE;			(* MOVE.l $09DE,(SP) *)
	(*$END*)

PROCEDURE LMSetWMgrPort*( value: Quickdraw.GrafPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $09DE;			(* MOVE.l (SP)+,$09DE *)
	(*$END*)

PROCEDURE LMGetGrayRgn*(): Quickdraw.RgnHandle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $09EE;			(* MOVE.l $09EE,(SP) *)
	(*$END*)

PROCEDURE LMGetDragHook*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $09F6;			(* MOVE.l $09F6,(SP) *)
	(*$END*)

PROCEDURE LMSetDragHook*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $09F6;			(* MOVE.l (SP)+,$09F6 *)
	(*$END*)

(*
 To best work with future versions of the window manager,
 avoid using anything not defined with STRICT_WINDOWS
 set to true.  Most, if not all of these will still
 be supported in the next major version of the window manager
 but will trigger non-optimal compatibility code paths that
 should be avoided if possible.
*)
(*$IF NOT STRICT_WINDOWS *)
(*
 There is no reason to set the window list directly.
 Use BringToFront and SendBehind.

 If you need to do floating windows, avoid using GhostWindow 
 and especially avoid patching the window manager.

 See Dean Yu's article in Develop 15 about how to implement floating
 windows using low-level window manager calls.  The next generation
 Macintosh Window Manager will have built-in support for floating
 and modal windows.
*)
PROCEDURE LMSetWindowList*( value: Quickdraw.WindowRef );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $09D6;			(* MOVE.l (SP)+,$09D6 *)
	(*$END*)

PROCEDURE LMGetGhostWindow*(): Quickdraw.WindowRef;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A84;			(* MOVE.l $0A84,(SP) *)
	(*$END*)

PROCEDURE LMSetGhostWindow*( value: Quickdraw.WindowRef );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A84;			(* MOVE.l (SP)+,$0A84 *)
	(*$END*)

(*
 The auxiliary window record list will be empty in future
 versions of the window manager.  There is no reason to 
 walk it or change it. 
*)
PROCEDURE LMGetAuxWinHead*(): Windows.AuxWinHandle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0CD0;			(* MOVE.l $0CD0,(SP) *)
	(*$END*)

PROCEDURE LMSetAuxWinHead*( value: Windows.AuxWinHandle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0CD0;			(* MOVE.l (SP)+,$0CD0 *)
	(*$END*)

(*
 Please rely on the event manager to deliver activate and 
 deactivate events and on the window manager to generate them.

 The next generation window manager will queue these events
 rather than just slamming these lowmems with the latest
 generated event, so it pays to rely on the event manager.
*)
PROCEDURE LMGetCurActivate*(): Quickdraw.WindowRef;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A64;			(* MOVE.l $0A64,(SP) *)
	(*$END*)

PROCEDURE LMSetCurActivate*( value: Quickdraw.WindowRef );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A64;			(* MOVE.l (SP)+,$0A64 *)
	(*$END*)

PROCEDURE LMGetCurDeactive*(): Quickdraw.WindowRef;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A68;			(* MOVE.l $0A68,(SP) *)
	(*$END*)

PROCEDURE LMSetCurDeactive*( value: Quickdraw.WindowRef );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A68;			(* MOVE.l (SP)+,$0A68 *)
	(*$END*)

PROCEDURE LMGetOldStructure*(): Quickdraw.RgnHandle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $09E6;			(* MOVE.l $09E6,(SP) *)
	(*$END*)

PROCEDURE LMSetOldStructure*( value: Quickdraw.RgnHandle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $09E6;			(* MOVE.l (SP)+,$09E6 *)
	(*$END*)

PROCEDURE LMGetOldContent*(): Quickdraw.RgnHandle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $09EA;			(* MOVE.l $09EA,(SP) *)
	(*$END*)

PROCEDURE LMSetOldContent*( value: Quickdraw.RgnHandle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $09EA;			(* MOVE.l (SP)+,$09EA *)
	(*$END*)

(*
 Please don't mess with the gray region.  There has
 to be a better way.  If not, please manipulate the
 existing region, don't change the value of the lowmem.
*)
PROCEDURE LMSetGrayRgn*( value: Quickdraw.RgnHandle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $09EE;			(* MOVE.l (SP)+,$09EE *)
	(*$END*)

PROCEDURE LMGetSaveVisRgn*(): Quickdraw.RgnHandle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $09F2;			(* MOVE.l $09F2,(SP) *)
	(*$END*)

PROCEDURE LMSetSaveVisRgn*( value: Quickdraw.RgnHandle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $09F2;			(* MOVE.l (SP)+,$09F2 *)
	(*$END*)

(*$END*)
PROCEDURE LMGetOneOne*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A02;			(* MOVE.l $0A02,(SP) *)
	(*$END*)

PROCEDURE LMSetOneOne*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A02;			(* MOVE.l (SP)+,$0A02 *)
	(*$END*)

PROCEDURE LMGetMinusOne*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A06;			(* MOVE.l $0A06,(SP) *)
	(*$END*)

PROCEDURE LMSetMinusOne*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A06;			(* MOVE.l (SP)+,$0A06 *)
	(*$END*)

PROCEDURE LMGetTopMenuItem*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0A0A;			(* MOVE.w $0A0A,(SP) *)
	(*$END*)

PROCEDURE LMSetTopMenuItem*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0A0A;			(* MOVE.w (SP)+,$0A0A *)
	(*$END*)

PROCEDURE LMGetAtMenuBottom*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0A0C;			(* MOVE.w $0A0C,(SP) *)
	(*$END*)

PROCEDURE LMSetAtMenuBottom*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0A0C;			(* MOVE.w (SP)+,$0A0C *)
	(*$END*)

PROCEDURE LMGetMenuList*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A1C;			(* MOVE.l $0A1C,(SP) *)
	(*$END*)

PROCEDURE LMSetMenuList*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A1C;			(* MOVE.l (SP)+,$0A1C *)
	(*$END*)

PROCEDURE LMGetMBarEnable*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0A20;			(* MOVE.w $0A20,(SP) *)
	(*$END*)

PROCEDURE LMSetMBarEnable*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0A20;			(* MOVE.w (SP)+,$0A20 *)
	(*$END*)

PROCEDURE LMGetMenuFlash*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0A24;			(* MOVE.w $0A24,(SP) *)
	(*$END*)

PROCEDURE LMSetMenuFlash*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0A24;			(* MOVE.w (SP)+,$0A24 *)
	(*$END*)

PROCEDURE LMGetTheMenu*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0A26;			(* MOVE.w $0A26,(SP) *)
	(*$END*)

PROCEDURE LMSetTheMenu*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0A26;			(* MOVE.w (SP)+,$0A26 *)
	(*$END*)

PROCEDURE LMGetMBarHook*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A2C;			(* MOVE.l $0A2C,(SP) *)
	(*$END*)

PROCEDURE LMSetMBarHook*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A2C;			(* MOVE.l (SP)+,$0A2C *)
	(*$END*)

PROCEDURE LMGetMenuHook*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A30;			(* MOVE.l $0A30,(SP) *)
	(*$END*)

PROCEDURE LMSetMenuHook*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A30;			(* MOVE.l (SP)+,$0A30 *)
	(*$END*)

PROCEDURE LMGetTopMapHndl*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A50;			(* MOVE.l $0A50,(SP) *)
	(*$END*)

PROCEDURE LMSetTopMapHndl*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A50;			(* MOVE.l (SP)+,$0A50 *)
	(*$END*)

PROCEDURE LMGetSysMapHndl*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A54;			(* MOVE.l $0A54,(SP) *)
	(*$END*)

PROCEDURE LMSetSysMapHndl*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A54;			(* MOVE.l (SP)+,$0A54 *)
	(*$END*)

PROCEDURE LMGetSysMap*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0A58;			(* MOVE.w $0A58,(SP) *)
	(*$END*)

PROCEDURE LMSetSysMap*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0A58;			(* MOVE.w (SP)+,$0A58 *)
	(*$END*)

PROCEDURE LMGetCurMap*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0A5A;			(* MOVE.w $0A5A,(SP) *)
	(*$END*)

PROCEDURE LMSetCurMap*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0A5A;			(* MOVE.w (SP)+,$0A5A *)
	(*$END*)

PROCEDURE LMGetResLoad*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0A5E;			(* MOVE.b $0A5E,(SP) *)
	(*$END*)

PROCEDURE LMSetResLoad*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0A5E;			(* MOVE.b (SP)+,$0A5E *)
	(*$END*)

PROCEDURE LMGetResErr*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0A60;			(* MOVE.w $0A60,(SP) *)
	(*$END*)

PROCEDURE LMSetResErr*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0A60;			(* MOVE.w (SP)+,$0A60 *)
	(*$END*)

PROCEDURE LMGetFScaleDisable*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0A63;			(* MOVE.b $0A63,(SP) *)
	(*$END*)

PROCEDURE LMSetFScaleDisable*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0A63;			(* MOVE.b (SP)+,$0A63 *)
	(*$END*)

PROCEDURE LMGetDeskHook*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A6C;			(* MOVE.l $0A6C,(SP) *)
	(*$END*)

PROCEDURE LMSetDeskHook*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A6C;			(* MOVE.l (SP)+,$0A6C *)
	(*$END*)

PROCEDURE LMGetTEDoText*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A70;			(* MOVE.l $0A70,(SP) *)
	(*$END*)

PROCEDURE LMSetTEDoText*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A70;			(* MOVE.l (SP)+,$0A70 *)
	(*$END*)

PROCEDURE LMGetTERecal*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A74;			(* MOVE.l $0A74,(SP) *)
	(*$END*)

PROCEDURE LMSetTERecal*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A74;			(* MOVE.l (SP)+,$0A74 *)
	(*$END*)

PROCEDURE LMGetResumeProc*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A8C;			(* MOVE.l $0A8C,(SP) *)
	(*$END*)

PROCEDURE LMSetResumeProc*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A8C;			(* MOVE.l (SP)+,$0A8C *)
	(*$END*)

PROCEDURE LMGetANumber*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0A98;			(* MOVE.w $0A98,(SP) *)
	(*$END*)

PROCEDURE LMSetANumber*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0A98;			(* MOVE.w (SP)+,$0A98 *)
	(*$END*)

PROCEDURE LMGetACount*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0A9A;			(* MOVE.w $0A9A,(SP) *)
	(*$END*)

PROCEDURE LMSetACount*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0A9A;			(* MOVE.w (SP)+,$0A9A *)
	(*$END*)

PROCEDURE LMGetDABeeper*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0A9C;			(* MOVE.l $0A9C,(SP) *)
	(*$END*)

PROCEDURE LMSetDABeeper*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0A9C;			(* MOVE.l (SP)+,$0A9C *)
	(*$END*)

PROCEDURE LMGetTEScrpLength*(): Types.UInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0AB0;			(* MOVE.w $0AB0,(SP) *)
	(*$END*)

PROCEDURE LMSetTEScrpLength*( value: Types.UInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0AB0;			(* MOVE.w (SP)+,$0AB0 *)
	(*$END*)

PROCEDURE LMGetTEScrpHandle*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0AB4;			(* MOVE.l $0AB4,(SP) *)
	(*$END*)

PROCEDURE LMSetTEScrpHandle*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0AB4;			(* MOVE.l (SP)+,$0AB4 *)
	(*$END*)

PROCEDURE LMGetAppParmHandle*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0AEC;			(* MOVE.l $0AEC,(SP) *)
	(*$END*)

PROCEDURE LMSetAppParmHandle*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0AEC;			(* MOVE.l (SP)+,$0AEC *)
	(*$END*)

PROCEDURE LMGetDSErrCode*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0AF0;			(* MOVE.w $0AF0,(SP) *)
	(*$END*)

PROCEDURE LMSetDSErrCode*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0AF0;			(* MOVE.w (SP)+,$0AF0 *)
	(*$END*)

PROCEDURE LMGetResErrProc*(): Resources.ResErrUPP;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0AF2;			(* MOVE.l $0AF2,(SP) *)
	(*$END*)

PROCEDURE LMSetResErrProc*( value: Resources.ResErrUPP );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0AF2;			(* MOVE.l (SP)+,$0AF2 *)
	(*$END*)

PROCEDURE LMGetDlgFont*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0AFA;			(* MOVE.w $0AFA,(SP) *)
	(*$END*)

PROCEDURE LMSetDlgFont*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0AFA;			(* MOVE.w (SP)+,$0AFA *)
	(*$END*)

PROCEDURE LMGetROMMapHandle*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0B06;			(* MOVE.l $0B06,(SP) *)
	(*$END*)

PROCEDURE LMSetROMMapHandle*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0B06;			(* MOVE.l (SP)+,$0B06 *)
	(*$END*)

PROCEDURE LMGetWidthPtr*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0B10;			(* MOVE.l $0B10,(SP) *)
	(*$END*)

PROCEDURE LMSetWidthPtr*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0B10;			(* MOVE.l (SP)+,$0B10 *)
	(*$END*)

PROCEDURE LMGetATalkHk2*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0B18;			(* MOVE.l $0B18,(SP) *)
	(*$END*)

PROCEDURE LMSetATalkHk2*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0B18;			(* MOVE.l (SP)+,$0B18 *)
	(*$END*)

PROCEDURE LMGetHWCfgFlags*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0B22;			(* MOVE.w $0B22,(SP) *)
	(*$END*)

PROCEDURE LMSetHWCfgFlags*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0B22;			(* MOVE.w (SP)+,$0B22 *)
	(*$END*)

PROCEDURE LMGetWidthTabHandle*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0B2A;			(* MOVE.l $0B2A,(SP) *)
	(*$END*)

PROCEDURE LMSetWidthTabHandle*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0B2A;			(* MOVE.l (SP)+,$0B2A *)
	(*$END*)

PROCEDURE LMGetLastSPExtra*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0B4C;			(* MOVE.l $0B4C,(SP) *)
	(*$END*)

PROCEDURE LMSetLastSPExtra*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0B4C;			(* MOVE.l (SP)+,$0B4C *)
	(*$END*)

PROCEDURE LMGetMenuDisable*(): Types.SInt32;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0B54;			(* MOVE.l $0B54,(SP) *)
	(*$END*)

PROCEDURE LMSetMenuDisable*( value: Types.SInt32 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0B54;			(* MOVE.l (SP)+,$0B54 *)
	(*$END*)

PROCEDURE LMGetROMMapInsert*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0B9E;			(* MOVE.b $0B9E,(SP) *)
	(*$END*)

PROCEDURE LMSetROMMapInsert*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0B9E;			(* MOVE.b (SP)+,$0B9E *)
	(*$END*)

PROCEDURE LMGetTmpResLoad*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0B9F;			(* MOVE.b $0B9F,(SP) *)
	(*$END*)

PROCEDURE LMSetTmpResLoad*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0B9F;			(* MOVE.b (SP)+,$0B9F *)
	(*$END*)

PROCEDURE LMGetIntlSpec*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0BA0;			(* MOVE.l $0BA0,(SP) *)
	(*$END*)

PROCEDURE LMSetIntlSpec*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0BA0;			(* MOVE.l (SP)+,$0BA0 *)
	(*$END*)

PROCEDURE LMGetWordRedraw*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0BA5;			(* MOVE.b $0BA5,(SP) *)
	(*$END*)

PROCEDURE LMSetWordRedraw*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0BA5;			(* MOVE.b (SP)+,$0BA5 *)
	(*$END*)

PROCEDURE LMGetSysFontFam*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0BA6;			(* MOVE.w $0BA6,(SP) *)
	(*$END*)

PROCEDURE LMSetSysFontFam*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0BA6;			(* MOVE.w (SP)+,$0BA6 *)
	(*$END*)

PROCEDURE LMGetSysFontSize*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0BA8;			(* MOVE.w $0BA8,(SP) *)
	(*$END*)

PROCEDURE LMSetSysFontSize*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0BA8;			(* MOVE.w (SP)+,$0BA8 *)
	(*$END*)

PROCEDURE LMGetMBarHeight*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0BAA;			(* MOVE.w $0BAA,(SP) *)
	(*$END*)

PROCEDURE LMSetMBarHeight*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0BAA;			(* MOVE.w (SP)+,$0BAA *)
	(*$END*)

PROCEDURE LMGetTESysJust*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0BAC;			(* MOVE.w $0BAC,(SP) *)
	(*$END*)

PROCEDURE LMSetTESysJust*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0BAC;			(* MOVE.w (SP)+,$0BAC *)
	(*$END*)

PROCEDURE LMGetHighHeapMark*(): Types.Ptr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0BAE;			(* MOVE.l $0BAE,(SP) *)
	(*$END*)

PROCEDURE LMSetHighHeapMark*( value: Types.Ptr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0BAE;			(* MOVE.l (SP)+,$0BAE *)
	(*$END*)

PROCEDURE LMGetLastFOND*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0BC2;			(* MOVE.l $0BC2,(SP) *)
	(*$END*)

PROCEDURE LMSetLastFOND*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0BC2;			(* MOVE.l (SP)+,$0BC2 *)
	(*$END*)

PROCEDURE LMGetFractEnable*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0BF4;			(* MOVE.b $0BF4,(SP) *)
	(*$END*)

PROCEDURE LMSetFractEnable*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0BF4;			(* MOVE.b (SP)+,$0BF4 *)
	(*$END*)

PROCEDURE LMGetMMU32Bit*(): Types.ByteParameter;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $1EB8, $0CB2;			(* MOVE.b $0CB2,(SP) *)
	(*$END*)

PROCEDURE LMSetMMU32Bit*( value: Types.ByteParameter );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $11DF, $0CB2;			(* MOVE.b (SP)+,$0CB2 *)
	(*$END*)

PROCEDURE LMGetTheGDevice*(): Quickdraw.GDHandle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0CC8;			(* MOVE.l $0CC8,(SP) *)
	(*$END*)

PROCEDURE LMSetTheGDevice*( value: Quickdraw.GDHandle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0CC8;			(* MOVE.l (SP)+,$0CC8 *)
	(*$END*)

PROCEDURE LMGetDeskCPat*(): Quickdraw.PixPatHandle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0CD8;			(* MOVE.l $0CD8,(SP) *)
	(*$END*)

PROCEDURE LMSetDeskCPat*( value: Quickdraw.PixPatHandle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0CD8;			(* MOVE.l (SP)+,$0CD8 *)
	(*$END*)

PROCEDURE LMGetTimeDBRA*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0D00;			(* MOVE.w $0D00,(SP) *)
	(*$END*)

PROCEDURE LMSetTimeDBRA*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0D00;			(* MOVE.w (SP)+,$0D00 *)
	(*$END*)

PROCEDURE LMGetTimeSCCDB*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0D02;			(* MOVE.w $0D02,(SP) *)
	(*$END*)

PROCEDURE LMSetTimeSCCDB*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0D02;			(* MOVE.w (SP)+,$0D02 *)
	(*$END*)

PROCEDURE LMGetJVBLTask*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0D28;			(* MOVE.l $0D28,(SP) *)
	(*$END*)

PROCEDURE LMSetJVBLTask*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0D28;			(* MOVE.l (SP)+,$0D28 *)
	(*$END*)

PROCEDURE LMGetSynListHandle*(): Types.Handle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0D32;			(* MOVE.l $0D32,(SP) *)
	(*$END*)

PROCEDURE LMSetSynListHandle*( value: Types.Handle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0D32;			(* MOVE.l (SP)+,$0D32 *)
	(*$END*)

PROCEDURE LMGetMenuCInfo*(): Menus.MCTableHandle;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0D50;			(* MOVE.l $0D50,(SP) *)
	(*$END*)

PROCEDURE LMSetMenuCInfo*( value: Menus.MCTableHandle );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0D50;			(* MOVE.l (SP)+,$0D50 *)
	(*$END*)

PROCEDURE LMGetJDTInstall*(): Types.UniversalProcPtr;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $2EB8, $0D9C;			(* MOVE.l $0D9C,(SP) *)
	(*$END*)

PROCEDURE LMSetJDTInstall*( value: Types.UniversalProcPtr );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $21DF, $0D9C;			(* MOVE.l (SP)+,$0D9C *)
	(*$END*)

PROCEDURE LMGetTimeSCSIDB*(): Types.SInt16;
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $3EB8, $0B24;			(* MOVE.w $0B24,(SP) *)
	(*$END*)

PROCEDURE LMSetTimeSCSIDB*( value: Types.SInt16 );
	(*$IF NOT CFMSYSTEMCALLS*)
	INLINE PASCAL $31DF, $0B24;			(* MOVE.w (SP)+,$0B24 *)
	(*$END*)

(**************************************************************************************

	MORE COMPLEX LOWMEM ACCESSORS

**************************************************************************************)
(*$IF CFMSYSTEMCALLS *)
PROCEDURE LMGetDSAlertRect*(VAR dsAlertRectValue: Types.Rect);
	EXTERNAL PASCAL;
PROCEDURE LMSetDSAlertRect*((*CONST*)VAR dsAlertRectValue: Types.Rect);
	EXTERNAL PASCAL;
PROCEDURE LMGetDragPattern*(VAR dragPatternValue: Quickdraw.Pattern);
	EXTERNAL PASCAL;
PROCEDURE LMSetDragPattern*((*CONST*)VAR dragPatternValue: Quickdraw.Pattern);
	EXTERNAL PASCAL;
PROCEDURE LMGetDeskPattern*(VAR deskPatternValue: Quickdraw.Pattern);
	EXTERNAL PASCAL;
PROCEDURE LMSetDeskPattern*((*CONST*)VAR deskPatternValue: Quickdraw.Pattern);
	EXTERNAL PASCAL;
PROCEDURE LMGetHiliteRGB*(VAR hiliteRGBValue: Quickdraw.RGBColor);
	EXTERNAL PASCAL;
PROCEDURE LMSetHiliteRGB*((*CONST*)VAR hiliteRGBValue: Quickdraw.RGBColor);
	EXTERNAL PASCAL;
PROCEDURE LMGetEventQueue*(): OSUtils.QHdrPtr;
	EXTERNAL PASCAL;
PROCEDURE LMSetEventQueue*(eventQueueValue: OSUtils.QHdrPtr);
	EXTERNAL PASCAL;
PROCEDURE LMGetVBLQueue*(): OSUtils.QHdrPtr;
	EXTERNAL PASCAL;
PROCEDURE LMSetVBLQueue*(vblQueueValue: OSUtils.QHdrPtr);
	EXTERNAL PASCAL;
PROCEDURE LMGetDrvQHdr*(): OSUtils.QHdrPtr;
	EXTERNAL PASCAL;
PROCEDURE LMSetDrvQHdr*(drvQHdrValue: OSUtils.QHdrPtr);
	EXTERNAL PASCAL;
PROCEDURE LMGetVCBQHdr*(): OSUtils.QHdrPtr;
	EXTERNAL PASCAL;
PROCEDURE LMSetVCBQHdr*(vcbQHdrValue: OSUtils.QHdrPtr);
	EXTERNAL PASCAL;
PROCEDURE LMGetDTQueue*(): OSUtils.QHdrPtr;
	EXTERNAL PASCAL;
PROCEDURE LMSetDTQueue*(dtQueueValue: OSUtils.QHdrPtr);
	EXTERNAL PASCAL;
PROCEDURE LMGetFSQHdr*(): OSUtils.QHdrPtr;
	EXTERNAL PASCAL;
(**************************************************************************************
	"BLOCKMOVE ACCESSORS"
	
		These lowmem accessors use the BlockMove trap
**************************************************************************************)
PROCEDURE LMGetCurApName*(): Types.StringPtr;
	EXTERNAL PASCAL;
PROCEDURE LMSetCurApName*(curApNameValue: ConstStr31Param);
	EXTERNAL PASCAL;
PROCEDURE LMGetSysResName*(): Types.StringPtr;
	EXTERNAL PASCAL;
PROCEDURE LMSetSysResName*(sysResNameValue: ConstStr15Param);
	EXTERNAL PASCAL;
PROCEDURE LMGetFinderName*(): Types.StringPtr;
	EXTERNAL PASCAL;
PROCEDURE LMSetFinderName*(finderNameValue: ConstStr15Param);
	EXTERNAL PASCAL;
PROCEDURE LMGetABusVars*(): Types.Ptr;
	EXTERNAL PASCAL;
PROCEDURE LMSetABusVars*(aBusVarsValue: Types.Ptr);
	EXTERNAL PASCAL;
PROCEDURE LMGetScratch20*(): Types.Ptr;
	EXTERNAL PASCAL;
PROCEDURE LMSetScratch20*(scratch20Value: (*UNIV*) Types.Ptr);
	EXTERNAL PASCAL;
PROCEDURE LMGetToolScratch*(): Types.Ptr;
	EXTERNAL PASCAL;
PROCEDURE LMSetToolScratch*(toolScratchValue: (*UNIV*) Types.Ptr);
	EXTERNAL PASCAL;
PROCEDURE LMGetApplScratch*(): Types.Ptr;
	EXTERNAL PASCAL;
PROCEDURE LMSetApplScratch*(applScratchValue: (*UNIV*) Types.Ptr);
	EXTERNAL PASCAL;
(**************************************************************************************
	"INDEXED ACCESSORS"
	
		These lowmem accessors take an index parameter to get/set an indexed
		lowmem global.
**************************************************************************************)
PROCEDURE LMGetDAStrings*(whichString: INTEGER): Types.StringHandle;
	EXTERNAL PASCAL;
PROCEDURE LMSetDAStrings*(stringsValue: Types.StringHandle; whichString: INTEGER);
	EXTERNAL PASCAL;
PROCEDURE LMGetLvl2DT*(vectorNumber: INTEGER): Types.UniversalProcPtr;
	EXTERNAL PASCAL;
PROCEDURE LMSetLvl2DT*(Lvl2DTValue: Types.UniversalProcPtr; vectorNumber: INTEGER);
	EXTERNAL PASCAL;
PROCEDURE LMGetExtStsDT*(vectorNumber: INTEGER): Types.UniversalProcPtr;
	EXTERNAL PASCAL;
PROCEDURE LMSetExtStsDT*(ExtStsDTValue: Types.UniversalProcPtr; vectorNumber: INTEGER);
	EXTERNAL PASCAL;
(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END LowMem.
