(*
 	File:		Notification.mod
 
 	Contains:	Notification Manager interfaces
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE Notification;

IMPORT SYSTEM, Types, OSUtils;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)
	
TYPE
	NMRecPtr* = POINTER TO NMRec;

	NMProcPtr* = (*Types.ProcPtr;*) PROCEDURE (nmReqPtr: NMRecPtr);
	NMUPP* = Types.UniversalProcPtr;

	NMRec* = RECORD
		qLink*:					OSUtils.QElemPtr;								(* next queue entry*)
		qType*:					INTEGER;								(* queue type -- ORD(nmType)* = 8*)
		nmFlags*:				INTEGER;								(* reserved*)
		nmPrivate*:				LONGINT;								(* reserved*)
		nmReserved*:				INTEGER;								(* reserved*)
		nmMark*:					INTEGER;								(* item to mark in Apple menu*)
		nmIcon*:					Types.Handle;									(* handle to small icon*)
		nmSound*:				Types.Handle;									(* handle to sound record*)
		nmStr*:					Types.StringPtr;								(* string to appear in alert*)
		nmResp*:					NMUPP;									(* pointer to response routine*)
		nmRefCon*:				LONGINT;								(* for application use*)
	END;

CONST
	uppNMProcInfo* = $000000C0; (* PROCEDURE (4 byte param); *)

PROCEDURE CallNMProc*(nmReqPtr: NMRecPtr; userRoutine: NMUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE NewNMProc*(userRoutine: NMProcPtr): NMUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NMInstall*(nmReqPtr: NMRecPtr): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $A05E, $3E80;
	(*$END*)
PROCEDURE NMRemove*(nmReqPtr: NMRecPtr): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $A05F, $3E80;
	(*$END*)
(* ------------------ *)

(* $ALIGN RESET*)
(* $POP*)

 END Notification.
