(*
 	File:		OCEStandardDirectory.mod
 
 	Contains:	Apple Open Collaboration Environment Standard Directory Interfaces.
 
 	Version:	Technology:	AOCE Toolbox 1.02
 				Package:	Universal Interfaces 2.11 in MPW Prerelease on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE OCEStandardDirectory;

IMPORT SYSTEM, Types, Quickdraw, Icons, Events, Files, OCE, OCEAuthDir;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	kSDPNewPanel*				= 100;
	kSDPGetNewPanel*				= 101;
	kSDPDisposePanel*			= 102;
	kSDPHidePanel*				= 103;
	kSDPShowPanel*				= 104;
	kSDPEnablePanel*				= 105;
	kSDPUpdatePanel*				= 106;
	kSDPMovePanel*				= 107;
	kSDPSizePanel*				= 108;
	kSDPOpenSelectedItem*		= 109;
	kSDPGetPanelSelectionState*	= 110;
	kSDPGetPanelSelection*		= 111;
	kSDPSetPath*					= 112;
	kSDPPanelEvent*				= 113;
	kSDPGetPanelSelectionSize*	= 114;
	kSDPSetIdentity*				= 115;
	kSDPSelectString*			= 116;
	kSDPGetPathLength*			= 117;
	kSDPGetPath*					= 118;
	kSDPSetFocus*				= 119;
	kSDPSetPanelBalloonHelp*		= 120;
	kSDPInstallPanelBusyProc*	= 121;
	kSDPPromptForID*				= 904;
	kSDPNewFindPanel*			= 2300;
	kSDPDisposeFindPanel*		= 2301;
	kSDPStartFind*				= 2302;
	kSDPStopFind*				= 2303;
	kSDPFindPanelEvent*			= 2304;
	kSDPDrawFindPanel*			= 2305;
	kSDPShowFindPanel*			= 2306;
	kSDPHideFindPanel*			= 2307;
	kSDPMoveFindPanel*			= 2308;
	kSDPEnableFindPanel*			= 2309;
	kSDPSetFindPanelFocus*		= 2310;
	kSDPGetFindPanelState*		= 2311;
	kSDPGetFindPanelSelectionSize* = 2312;
	kSDPGetFindPanelSelection*	= 2313;
	kSDPSetFindPanelBalloonHelp*	= 2314;
	kSDPSetFindIdentity*			= 2315;
	kSDPInstallFindPanelBusyProc* = 2316;
	kSDPGetIconByType*			= 1024;
	kSDPGetDSSpecIcon*			= 1025;
	kSDPGetCategories*			= 1026;
	kSDPGetCategoryTypes*		= 1027;
	kSDPResolveAliasFile*		= 3700;
	kSDPResolveAliasDSSpec*		= 3701;
	kSDPRepairPersonalDirectory*	= 6700;
(* Collaboration Package Gestalts. *)
	gestaltSDPStandardDirectoryVersion* = LONG("sdvr");
	gestaltSDPFindVersion*		= LONG("dfnd");
	gestaltSDPPromptVersion*		= LONG("prpv");

	genericDirectoryIconResource* = -16721;						(* icl8, icl4, ICN#, ics#, ics4, ics8, sicn  *)
	genericLockedDirectoryIconResource* = -16716;				(* icl8, icl4, ICN#, ics#, ics4, ics8, sicn  *)
	genericRecordIconResource*	= -16722;						(* icl8, icl4, ICN#, ics#, ics4, ics8, sicn  *)
	genericAttributeIconResource* = -16723;						(* icl8, icl4, ICN#, ics#, ics4, ics8, sicn  *)
	genericTemplateIconResource*	= -16746;						(* icl8, icl4, ICN#, ics#, ics4, ics8 *)

(* standard icon suites *)
	directoryFolderIconResource*	= -16720;						(* icl8, icl4, ICN#, ics#, ics4, ics8, sicn  *)
	lockedDirectoryFolderIconResource* = -16719;					(* icl8, icl4, ICN#, ics#, ics4, ics8, sicn  *)
	personalDirectoryIconResource* = -16718;						(* icl8, icl4, ICN#, ics#, ics4, ics8, sicn  *)
	directoriesIconResource*		= -16717;						(* icl8, icl4, ICN#, ics#, ics4, ics8, sicn  *)
	preferredPersonalDirectoryIconResource* = -16724;			(* icl8, icl4, ICN#, ics#, ics4, ics8, sicn  *)

(* icon IDs for spinning arrows *)
	kFirstSpinnerIcon*			= -16745;
	kLastSpinnerIcon*			= -16738;

(* resource types *)
	kSDPPanelResourceType*		= LONG("panl");
	kSDPFindPanelResourceType*	= LONG("find");

(* Standard FindPanel resource *)
	kStandardFindLayout*			= -16700;

(* Prompt For Identity structures *)
	kSDPGuestBit*				= 0;
	kSDPSpecificIdentityBit*		= 1;
	kSDPLocalIdentityBit*		= 2;

(* Values of SDPIdentityKind *)
	kSDPGuestMask*				= ASH(1,kSDPGuestBit);
	kSDPSpecificIdentityMask*	= ASH(1,kSDPSpecificIdentityBit);
	kSDPLocalIdentityMask*		= ASH(1,kSDPLocalIdentityBit);

	
TYPE
	SDPIdentityKind* = INTEGER;


CONST
	kSDPSuggestionOnly*			= 0;
	kSDPRestrictToDirectory*		= 1;
	kSDPRestrictToRecord*		= 2;

	
TYPE
	SDPLoginFilterKind* = INTEGER;

(* Panel Structures *)
(*
While the panel is in operation, four selection states may exist.
	1) kSDPNothingSelected means nothing is selected.
	2) kContainSelected means a volume, folder, catalog, dnode, or PAB is selected.
	3) kSDPLockedContainerSelected means one of the above, but no access privledges.
	4) kSDPRecordSelected means that a record is currently selected.
*)
(* Values of SDPSelectionState *)

CONST
	kSDPNothingSelected*			= 0;
	kSDPLockedContainerSelected*	= 1;
	kSDPContainerSelected*		= 2;
	kSDPRecordSelected*			= 3;
	kSDPRecordAliasSelected*		= 4;
	kSDPContainerAliasSelected*	= 5;

	
TYPE
	SDPSelectionState* = INTEGER;

(*
This type informs the caller of the action the user took, either as the result
of an event (as returned by SDPPanelEvent) or when SDPOpenSelectedItem is called.

kSDPProcessed means that the event (or call to SDPOpenSelectedItem) resulted in no
state change.

kSDPSelectedAnItem indicates that the user wants to select the currently-hilited
record. This is returned, for example, when a user double-clicks on a record.

kSDPChangedSelection implies that the user clicked on a new item (which may mean
that no item is selected).
*)
(* Values of SDPPanelState *)

CONST
	kSDPProcessed*				= 0;
	kSDPSelectedAnItem*			= 1;
	kSDPChangedSelection*		= 2;

	
TYPE
	SDPPanelState* = INTEGER;

(*
Your application may read any of the fields in a SDPPanelRecord, but it should
use the appropriate routines to make changes to the records with the exception
of the refCon field which your application may read or write at will.  Private
information follows the SDPPanelRecord, so the handle must not be re-sized.
*)
	SDPPanelRecord* = RECORD
		bounds*:					Types.Rect;
		visible*:				BOOLEAN;
		enabled*:				BOOLEAN;
		focused*:				BOOLEAN;
		padByte*:				Types.SInt8; (* Types.Byte *)
		identity*:				OCEAuthDir.AuthIdentity;
		refCon*:					LONGINT;
		listRect*:				Types.Rect;
		popupRect*:				Types.Rect;
		numberOfRows*:			INTEGER;
		rowHeight*:				INTEGER;
		pabMode*:				BOOLEAN;
		filler1*:				BOOLEAN;
	END;

	SDPPanelPtr* = POINTER TO SDPPanelRecord;
	SDPPanelHandle* = HANDLE TO SDPPanelRecord (* POINTER TO SDPPanelPtr*);

	PanelBusyProcPtr* = (*Types.ProcPtr;*) PROCEDURE (Panel: SDPPanelHandle; busy: BOOLEAN);
	PanelBusyUPP* = Types.UniversalProcPtr;

CONST
	uppPanelBusyProcInfo* = $000001C0; (* PROCEDURE (4 byte param, 1 byte param); *)

PROCEDURE NewPanelBusyProc*(userRoutine: PanelBusyProcPtr): PanelBusyUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallPanelBusyProc*(Panel: SDPPanelHandle; busy: BOOLEAN; userRoutine: PanelBusyUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)
	
TYPE
	PanelBusyProc* = PanelBusyUPP;

(* Find Panel Structures *)

CONST
	kSDPItemIsSelectedBit*		= 0;
	kSDPFindTextExistsBit*		= 1;

(* Values of SDPFindPanelState *)
	kSDPItemIsSelectedMask*		= ASH(1,kSDPItemIsSelectedBit);
	kSDPFindTextExistsMask*		= ASH(1,kSDPFindTextExistsBit);

	
TYPE
	SDPFindPanelState* = INTEGER;

(* Values of SDPFindPanelFocus *)

CONST
	kSDPFindPanelNoFocus*		= 0;
	kSDPFindPanelListHasFocus*	= 1;
	kSDPFindPanelTextHasFocus*	= 2;

	
TYPE
	SDPFindPanelFocus* = INTEGER;

	SDPFindPanelRecord* = RECORD
		upperLeft*:				Types.Point;
		visible*:				BOOLEAN;
		enabled*:				BOOLEAN;
		nowFinding*:				BOOLEAN;
		padByte*:				Types.SInt8; (* Types.Byte *)
		currentFocus*:			SDPFindPanelFocus;
		identity*:				OCEAuthDir.AuthIdentity;
		simultaneousSearchCount*: INTEGER;
		refCon*:					LONGINT;
	END;

	SDPFindPanelPtr* = POINTER TO SDPFindPanelRecord;
	SDPFindPanelHandle* = HANDLE TO SDPFindPanelRecord(*POINTER TO SDPFindPanelPtr*);

(* Values of SDPFindPanelResult *)

CONST
	kSDPSelectedAFindItem*		= 0;
	kSDPFindSelectionChanged*	= 1;
	kSDPFindCompleted*			= 2;
	kSDPTextStateChanged*		= 3;
	kSDPFocusChanged*			= 4;
	kSDPSelectionAndFocusChanged* = 5;
	kSDPMenuChanged*				= 6;
	kSDPSelectionAndMenuChanged*	= 7;
	kSDPProcessedFind*			= 8;

	
TYPE
	SDPFindPanelResult* = INTEGER;

	PackedRStringListHandle* = HANDLE TO OCE.PackedPathName (* POINTER TO PackedPathNamePtr*);

	PackedDSSpecHandle* = HANDLE TO OCE.PackedDSSpec (* POINTER TO PackedDSSpecPtr*);

	FindPanelBusyProcPtr* = (*Types.ProcPtr;*) PROCEDURE (findPanel: SDPFindPanelHandle; busy: BOOLEAN);
	FindPanelBusyUPP* = Types.UniversalProcPtr;

CONST
	uppFindPanelBusyProcInfo* = $000001C0; (* PROCEDURE (4 byte param, 1 byte param); *)

PROCEDURE NewFindPanelBusyProc*(userRoutine: FindPanelBusyProcPtr): FindPanelBusyUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallFindPanelBusyProc*(findPanel: SDPFindPanelHandle; busy: BOOLEAN; userRoutine: FindPanelBusyUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)
	
TYPE
	FindPanelBusyProc* = FindPanelBusyUPP;

(* Prompt For Identity Routines *)

PROCEDURE SDPPromptForID*(VAR id: OCEAuthDir.AuthIdentity; guestPrompt: Types.ConstStr255Param; specificIDPrompt: Types.ConstStr255Param; localIDPrompt: Types.ConstStr255Param; (*CONST*)VAR recordType: OCE.RString; permittedKinds: SDPIdentityKind; VAR selectedKind: SDPIdentityKind; (*CONST*)VAR loginFilter: OCE.RecordID; filterKind: SDPLoginFilterKind): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 16, 904, $AA5D;
	(*$END*)
(*
SDPNewPanel creates a new panel. You supply the window in which the panel
is to live, the bounds for the panel (which includes both the menu and the list),
whether or not the panel is to be initially visible, the initial RLI (nil for
catalogs and volumes), the types of records that will be shown (only a single
(non-nil) type which may contain wildcards), the identity by which to browse
(for access control reasons), and a refCon which is  available to the caller.
*)
PROCEDURE SDPNewPanel*(VAR newPanel: SDPPanelHandle; window: Quickdraw.WindowPtr; (*CONST*)VAR bounds: Types.Rect; visible: BOOLEAN; enabled: BOOLEAN; (*CONST*)VAR initialRLI: OCE.PackedRLI; (*CONST*)VAR typesList: OCE.RStringPtr; typeCount: LONGINT; identity: OCEAuthDir.AuthIdentity; enumFlags: OCEAuthDir.DirEnumChoices; matchTypeHow: Types.ByteParameter; refCon: LONGINT): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 21, 100, $AA5D;
	(*$END*)
(*
SDPSetIdentity Sets the identity used for browsing.  NOTE*: This call is likely to go
away if the new authentication scheme works.
*)
PROCEDURE SDPSetIdentity*(panel: SDPPanelHandle; identity: OCEAuthDir.AuthIdentity): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 115, $AA5D;
	(*$END*)
(*
SDPGetNewPanel is similar to SDPNewPanel above, except it takes a resource id of a
LONG("panl") resource.
*)
PROCEDURE SDPGetNewPanel*(VAR newPanel: SDPPanelHandle; resourceID: INTEGER; window: Quickdraw.WindowPtr; (*CONST*)VAR initialRLI: OCE.PackedRLI; identity: OCEAuthDir.AuthIdentity): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 9, 101, $AA5D;
	(*$END*)
(*
Call this when you're completely done with a panel. It deallocates all of the
associated data structures.
*)
PROCEDURE SDPDisposePanel*(panel: SDPPanelHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 2, 102, $AA5D;
	(*$END*)
(*
If the panel is visible, it makes it invisible by hiding the menu, turning off
drawing of the list, and erasing and  invaling the list's rectangle.
*)
PROCEDURE SDPHidePanel*(panel: SDPPanelHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 2, 103, $AA5D;
	(*$END*)
(* If the panel is invisible, it makes it visible and draws it. *)
PROCEDURE SDPShowPanel*(panel: SDPPanelHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 2, 104, $AA5D;
	(*$END*)
(* Disables the list and menu so that it won't accept any commands. *)
PROCEDURE SDPEnablePanel*(panel: SDPPanelHandle; enable: BOOLEAN): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 3, 105, $AA5D;
	(*$END*)
(*
Move the upper-left-hand corner of the panel to (h,v), given in local coordinates of
the panel's window.
*)
PROCEDURE SDPMovePanel*(panel: SDPPanelHandle; h: INTEGER; v: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 107, $AA5D;
	(*$END*)
(*
Resizes the panel to have the given width and height (keeping the upper-left-hand
corner in a fixed position).
*)
PROCEDURE SDPSizePanel*(panel: SDPPanelHandle; width: INTEGER; height: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 108, $AA5D;
	(*$END*)
(*
This routine simulates a double-click on the selected item (if there is no selected
item, then it does nothing), and it returns the result of that "double-click" via the
whatHappened parameter. If a container is selected, then that container will be
opened and kMovedDownTheHierarchy is returned. If, however, the user is at the lowest
level in the hierarchy, then kSDPSelectedAnItem is returned.
*)
PROCEDURE SDPOpenSelectedItem*(panel: SDPPanelHandle; VAR whatHappened: SDPPanelState): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 109, $AA5D;
	(*$END*)
(*
Returns whether a record is selected, something else is selected, or nothing is
selected.
*)
PROCEDURE SDPGetPanelSelectionState*(panel: SDPPanelHandle; VAR itsState: SDPSelectionState): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 110, $AA5D;
	(*$END*)
(*
Returns the size of the currently-selected DSSpec, or zero if a record is
not selected.  It is safe to do a NewPtr (SDPGetPanelSelectionSize (...))
*)
PROCEDURE SDPGetPanelSelectionSize*(panel: SDPPanelHandle; VAR dsSpecSize: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 114, $AA5D;
	(*$END*)
(*
Returns the currently-selected DSSpec, or a zero-lengthed
DSSpec if a record is not selected. It is assumed that the selection
buffer allocated is large enough.
*)
PROCEDURE SDPGetPanelSelection*(panel: SDPPanelHandle; VAR selection: OCE.PackedDSSpec): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 111, $AA5D;
	(*$END*)
(*
Forces browsing to the specified RLI. If prli is the current RLI, then it does
nothing.
*)
PROCEDURE SDPSetPath*(panel: SDPPanelHandle; (*CONST*)VAR prli: OCE.PackedRLI): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 112, $AA5D;
	(*$END*)
(*
This is the main driver for the panel.  You should pass all events to SDPPanelEvent
including NULL events.  If you have more than 1 panel, you will need to
call SDPPanelEvent for each panel.  NOTE:  For Update Events you will also need to call
SDPUpdatePanel as described below.
*)
PROCEDURE SDPPanelEvent*(panel: SDPPanelHandle; (*CONST*)VAR theEvent: Events.EventRecord; VAR whatHappened: SDPPanelState): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 6, 113, $AA5D;
	(*$END*)
(*
SDPUpdatePanel should be called in response to an update event.  Generally you will
have first called BeginUpdate, and pass the windows visRgn as theRgn.  If NULL
is passed for theRgn the entire panel is re-drawn.  NOTE:  Drawing is not cliped to
theRgn, if this is desired, you must first call SetClip.
*)
PROCEDURE SDPUpdatePanel*(panel: SDPPanelHandle; theRgn: Quickdraw.RgnHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 106, $AA5D;
	(*$END*)
(*
SDPSelectString scrolls and selects the closest matching string at the current
level.  This is the same behavior as if the user typed in the given string.
*)
PROCEDURE SDPSelectString*(panel: SDPPanelHandle; (*CONST*)VAR name: OCE.RString): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 116, $AA5D;
	(*$END*)
(*
SDPGetPathLength returns the length in bytes required to hold the current path name
in RLI format.  This corresponds to the path name in the popup menu.
*)
PROCEDURE SDPGetPathLength*(panel: SDPPanelHandle; VAR pathNameLength: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 117, $AA5D;
	(*$END*)
(* SDPGetPath returns the current rli. *)
PROCEDURE SDPGetPath*(panel: SDPPanelHandle; VAR prli: OCE.PackedRLI; VAR dsRefNum: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 6, 118, $AA5D;
	(*$END*)
(*
SDPSetFocus will draw the focus rectangle or erase the focus rectangle depending upon
the focus boolean.
*)
PROCEDURE SDPSetFocus*(panel: SDPPanelHandle; focus: BOOLEAN): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 3, 119, $AA5D;
	(*$END*)
(*
SDPSetPanelBalloonHelp allows clients to specify a STR# resource id to use for 
balloon help.  Balloon help is unavailable until this call is made.
*)
PROCEDURE SDPSetPanelBalloonHelp*(panel: SDPPanelHandle; balloonHelpID: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 3, 120, $AA5D;
	(*$END*)
(*
SDPInstallPanelBusyProc allows clients to install a CB that will be called while
the panel is aynchronously busy.
*)
PROCEDURE SDPInstallPanelBusyProc*(panel: SDPPanelHandle; busyProc: PanelBusyProc): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 121, $AA5D;
	(*$END*)
PROCEDURE SDPNewFindPanel*(VAR newPanel: SDPFindPanelHandle; window: Quickdraw.WindowPtr; upperLeft: Types.Point; layoutResourceID: INTEGER; visible: BOOLEAN; enabled: BOOLEAN; (*CONST*)VAR typesList: OCE.RStringPtr; typeCount: LONGINT; matchTypeHow: Types.ByteParameter; identity: OCEAuthDir.AuthIdentity; simultaneousSearchCount: INTEGER; initialFocus: SDPFindPanelFocus; refCon: LONGINT): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 20, 2300, $AA5D;
	(*$END*)
PROCEDURE SDPDisposeFindPanel*(findPanel: SDPFindPanelHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 2, 2301, $AA5D;
	(*$END*)
PROCEDURE SDPStartFind*(findPanel: SDPFindPanelHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 2, 2302, $AA5D;
	(*$END*)
PROCEDURE SDPStopFind*(findPanel: SDPFindPanelHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 2, 2303, $AA5D;
	(*$END*)
PROCEDURE SDPFindPanelEvent*(findPanel: SDPFindPanelHandle; (*CONST*)VAR event: Events.EventRecord; VAR whatHappened: SDPFindPanelResult): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 6, 2304, $AA5D;
	(*$END*)
PROCEDURE SDPUpdateFindPanel*(findPanel: SDPFindPanelHandle; theRgn: Quickdraw.RgnHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 2305, $AA5D;
	(*$END*)
PROCEDURE SDPShowFindPanel*(findPanel: SDPFindPanelHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 2, 2306, $AA5D;
	(*$END*)
PROCEDURE SDPHideFindPanel*(findPanel: SDPFindPanelHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 2, 2307, $AA5D;
	(*$END*)
PROCEDURE SDPMoveFindPanel*(findPanel: SDPFindPanelHandle; h: INTEGER; v: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 2308, $AA5D;
	(*$END*)
PROCEDURE SDPEnableFindPanel*(findPanel: SDPFindPanelHandle; enabled: BOOLEAN): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 3, 2309, $AA5D;
	(*$END*)
PROCEDURE SDPSetFindPanelFocus*(findPanel: SDPFindPanelHandle; newFocus: SDPFindPanelFocus): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 3, 2310, $AA5D;
	(*$END*)
PROCEDURE SDPGetFindPanelState*(findPanel: SDPFindPanelHandle; VAR itsState: SDPFindPanelState): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 2311, $AA5D;
	(*$END*)
PROCEDURE SDPGetFindPanelSelectionSize*(findPanel: SDPFindPanelHandle; VAR size: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 2312, $AA5D;
	(*$END*)
PROCEDURE SDPGetFindPanelSelection*(findPanel: SDPFindPanelHandle; VAR selection: OCE.PackedDSSpec): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 2313, $AA5D;
	(*$END*)
PROCEDURE SDPSetFindPanelBalloonHelp*(findPanel: SDPFindPanelHandle; balloonHelpID: INTEGER): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 3, 2314, $AA5D;
	(*$END*)
PROCEDURE SDPSetFindIdentity*(findPanel: SDPFindPanelHandle; identity: OCEAuthDir.AuthIdentity): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 2315, $AA5D;
	(*$END*)
PROCEDURE SDPInstallFindPanelBusyProc*(findPanel: SDPFindPanelHandle; busyProc: FindPanelBusyProc): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 4, 2316, $AA5D;
	(*$END*)
PROCEDURE SDPGetIconByType*((*CONST*)VAR recordType: OCE.RString; whichIcons: Icons.IconSelectorValue; VAR iconSuite: Types.Handle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, 1024, $AA5C;
	(*$END*)
PROCEDURE SDPGetDSSpecIcon*((*CONST*)VAR packedDSSpec: OCE.PackedDSSpec; whichIcons: Icons.IconSelectorValue; VAR iconSuite: Types.Handle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, 1025, $AA5C;
	(*$END*)
PROCEDURE SDPGetCategories*(VAR categories: PackedRStringListHandle; VAR displayNames: PackedRStringListHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, 1026, $AA5C;
	(*$END*)
PROCEDURE SDPGetCategoryTypes*((*CONST*)VAR category: OCE.RString; VAR types: PackedRStringListHandle): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $303C, 1027, $AA5C;
	(*$END*)
PROCEDURE SDPResolveAliasFile*(fileSpec: Files.FSSpecPtr; resolvedDSSpec: PackedDSSpecHandle; identity: OCEAuthDir.AuthIdentity; mayPromptUser: BOOLEAN): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 7, 3700, $AA5D;
	(*$END*)
PROCEDURE SDPResolveAliasDSSpec*(theAliasDSSpec: PackedDSSpecHandle; identity: OCEAuthDir.AuthIdentity; mayPromptUser: BOOLEAN): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 5, 3701, $AA5D;
	(*$END*)
PROCEDURE SDPRepairPersonalDirectory*(VAR pd: Files.FSSpec; showProgress: BOOLEAN): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, 3, 6700, $AA5D;
	(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END OCEStandardDirectory.
