(*
	File:		ObjIntf.mod

	Copyright:	 1983-1993 by Apple Computer, Inc.
				All rights reserved.

	Version:	System 7.1 for ETO #11
	Created:	Tuesday, March 30, 1993 18:00

*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE ObjIntf;

IMPORT SYSTEM;

TYPE
	TObject* = POINTER TO TObjectRec;
	TObjectRec* = RECORD END;

PROCEDURE (obj:TObject) ShallowClone*(): TObject;
	EXTERNAL; (**)
	(*Lowest level method for copying an object; should not be overridden
		except in very unusual cases.  Simply calls HandToHand to copy
		the object data.*)

PROCEDURE (obj:TObject) Clone*(): TObject;
	EXTERNAL; (**)
	(*Defaults to calling ShallowClone; can be overridden to copy objects
		refered to by fields.*)

PROCEDURE (obj:TObject) ShallowFree*;
	EXTERNAL; (**)
	(*Lowest level method for freeing an object; should not be overridden
		except in very unusual cases.  Simply calls DisposHandle to
		free the object data.*)

PROCEDURE (obj:TObject) Free*;
	EXTERNAL; (**)
	(*Defaults to calling ShallowFree; can be overridden to free objects 
		refered to by fields.*)

 END ObjIntf.
