(*
 	File:		QDOffscreen.mod
 
 	Contains:	QuickDraw Offscreen GWorld Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE QDOffscreen;

IMPORT SYSTEM, Types, Quickdraw;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	pixPurgeBit*					= 0;
	noNewDeviceBit*				= 1;
	useTempMemBit*				= 2;
	keepLocalBit*				= 3;
	pixelsPurgeableBit*			= 6;
	pixelsLockedBit*				= 7;
	mapPixBit*					= 16;
	newDepthBit*					= 17;
	alignPixBit*					= 18;
	newRowBytesBit*				= 19;
	reallocPixBit*				= 20;
	clipPixBit*					= 28;
	stretchPixBit*				= 29;
	ditherPixBit*				= 30;
	gwFlagErrBit*				= 31;

	pixPurge*					= ASH(1,pixPurgeBit);
	noNewDevice*					= ASH(1,noNewDeviceBit);
	useTempMem*					= ASH(1,useTempMemBit);
	keepLocal*					= ASH(1,keepLocalBit);
	pixelsPurgeable*				= ASH(1,pixelsPurgeableBit);
	pixelsLocked*				= ASH(1,pixelsLockedBit);
	mapPix*						= ASH(1,mapPixBit);
	newDepth*					= ASH(1,newDepthBit);
	alignPix*					= ASH(1,alignPixBit);
	newRowBytes*					= ASH(1,newRowBytesBit);
	reallocPix*					= ASH(1,reallocPixBit);
	clipPix*						= ASH(1,clipPixBit);
	stretchPix*					= ASH(1,stretchPixBit);
	ditherPix*					= ASH(1,ditherPixBit);
	gwFlagErr*					= ASH(1,gwFlagErrBit);

	
TYPE
	GWorldFlags* = LONGINT;

(* Type definition of a GWorldPtr *)
	GWorldPtr* = Quickdraw.CGrafPtr;


PROCEDURE NewGWorld*(VAR offscreenGWorld: GWorldPtr; PixelDepth: INTEGER; (*CONST*)VAR boundsRect: Types.Rect; cTable: Quickdraw.CTabHandle; aGDevice: Quickdraw.GDHandle; flags: GWorldFlags): Quickdraw.QDErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0016, $0000, $AB1D;
	(*$END*)
PROCEDURE LockPixels*(pm: Quickdraw.PixMapHandle): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $0001, $AB1D;
	(*$END*)
PROCEDURE UnlockPixels*(pm: Quickdraw.PixMapHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $0002, $AB1D;
	(*$END*)
PROCEDURE UpdateGWorld*(VAR offscreenGWorld: GWorldPtr; pixelDepth: INTEGER; (*CONST*)VAR boundsRect: Types.Rect; cTable: Quickdraw.CTabHandle; aGDevice: Quickdraw.GDHandle; flags: GWorldFlags): GWorldFlags;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0016, $0003, $AB1D;
	(*$END*)
PROCEDURE DisposeGWorld*(offscreenGWorld: GWorldPtr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $0004, $AB1D;
	(*$END*)
PROCEDURE GetGWorld*(VAR port: Quickdraw.CGrafPtr; VAR gdh: Quickdraw.GDHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0008, $0005, $AB1D;
	(*$END*)
PROCEDURE SetGWorld*(port: Quickdraw.CGrafPtr; gdh: Quickdraw.GDHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0008, $0006, $AB1D;
	(*$END*)
PROCEDURE CTabChanged*(ctab: Quickdraw.CTabHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $0007, $AB1D;
	(*$END*)
PROCEDURE PixPatChanged*(ppat: Quickdraw.PixPatHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $0008, $AB1D;
	(*$END*)
PROCEDURE PortChanged*(port: Quickdraw.GrafPtr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $0009, $AB1D;
	(*$END*)
PROCEDURE GDeviceChanged*(gdh: Quickdraw.GDHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $000A, $AB1D;
	(*$END*)
PROCEDURE AllowPurgePixels*(pm: Quickdraw.PixMapHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $000B, $AB1D;
	(*$END*)
PROCEDURE NoPurgePixels*(pm: Quickdraw.PixMapHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $000C, $AB1D;
	(*$END*)
PROCEDURE GetPixelsState*(pm: Quickdraw.PixMapHandle): GWorldFlags;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $000D, $AB1D;
	(*$END*)
PROCEDURE SetPixelsState*(pm: Quickdraw.PixMapHandle; state: GWorldFlags);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0008, $000E, $AB1D;
	(*$END*)
PROCEDURE GetPixBaseAddr*(pm: Quickdraw.PixMapHandle): Types.Ptr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $000F, $AB1D;
	(*$END*)
PROCEDURE NewScreenBuffer*((*CONST*)VAR globalRect: Types.Rect; purgeable: BOOLEAN; VAR gdh: Quickdraw.GDHandle; VAR offscreenPixMap: Quickdraw.PixMapHandle): Quickdraw.QDErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $000E, $0010, $AB1D;
	(*$END*)
PROCEDURE DisposeScreenBuffer*(offscreenPixMap: Quickdraw.PixMapHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $0011, $AB1D;
	(*$END*)
PROCEDURE GetGWorldDevice*(offscreenGWorld: GWorldPtr): Quickdraw.GDHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $0012, $AB1D;
	(*$END*)
PROCEDURE QDDone*(port: Quickdraw.GrafPtr): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $0013, $AB1D;
	(*$END*)
PROCEDURE OffscreenVersion*(): LONGINT;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $7014, $AB1D;
	(*$END*)
PROCEDURE NewTempScreenBuffer*((*CONST*)VAR globalRect: Types.Rect; purgeable: BOOLEAN; VAR gdh: Quickdraw.GDHandle; VAR offscreenPixMap: Quickdraw.PixMapHandle): Quickdraw.QDErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $000E, $0015, $AB1D;
	(*$END*)
PROCEDURE PixMap32Bit*(pmHandle: Quickdraw.PixMapHandle): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $0016, $AB1D;
	(*$END*)
PROCEDURE GetGWorldPixMap*(offscreenGWorld: GWorldPtr): Quickdraw.PixMapHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $203C, $0004, $0017, $AB1D;
	(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END QDOffscreen.
