(*
 	File:		Quickdraw.mod
 
 	Contains:	QuickDraw Graphics Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$IF UNDEFINED OLDROUTINELOCATIONS*)
  (*$SET OLDROUTINELOCATIONS FALSE*)
(*$END*)
(*$IF UNDEFINED OLDROUTINENAMES*)
  (*$SET OLDROUTINENAMES FALSE*)
(*$END*)
(*$IF UNDEFINED SystemSevenFiveOrLater *)
  (*$SET SystemSevenFiveOrLater FALSE*)
(*$END*)
(*$IF UNDEFINED SystemSevenOrLater *)
  (*$IF GENERATINGCFM *)
    (*$SET SystemSevenOrLater TRUE*)
  (*$ELSE*)
    (*$SET SystemSevenOrLater SystemSevenFiveOrLater*)
  (*$END*)
(*$END*)
(*$IF UNDEFINED SystemSixOrLater *)
  (*$SET SystemSixOrLater SystemSevenOrLater*)
(*$END*)
(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE Quickdraw;

IMPORT SYSTEM, Types, QuickdrawText;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	invalColReq*					= -1;							(*invalid color table request*)
(* transfer modes *)
	srcCopy*						= 0;							(*the 16 transfer modes*)
	srcOr*						= 1;
	srcXor*						= 2;
	srcBic*						= 3;
	notSrcCopy*					= 4;
	notSrcOr*					= 5;
	notSrcXor*					= 6;
	notSrcBic*					= 7;
	patCopy*						= 8;
	patOr*						= 9;
	patXor*						= 10;
	patBic*						= 11;
	notPatCopy*					= 12;
	notPatOr*					= 13;
	notPatXor*					= 14;
	notPatBic*					= 15;
(* Special Text Transfer Mode *)
	grayishTextOr*				= 49;
	hilitetransfermode*			= 50;
(* Arithmetic transfer modes *)
	blend*						= 32;
	addPin*						= 33;

	addOver*						= 34;
	subPin*						= 35;
	addMax*						= 37;
	adMax*						= 37;
	subOver*						= 38;
	adMin*						= 39;
	ditherCopy*					= 64;
(* Transparent mode constant *)
	transparent*					= 36;
	italicBit*					= 1;
	ulineBit*					= 2;
	outlineBit*					= 3;
	shadowBit*					= 4;
	condenseBit*					= 5;
	extendBit*					= 6;
(* QuickDraw color separation constants *)
	normalBit*					= 0;							(*normal screen mapping*)
	inverseBit*					= 1;							(*inverse screen mapping*)
	redBit*						= 4;							(*RGB additive mapping*)
	greenBit*					= 3;
	blueBit*						= 2;
	cyanBit*						= 8;							(*CMYBk subtractive mapping*)
	magentaBit*					= 7;
	yellowBit*					= 6;
	blackBit*					= 5;
	blackColor*					= 33;							(*colors expressed in these mappings*)
	whiteColor*					= 30;
	redColor*					= 205;

	greenColor*					= 341;
	blueColor*					= 409;
	cyanColor*					= 273;
	magentaColor*				= 137;
	yellowColor*					= 69;
	picLParen*					= 0;							(*standard picture comments*)
	picRParen*					= 1;
	clutType*					= 0;							(*0 if lookup table*)
	fixedType*					= 1;							(*1 if fixed table*)
	directType*					= 2;							(*2 if direct values*)
	gdDevType*					= 0;							(*0* = monochrome 1* = color*)

	roundedDevice*				= 5;							(* 1 if device has been rounded into the GrayRgn *)
	hasAuxMenuBar*				= 6;							(* 1 if device has an aux menu bar on it *)
	burstDevice*					= 7;
	ext32Device*					= 8;
	ramInit*						= 10;							(*1 if initialized from LONG("scrn") resource*)
	mainScreen*					= 11;							(* 1 if main screen *)
	allInit*						= 12;							(* 1 if all devices initialized *)
	screenDevice*				= 13;							(*1 if screen device [not used]*)
	noDriver*					= 14;							(* 1 if no driver for this GDevice *)
	screenActive*				= 15;							(*1 if in use*)
	hiliteBit*					= 7;							(*flag bit in HiliteMode (lowMem flag)*)
	pHiliteBit*					= 0;							(*flag bit in HiliteMode used with BitClr procedure*)
	defQDColors*					= 127;							(*resource AIFF.ID of clut for default QDColors*)
(* pixel type *)
	RGBDirect*					= 16;							(* 16 & 32 bits/pixel pixelType value *)
(* pmVersion values *)
	baseAddr32*					= 4;							(*pixmap base address is 32-bit address*)

	frame*						= 0;
	paint*						= 1;
	erase*						= 2;
	invert*						= 3;
	fill*						= 4;

	
TYPE
	GrafVerb* = Types.SInt8;


CONST
	chunky*						= 0;
	chunkyPlanar*				= 1;
	planar*						= 2;

	
TYPE
	PixelType* = Types.SInt8;

	Bits16* = ARRAY 16 (*[0..15]*) OF INTEGER;

(***************   IMPORTANT NOTE REGARDING Pattern  **************************************
   Patterns were originally defined as*:
   
		C*: 			typedef unsigned char Pattern[8];
		Pascal*:		Pattern* = (*PACKED*) ARRAY [0..7] OF 0..255;
		
   The old array defintion of Pattern would cause 68000 based CPU's to crash in certain circum-
   stances. The new struct definition is safe, but may require source code changes to compile.
   Read the details in TechNote "Platforms & Tools" #PT 38.
	
*********************************************************************************************)
	Pattern* = RECORD
		pat*:					(* (*PACKED*)*) ARRAY 8 (*[0..7]*) OF Types.SInt8; (* UInt8 *)
	END;

(*
 ConstPatternParam is now longer needed.  It was first created when Pattern was an array.
 Now that Pattern is a struct, it is more straight forward just add the "const" qualifier
 on the parameter type (e.g. "const Pattern * pat" instead of "ConstPatternParam pat").
*)
	PatPtr* = POINTER TO Pattern;

	PatHandle* = HANDLE TO Pattern (* POINTER TO PatPtr*);

	QDByte* = Types.SignedByte;

	QDPtr* = Types.Ptr;

	QDHandle* = Types.Handle;

	QDErr* = INTEGER;


CONST
	singleDevicesBit*			= 0;
	dontMatchSeedsBit*			= 1;
	allDevicesBit*				= 2;

	singleDevices*				= ASH(1,singleDevicesBit);
	dontMatchSeeds*				= ASH(1,dontMatchSeedsBit);
	allDevices*					= ASH(1,allDevicesBit);

	
TYPE
	DeviceLoopFlags* = LONGINT;

	BitMap* = RECORD
		baseAddr*:				Types.Ptr;
		rowBytes*:				INTEGER;
		bounds*:					Types.Rect;
	END;

	BitMapPtr* = POINTER TO BitMap;
	BitMapHandle* = HANDLE TO BitMap (*POINTER TO BitMapPtr*);

	Cursor* = RECORD
		data*:					Bits16;
		mask*:					Bits16;
		hotSpot*:				Types.Point;
	END;

	CursPtr* = POINTER TO Cursor;
	CursHandle* = HANDLE TO Cursor (*POINTER TOCursPtr*);

	PenState* = RECORD
		pnLoc*:					Types.Point;
		pnSize*:					Types.Point;
		pnMode*:					INTEGER;
		pnPat*:					Pattern;
	END;

	Region* = RECORD
		rgnSize*:				INTEGER;								(*size in bytes*)
		rgnBBox*:				Types.Rect;									(*enclosing rectangle*)
	END;

	RgnPtr* = POINTER TO Region;
	RgnHandle* = HANDLE TO Region (*POINTER TORgnPtr*);

	Picture* = RECORD
		picSize*:				INTEGER;
		picFrame*:				Types.Rect;
	END;

	PicPtr* = POINTER TO Picture;
	PicHandle* = HANDLE TO Picture (*POINTER TO PicPtr*);

	Polygon* = RECORD
		polySize*:				INTEGER;
		polyBBox*:				Types.Rect;
		polyPoints*:				ARRAY 1 (*[0..0]*) OF Types.Point;
	END;

	PolyPtr* = POINTER TO Polygon;
	PolyHandle* = HANDLE TO Polygon (* POINTER TO PolyPtr*);

	QDTextProcPtr* = (*Types.ProcPtr;*) PROCEDURE (byteCount: INTEGER; textBuf: Types.Ptr; numer: Types.Point; denom: Types.Point);
	QDLineProcPtr* = (*Types.ProcPtr;*) PROCEDURE (newPt: Types.Point);
	QDRectProcPtr* = (*Types.ProcPtr;*) PROCEDURE (verb: Types.ByteParameter; VAR r: Types.Rect);
	QDRRectProcPtr* = (*Types.ProcPtr;*) PROCEDURE (verb: Types.ByteParameter; VAR r: Types.Rect; ovalWidth: INTEGER; ovalHeight: INTEGER);
	QDOvalProcPtr* = (*Types.ProcPtr;*) PROCEDURE (verb: Types.ByteParameter; VAR r: Types.Rect);
	QDArcProcPtr* = (*Types.ProcPtr;*) PROCEDURE (verb: Types.ByteParameter; VAR r: Types.Rect; startAngle: INTEGER; arcAngle: INTEGER);
	QDPolyProcPtr* = (*Types.ProcPtr;*) PROCEDURE (verb: Types.ByteParameter; poly: PolyHandle);
	QDRgnProcPtr* = (*Types.ProcPtr;*) PROCEDURE (verb: Types.ByteParameter; rgn: RgnHandle);
	QDBitsProcPtr* = (*Types.ProcPtr;*) PROCEDURE (VAR srcBits: BitMap; VAR srcRect: Types.Rect; VAR dstRect: Types.Rect; mode: INTEGER; maskRgn: RgnHandle);
	QDCommentProcPtr* = (*Types.ProcPtr;*) PROCEDURE (kind: INTEGER; dataSize: INTEGER; dataHandle: Types.Handle);
	QDTxMeasProcPtr* = (*Types.ProcPtr;*) PROCEDURE (byteCount: INTEGER; textAddr: Types.Ptr; VAR numer: Types.Point; VAR denom: Types.Point; VAR info: QuickdrawText.FontInfo): INTEGER;
	QDGetPicProcPtr* = (*Types.ProcPtr;*) PROCEDURE (dataPtr: Types.Ptr; byteCount: INTEGER);
	QDPutPicProcPtr* = (*Types.ProcPtr;*) PROCEDURE (dataPtr: Types.Ptr; byteCount: INTEGER);
	QDOpcodeProcPtr* = (*Types.ProcPtr;*) PROCEDURE (VAR fromRect: Types.Rect; VAR toRect: Types.Rect; opcode: INTEGER; version: INTEGER);
	QDJShieldCursorProcPtr* = (*Types.ProcPtr;*) PROCEDURE (left: INTEGER; top: INTEGER; right: INTEGER; bottom: INTEGER);
	QDTextUPP* = Types.UniversalProcPtr;
	QDLineUPP* = Types.UniversalProcPtr;
	QDRectUPP* = Types.UniversalProcPtr;
	QDRRectUPP* = Types.UniversalProcPtr;
	QDOvalUPP* = Types.UniversalProcPtr;
	QDArcUPP* = Types.UniversalProcPtr;
	QDPolyUPP* = Types.UniversalProcPtr;
	QDRgnUPP* = Types.UniversalProcPtr;
	QDBitsUPP* = Types.UniversalProcPtr;
	QDCommentUPP* = Types.UniversalProcPtr;
	QDTxMeasUPP* = Types.UniversalProcPtr;
	QDGetPicUPP* = Types.UniversalProcPtr;
	QDPutPicUPP* = Types.UniversalProcPtr;
	QDOpcodeUPP* = Types.UniversalProcPtr;
	QDJShieldCursorUPP* = Types.UniversalProcPtr;

	QDProcs* = RECORD
		textProc*:				QDTextUPP;
		lineProc*:				QDLineUPP;
		rectProc*:				QDRectUPP;
		rRectProc*:				QDRRectUPP;
		ovalProc*:				QDOvalUPP;
		arcProc*:				QDArcUPP;
		polyProc*:				QDPolyUPP;
		rgnProc*:				QDRgnUPP;
		bitsProc*:				QDBitsUPP;
		commentProc*:			QDCommentUPP;
		txMeasProc*:				QDTxMeasUPP;
		getPicProc*:				QDGetPicUPP;
		putPicProc*:				QDPutPicUPP;
	END;

	QDProcsPtr* = POINTER TO QDProcs;

CONST
	uppQDTextProcInfo* = $00003F80; (* PROCEDURE (2 byte param, 4 byte param, 4 byte param, 4 byte param); *)
	uppQDLineProcInfo* = $000000C0; (* PROCEDURE (4 byte param); *)
	uppQDRectProcInfo* = $00000340; (* PROCEDURE (1 byte param, 4 byte param); *)
	uppQDRRectProcInfo* = $00002B40; (* PROCEDURE (1 byte param, 4 byte param, 2 byte param, 2 byte param); *)
	uppQDOvalProcInfo* = $00000340; (* PROCEDURE (1 byte param, 4 byte param); *)
	uppQDArcProcInfo* = $00002B40; (* PROCEDURE (1 byte param, 4 byte param, 2 byte param, 2 byte param); *)
	uppQDPolyProcInfo* = $00000340; (* PROCEDURE (1 byte param, 4 byte param); *)
	uppQDRgnProcInfo* = $00000340; (* PROCEDURE (1 byte param, 4 byte param); *)
	uppQDBitsProcInfo* = $0000EFC0; (* PROCEDURE (4 byte param, 4 byte param, 4 byte param, 2 byte param, 4 byte param); *)
	uppQDCommentProcInfo* = $00000E80; (* PROCEDURE (2 byte param, 2 byte param, 4 byte param); *)
	uppQDTxMeasProcInfo* = $0000FFA0; (* PROCEDURE (2 byte param, 4 byte param, 4 byte param, 4 byte param, 4 byte param): 2 byte result; *)
	uppQDGetPicProcInfo* = $000002C0; (* PROCEDURE (4 byte param, 2 byte param); *)
	uppQDPutPicProcInfo* = $000002C0; (* PROCEDURE (4 byte param, 2 byte param); *)
	uppQDOpcodeProcInfo* = $00002BC0; (* PROCEDURE (4 byte param, 4 byte param, 2 byte param, 2 byte param); *)
	uppQDJShieldCursorProcInfo* = $00002A80; (* PROCEDURE (2 byte param, 2 byte param, 2 byte param, 2 byte param); *)

PROCEDURE NewQDTextProc*(userRoutine: QDTextProcPtr): QDTextUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDLineProc*(userRoutine: QDLineProcPtr): QDLineUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDRectProc*(userRoutine: QDRectProcPtr): QDRectUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDRRectProc*(userRoutine: QDRRectProcPtr): QDRRectUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDOvalProc*(userRoutine: QDOvalProcPtr): QDOvalUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDArcProc*(userRoutine: QDArcProcPtr): QDArcUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDPolyProc*(userRoutine: QDPolyProcPtr): QDPolyUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDRgnProc*(userRoutine: QDRgnProcPtr): QDRgnUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDBitsProc*(userRoutine: QDBitsProcPtr): QDBitsUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDCommentProc*(userRoutine: QDCommentProcPtr): QDCommentUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDTxMeasProc*(userRoutine: QDTxMeasProcPtr): QDTxMeasUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDGetPicProc*(userRoutine: QDGetPicProcPtr): QDGetPicUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDPutPicProc*(userRoutine: QDPutPicProcPtr): QDPutPicUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDOpcodeProc*(userRoutine: QDOpcodeProcPtr): QDOpcodeUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewQDJShieldCursorProc*(userRoutine: QDJShieldCursorProcPtr): QDJShieldCursorUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallQDTextProc*(byteCount: INTEGER; textBuf: Types.Ptr; numer: Types.Point; denom: Types.Point; userRoutine: QDTextUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDLineProc*(newPt: Types.Point; userRoutine: QDLineUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDRectProc*(verb: Types.ByteParameter; VAR r: Types.Rect; userRoutine: QDRectUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDRRectProc*(verb: Types.ByteParameter; VAR r: Types.Rect; ovalWidth: INTEGER; ovalHeight: INTEGER; userRoutine: QDRRectUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDOvalProc*(verb: Types.ByteParameter; VAR r: Types.Rect; userRoutine: QDOvalUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDArcProc*(verb: Types.ByteParameter; VAR r: Types.Rect; startAngle: INTEGER; arcAngle: INTEGER; userRoutine: QDArcUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDPolyProc*(verb: Types.ByteParameter; poly: PolyHandle; userRoutine: QDPolyUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDRgnProc*(verb: Types.ByteParameter; rgn: RgnHandle; userRoutine: QDRgnUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDBitsProc*(VAR srcBits: BitMap; VAR srcRect: Types.Rect; VAR dstRect: Types.Rect; mode: INTEGER; maskRgn: RgnHandle; userRoutine: QDBitsUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDCommentProc*(kind: INTEGER; dataSize: INTEGER; dataHandle: Types.Handle; userRoutine: QDCommentUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDTxMeasProc*(byteCount: INTEGER; textAddr: Types.Ptr; VAR numer: Types.Point; VAR denom: Types.Point; VAR info: QuickdrawText.FontInfo; userRoutine: QDTxMeasUPP): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDGetPicProc*(dataPtr: Types.Ptr; byteCount: INTEGER; userRoutine: QDGetPicUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDPutPicProc*(dataPtr: Types.Ptr; byteCount: INTEGER; userRoutine: QDPutPicUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDOpcodeProc*(VAR fromRect: Types.Rect; VAR toRect: Types.Rect; opcode: INTEGER; version: INTEGER; userRoutine: QDOpcodeUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallQDJShieldCursorProc*(left: INTEGER; top: INTEGER; right: INTEGER; bottom: INTEGER; userRoutine: QDJShieldCursorUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

TYPE
	GrafPort* = RECORD
		device*:					INTEGER;
		portBits*:				BitMap;
		portRect*:				Types.Rect;
		visRgn*:					RgnHandle;
		clipRgn*:				RgnHandle;
		bkPat*:					Pattern;
		fillPat*:				Pattern;
		pnLoc*:					Types.Point;
		pnSize*:					Types.Point;
		pnMode*:					INTEGER;
		pnPat*:					Pattern;
		pnVis*:					INTEGER;
		txFont*:					INTEGER;
		txFace*:					Types.Style;									(*txFace is unpacked byte but push as short*)
		txMode*:					INTEGER;
		txSize*:					INTEGER;
		spExtra*:				Types.Fixed;
		fgColor*:				LONGINT;
		bkColor*:				LONGINT;
		colrBit*:				INTEGER;
		patStretch*:				INTEGER;
		picSave*:				Types.Handle;
		rgnSave*:				Types.Handle;
		polySave*:				Types.Handle;
		grafProcs*:				QDProcsPtr;
	END;

	GrafPtr* = POINTER TO GrafPort;

(*
 *	This set of definitions "belongs" in Windows.
 *	But, there is a circularity in the headers where Windows includes Controls and
 *	Controls includes Windows. To break the circle, the information
 *	needed by Controls is moved from Windows to 
 *)
	WindowPtr* = GrafPtr;

(*
	Set STRICT_WINDOWS to 1 to make sure your code 
	doesn't access the window record directly
*)
(*$IF UNDEFINED STRICT_WINDOWS *)
(*$SET STRICT_WINDOWS FALSE*)
(*$END*)
(*$IF STRICT_WINDOWS *)
	WindowRef* = Types.Ptr;

(*$ELSE*)
	WindowRef* = WindowPtr;

(*$END*)
	DragConstraint* = Types.UInt16;


CONST
	kNoConstraint*				= 0;
	kVerticalConstraint*			= 1;
	kHorizontalConstraint*		= 2;

(*
 *	Here ends the list of things that "belong" in Windows.
 *)

TYPE
	RGBColor* = RECORD
		red*:					INTEGER;								(*magnitude of red component*)
		green*:					INTEGER;								(*magnitude of green component*)
		blue*:					INTEGER;								(*magnitude of blue component*)
	END;

	RGBColorPtr* = POINTER TO RGBColor;
	RGBColorHdl* = HANDLE TO RGBColor (* POINTER TO RGBColorPtr*);

	DragGrayRgnProcPtr* = (*Types.ProcPtr;*) PROCEDURE ;
	ColorSearchProcPtr* = (*Types.ProcPtr;*) PROCEDURE (VAR rgb: RGBColor; VAR position: LONGINT): BOOLEAN;
	ColorComplementProcPtr* = (*Types.ProcPtr;*) PROCEDURE (VAR rgb: RGBColor): BOOLEAN;
	DragGrayRgnUPP* = Types.UniversalProcPtr;
	ColorSearchUPP* = Types.UniversalProcPtr;
	ColorComplementUPP* = Types.UniversalProcPtr;

CONST
	uppDragGrayRgnProcInfo* = $00000000; (* PROCEDURE ; *)
	uppColorSearchProcInfo* = $000003D0; (* PROCEDURE (4 byte param, 4 byte param): 1 byte result; *)
	uppColorComplementProcInfo* = $000000D0; (* PROCEDURE (4 byte param): 1 byte result; *)

PROCEDURE NewDragGrayRgnProc*(userRoutine: DragGrayRgnProcPtr): DragGrayRgnUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewColorSearchProc*(userRoutine: ColorSearchProcPtr): ColorSearchUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewColorComplementProc*(userRoutine: ColorComplementProcPtr): ColorComplementUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallDragGrayRgnProc*(userRoutine: DragGrayRgnUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallColorSearchProc*(VAR rgb: RGBColor; VAR position: LONGINT; userRoutine: ColorSearchUPP): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallColorComplementProc*(VAR rgb: RGBColor; userRoutine: ColorComplementUPP): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

TYPE
	ColorSpec* = RECORD
		value*:					INTEGER;								(*index or other value*)
		rgb*:					RGBColor;								(*true color*)
	END;

	ColorSpecPtr* = POINTER TO ColorSpec;

	CSpecArray* = ARRAY 1 (*[0..0]*) OF ColorSpec;

	xColorSpec* = RECORD
		value*:					INTEGER;								(*index or other value*)
		rgb*:					RGBColor;								(*true color*)
		xalpha*:					INTEGER;
	END;

	xColorSpecPtr* = POINTER TO xColorSpec;

	xCSpecArray* = ARRAY 1 (*[0..0]*) OF xColorSpec;

	ColorTable* = RECORD
		ctSeed*:					LONGINT;								(*unique identifier for table*)
		ctFlags*:				INTEGER;								(*high bit*: 0* = PixMap; 1* = device*)
		ctSize*:					INTEGER;								(*number of entries in CTTable*)
		ctTable*:				CSpecArray;								(*array [0..0] of ColorSpec*)
	END;

	CTabPtr* = POINTER TO ColorTable;
	CTabHandle* = HANDLE TO ColorTable (* POINTER TO CTabPtr*);

	MatchRec* = RECORD
		red*:					INTEGER;
		green*:					INTEGER;
		blue*:					INTEGER;
		matchData*:				LONGINT;
	END;

	PixMap* = RECORD
		baseAddr*:				Types.Ptr;									(*pointer to pixels*)
		rowBytes*:				INTEGER;								(*offset to next line*)
		bounds*:					Types.Rect;									(*encloses bitmap*)
		pmVersion*:				INTEGER;								(*pixMap version number*)
		packType*:				INTEGER;								(*defines packing format*)
		packSize*:				LONGINT;								(*length of pixel data*)
		hRes*:					Types.Fixed;									(*horiz. resolution (ppi)*)
		vRes*:					Types.Fixed;									(*vert. resolution (ppi)*)
		pixelType*:				INTEGER;								(*defines pixel type*)
		pixelSize*:				INTEGER;								(*# bits in pixel*)
		cmpCount*:				INTEGER;								(*# components in pixel*)
		cmpSize*:				INTEGER;								(*# bits per component*)
		planeBytes*:				LONGINT;								(*offset to next plane*)
		pmTable*:				CTabHandle;								(*color map for this pixMap*)
		pmReserved*:				LONGINT;								(*for future use. MUST BE 0*)
	END;

	PixMapPtr* = POINTER TO PixMap;
	PixMapHandle* = HANDLE TO PixMap (* POINTER TO PixMapPtr*);

	PixPat* = RECORD
		patType*:				INTEGER;								(*type of pattern*)
		patMap*:					PixMapHandle;							(*the pattern's pixMap*)
		patData*:				Types.Handle;									(*pixmap's data*)
		patXData*:				Types.Handle;									(*expanded Pattern data*)
		patXValid*:				INTEGER;								(*flags whether expanded Pattern valid*)
		patXMap*:				Types.Handle;									(*Types.Handle to expanded Pattern data*)
		pat1Data*:				Pattern;								(*old-Types.Style pattern/RGB color*)
	END;

	PixPatPtr* = POINTER TO PixPat;
	PixPatHandle* = HANDLE TO PixPat (* POINTER TO PixPatPtr*);

	CCrsr* = RECORD
		crsrType*:				INTEGER;								(*type of cursor*)
		crsrMap*:				PixMapHandle;							(*the cursor's pixmap*)
		crsrData*:				Types.Handle;									(*cursor's data*)
		crsrXData*:				Types.Handle;									(*expanded cursor data*)
		crsrXValid*:				INTEGER;								(*depth of expanded data (0 if none)*)
		crsrXHandle*:			Types.Handle;									(*future use*)
		crsr1Data*:				Bits16;									(*one-bit cursor*)
		crsrMask*:				Bits16;									(*cursor's mask*)
		crsrHotSpot*:			Types.Point;									(*cursor's hotspot*)
		crsrXTable*:				LONGINT;								(*private*)
		crsrID*:					LONGINT;								(*private*)
	END;

	CCrsrPtr* = POINTER TO CCrsr;
	CCrsrHandle* = HANDLE TO CCrsr (* POINTER TO CCrsrPtr*);

(*$IF OLDROUTINELOCATIONS *)
	CIcon* = RECORD
		iconPMap*:				PixMap;									(*the icon's pixMap*)
		iconMask*:				BitMap;									(*the icon's mask*)
		iconBMap*:				BitMap;									(*the icon's bitMap*)
		iconData*:				Types.Handle;									(*the icon's data*)
		iconMaskData*:			ARRAY 1 (*[0..0]*) OF INTEGER;				(*icon's mask and BitMap data*)
	END;

	CIconPtr* = POINTER TO CIcon;
	CIconHandle* = HANDLE TO CIcon (* POINTER TO CIconPtr*);

(*$END*)
	GammaTbl* = RECORD
		gVersion*:				INTEGER;								(*gamma version number*)
		gType*:					INTEGER;								(*gamma data type*)
		gFormulaSize*:			INTEGER;								(*Formula data size*)
		gChanCnt*:				INTEGER;								(*number of channels of data*)
		gDataCnt*:				INTEGER;								(*number of values/channel*)
		gDataWidth*:				INTEGER;								(*bits/corrected value (data packed to next larger byte size)*)
		gFormulaData*:			ARRAY 1 (*[0..0]*) OF INTEGER;				(*data for formulas followed by gamma values*)
	END;

	GammaTblPtr* = POINTER TO GammaTbl;
	GammaTblHandle* = HANDLE TO GammaTbl (* POINTER TO GammaPtr*);

	ITab* = RECORD
		iTabSeed*:				LONGINT;								(*copy of CTSeed from source CTable*)
		iTabRes*:				INTEGER;								(*bits/channel resolution of iTable*)
		iTTable*:				ARRAY 1 (*[0..0]*) OF Types.SInt8; (* Types.Byte *)		(*byte colortable index values*)
	END;

	ITabPtr* = POINTER TO ITab;
	ITabHandle* = HANDLE TO ITab (* POINTER TO ITabPtr*);

	SProcRec* = RECORD
		nxtSrch*:				Types.Handle;									(*SProcHndl Types.Handle to next SProcRec*)
		srchProc*:				ColorSearchUPP;							(*search procedure proc* ptr*)
	END;

	SProcPtr* = POINTER TO SProcRec;
	SProcHndl* = HANDLE TO SProcRec (* POINTER TO SProcPtr*);

	CProcRec* = RECORD
		nxtComp*:				Types.Handle;									(*CProcHndl Types.Handle to next CProcRec*)
		compProc*:				ColorComplementUPP;						(*complement procedure proc* ptr*)
	END;

	CProcPtr* = POINTER TO CProcRec;
	CProcHndl* = HANDLE TO CProcRec (* POINTER TO CProcPtr*);

	GDevice* = RECORD
		gdRefNum*:				INTEGER;								(*driver's unit number*)
		gdID*:					INTEGER;								(*client AIFF.ID for search procs*)
		gdType*:					INTEGER;								(*fixed/CLUT/direct*)
		gdITable*:				ITabHandle;								(*Types.Handle to inverse lookup table*)
		gdResPref*:				INTEGER;								(*preferred resolution of GDITable*)
		gdSearchProc*:			SProcHndl;								(*search proc list head*)
		gdCompProc*:				CProcHndl;								(*complement proc list*)
		gdFlags*:				INTEGER;								(*grafDevice flags word*)
		gdPMap*:					PixMapHandle;							(*describing pixMap*)
		gdRefCon*:				LONGINT;								(*reference value*)
		gdNextGD*:				Types.Handle;									(*GDHandle Types.Handle of next gDevice*)
		gdRect*:					Types.Rect;									(* device's bounds in global coordinates*)
		gdMode*:					LONGINT;								(*device's current mode*)
		gdCCBytes*:				INTEGER;								(*depth of expanded cursor data*)
		gdCCDepth*:				INTEGER;								(*depth of expanded cursor data*)
		gdCCXData*:				Types.Handle;									(*Types.Handle to cursor's expanded data*)
		gdCCXMask*:				Types.Handle;									(*Types.Handle to cursor's expanded mask*)
		gdReserved*:				LONGINT;								(*future use. MUST BE 0*)
	END;

	GDPtr* = POINTER TO GDevice;
	GDHandle* = HANDLE TO GDevice (* POINTER TO GDPtr*);

	GrafVars* = RECORD
		rgbOpColor*:				RGBColor;								(*color for addPin  subPin and average*)
		rgbHiliteColor*:			RGBColor;								(*color for hiliting*)
		pmFgColor*:				Types.Handle;									(*palette Types.Handle for foreground color*)
		pmFgIndex*:				INTEGER;								(*index value for foreground*)
		pmBkColor*:				Types.Handle;									(*palette Types.Handle for background color*)
		pmBkIndex*:				INTEGER;								(*index value for background*)
		pmFlags*:				INTEGER;								(*flags for Palettes.Palette Manager*)
	END;

	GVarPtr* = POINTER TO GrafVars;
	GVarHandle* = HANDLE TO GrafVars (* POINTER TO GVarPtr*);

	CQDProcs* = RECORD
		textProc*:				QDTextUPP;
		lineProc*:				QDLineUPP;
		rectProc*:				QDRectUPP;
		rRectProc*:				QDRRectUPP;
		ovalProc*:				QDOvalUPP;
		arcProc*:				QDArcUPP;
		polyProc*:				QDPolyUPP;
		rgnProc*:				QDRgnUPP;
		bitsProc*:				QDBitsUPP;
		commentProc*:			QDCommentUPP;
		txMeasProc*:				QDTxMeasUPP;
		getPicProc*:				QDGetPicUPP;
		putPicProc*:				QDPutPicUPP;
		opcodeProc*:				QDOpcodeUPP;							(*fields added to QDProcs*)
		newProc1*:				Types.UniversalProcPtr;
		newProc2*:				Types.UniversalProcPtr;
		newProc3*:				Types.UniversalProcPtr;
		newProc4*:				Types.UniversalProcPtr;
		newProc5*:				Types.UniversalProcPtr;
		newProc6*:				Types.UniversalProcPtr;
	END;

	CQDProcsPtr* = POINTER TO CQDProcs;

	CGrafPort* = RECORD
		device*:					INTEGER;
		portPixMap*:				PixMapHandle;							(*port's pixel map*)
		portVersion*:			INTEGER;								(*high 2 bits always set*)
		grafVars*:				Types.Handle;									(*Types.Handle to more fields*)
		chExtra*:				INTEGER;								(*character extra*)
		pnLocHFrac*:				INTEGER;								(*pen fraction*)
		portRect*:				Types.Rect;
		visRgn*:					RgnHandle;
		clipRgn*:				RgnHandle;
		bkPixPat*:				PixPatHandle;							(*background pattern*)
		rgbFgColor*:				RGBColor;								(*RGB components of fg*)
		rgbBkColor*:				RGBColor;								(*RGB components of bk*)
		pnLoc*:					Types.Point;
		pnSize*:					Types.Point;
		pnMode*:					INTEGER;
		pnPixPat*:				PixPatHandle;							(*pen's pattern*)
		fillPixPat*:				PixPatHandle;							(*fill pattern*)
		pnVis*:					INTEGER;
		txFont*:					INTEGER;
		txFace*:					Types.Style;									(*txFace is unpacked byte  push as short*)
		txMode*:					INTEGER;
		txSize*:					INTEGER;
		spExtra*:				Types.Fixed;
		fgColor*:				LONGINT;
		bkColor*:				LONGINT;
		colrBit*:				INTEGER;
		patStretch*:				INTEGER;
		picSave*:				Types.Handle;
		rgnSave*:				Types.Handle;
		polySave*:				Types.Handle;
		grafProcs*:				CQDProcsPtr;
	END;

	CGrafPtr* = POINTER TO CGrafPort;

	CWindowPtr* = CGrafPtr;

	ReqListRec* = RECORD
		reqLSize*:				INTEGER;								(*request list size*)
		reqLData*:				ARRAY 1 (*[0..0]*) OF INTEGER;				(*request list data*)
	END;

	OpenCPicParams* = RECORD
		srcRect*:				Types.Rect;
		hRes*:					Types.Fixed;
		vRes*:					Types.Fixed;
		version*:				INTEGER;
		reserved1*:				INTEGER;
		reserved2*:				LONGINT;
	END;

	CursorImageRec* = RECORD
		majorVersion*:			Types.UInt16;
		minorVersion*:			Types.UInt16;
		cursorPixMap*:			PixMapHandle;
		cursorBitMask*:			BitMapHandle;
	END;

	CursorImagePtr* = POINTER TO CursorImageRec;

	DeviceLoopDrawingProcPtr* = (*Types.ProcPtr;*) PROCEDURE (depth: INTEGER; deviceFlags: INTEGER; targetDevice: GDHandle; userData: LONGINT);
	DeviceLoopDrawingUPP* = Types.UniversalProcPtr;

CONST
	uppDeviceLoopDrawingProcInfo* = $00003E80; (* PROCEDURE (2 byte param, 2 byte param, 4 byte param, 4 byte param); *)

PROCEDURE NewDeviceLoopDrawingProc*(userRoutine: DeviceLoopDrawingProcPtr): DeviceLoopDrawingUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallDeviceLoopDrawingProc*(depth: INTEGER; deviceFlags: INTEGER; targetDevice: GDHandle; userData: LONGINT; userRoutine: DeviceLoopDrawingUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

TYPE
	QDGlobals* = RECORD
		privates*:				(*PACKED*) ARRAY 76 (*[0..75]*) OF CHAR;
		randSeed*:				LONGINT;
		screenBits*:				BitMap;
		arrow*:					Cursor;
		dkGray*:					Pattern;
		ltGray*:					Pattern;
		gray*:					Pattern;
		black*:					Pattern;
		white*:					Pattern;
		thePort*:				GrafPtr;
	END;

	QDGlobalsPtr* = POINTER TO QDGlobals;
	QDGlobalsHdl* = HANDLE TO QDGlobals (* POINTER TO QDGlobalsPtr*);


(* To be in sync with the C interface to QuickDraw globals, pascal code must now *)
(* qualify the QuickDraw globals with qd. (e.g. InitGraf(.qd.thePort);  )       *)
VAR
	(*$PUSH*)
	(*$J+*)
	qd*: QDGlobals;
	(*$POP*)

PROCEDURE InitGraf*(globalPtr: (* (*UNIV*)*) Types.Ptr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A86E;
	(*$END*)
PROCEDURE OpenPort*(port: GrafPtr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A86F;
	(*$END*)
PROCEDURE InitPort*(port: GrafPtr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A86D;
	(*$END*)
PROCEDURE ClosePort*(port: GrafPtr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A87D;
	(*$END*)
PROCEDURE SetPort*(port: GrafPtr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A873;
	(*$END*)
PROCEDURE GetPort*(VAR port: GrafPtr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A874;
	(*$END*)
PROCEDURE GrafDevice*(device: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A872;
	(*$END*)
PROCEDURE SetPortBits*((*CONST*)VAR bm: BitMap);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A875;
	(*$END*)
PROCEDURE PortSize*(width: INTEGER; height: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A876;
	(*$END*)
PROCEDURE MovePortTo*(leftGlobal: INTEGER; topGlobal: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A877;
	(*$END*)
PROCEDURE SetOrigin*(h: INTEGER; v: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A878;
	(*$END*)
PROCEDURE SetClip*(rgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A879;
	(*$END*)
PROCEDURE GetClip*(rgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A87A;
	(*$END*)
PROCEDURE ClipRect*((*CONST*)VAR r: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A87B;
	(*$END*)
PROCEDURE BackPat*((*CONST*)VAR pat: Pattern);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A87C;
	(*$END*)
PROCEDURE InitCursor*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A850;
	(*$END*)
PROCEDURE SetCursor*((*CONST*)VAR crsr: Cursor);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A851;
	(*$END*)
PROCEDURE HideCursor*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A852;
	(*$END*)
PROCEDURE ShowCursor*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A853;
	(*$END*)
PROCEDURE ObscureCursor*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A856;
	(*$END*)
PROCEDURE HidePen*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A896;
	(*$END*)
PROCEDURE ShowPen*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A897;
	(*$END*)
PROCEDURE GetPen*(VAR pt: Types.Point);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A89A;
	(*$END*)
PROCEDURE GetPenState*(VAR pnState: PenState);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A898;
	(*$END*)
PROCEDURE SetPenState*((*CONST*)VAR pnState: PenState);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A899;
	(*$END*)
PROCEDURE PenSize*(width: INTEGER; height: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A89B;
	(*$END*)
PROCEDURE PenMode*(mode: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A89C;
	(*$END*)
PROCEDURE PenPat*((*CONST*)VAR pat: Pattern);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A89D;
	(*$END*)
PROCEDURE PenNormal*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A89E;
	(*$END*)
PROCEDURE MoveTo*(h: INTEGER; v: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A893;
	(*$END*)
PROCEDURE Move*(dh: INTEGER; dv: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A894;
	(*$END*)
PROCEDURE LineTo*(h: INTEGER; v: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A891;
	(*$END*)
PROCEDURE Line*(dh: INTEGER; dv: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A892;
	(*$END*)
PROCEDURE ForeColor*(color: LONGINT);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A862;
	(*$END*)
PROCEDURE BackColor*(color: LONGINT);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A863;
	(*$END*)
PROCEDURE ColorBit*(whichBit: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A864;
	(*$END*)
PROCEDURE SetRect*(VAR r: Types.Rect; left: INTEGER; top: INTEGER; right: INTEGER; bottom: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8A7;
	(*$END*)
PROCEDURE OffsetRect*(VAR r: Types.Rect; dh: INTEGER; dv: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8A8;
	(*$END*)
PROCEDURE InsetRect*(VAR r: Types.Rect; dh: INTEGER; dv: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8A9;
	(*$END*)
PROCEDURE SectRect*((*CONST*)VAR src1: Types.Rect; (*CONST*)VAR src2: Types.Rect; VAR dstRect: Types.Rect): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8AA;
	(*$END*)
PROCEDURE UnionRect*((*CONST*)VAR src1: Types.Rect; (*CONST*)VAR src2: Types.Rect; VAR dstRect: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8AB;
	(*$END*)
PROCEDURE EqualRect*((*CONST*)VAR rect1: Types.Rect; (*CONST*)VAR rect2: Types.Rect): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8A6;
	(*$END*)
PROCEDURE EmptyRect*((*CONST*)VAR r: Types.Rect): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8AE;
	(*$END*)
PROCEDURE FrameRect*((*CONST*)VAR r: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8A1;
	(*$END*)
PROCEDURE PaintRect*((*CONST*)VAR r: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8A2;
	(*$END*)
PROCEDURE EraseRect*((*CONST*)VAR r: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8A3;
	(*$END*)
PROCEDURE InvertRect*((*CONST*)VAR r: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8A4;
	(*$END*)
PROCEDURE FillRect*((*CONST*)VAR r: Types.Rect; (*CONST*)VAR pat: Pattern);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8A5;
	(*$END*)
PROCEDURE FrameOval*((*CONST*)VAR r: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8B7;
	(*$END*)
PROCEDURE PaintOval*((*CONST*)VAR r: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8B8;
	(*$END*)
PROCEDURE EraseOval*((*CONST*)VAR r: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8B9;
	(*$END*)
PROCEDURE InvertOval*((*CONST*)VAR r: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8BA;
	(*$END*)
PROCEDURE FillOval*((*CONST*)VAR r: Types.Rect; (*CONST*)VAR pat: Pattern);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8BB;
	(*$END*)
PROCEDURE FrameRoundRect*((*CONST*)VAR r: Types.Rect; ovalWidth: INTEGER; ovalHeight: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8B0;
	(*$END*)
PROCEDURE PaintRoundRect*((*CONST*)VAR r: Types.Rect; ovalWidth: INTEGER; ovalHeight: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8B1;
	(*$END*)
PROCEDURE EraseRoundRect*((*CONST*)VAR r: Types.Rect; ovalWidth: INTEGER; ovalHeight: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8B2;
	(*$END*)
PROCEDURE InvertRoundRect*((*CONST*)VAR r: Types.Rect; ovalWidth: INTEGER; ovalHeight: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8B3;
	(*$END*)
PROCEDURE FillRoundRect*((*CONST*)VAR r: Types.Rect; ovalWidth: INTEGER; ovalHeight: INTEGER; (*CONST*)VAR pat: Pattern);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8B4;
	(*$END*)
PROCEDURE FrameArc*((*CONST*)VAR r: Types.Rect; startAngle: INTEGER; arcAngle: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8BE;
	(*$END*)
PROCEDURE PaintArc*((*CONST*)VAR r: Types.Rect; startAngle: INTEGER; arcAngle: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8BF;
	(*$END*)
PROCEDURE EraseArc*((*CONST*)VAR r: Types.Rect; startAngle: INTEGER; arcAngle: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8C0;
	(*$END*)
PROCEDURE InvertArc*((*CONST*)VAR r: Types.Rect; startAngle: INTEGER; arcAngle: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8C1;
	(*$END*)
PROCEDURE FillArc*((*CONST*)VAR r: Types.Rect; startAngle: INTEGER; arcAngle: INTEGER; (*CONST*)VAR pat: Pattern);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8C2;
	(*$END*)
PROCEDURE NewRgn*(): RgnHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8D8;
	(*$END*)
PROCEDURE OpenRgn*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8DA;
	(*$END*)
PROCEDURE CloseRgn*(dstRgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8DB;
	(*$END*)
(*$IF NOT SystemSevenOrLater *)
PROCEDURE BitMapToRegionGlue*(region: RgnHandle; (*CONST*)VAR bMap: BitMap): Types.OSErr;
	EXTERNAL PASCAL;
(*$END*)
PROCEDURE BitMapToRegion*(region: RgnHandle; (*CONST*)VAR bMap: BitMap): Types.OSErr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8D7;
	(*$END*)
PROCEDURE DisposeRgn*(rgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8D9;
	(*$END*)
PROCEDURE CopyRgn*(srcRgn: RgnHandle; dstRgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8DC;
	(*$END*)
PROCEDURE SetEmptyRgn*(rgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8DD;
	(*$END*)
PROCEDURE SetRectRgn*(rgn: RgnHandle; left: INTEGER; top: INTEGER; right: INTEGER; bottom: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8DE;
	(*$END*)
PROCEDURE RectRgn*(rgn: RgnHandle; (*CONST*)VAR r: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8DF;
	(*$END*)
PROCEDURE OffsetRgn*(rgn: RgnHandle; dh: INTEGER; dv: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8E0;
	(*$END*)
PROCEDURE InsetRgn*(rgn: RgnHandle; dh: INTEGER; dv: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8E1;
	(*$END*)
PROCEDURE SectRgn*(srcRgnA: RgnHandle; srcRgnB: RgnHandle; dstRgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8E4;
	(*$END*)
PROCEDURE UnionRgn*(srcRgnA: RgnHandle; srcRgnB: RgnHandle; dstRgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8E5;
	(*$END*)
PROCEDURE DiffRgn*(srcRgnA: RgnHandle; srcRgnB: RgnHandle; dstRgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8E6;
	(*$END*)
PROCEDURE XorRgn*(srcRgnA: RgnHandle; srcRgnB: RgnHandle; dstRgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8E7;
	(*$END*)
PROCEDURE RectInRgn*((*CONST*)VAR r: Types.Rect; rgn: RgnHandle): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8E9;
	(*$END*)
PROCEDURE EqualRgn*(rgnA: RgnHandle; rgnB: RgnHandle): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8E3;
	(*$END*)
PROCEDURE EmptyRgn*(rgn: RgnHandle): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8E2;
	(*$END*)
PROCEDURE FrameRgn*(rgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8D2;
	(*$END*)
PROCEDURE PaintRgn*(rgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8D3;
	(*$END*)
PROCEDURE EraseRgn*(rgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8D4;
	(*$END*)
PROCEDURE InvertRgn*(rgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8D5;
	(*$END*)
PROCEDURE FillRgn*(rgn: RgnHandle; (*CONST*)VAR pat: Pattern);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8D6;
	(*$END*)
PROCEDURE ScrollRect*((*CONST*)VAR r: Types.Rect; dh: INTEGER; dv: INTEGER; updateRgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8EF;
	(*$END*)
PROCEDURE CopyBits*((*CONST*)VAR srcBits: BitMap; (*CONST*)VAR dstBits: BitMap; (*CONST*)VAR srcRect: Types.Rect; (*CONST*)VAR dstRect: Types.Rect; mode: INTEGER; maskRgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8EC;
	(*$END*)
PROCEDURE SeedFill*(srcPtr: (* (*UNIV*)*) Types.Ptr; dstPtr: (* (*UNIV*)*) Types.Ptr; srcRow: INTEGER; dstRow: INTEGER; height: INTEGER; words: INTEGER; seedH: INTEGER; seedV: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A839;
	(*$END*)
PROCEDURE CalcMask*(srcPtr: (* (*UNIV*)*) Types.Ptr; dstPtr: (* (*UNIV*)*) Types.Ptr; srcRow: INTEGER; dstRow: INTEGER; height: INTEGER; words: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A838;
	(*$END*)
PROCEDURE CopyMask*((*CONST*)VAR srcBits: BitMap; (*CONST*)VAR maskBits: BitMap; (*CONST*)VAR dstBits: BitMap; (*CONST*)VAR srcRect: Types.Rect; (*CONST*)VAR maskRect: Types.Rect; (*CONST*)VAR dstRect: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A817;
	(*$END*)
PROCEDURE OpenPicture*((*CONST*)VAR picFrame: Types.Rect): PicHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8F3;
	(*$END*)
PROCEDURE PicComment*(kind: INTEGER; dataSize: INTEGER; dataHandle: Types.Handle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8F2;
	(*$END*)
PROCEDURE ClosePicture*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8F4;
	(*$END*)
PROCEDURE DrawPicture*(myPicture: PicHandle; (*CONST*)VAR dstRect: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8F6;
	(*$END*)
PROCEDURE KillPicture*(myPicture: PicHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8F5;
	(*$END*)
PROCEDURE OpenPoly*(): PolyHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8CB;
	(*$END*)
PROCEDURE ClosePoly*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8CC;
	(*$END*)
PROCEDURE KillPoly*(poly: PolyHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8CD;
	(*$END*)
PROCEDURE OffsetPoly*(poly: PolyHandle; dh: INTEGER; dv: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8CE;
	(*$END*)
PROCEDURE FramePoly*(poly: PolyHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8C6;
	(*$END*)
PROCEDURE PaintPoly*(poly: PolyHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8C7;
	(*$END*)
PROCEDURE ErasePoly*(poly: PolyHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8C8;
	(*$END*)
PROCEDURE InvertPoly*(poly: PolyHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8C9;
	(*$END*)
PROCEDURE FillPoly*(poly: PolyHandle; (*CONST*)VAR pat: Pattern);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8CA;
	(*$END*)
PROCEDURE SetPt*(VAR pt: Types.Point; h: INTEGER; v: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A880;
	(*$END*)
PROCEDURE LocalToGlobal*(VAR pt: Types.Point);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A870;
	(*$END*)
PROCEDURE GlobalToLocal*(VAR pt: Types.Point);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A871;
	(*$END*)
PROCEDURE Random*(): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A861;
	(*$END*)
PROCEDURE StuffHex*(thingPtr: (*UNIV*) Types.Ptr; s: Types.ConstStr255Param);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A866;
	(*$END*)
PROCEDURE GetPixel*(h: INTEGER; v: INTEGER): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A865;
	(*$END*)
PROCEDURE ScalePt*(VAR pt: Types.Point; (*CONST*)VAR srcRect: Types.Rect; (*CONST*)VAR dstRect: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8F8;
	(*$END*)
PROCEDURE MapPt*(VAR pt: Types.Point; (*CONST*)VAR srcRect: Types.Rect; (*CONST*)VAR dstRect: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8F9;
	(*$END*)
PROCEDURE MapRect*(VAR r: Types.Rect; (*CONST*)VAR srcRect: Types.Rect; (*CONST*)VAR dstRect: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8FA;
	(*$END*)
PROCEDURE MapRgn*(rgn: RgnHandle; (*CONST*)VAR srcRect: Types.Rect; (*CONST*)VAR dstRect: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8FB;
	(*$END*)
PROCEDURE MapPoly*(poly: PolyHandle; (*CONST*)VAR srcRect: Types.Rect; (*CONST*)VAR dstRect: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8FC;
	(*$END*)
PROCEDURE SetStdProcs*(VAR procs: QDProcs);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8EA;
	(*$END*)
PROCEDURE StdRect*(verb: Types.ByteParameter; (*CONST*)VAR r: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8A0;
	(*$END*)
PROCEDURE StdRRect*(verb: Types.ByteParameter; (*CONST*)VAR r: Types.Rect; ovalWidth: INTEGER; ovalHeight: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8AF;
	(*$END*)
PROCEDURE StdOval*(verb: Types.ByteParameter; (*CONST*)VAR r: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8B6;
	(*$END*)
PROCEDURE StdArc*(verb: Types.ByteParameter; (*CONST*)VAR r: Types.Rect; startAngle: INTEGER; arcAngle: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8BD;
	(*$END*)
PROCEDURE StdPoly*(verb: Types.ByteParameter; poly: PolyHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8C5;
	(*$END*)
PROCEDURE StdRgn*(verb: Types.ByteParameter; rgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8D1;
	(*$END*)
PROCEDURE StdBits*((*CONST*)VAR srcBits: BitMap; (*CONST*)VAR srcRect: Types.Rect; (*CONST*)VAR dstRect: Types.Rect; mode: INTEGER; maskRgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8EB;
	(*$END*)
PROCEDURE StdComment*(kind: INTEGER; dataSize: INTEGER; dataHandle: Types.Handle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8F1;
	(*$END*)
PROCEDURE StdGetPic*(dataPtr: (* (*UNIV*)*) Types.Ptr; byteCount: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8EE;
	(*$END*)
PROCEDURE StdPutPic*(dataPtr: (* (*UNIV*)*) Types.Ptr; byteCount: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8F0;
	(*$END*)
PROCEDURE AddPt*(src: Types.Point; VAR dst: Types.Point);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A87E;
	(*$END*)
PROCEDURE EqualPt*(pt1: Types.Point; pt2: Types.Point): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A881;
	(*$END*)
PROCEDURE PtInRect*(pt: Types.Point; (*CONST*)VAR r: Types.Rect): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8AD;
	(*$END*)
PROCEDURE Pt2Rect*(pt1: Types.Point; pt2: Types.Point; VAR dstRect: Types.Rect);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8AC;
	(*$END*)
PROCEDURE PtToAngle*((*CONST*)VAR r: Types.Rect; pt: Types.Point; VAR angle: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8C3;
	(*$END*)
PROCEDURE SubPt*(src: Types.Point; VAR dst: Types.Point);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A87F;
	(*$END*)
PROCEDURE PtInRgn*(pt: Types.Point; rgn: RgnHandle): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8E8;
	(*$END*)
PROCEDURE StdLine*(newPt: Types.Point);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A890;
	(*$END*)
PROCEDURE OpenCPort*(port: CGrafPtr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA00;
	(*$END*)
PROCEDURE InitCPort*(port: CGrafPtr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA01;
	(*$END*)
PROCEDURE CloseCPort*(port: CGrafPtr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A87D;
	(*$END*)
PROCEDURE NewPixMap*(): PixMapHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA03;
	(*$END*)
PROCEDURE DisposePixMap*(pm: PixMapHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA04;
	(*$END*)
PROCEDURE CopyPixMap*(srcPM: PixMapHandle; dstPM: PixMapHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA05;
	(*$END*)
PROCEDURE NewPixPat*(): PixPatHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA07;
	(*$END*)
PROCEDURE DisposePixPat*(pp: PixPatHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA08;
	(*$END*)
PROCEDURE CopyPixPat*(srcPP: PixPatHandle; dstPP: PixPatHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA09;
	(*$END*)
PROCEDURE PenPixPat*(pp: PixPatHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA0A;
	(*$END*)
PROCEDURE BackPixPat*(pp: PixPatHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA0B;
	(*$END*)
PROCEDURE GetPixPat*(patID: INTEGER): PixPatHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA0C;
	(*$END*)
PROCEDURE MakeRGBPat*(pp: PixPatHandle; (*CONST*)VAR myColor: RGBColor);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA0D;
	(*$END*)
PROCEDURE FillCRect*((*CONST*)VAR r: Types.Rect; pp: PixPatHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA0E;
	(*$END*)
PROCEDURE FillCOval*((*CONST*)VAR r: Types.Rect; pp: PixPatHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA0F;
	(*$END*)
PROCEDURE FillCRoundRect*((*CONST*)VAR r: Types.Rect; ovalWidth: INTEGER; ovalHeight: INTEGER; pp: PixPatHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA10;
	(*$END*)
PROCEDURE FillCArc*((*CONST*)VAR r: Types.Rect; startAngle: INTEGER; arcAngle: INTEGER; pp: PixPatHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA11;
	(*$END*)
PROCEDURE FillCRgn*(rgn: RgnHandle; pp: PixPatHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA12;
	(*$END*)
PROCEDURE FillCPoly*(poly: PolyHandle; pp: PixPatHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA13;
	(*$END*)
PROCEDURE RGBForeColor*((*CONST*)VAR color: RGBColor);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA14;
	(*$END*)
PROCEDURE RGBBackColor*((*CONST*)VAR color: RGBColor);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA15;
	(*$END*)
PROCEDURE SetCPixel*(h: INTEGER; v: INTEGER; (*CONST*)VAR cPix: RGBColor);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA16;
	(*$END*)
PROCEDURE SetPortPix*(pm: PixMapHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA06;
	(*$END*)
PROCEDURE GetCPixel*(h: INTEGER; v: INTEGER; VAR cPix: RGBColor);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA17;
	(*$END*)
PROCEDURE GetForeColor*(VAR color: RGBColor);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA19;
	(*$END*)
PROCEDURE GetBackColor*(VAR color: RGBColor);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA1A;
	(*$END*)
PROCEDURE SeedCFill*((*CONST*)VAR srcBits: BitMap; (*CONST*)VAR dstBits: BitMap; (*CONST*)VAR srcRect: Types.Rect; (*CONST*)VAR dstRect: Types.Rect; seedH: INTEGER; seedV: INTEGER; matchProc: ColorSearchUPP; matchData: LONGINT);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA50;
	(*$END*)
PROCEDURE CalcCMask*((*CONST*)VAR srcBits: BitMap; (*CONST*)VAR dstBits: BitMap; (*CONST*)VAR srcRect: Types.Rect; (*CONST*)VAR dstRect: Types.Rect; (*CONST*)VAR seedRGB: RGBColor; matchProc: ColorSearchUPP; matchData: LONGINT);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA4F;
	(*$END*)
PROCEDURE OpenCPicture*((*CONST*)VAR newHeader: OpenCPicParams): PicHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA20;
	(*$END*)
PROCEDURE OpColor*((*CONST*)VAR color: RGBColor);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA21;
	(*$END*)
PROCEDURE HiliteColor*((*CONST*)VAR color: RGBColor);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA22;
	(*$END*)
PROCEDURE DisposeCTable*(cTable: CTabHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA24;
	(*$END*)
PROCEDURE GetCTable*(ctID: INTEGER): CTabHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA18;
	(*$END*)
PROCEDURE GetCCursor*(crsrID: INTEGER): CCrsrHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA1B;
	(*$END*)
PROCEDURE SetCCursor*(cCrsr: CCrsrHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA1C;
	(*$END*)
PROCEDURE AllocCursor*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA1D;
	(*$END*)
PROCEDURE DisposeCCursor*(cCrsr: CCrsrHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA26;
	(*$END*)
(*$IF OLDROUTINELOCATIONS *)
PROCEDURE GetCIcon*(iconID: INTEGER): CIconHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA1E;
	(*$END*)
PROCEDURE PlotCIcon*((*CONST*)VAR theRect: Types.Rect; theIcon: CIconHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA1F;
	(*$END*)
PROCEDURE DisposeCIcon*(theIcon: CIconHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA25;
	(*$END*)
(*$END*)
PROCEDURE SetStdCProcs*(VAR procs: CQDProcs);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA4E;
	(*$END*)
PROCEDURE GetMaxDevice*((*CONST*)VAR globalRect: Types.Rect): GDHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA27;
	(*$END*)
PROCEDURE GetCTSeed*(): LONGINT;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA28;
	(*$END*)
PROCEDURE GetDeviceList*(): GDHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA29;
	(*$END*)
PROCEDURE GetMainDevice*(): GDHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA2A;
	(*$END*)
PROCEDURE GetNextDevice*(curDevice: GDHandle): GDHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA2B;
	(*$END*)
PROCEDURE TestDeviceAttribute*(gdh: GDHandle; attribute: INTEGER): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA2C;
	(*$END*)
PROCEDURE SetDeviceAttribute*(gdh: GDHandle; attribute: INTEGER; value: BOOLEAN);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA2D;
	(*$END*)
PROCEDURE InitGDevice*(qdRefNum: INTEGER; mode: LONGINT; gdh: GDHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA2E;
	(*$END*)
PROCEDURE NewGDevice*(refNum: INTEGER; mode: LONGINT): GDHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA2F;
	(*$END*)
PROCEDURE DisposeGDevice*(gdh: GDHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA30;
	(*$END*)
PROCEDURE SetGDevice*(gd: GDHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA31;
	(*$END*)
PROCEDURE GetGDevice*(): GDHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA32;
	(*$END*)
PROCEDURE Color2Index*((*CONST*)VAR myColor: RGBColor): LONGINT;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA33;
	(*$END*)
PROCEDURE Index2Color*(index: LONGINT; VAR aColor: RGBColor);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA34;
	(*$END*)
PROCEDURE InvertColor*(VAR myColor: RGBColor);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA35;
	(*$END*)
PROCEDURE RealColor*((*CONST*)VAR color: RGBColor): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA36;
	(*$END*)
PROCEDURE GetSubTable*(myColors: CTabHandle; iTabRes: INTEGER; targetTbl: CTabHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA37;
	(*$END*)
PROCEDURE MakeITable*(cTabH: CTabHandle; iTabH: ITabHandle; res: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA39;
	(*$END*)
PROCEDURE AddSearch*(searchProc: ColorSearchUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA3A;
	(*$END*)
PROCEDURE AddComp*(compProc: ColorComplementUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA3B;
	(*$END*)
PROCEDURE DelSearch*(searchProc: ColorSearchUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA4C;
	(*$END*)
PROCEDURE DelComp*(compProc: ColorComplementUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA4D;
	(*$END*)
PROCEDURE SetClientID*(id: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA3C;
	(*$END*)
PROCEDURE ProtectEntry*(index: INTEGER; protect: BOOLEAN);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA3D;
	(*$END*)
PROCEDURE ReserveEntry*(index: INTEGER; reserve: BOOLEAN);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA3E;
	(*$END*)
PROCEDURE SetEntries*(start: INTEGER; count: INTEGER; VAR aTable: CSpecArray);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA3F;
	(*$END*)
PROCEDURE SaveEntries*(srcTable: CTabHandle; resultTable: CTabHandle; VAR selection: ReqListRec);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA49;
	(*$END*)
PROCEDURE RestoreEntries*(srcTable: CTabHandle; dstTable: CTabHandle; VAR selection: ReqListRec);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA4A;
	(*$END*)
PROCEDURE QDError*(): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA40;
	(*$END*)
PROCEDURE CopyDeepMask*((*CONST*)VAR srcBits: BitMap; (*CONST*)VAR maskBits: BitMap; (*CONST*)VAR dstBits: BitMap; (*CONST*)VAR srcRect: Types.Rect; (*CONST*)VAR maskRect: Types.Rect; (*CONST*)VAR dstRect: Types.Rect; mode: INTEGER; maskRgn: RgnHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA51;
	(*$END*)
PROCEDURE DeviceLoop*(drawingRgn: RgnHandle; drawingProc: DeviceLoopDrawingUPP; userData: LONGINT; flags: DeviceLoopFlags);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $ABCA;
	(*$END*)
PROCEDURE GetMaskTable*(): Types.Ptr;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A836, $2E88;
	(*$END*)
(*$IF OLDROUTINENAMES *)
PROCEDURE DisposPixMap*(pm: PixMapHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA04;
	(*$END*)
PROCEDURE DisposPixPat*(pp: PixPatHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA08;
	(*$END*)
PROCEDURE DisposCTable*(cTable: CTabHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA24;
	(*$END*)
PROCEDURE DisposCCursor*(cCrsr: CCrsrHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA26;
	(*$END*)
(*$IF OLDROUTINELOCATIONS *)
PROCEDURE DisposCIcon*(theIcon: CIconHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA25;
	(*$END*)
(*$END*)
PROCEDURE DisposGDevice*(gdh: GDHandle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $AA30;
	(*$END*)
(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END Quickdraw.
