(*
 	File:		SegLoad.mod
 
 	Contains:	Segment Loader Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE SegLoad;

IMPORT SYSTEM, Types;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	appOpen*						= 0;							(*Open the Document (s)*)
	appPrint*					= 1;							(*Print the Document (s)*)


TYPE
	AppFile* = RECORD
		vRefNum*:				INTEGER;
		fType*:					Types.OSType;
		versNum*:				INTEGER;								(*versNum in high byte*)
		fName*:					Types.Str255;
	END;

(*
	Because PowerPC applications dont have segments,
	UnloadSeg is unsupported for PowerPC.
*)
(*$IF GENERATING68K *)

PROCEDURE UnloadSeg*(routineAddr: (*UNIV*) Types.Ptr);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A9F1;
	(*$END*)
(*$ELSE*)
(*$END*)
(*$IF NOT GENERATINGCFM *)

PROCEDURE CountAppFiles*(VAR message: INTEGER; VAR count: INTEGER);
	EXTERNAL PASCAL;
PROCEDURE GetAppFiles*(index: INTEGER; VAR theFile: AppFile);
	EXTERNAL PASCAL;
PROCEDURE ClrAppFiles*(index: INTEGER);
	EXTERNAL PASCAL;
PROCEDURE GetAppParms*(VAR apName: Types.Str255; VAR apRefNum: INTEGER; VAR apParam: Types.Handle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A9F5;
	(*$END*)
(*$END*)

PROCEDURE ExitToShell*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A9F4;
	(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END SegLoad.
