(*
 	File:		ShutDown.mod
 
 	Contains:	Shutdown Manager Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE ShutDown;

IMPORT SYSTEM, Types;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	sdOnPowerOff*				= 1;							(*call procedure before* power off.*)
	sdOnRestart*					= 2;							(*call procedure before* restart.*)
	sdOnUnmount*					= 4;							(*call procedure before* unmounting.*)
	sdOnDrivers*					= 8;							(*call procedure before* closing drivers.*)
	sdRestartOrPower*			= 3;							(*call before either power off or restart.*)

TYPE
	(*
		ShutDwnProcPtr uses register based parameters on the 68k and cannot
		be written in or called from a high-level language without the help of
		mixed mode or assembly glue.

		In*:
		 => shutDownStage	D0.W
	*)
	ShutDwnProcPtr* = Types.Register68kProcPtr;  (* register PROCEDURE ShutDwn*(shutDownStage: INTEGER); *)
	ShutDwnUPP* = Types.UniversalProcPtr;

CONST
	uppShutDwnProcInfo* = $00001002; (* Register PROCEDURE (2 bytes in D0); *)

PROCEDURE NewShutDwnProc*(userRoutine: ShutDwnProcPtr): ShutDwnUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallShutDwnProc*(shutDownStage: INTEGER; userRoutine: ShutDwnUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL ; (**)
	(*To be implemented*:  Glue to move parameters into registers.*)
	(*$END*)

PROCEDURE ShutDwnPower*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $3F3C, $0001, $A895;
	(*$END*)
PROCEDURE ShutDwnStart*;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $3F3C, $0002, $A895;
	(*$END*)
PROCEDURE ShutDwnInstall*(shutDownProc: ShutDwnUPP; flags: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $3F3C, $0003, $A895;
	(*$END*)
PROCEDURE ShutDwnRemove*(shutDownProc: ShutDwnUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $3F3C, $0004, $A895;
	(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END ShutDown.
