
(*
Created: Friday, August 2, 1991 at 11:40 PM
 Signal.p
 Pascal Interface to the Macintosh Libraries

	Signal Handling interface.
	This must be compatible with C's <signal.h>

  Copyright Apple Computer, Inc. 1986, 1987, 1988, 1991, 1994
  All rights reserved
*)


(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE Signal;

IMPORT SYSTEM;

(* $ALIGN MAC68K*)


TYPE
	SignalMap* = 	INTEGER;
    (* Signal handlers actually have a single parameters of type LONGINT *)
    (* it is not supported in Oberon since the MPW Shell uses the C calling *)
    (* convention that is not supported by MPW Oberon. *)
	SignalHandler* = PROCEDURE (* POINTER TO LONGINT*);	(* Pointer to function *)

CONST
	SIG_ERR* =	   -1;			(* Returned by IEsignal on error *)
	SIG_IGN* =		0;
	SIG_DFL* =		1;
	SIG_HOLD* =		3;
	SIG_RELEASE* =	5;

	SIGABRT* =		$0001;
	SIGINT* =		$0002;		(* Currently only SIGINT implemented *)
	SIGFPE* = 		$0004;
	SIGILL* =		$0008;
	SIGSEGV* =		$0010;
	SIGTERM* =		$0020;

(* Signal Handling Functions *)

PROCEDURE
	IEsignal*(sigNum: LONGINT; sigHdlr: (*UNIV*) SignalHandler):
	SignalHandler; (*C;*)
	EXTERNAL (* C*);

PROCEDURE
	IEraise*(sigNum: LONGINT):
	LONGINT; (*C;*)
	EXTERNAL (* C*);

(* $ALIGN RESET*)

 END Signal.
