(*
 	File:		TSMTE.mod
 
 	Contains:	Text Services Managerfor TextEdit Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE TSMTE;

IMPORT SYSTEM, Types, TextEdit, Dialogs, TextServices;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	kTSMTESignature*				= LONG("tmTE");
	kTSMTEInterfaceType*			= LONG("tmTE");
	kTSMTEDialog*				= LONG("tmDI");


CONST
	gestaltTSMTEAttr*			= LONG("tmTE");
	gestaltTSMTEPresent*			= 0;
	gestaltTSMTE*				= 0;							(* gestaltTSMTE is old name for gestaltTSMTEPresent *)

	gestaltTSMTEVersion*			= LONG("tmTV");
	gestaltTSMTE1*				= $100;

	kTSMTEAutoScroll*			= 1;

(* callback procedure definitions**)
TYPE
	TSMTEPreUpdateProcPtr* = (*Types.ProcPtr;*) PROCEDURE(textH: TextEdit.TEHandle; refCon: LONGINT);
	TSMTEPostUpdateProcPtr* = (* Types.ProcPtr;*) PROCEDURE(textH: TextEdit.TEHandle; fixLen: LONGINT; inputAreaStart: LONGINT; inputAreaEnd: LONGINT; pinStart: LONGINT; pinEnd: LONGINT; refCon: LONGINT);
	TSMTEPreUpdateUPP* = Types.UniversalProcPtr;
	TSMTEPostUpdateUPP* = Types.UniversalProcPtr;

	TSMTERec* = RECORD
		textH*:					TextEdit.TEHandle;
		preUpdateProc*:			TSMTEPreUpdateUPP;
		postUpdateProc*:			TSMTEPostUpdateUPP;
		updateFlag*:				LONGINT;
		refCon*:					LONGINT;
	END;

	TSMTERecPtr* = POINTER TO TSMTERec;
	TSMTERecHandle* = HANDLE TO TSMTERec (* POINTER TO TSMTERecPtr*);

	TSMDialogRecord* = RECORD(Dialogs.DialogRecord)
		(* fDialog*:				Dialogs.DialogRecord;*)
		fDocID*:					TextServices.TSMDocumentID;
		fTSMTERecH*:				TSMTERecHandle;
		fTSMTERsvd*:				ARRAY 3 (*[0..2]*) OF LONGINT;				(* reserved*)
	END;

	TSMDialogPeek* = POINTER TO TSMDialogRecord;


CONST
	uppTSMTEPreUpdateProcInfo* = $000003C0; (* PROCEDURE (4 byte param, 4 byte param); *)
	uppTSMTEPostUpdateProcInfo* = $000FFFC0; (* PROCEDURE (4 byte param, 4 byte param, 4 byte param, 4 byte param, 4 byte param, 4 byte param, 4 byte param); *)

PROCEDURE NewTSMTEPreUpdateProc*(userRoutine: TSMTEPreUpdateProcPtr): TSMTEPreUpdateUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE NewTSMTEPostUpdateProc*(userRoutine: TSMTEPostUpdateProcPtr): TSMTEPostUpdateUPP;
	(*$IF NOT GENERATINGCFM *)
	INLINE PASCAL $2E9F;
	(*$END*)

PROCEDURE CallTSMTEPreUpdateProc*(textH: TextEdit.TEHandle; refCon: LONGINT; userRoutine: TSMTEPreUpdateUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

PROCEDURE CallTSMTEPostUpdateProc*(textH: TextEdit.TEHandle; fixLen: LONGINT; inputAreaStart: LONGINT; inputAreaEnd: LONGINT; pinStart: LONGINT; pinEnd: LONGINT; refCon: LONGINT; userRoutine: TSMTEPostUpdateUPP);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $205F, $4E90;
	(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END TSMTE.
