(*
 	File:		TerminalTools.mod
 
 	Contains:	Communications Toolbox Terminal tools Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE TerminalTools;

IMPORT SYSTEM, Types, Dialogs, Terminals;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	tdefType*					= LONG("tdef");
	tvalType*					= LONG("tval");
	tsetType*					= LONG("tset");
	tlocType*					= LONG("tloc");
	tscrType*					= LONG("tscr");
	tbndType*					= LONG("tbnd");
	tverType*					= LONG("vers");
(* messages *)
	tmInitMsg*					= 0;
	tmDisposeMsg*				= 1;
	tmSuspendMsg*				= 2;
	tmResumeMsg*					= 3;
	tmMenuMsg*					= 4;
	tmEventMsg*					= 5;
	tmActivateMsg*				= 6;
	tmDeactivateMsg*				= 7;
	tmGetErrorStringMsg*			= 8;
	tmIdleMsg*					= 50;
	tmResetMsg*					= 51;
	tmKeyMsg*					= 100;
	tmStreamMsg*					= 101;
	tmResizeMsg*					= 102;
	tmUpdateMsg*					= 103;
	tmClickMsg*					= 104;
	tmGetSelectionMsg*			= 105;
	tmSetSelectionMsg*			= 106;
	tmScrollMsg*					= 107;
	tmClearMsg*					= 108;

	tmGetLineMsg*				= 109;
	tmPaintMsg*					= 110;
	tmCursorMsg*					= 111;
	tmGetEnvironsMsg*			= 112;
	tmDoTermKeyMsg*				= 113;
	tmCountTermKeysMsg*			= 114;
	tmGetIndTermKeyMsg*			= 115;
(* messages for validate DefProc    *)
	tmValidateMsg*				= 0;
	tmDefaultMsg*				= 1;
(* messages for Setup DefProc    *)
	tmSpreflightMsg*				= 0;
	tmSsetupMsg*					= 1;
	tmSitemMsg*					= 2;
	tmSfilterMsg*				= 3;
	tmScleanupMsg*				= 4;
(* messages for scripting defProc    *)
	tmMgetMsg*					= 0;
	tmMsetMsg*					= 1;
(* messages for localization defProc  *)
	tmL2English*					= 0;
	tmL2Intl*					= 1;

	
TYPE
	TMSearchBlockPtr* = POINTER TO TMSearchBlock;

	TMSearchBlock* = RECORD
		theString*:				Types.StringHandle;
		where*:					Types.Rect;
		searchType*:				Terminals.TMSearchTypes;
		callBack*:				Terminals.TerminalSearchCallBackUPP;
		refnum*:					INTEGER;
		next*:					TMSearchBlockPtr;
	END;

	TMSetupPtr* = POINTER TO TMSetupStruct;

	TMSetupStruct* = RECORD
		theDialog*:				Dialogs.DialogPtr;
		count*:					INTEGER;
		theConfig*:				Types.Ptr;
		procID*:					INTEGER;								(* procID of the tool *)
	END;


(* $ALIGN RESET*)
(* $POP*)

 END TerminalTools.
