(*
 	File:		ToolUtils.mod
 
 	Contains:	Toolbox Utilities Interfaces.
 
 	Version:	Technology:	System 7.5
 				Package:	Universal Interfaces 2.0 in MPW Latest on ETO #17
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs.applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*)

(*$IF UNDEFINED OLDROUTINELOCATIONS*)
(*$SET OLDROUTINELOCATIONS FALSE*)
(*$END*)
(*$TAGS-*)
(*$CALLING PASCAL*)
MODULE ToolUtils;

IMPORT SYSTEM, Types, Quickdraw;

(* $PUSH*)
(* $ALIGN MAC68K*)
(* $LibExport+*)

CONST
	sysPatListID*				= 0;
	iBeamCursor*					= 1;
	crossCursor*					= 2;
	plusCursor*					= 3;
	watchCursor*					= 4;


TYPE
	Int64Bit* = RECORD
		hiLong*:					LONGINT;
		loLong*:					LONGINT;
	END;


PROCEDURE FixRatio*(numer: INTEGER; denom: INTEGER): Types.Fixed;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A869;
	(*$END*)
PROCEDURE FixMul*(a: Types.Fixed; b: Types.Fixed): Types.Fixed;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A868;
	(*$END*)
PROCEDURE FixRound*(x: Types.Fixed): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A86C;
	(*$END*)
PROCEDURE PackBits*(VAR srcPtr: Types.Ptr; VAR dstPtr: Types.Ptr; srcBytes: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8CF;
	(*$END*)
PROCEDURE UnpackBits*(VAR srcPtr: Types.Ptr; VAR dstPtr: Types.Ptr; dstBytes: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8D0;
	(*$END*)
PROCEDURE BitTst*(bytePtr: (*UNIV*) Types.Ptr; bitNum: LONGINT): BOOLEAN;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A85D;
	(*$END*)
PROCEDURE BitSet*(bytePtr: (*UNIV*) Types.Ptr; bitNum: LONGINT);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A85E;
	(*$END*)
PROCEDURE BitClr*(bytePtr: (*UNIV*) Types.Ptr; bitNum: LONGINT);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A85F;
	(*$END*)
PROCEDURE BitAnd*(value1: LONGINT; value2: LONGINT): LONGINT;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A858;
	(*$END*)
PROCEDURE BitOr*(value1: LONGINT; value2: LONGINT): LONGINT;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A85B;
	(*$END*)
PROCEDURE BitXor*(value1: LONGINT; value2: LONGINT): LONGINT;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A859;
	(*$END*)
PROCEDURE BitNot*(value: LONGINT): LONGINT;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A85A;
	(*$END*)
PROCEDURE BitShift*(value: LONGINT; count: INTEGER): LONGINT;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A85C;
	(*$END*)
(*$IF GENERATING68K *)
PROCEDURE LongMul*(a: LONGINT; b: LONGINT; VAR result: Int64Bit);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A867;
	(*$END*)
(*$END*)
(*$IF OLDROUTINELOCATIONS *)
PROCEDURE GetIcon*(iconID: INTEGER): Types.Handle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A9BB;
	(*$END*)
PROCEDURE PlotIcon*((*CONST*)VAR theRect: Types.Rect; theIcon: Types.Handle);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A94B;
	(*$END*)
(*$END*)
PROCEDURE GetPattern*(patternID: INTEGER): Quickdraw.PatHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A9B8;
	(*$END*)
PROCEDURE GetCursor*(cursorID: INTEGER): Quickdraw.CursHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A9B9;
	(*$END*)
PROCEDURE GetPicture*(pictureID: INTEGER): Quickdraw.PicHandle;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A9BC;
	(*$END*)
PROCEDURE SlopeFromAngle*(angle: INTEGER): Types.Fixed;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8BC;
	(*$END*)
PROCEDURE AngleFromSlope*(slope: Types.Fixed): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A8C4;
	(*$END*)
PROCEDURE DeltaPoint*(ptA: Types.Point; ptB: Types.Point): LONGINT;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A94F;
	(*$END*)
PROCEDURE ShieldCursor*((*CONST*)VAR shieldRect: Types.Rect; offsetPt: Types.Point);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A855;
	(*$END*)
PROCEDURE ScreenRes*(VAR scrnHRes: INTEGER; VAR scrnVRes: INTEGER);
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $225F, $32B8, $0102, $225F, $32B8, $0104;
	(*$END*)
PROCEDURE GetIndPattern*(VAR thePat: Quickdraw.Pattern; patternListID: INTEGER; index: INTEGER);
	EXTERNAL PASCAL;
PROCEDURE HiWord*(x: LONGINT): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A86A;
	(*$END*)
PROCEDURE LoWord*(x: LONGINT): INTEGER;
	(*$IF NOT GENERATINGCFM*)
	INLINE PASCAL $A86B;
	(*$END*)

(* $ALIGN RESET*)
(* $POP*)

 END ToolUtils.
