
/*
 *  stdlib.h
 *
 *  Copyright (c) 1989 Symantec Corporation.  All rights reserved.
 *
 */

#define _H_stdlib

#ifndef NULL
#define NULL		((void *) 0)
#endif

#define EXIT_SUCCESS			0
#define EXIT_FAILURE			(-1)
#define RAND_MAX				32767
#define MB_CUR_MAX				1

typedef struct { int quot, rem; } div_t;
typedef struct { long quot, rem; } ldiv_t;

#ifndef __size_t
#define __size_t
typedef unsigned long size_t;
#endif

#ifndef __wchar_t
#define __wchar_t
typedef char wchar_t;
#endif

double atof(char *);
int atoi(char *);
long atol(char *);
double strtod(char *, char **);
long strtol(char *, char **, int);
unsigned long strtoul(char *, char **, int);

int rand(void);
void srand(unsigned);

void *calloc(size_t, size_t);
void free(void *);
void *malloc(size_t);
void *realloc(void *, size_t);

void abort(void);
int atexit(void (*)());
void exit(int);
char *getenv(char *);
int system(char *);

void *bsearch(void *, void *, size_t, size_t, int (*)());
void qsort(void *, size_t, size_t, int (*)());

int abs(int);
div_t div(int, int);
long labs(long);
ldiv_t ldiv(long, long);

int mblen(char *, size_t);
int mbtowc(wchar_t *, char *, size_t);
int wctomb(char *, wchar_t);

size_t mbstowcs(wchar_t *, char *, size_t);
size_t wcstombs(char *, wchar_t *, size_t);

void _exit(int);
int _atexit(void (*)());
void _exiting(int);
extern int _abnormal_exit;
void _qsort(size_t, int (*)(), void (*)());
